#include<bits/stdc++.h>

using namespace std;

typedef long long LL;

const int N = 5e5 + 10;
const LL INF = 4e18;

int n , type;
LL a[N] , b[N] , l[N] , r[N] , p[N];
LL sum[5010] , f[5010][5010] , Min[5010][5010];

template <typename T> inline void chkmax(T &x , T y) { x = max(x , y); }
template <typename T> inline void chkmin(T &x , T y) { x = min(x , y); }
template <typename T> inline void read(T &x) {
	T f = 1; x = 0;
	char c = getchar();
	for (; !isdigit(c); c = getchar()) if (c == '-') f = -f;
	for (; isdigit(c); c = getchar()) x = (x << 3) + (x << 1) + c - '0';
	x *= f;
}

namespace solver1 {
	inline void solve() {
		for (int i = 1; i <= n; ++i) sum[i] = sum[i - 1] + a[i];
		for (int i = 1; i <= n; ++i)
		for (int j = 0; j < i; ++j)
			f[i][j] = INF;
		for (int i = 1; i <= n; ++i) chkmin(f[i][0] , (LL)sum[i] * sum[i]);
		for (int i = 1; i <= n; ++i)
		for (int j = 1; j < i; ++j) 
		for (int k = 0; k < j; ++k) {
			if (sum[i] - sum[j] >= sum[j] - sum[k])
				chkmin(f[i][j] , f[j][k] + (LL)(sum[i] - sum[j]) * (sum[i] - sum[j]));
		}
		LL ans = INF;
		for (int i = 0; i < n; ++i)
			chkmin(ans , f[n][i]);
		printf("%lld\n" , ans);
	}
} ;

namespace solver2 {
 	inline void solve() {
		for (int i = 1; i <= n; ++i) sum[i] = sum[i - 1] + a[i];
		for (int i = 1; i <= n; ++i)
		for (int j = 0; j < i; ++j)
			f[i][j] = Min[i][j] = INF;
		for (int i = 1; i <= n; ++i) {
			Min[i][0] = (LL)sum[i] * sum[i];
			chkmin(f[i][0] , (LL)sum[i] * sum[i]);
		}
		for (int i = 1; i <= n; ++i) {
			Min[i][i] = INF;
			for (int j = i - 1; j >= 1; --j) {
				int l = 0 , r = j - 1 , res = -1;
				while (l <= r) {
					int mid = l + r >> 1;
					if (sum[i] - sum[j] >= sum[j] - sum[mid]) res = mid , r = mid - 1;
					else l = mid + 1;
				}
				if (res == -1 || Min[j][res] == INF) 
					f[i][j] = INF;
				else 
					f[i][j] = Min[j][res] + (LL)(sum[i] - sum[j]) * (sum[i] - sum[j]);
				Min[i][j] = min(Min[i][j + 1] , f[i][j]);
			}
			Min[i][0] = min(Min[i][0] , Min[i][1]);
		}
 		LL ans = INF;
		for (int i = 0; i < n; ++i) 
			chkmin(ans , f[n][i]);
		printf("%lld\n" , ans);
	}
} ;

namespace solver3 {
	inline void solve() {
		LL ans = 0;
		for (int i = 1; i <= n; ++i) ans += (LL)a[i] * a[i];
		printf("%lld\n" , ans);
	}
} ;

int main() {
	
	freopen("partition.in" , "r" , stdin);
	freopen("partition.out" , "w" , stdout);
	
	read(n); read(type);
	if (type == 1) {
		LL x , y , z , m;
		read(x); read(y); read(z); read(b[1]); read(b[2]); read(m);
		for (int i = 1; i <= m; ++i) {
			read(p[i]);
			read(l[i]);
			read(r[i]);
		}
		LL M = 1 << 30;
		for (int i = 3; i <= n; ++i) b[i] = (x * b[i - 1] % M + y * b[i - 2] % M + z) % M;
		for (int j = 1; j <= m; ++j) {
			for (int i = p[j - 1] + 1; i <= p[j]; ++i)
				a[i] = l[j] + b[i] % (r[j] - l[j] + 1);
		}
	} else {
		for (int i = 1; i <= n; ++i)
			read(a[i]);
	}
	if (n <= 400) {
		solver1 :: solve();
		return 0;
	} 
	if (n <= 5000) {
		solver2 :: solve();
		return 0;
	}
	if (n > 5000) {
		solver3 :: solve();
		return 0;
	}
	
	return 0;
}

