#include<iostream>
#include<cstdio>
#include<cstring>
#include<cstdlib>
#include<string>
#include<algorithm>
#include<cmath>
#include<queue>
#include<vector>
using namespace std;
#define ft(a,b,c) for(int (a)=(b);(a)<=(c);(a)++)
const int maxn=300010;
long long ans;
int T,n,fa[maxn],x,y;
int b[maxn],ne[2*maxn],nn[maxn],v[2*maxn],cnt;
int siz[maxn];
void iinit(){
	memset(b,sizeof(b),0);
	memset(ne,sizeof(ne),0);
	memset(nn,sizeof(nn),0);
	memset(v,sizeof(v),0);
	memset(fa,sizeof(fa),0);
	memset(siz,sizeof(siz),0);
	cnt=0;ans=0;
}
void add_edge(int x,int y){
	if(!b[x]) b[x]=++cnt;
	else ne[nn[x]]=++cnt;
	v[cnt]=y;nn[x]=cnt;
}
void dfs1(int x,int ffa){
	fa[x]=ffa;
	siz[x]=1;
	for(int p=b[x];p;p=ne[p]){
		if(v[p]!=ffa){
			dfs1(v[p],x);
			siz[x]+=siz[v[p]];
		}
	}
}
void dfs2(int x,int rt,int ct){
	bool flag=1;
	if(siz[rt]-siz[x]>siz[rt]/2) flag=0;
	for(int p=b[x];p;p=ne[p]){
		if(v[p]!=fa[x]&&v[p]!=ct){
			if(siz[v[p]]>siz[rt]/2) flag=0;
			dfs2(v[p],rt,ct);
		}	
	}
	if(flag) ans+=x;
}
void work(){
	iinit();
	scanf("%d",&n);
	if(n>2000){
		long long x=n;
		cout<<x*(x+1)<<endl;
		return;
	}
	ft(i,1,2*n) ne[i]=0;
	ft(i,1,n) b[i]=0;
	ft(i,1,n-1){
		scanf("%d%d",&x,&y);
		add_edge(x,y);
		add_edge(y,x);
	}
	fa[1]=1;
	dfs1(1,1);
	ft(i,2,n){
		int tmp=i;
		while(tmp!=1){
			siz[fa[tmp]]-=siz[i];
			tmp=fa[tmp];
		}
		dfs2(i,i,i);
		dfs2(1,1,i);
		tmp=i;
		while(tmp!=1){
			siz[fa[tmp]]+=siz[i];
			tmp=fa[tmp];
		}		
	}
	cout<<ans<<endl;
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	ft(i,1,T)
		work();
	
	return 0;
}
