#include <bits/stdc++.h>

#define ll long long

using namespace std;

const int N = 5 * 1e4 + 10;

int T, n, Head[N], tot, sz[N], Intime[N], Outtime[N], tim, fa[N];
ll ans;

struct Edge {
	int u, v, w, nxt;
}edges[N];

inline int _read() {
	   int w = 1, s = 0;
	   char ch = getchar();
	   while (ch < '0' || ch > '9') {if (ch == '-') w = -1; ch = getchar();}
	   while (ch >= '0' && ch <= '9') {s = s * 10 + ch - '0'; ch = getchar();}
	   return w * s;
}

void adde(int x, int y) {
	edges[++ tot].u = x;
	edges[tot].v = y;
	edges[tot].nxt = Head[x];
	
	Head[x] = tot;
}

void GetSize(int x, int lst) {
	sz[x] = 1;
	Intime[x] = tim ++;
	fa[x] = lst;
	
	for (int i = Head[x]; i; i = edges[i].nxt) {
		int y = edges[i].v;
		
		if (y != lst) {
			GetSize(y, x);
			sz[x] += sz[y];
		}
	}
	
	Outtime[x] = tim;
	
	return ;
}

void DelEdge(int x) {
	if (fa[x] != 0) {
		
		//cout << "pts: " << x << ' ' << fa[x] << endl;
		int sz1 = sz[x], sz2 = n - sz[x];
		//cout << "sz : " << sz1 << ' ' << sz2 << endl;
		
		for (int i = 1; i <= n; i ++) 
			if (Intime[i] < Intime[x] && Outtime[i] >= Outtime[x]) sz[i] -= sz[x];
		for (int i = 1; i <= n; i ++) {
			if (Intime[i] >= Intime[x] && Outtime[i] <= Outtime[x]) {
				int t1 = 0;
				int t2 = sz1 - sz[i];
				for (int j = Head[i]; j; j = edges[j].nxt) {
					int y = edges[j].v;
					if (y != fa[i]) t1 = max(t1, sz[y]);
				}
				
				if (t1 <= sz1 / 2 && t2 <= sz1 / 2) ans += i;
				//cout << i << ' ' << t1 << ' ' << t2 << endl;
			}
			
			else {
				int t1 = 0;
				int t2 = sz2 - sz[i];
				for (int j = Head[i]; j; j = edges[j].nxt) {
					int y = edges[j].v;
					
					if (y != fa[i] && y != x) t1 = max(t1, sz[y]);
				}
				
				if (t1 <= sz2 / 2 && t2 <= sz2 / 2) ans += i;
				//cout << sz2 << ' ' << sz[i] << sz[x] << ' ' << i << ' ' << t1 << ' ' << t2 << endl;
			}
		}
		for (int i = 1; i <= n; i ++) 
			if (Intime[i] < Intime[x] && Outtime[i] >= Outtime[x]) sz[i] += sz[x];
	}
	
	for (int i = Head[x]; i; i = edges[i].nxt) {
		int y = edges[i].v;
		
		if (y != fa[x]) DelEdge(y);
	}
}

int main() {

	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	
	T = _read();
	
	while (T --) {
		n = _read();
		
		tot = 0;
		ans = 0;
		tim = 0;
		for (int i = 1; i <= n; i ++)
			Head[i] = 0;
		
		for (int i = 1; i < n; i ++) {
			int x, y;
			
			x = _read();
			y = _read();
			
			adde(x, y);
			adde(y, x);
		}
		
		GetSize(1, 0);
		DelEdge(1);
		
		cout << ans << endl;
	}
	
	return 0;
}

