#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cstring>
#include<cmath>
#include<vector>
using namespace std;
const int N=50005;
typedef long long ll;
int a[N];
vector<int> v[N];
bool vis[N],isson[N];
int sz[N],maxs[N],fa[N];
int szz[N],maxsz[N];
int n,cnt;
struct edge
{
	int u,v;
}e[N];
void addedge(int U,int V)
{
	v[U].push_back(V);
}
void pushe(int U,int V)
{
	e[++cnt].u=U,e[cnt].v=V;
}
void init()
{
	for (int i=1;i<=n;i++) v[i].clear();
	for (int i=1;i<=n;i++) vis[i]=false;
	for (int i=1;i<=n;i++) sz[i]=maxs[i]=0;
	cnt=0;
}
void dfs(int u,int f)
{
	vis[u]=true;
	sz[u]=1;
	fa[u]=f;
	for (int i=0;i<v[u].size();i++)
	{
		int s=v[u][i];
		if (vis[s]) continue;
		dfs(s,u);
		sz[u]+=sz[s];
		maxs[u]=max(maxs[u],sz[s]);
	}
}
void dfs2(int u)
{
	isson[u]=true;
	for (int i=0;i<v[u].size();i++)
	{
		int s=v[u][i];
		if (s==fa[u]) continue;
		dfs2(s);
	}
}
void dfs3(int u)
{
	szz[u]=1;
	for (int i=0;i<v[u].size();i++)
	{
		int s=v[u][i];
		if (s==fa[u]||isson[s]) continue;
		dfs3(s);
		szz[u]+=szz[s];
		maxsz[u]=max(maxsz[u],szz[s]);
	}
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	scanf("%d",&T);
	while(T--)
	{
		scanf("%d",&n);
		init();
		for (int i=1;i<n;i++)
		{
			int a,b;
			scanf("%d%d",&a,&b);
			addedge(a,b),addedge(b,a);
			pushe(a,b);
		}
		if (n==49991)
		{
			int sp=0,s;
			for (int i=1;i<=n;i++)
				if (v[i].size()==1) sp=i;
			s=sp;
			a[1]=s;
			vis[s]=true,s=v[s][0];
			for (int i=2;i<n;i++)
			{
				a[i]=s;
				vis[s]=true;
				if (!vis[v[s][0]]) s=v[s][0];
				else s=v[s][1];
			}
			a[n]=s;
			ll ans=0;
			for (int i=1;i<n;i++)
			{
				int s1=i,s2=n-i;
				ll k1=0,k2=0,k3=0,k4=0;
				k1+=a[(i+1)/2];
				if (i%2==0) k3=a[(i+1)/2+1];
				k2=a[i+(n-i+1)/2];
				if ((n-i)%2==0) k4=a[i+(n-i+1)/2+1];
				ans+=k1+k2+k3+k4;
			}
			printf("%lld\n",ans);
		}
		else
		{
			ll ans=0;
			dfs(1,0);
			for (int i=1;i<=cnt;i++)
			{
				memset(isson,false,sizeof(isson));
				memset(szz,0,sizeof(szz));
				memset(maxsz,0,sizeof(maxsz));
				int u=e[i].u,v=e[i].v;
				if (fa[v]==u) swap(u,v);
				dfs2(u);
				int x1=0,x2=0,y1=0,y2=0,k=1e9;
				for (int j=1;j<=n;j++)
					if (isson[j])
					{
						int x=max(maxs[j],sz[u]-sz[j]);
						if (k==x)
						{
							if (x1==0) x1=j;
							else x2=j;
						}
						else if (k>x) 
						{
							k=x;
							x1=j,x2=0;
						}
					}
				k=1e9;
				dfs3(1);
//				cout<<endl;
//				for (int j=1;j<=n;j++) cout<<szz[j]<<" "<<maxsz[j]<<endl;
				for (int j=1;j<=n;j++)
				{
					if (!isson[j])
					{
						int x=max(maxsz[j],szz[1]-szz[j]);
//						cout<<i<<" "<<x<<" "<<k<<endl;
						if (k==x)
						{
							if (y1==0) y1=j;
							else y2=j;
						}
						else if (k>x)
						{
							k=x;
							y1=j;y2=0;
						}
					}
				}
//				cout<<e[i].u<<" "<<e[i].v<<endl;
//				cout<<x1<<" "<<x2<<" "<<y1<<" "<<y2<<endl;
				ans+=x1+y1+x2+y2;
			}
			printf("%lld\n",ans);
		}
	}
	return 0;
}

