#include<iostream>
#include<cstdio>
#include<algorithm>
#define ll long long int 
using namespace std;

const ll maxn = 5005;
ll inf = (4*1e18);

ll n, type, dp[maxn][maxn], sum[maxn], dp_min[maxn][maxn];

inline ll find(ll x) {
	//cout<<x<<endl;
	ll l=0, r=n, mid;
	while(l < r) {
		mid=(l+r)/2;
		if(sum[mid] >= x) r=mid;
		else l=mid+1;
	}
	return l;
}

int main() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	inf+=1ll;
	ll i, j, p, ts;
	cin>>n>>type;
	for(i=1; i <= n; i++) {
		cin>>sum[i];
		sum[i]+=sum[i-1];
	}
	for(i=1; i <= n; ++i) {
		dp_min[i][0]=inf;
		for(j=1; j <= i; ++j) {
			ts=sum[i]-sum[i-j];
			if(i-j == 0) dp[i][j]=ts*ts;
			else {
				p=find(sum[i-j]-ts);
				if(i-j-p > 0 && dp_min[i-j][i-j-p] != inf) dp[i][j]=dp_min[i-j][i-j-p]+ts*ts;
				else dp[i][j]=inf;
			}
			dp_min[i][j]=min(dp[i][j], dp_min[i][j-1]);
		}
	}
	cout<<dp_min[n][n]<<endl;
	return 0;
}
