#include<bits/stdc++.h>
using namespace std;
int read() {
	char c=getchar();while(!isdigit(c)) c=getchar();
	int num=0;while(isdigit(c))num=num*10+c-'0',c=getchar();
	return num;
}
struct node {
	int ls, rs;
	int cnt;
}nd[15000000];
int rt[300001], tot;
void modify(int &p, int l, int r, int x, int op) {
	if (!p) p = ++tot;
	nd[p].cnt += op;
	if (l == r) return;
	int mid = (l + r) / 2;
	if (x <= mid) modify(nd[p].ls, l, mid, x, op);
	else modify(nd[p].rs, mid + 1, r, x, op);
}
int query(int p, int l, int r, int x, int rt) {
	if (!p) return 0;
	if (r <= x) return nd[p].cnt;
	int mid = (l + r) / 2, ans = query(nd[p].ls, l, mid, x,rt);
	if (x > mid) ans += query(nd[p].rs, mid + 1, r, x,rt);
	return ans;
}
void clear(int &p) {
	if (!p) return;
	clear(nd[p].ls), clear(nd[p].rs);
	nd[p].cnt = 0;
	p = 0;
}
int n;
int a[300001];
void modify(int x, int num) {
	for (int i = x; i <= n; i += i & -i) modify(rt[i], 1, n, a[x], -1), modify(rt[i], 1, n, num, 1);
	a[x] = num;
}
int query(int x, int num) {
	int ans = 0;
	for (int i = x; i; i -= i & -i) ans += query(rt[i], 1, n, num,i);
	return ans;
}
int query(int l, int r, int num) {return query(r, num) - query(l - 1, num);}
void clear() {
	for (int i = 1; i <= n; i++) clear(rt[i]);
	tot = 0;
}
int head[300001], ver[600001], nxt[600001], sz;
void addedge(int u, int v) {
	ver[++sz] = v, nxt[sz] = head[u], head[u] = sz;
	ver[++sz] = u, nxt[sz] = head[v], head[v] = sz;
}
int fa[300001];
int size[300001];
int seq[300001], st[300001], ed[300001], num;
void dfs(int x) {
	st[x] = ++num;
	seq[num] = x;
	size[x] = 1;
	for (int i = head[x]; i; i = nxt[i])
		if (fa[x] != ver[i]) {
			fa[ver[i]] = x;
			dfs(ver[i]);
			size[x] += size[ver[i]];
		}
	ed[x] = num;
}
void init() {
	for (int i = 1; i <= n; i++) a[i] = size[seq[i]];
	for (int i = 1; i <= n; i++)
		for (int x = i; x <= n; x += x & -x) modify(rt[x], 1, n, a[i], 1);
}
long long ans = 0;
void dp(int x) {
	int max1 = 0, max2 = 0, cnt = 1;
	for (int i = head[x]; i; i = nxt[i]) {
		if (size[ver[i]] > max1) max2 = max1, max1 = size[ver[i]];
		else if (size[ver[i]] > max2) max2 = size[ver[i]];
		cnt += size[ver[i]];
	}
	int num = 0;
	for (int i = head[x]; i; i = nxt[i]) {
		int tmp1 = cnt - size[ver[i]];
		int tmp2;
		if (size[ver[i]] == max1) tmp2 = 2 * max2 - tmp1;
		else tmp2 = 2 * max1 - tmp1;
		tmp2 = size[ver[i]] - tmp2, tmp1 = size[ver[i]] - tmp1;
		if (tmp2 <= 0 || tmp1 > size[ver[i]]) continue;
		if (tmp2 > size[ver[i]]) tmp2 = size[ver[i]];
		if (tmp1 <= 0) tmp1 = 1;
		if (tmp1 > tmp2) continue;
		if (fa[x] == ver[i]) num += (query(1, n, tmp2) - query(st[x], ed[x], tmp2)) - (query(1, n, tmp1 - 1) - query(st[x], ed[x], tmp1 - 1));
		else num += query(st[ver[i]], ed[ver[i]], tmp2) - query(st[ver[i]], ed[ver[i]], tmp1 - 1);
	}
	ans += 1ll * x * num;
	for (int i = head[x]; i; i = nxt[i])
		if (fa[x] != ver[i]) {
			modify(st[x], n - size[ver[i]]);
			modify(st[ver[i]], n);
			size[x] = n - size[ver[i]], size[ver[i]] = n;
			dp(ver[i]);
		}
	if (fa[x]) {
		modify(st[x], n - size[fa[x]]);
		modify(st[fa[x]], n);
		size[x] = n - size[fa[x]], size[fa[x]] = n;
	}
}
int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T = read();
	while (T--) {
		memset(head, 0, sizeof(head));
		sz = 0;
		memset(fa, 0, sizeof(fa));
		n = read();
		for (int i = 1; i < n; i++) {
			int u, v;
			u = read(), v = read();
			addedge(u, v);
		}
		num = 0;
		dfs(1);
		init();
		ans = 0;
		dp(1);
		clear();
		cout << ans << endl;
	}
}
