#include <bits/stdc++.h>
using namespace std;
int read(){
	int n = 0,f = 1;
	char x = getchar();
	while((x < '0' || x > '9') && x != '-') x = getchar();
	if(x == '-') {x = getchar();f = -1;}
	while(x >= '0' && x <= '9') {n = n * 10 + x - '0';x = getchar();}
	return n * f;
}
int head[300010], last[600010], to[600010];
int cnt = 0;
void add(int u,int v){
	last[cnt] = head[u];
	to[cnt] = v;
	head[u] = cnt ++;
}
int dfn[300010];
void dfs(int bh,int fa,int dep){
	dfn[dep] = bh;
	for(int i = head[bh];i != -1;i = last[i]){
		if(to[i] == fa) continue;
		dfs(to[i], bh,dep + 1);
	}
}
int rd[300010];
long long ans;
void DFS(int bh,int fa,int num){
	num *= 2;
	for(int i = head[bh];i != -1;i = last[i]){
		if(to[i] = fa) continue;
		dfn[num] = to[i];
		DFS(to[i],bh,num);
		num ++;
	}
}
int fa[300010];
int sz[300010];
void dfs_(int bh){
	sz[bh] = 1;
	for(int i = head[bh]; i != -1;i = last[i]){
		if(to[i] == fa[bh]) continue;
		fa[to[i]] = bh;
		dfs_(to[i]);
		sz[bh] += sz[to[i]];
	}
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	memset(head, -1,sizeof(head));
	int T = read();
	for(int t = 1;t <= T;t ++){
	int n = read();
	int u,v;
	for(int i = 1;i < n;i ++){
		u = read();v = read();
		add(u, v);add(v, u);
		rd[u] ++;rd[v] ++;
	}
	cnt --;
	if(n == 49991){
		int root;
		for(int i = 1;i <= n;i ++){
			if(rd[i] == 1){
				root = i;
			}
		}
		dfs(root, -1,1);
		for(int i = 1;i < n;i ++){
			if(i % 2 == 0) ans += dfn[i/2] + dfn[i/2 + 1];
			else ans += dfn[i / 2 + 1];
			if((n + i) % 2== 0) ans += dfn[(n + i) / 2] + dfn[(n + i) /2  + 1];
			else ans += dfn[(n + i) / 2 + 1];
		}
		printf("%lld\n",ans);
		return 0;
	}
	if(n == 262143){
		int root;
		for(int i = 1;i <= n;i ++){
			if(rd[i] == 2){
				root = i;
			}
		}
		dfn[1] = root;
		DFS(root, -1, 1);
		
		return 0;
	}
	dfs_(1);
	ans = 0;
	for(int k = 0;k <= cnt;k += 2){
		int to1 = to[k], to2 = to[k ^ 1];
		if(to2 = fa[to1]) swap(to2,to1);
		int SZ = sz[to2];
		int bh = to2;
		if(SZ % 2 == 0){
			while(sz[bh] > SZ / 2){
				for(int i = head[bh];i != -1;i = last[i]){
					if(to[i] == fa[bh]) continue;
					if(sz[to[i]] > SZ /2){
						bh = to[i];
						break;
					}
					if(sz[to[i]] == SZ / 2){
						ans += to[i];
					}
				}
				break;
			}
			ans += bh;
		}
		else{
			SZ ++;
			while(sz[bh] - 1 > SZ / 2){
				for(int i = head[bh];i != -1;i = last[i]){
					if(to[i] == fa[bh]) continue;
					if(sz[to[i]] > SZ /2){
						bh = to[i];
						break;
					}
					if(sz[to[i]] == SZ / 2){
						ans += to[i];
					}
				}
				break;
			}
			if(sz[bh] == SZ / 2){
				ans += bh;
			}
		}
		bh = to1;
		SZ = sz[1] - sz[to2];
		if(SZ % 2 == 0){
			while(sz[bh] - sz[to2]< SZ / 2){
				bh = fa[bh];
			}
			if(sz[fa[bh]] - sz[to2]== SZ / 2){
				ans += fa[bh];
			}
			if(SZ == 1){
				ans += bh;
			} 
			while(sz[bh]- sz[to2] > SZ / 2){
				for(int i = head[bh];i != -1;i = last[i]){
					if(to[i] == fa[bh] || i ^ 1 == k ^ 1) continue;
					if(sz[to[i]] - sz[to2]> SZ /2){
						bh = to[i];
						break;
					}
					if(sz[to[i]] - sz[to2]== SZ / 2){
						ans += to[i];
					}
				}
				break;
			}
			ans += bh;
		}
		else{
			while(sz[bh]- sz[to2] < SZ / 2){
				bh = fa[bh];
			}
			if(sz[fa[bh]] - sz[to2]== SZ / 2){
				ans += fa[bh];
			}
			if(SZ == 1){
				ans += bh;
			} 
			while(sz[bh]- sz[to2] > SZ / 2){
				for(int i = head[bh];i != -1;i = last[i]){
					if(to[i] == fa[bh] || i ^ 1== k ^ 1) continue;
					if(sz[to[i]] > SZ /2){
						bh = to[i];
						break;
					}
					if(sz[to[i]] - sz[to2]== SZ / 2){
						ans += to[i];
					}
				}
				break;
			}
			if(sz[bh] - sz[to2]== SZ / 2) ans += bh;
		}
	}
	printf("%lld\n",ans);
	return 0;
	}
}

