#include<bits/stdc++.h>
#define N 105
#define M 2005
typedef long long ll;

using namespace std;

template <class T>
inline void read(T &n)
{
	n = 0;
	char ch = getchar();
	while (!isdigit(ch))
		ch = getchar();
	while (isdigit(ch))
		n = (n << 3) + (n << 1) + ch - '0', ch = getchar();
}

const ll mod = 998244353;
ll a[N][M], ans;
bool vis[N];
int n, m, cnt[M];

inline void dfs(int dep, long long sum, int k, int last)
{
	if (dep > k)
	{
		ans = (ans + sum) % mod;
		return;
	}
	for (int i = last; i <= n; ++i)
		for (int j = 1; j <= m; ++j)
			if (!vis[i] && a[i][j] && cnt[j] + 1 <= (k >> 1))
			{
				++cnt[j];
				vis[i] = 1;
				dfs(dep + 1, sum * a[i][j] % mod, k, i + 1);
				vis[i] = 0;
				--cnt[j];
			}
}

int main(int argc, char *argv[])
{
	freopen ("meal.in", "r", stdin);
	freopen ("meal.out", "w", stdout);
	read(n), read(m);
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j)
			read(a[i][j]);
	for (int i = 2; i <= n; ++i)
		dfs(1, 1, i, 1);
	printf ("%lld\n", ans);
	fclose(stdin);
	fclose(stdout);
	return 0;
}
