#include <bits/stdc++.h>

#define redirect(name)	(					\
		freopen(name ".in", "r", stdin),	\
		freopen(name ".out", "w", stdout)	\
	)

using namespace std;

int n;
int arr[5 * 100000 + 2];

template<typename T>
T CalcVectorResult(const vector<T> &vIn) {
	T nAns = 0, nTemp;
	for (size_t i = 0; i < vIn.size(); i++) {
		nTemp = vIn[i];
		nAns += nTemp * nTemp;
	}
	return nAns;
}
template<typename T>
T IsVectorGood(const vector<T> &vIn, size_t &nBadPos) {
	T nAns = 0, nTemp;
	for (size_t i = 1; i < vIn.size(); i++) {
		if (vIn[i] < vIn[i - 1])
			return nBadPos = i, false;
	}
	return true;
}
template<typename T>
T IsVectorGood(const vector<T> &vIn, size_t &nBadPos, size_t nSearchBegin) {
	T nAns = 0, nTemp;
	for (size_t i = max(size_t(1), nSearchBegin); i < vIn.size(); i++) {
		if (vIn[i] < vIn[i - 1])
			return nBadPos = i, false;
	}
	return true;
}

unsigned long long do_search(const vector<int> &vIn, size_t nSearchBegin)  {
	unsigned long long nAns;
	vector<int> vCopy;
	size_t nBadPos;
	
	if (IsVectorGood(vIn, nBadPos, nSearchBegin)) {
		return CalcVectorResult(vIn);
	}
	
	nAns = 0x3f3f3f3f3f3f3f3f;
	
	vCopy = vIn;
	vCopy[nBadPos - 1] += vCopy[nBadPos];
	vCopy.erase(vCopy.begin() + nBadPos);
	nAns = min(nAns, do_search(vCopy, nBadPos - 1));
	
	if (nBadPos + 1 < vIn.size() && vCopy[nBadPos - 1] > vCopy[nBadPos]) {
		vCopy = vIn;
		vCopy[nBadPos + 1] += vCopy[nBadPos];
		vCopy.erase(vCopy.begin() + nBadPos);
		nAns = min(nAns, do_search(vCopy, nBadPos));
	}
	
	return nAns;
}

void MAIN_BRANCH_0(void) {
	vector<int> vIn;
	
	for (int i = 1; i <= n; i++) {
		scanf("%d", &arr[i]);
		vIn.push_back(arr[i]);
	}
	
	cout << do_search(vIn, 0);
}

void MAIN_BRANCH_1(void) {
	return;
}

void MAIN(void) {
	int nType;
	
	scanf("%d%d", &n, &nType);
	if (nType == 0)
		MAIN_BRANCH_0();
	else
		MAIN_BRANCH_1();
}

int main(void) {
#if 1 
	redirect("partition");
#endif
	MAIN();
	return 0;
}

