#include <bits/stdc++.h>
#define ll long long
using namespace std;

ll rd() {
	ll s = 0, f = 1;
	char x = getchar();
	for (; !isdigit(x); x = getchar()) if (x == '-') f = -1;
	for (; isdigit(x); x = getchar()) s = s*10+x-48;
	return s*f;
}

const int N = 5005, BN = 5e4+10;
struct edge {
	int to, nexty;
} e[BN*2];
int son[N], fa[N], siz[N], lson[N];
int T, cnt, n, dson, k;
int u[BN], v[BN], du[BN], hd[BN];
ll a[BN];
ll ans;

void add_edge(int u, int v) {
	e[++cnt] = (edge) {v, hd[u]};
	hd[u] = cnt;
	return;
}

void dfs(int x) {
	siz[x] = 1;
	for (int i = hd[x]; i; i = e[i].nexty)
		if (e[i].to != fa[x]) {
			fa[e[i].to] = x;
			dfs(e[i].to);
			siz[x] += siz[e[i].to];
			if (siz[e[i].to] > siz[son[x]])	{
				lson[x] = son[x];
				son[x] = e[i].to;
			} else if (siz[e[i].to] > siz[lson[x]]) lson[x] = e[i].to;
		}
	return;
}

void ansfa(int x, int dson, int dlt) {
	int ts = siz[son[x]], l = 0;
	if (fa[dson] == x) l = siz[dlt];
	if (son[x] == dson) ts -= siz[dlt];
	ts = max(n-siz[dlt]-siz[x]+l, max(ts, siz[lson[x]]));
	if (ts <= (n-siz[dlt])/2) ans += x;
	for (int i = hd[x]; i; i = e[i].nexty)
		if (e[i].to != dson && e[i].to != fa[x]) ansfa(e[i].to, dson, dlt);
	return;
}

void anson(int x, int rt) {
	int ts = max(siz[rt]-siz[x], siz[son[x]]);
	if (ts <= (siz[rt]/2)) ans += x;
	for (int i = hd[x]; i; i = e[i].nexty)
		if (e[i].to != fa[x]) anson(e[i].to, rt);
	return;
}

void baoli() {
	cnt = 0;
	memset(hd, 0, sizeof hd);
	memset(son, 0, sizeof son);
	memset(lson, 0, sizeof lson);
	memset(siz, 0, sizeof siz);
	memset(fa, 0, sizeof fa);
	for (int i = 1; i < n; i++) {
		add_edge(u[i], v[i]);
		add_edge(v[i], u[i]);
	}
	dfs(1);
	ans = 0;
	for (int i = 1; i < n; i++) {
		if (fa[u[i]] == v[i]) swap(u[i], v[i]);
		dson = v[i];
		for (int x = u[i]; x; dson = x, x = fa[x]) ansfa(x, dson, v[i]);
		anson(v[i], v[i]);
	}
	cout << ans << endl;
	return; 
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	for (T = rd(); T--; ) {
		n = rd();
		for (int i = 1; i < n; i++) {
			u[i] = rd();
			v[i] = rd();
		}
		if (n <= 2000) {
			baoli();
			continue;
		}
		if (n > 2000) {
			cnt = 0;
			memset(du, 0, sizeof du);
			memset(hd, 0, sizeof hd); 
			for (int i = 1; i < n; i++) {
				add_edge(u[i], v[i]);
				add_edge(v[i], u[i]);
				du[u[i]]++;
				du[v[i]]++; 
			}
			for (int i = 1; i <= n; i++)
				if (du[i] == 1) {
					k = i;
					break;
				}
			a[1] = k;
			for (int i = 1; i < n; i++)
				for (int j = hd[a[i]]; j; j = e[j].nexty)
					if (e[j].to != a[i-1]) a[i+1] = e[j].to;
			ans = 0;
			for (int i = 1; i < n; i++) {
				ans += a[i/2+1]+a[i+(n-i)/2+1];
				if (i%2 == 0) ans += a[i/2];
				if ((n-i)%2 == 0) ans += a[i+(n-i)/2];
			}
			cout << ans << endl;
		}
	}
	return 0;
}

