#include<iostream> 
#include<cstdio>
#include<cstring>
using namespace std;
struct Edge{
	int v,nxt;
}edge[600001];
int head[300001],tot=0;
int maxs[300001],maxi[300001],prems[300001],size[300001],f[300001],a[300001],b[300001];
void init()
{
	tot=0;
	memset(head,0,sizeof(head));
	memset(maxs,0,sizeof(maxs));
	memset(prems,0,sizeof(prems));
	memset(size,0,sizeof(size));
	memset(f,0,sizeof(f));
	memset(a,0,sizeof(a));
	memset(b,0,sizeof(b));
}
void addedge(int u,int v)
{
	tot++;
	edge[tot].v=v;
	edge[tot].nxt=head[u];
	head[u]=tot;
}
void dfs(int u,int fa)
{
	size[u]=1;f[u]=fa;
	for(int i=head[u];i;i=edge[i].nxt)
	{
		int v=edge[i].v;
		if(v==fa)continue;
		dfs(v,u);size[u]+=size[v];
		if(size[v]>maxs[u])
			prems[u]=maxs[u],maxi[u]=v,maxs[u]=size[v];
		else if(size[v]>prems[u]) prems[u]=size[v];
	}
}
long long ans=0;
void dfs2(int u,int fa)
{
	for(int i=head[u];i;i=edge[i].nxt)
	{
		int v=edge[i].v;
		if(v==fa)continue;
		dfs2(v,u);
	}
	int r=size[1]-2*maxs[u];
	for(int j=1;j<=r;j++)
		ans=ans+u*a[j];
	if(maxi[u]!=fa)
	{
		int l=max(2*maxs[u]-size[1],r+1),r2=min(size[u],size[1]-2*prems[u]);
		for(int j=l;j<=r2;j++)
			ans=ans+u*a[j];
	}
	a[size[u]]++;
}
void dfs3(int u,int fa)
{
	b[size[1]-size[u]]++;
	for(int i=head[u];i;i=edge[i].nxt)
	{
		int v=edge[i].v;
		if(v==fa)continue;
		b[size[v]]++;
	}
	for(int i=head[u];i;i=edge[i].nxt)
	{
		int v=edge[i].v;
		if(v==fa)continue;
		b[size[v]]--;dfs3(v,u);b[size[v]]++;
	}
	if(maxi[u]==fa)
	{
		int l=2*maxs[u]-size[1],r2=size[1]-2*prems[u];
		for(int j=l;j<=r2;j++)
			ans=ans+u*b[j];
	}
	else
	{
		int r=size[1]-2*maxs[u];
		for(int j=1;j<=r;j++)
			ans=ans+u*b[j];
	}
	b[size[1]-size[u]]--;
	for(int i=head[u];i;i=edge[i].nxt)
	{
		int v=edge[i].v;
		if(v==fa)continue;
		b[size[v]]--;
	}
}
signed main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;cin>>T;
	while(T--)
	{
		ans=0;init();
		int n;scanf("%d",&n);
		for(int i=1;i<n;i++)
		{
			int u,v;scanf("%d%d",&u,&v);
			addedge(u,v);addedge(v,u);
		}
		dfs(1,0);
		for(int i=2;i<=n;i++)
			if(size[1]-size[i]>maxs[i])
				prems[i]=maxs[i],maxi[i]=f[i],maxs[i]=size[1]-size[i];
			else if(size[1]-size[i]>prems[i]) prems[i]=size[1]-size[i];
		dfs2(1,0);
		//for(int i=1;i<=n/2;i++)
		//	swap(a[i],a[n-i]);
		dfs3(1,0);
		cout<<ans<<endl;
	}
	return 0;
}
