#include <bits/stdc++.h>
using namespace std;

#define rep(i, n) for(int i = 0; i < (n); i ++)
#define rep1(i, n) for(int i = 1; i <= (n); i ++)
typedef long long LL;
typedef pair<int, int> PII;

struct segt
{
	int dat[1048576];
	void clear()
	{
		memset(dat, 0, sizeof(dat));
	}
	
	void add(int pos, int val)
	{
		pos += 524288;
		while(pos > 0) {
			dat[pos] += val;
			pos >>= 1;
		}
	}
	
	int query(int l, int r)
	{
		l = max(l, 0);
		if(l > r) return 0;
		int ret = 0;
		l += 524288; r += 524288;
		while(l < r) {
			if(l & 1) ret += dat[l];
			if(!(r & 1)) ret += dat[r];
			l = l + 1 >> 1;
			r = r - 1 >> 1; 
		}
		if(l == r) ret += dat[l];
		return ret;
	}
}tre;

int n;
vector<int> G[300005];
int siz[300005], dfn[300005], dfr[300005], seq[300005], cnt;
int ql[2000005], qr[2000005], qw[2000005], qcnt;
vector<int> qs[300005];

void addq(int pos, int l, int r, int wei)
{
	ql[qcnt] = l;
	qr[qcnt] = r;
	qw[qcnt] = wei;
	qs[pos].push_back(qcnt ++);
}

void init_dfs(int v, int par)
{
	siz[v] = 1;
	dfn[v] = cnt;
	seq[cnt ++] = v;
	rep(i, G[v].size()) {
		int u = G[v][i];
		if(u == par) continue;
		init_dfs(u, v);
		siz[v] += siz[u];
	}
	dfr[v] = cnt - 1;
}

LL ans;
void sol_dfs(int v, int par)
{
	rep(i, G[v].size()) {
		int u = G[v][i];
		if(u == par) continue;
		tre.add(n - siz[u], 1);
		tre.add(siz[v], -1);
		sol_dfs(u, v);
		tre.add(n - siz[u], -1);
		tre.add(siz[v], 1);
	}
	
	int ssz = n, msz = 0, msz1 = 0;
	rep(i, G[v].size()) {
		int u = G[v][i], usz = u == par ? n - siz[v] : siz[u];
		if(usz > msz) {
			msz1 = msz;
			msz = usz;
		} else if(usz > msz1) msz1 = usz;
	}
	rep(i, G[v].size()) {
		int u = G[v][i], usz = u == par ? n - siz[v] : siz[u];
		int lb = 0, rb = 0;
		if(usz == msz) {
			lb = 2 * msz - ssz; rb = ssz - 2 * msz1;
		} else rb = ssz - 2 * msz;
		if(u == par) {
			addq(0, lb, rb, v);
			addq(dfn[v], lb, rb, -v);
			addq(dfr[v] + 1, lb, rb, v);
			ans += 1LL * v * tre.query(lb, rb);
		} else {
			addq(dfn[u], lb, rb, v);
			addq(dfr[u] + 1, lb, rb, -v);
		}
	}
}

void solve()
{
	scanf("%d", &n);
	rep1(i, n) G[i].clear();
	rep(i, n - 1) {
		int u, v;
		scanf("%d%d", &u, &v);
		G[u].push_back(v);
		G[v].push_back(u);
	}
	
	cnt = 0;
	init_dfs(1, -1);
	
	tre.clear();
	qcnt = 0;
	rep(i, n + 1) qs[i].clear();
	ans = 0;
	sol_dfs(1, -1);
	
	for(int i = n - 1; i >= 0; i --) {
		tre.add(siz[seq[i]], 1);
		rep(j, qs[i].size()) {
			int cq = qs[i][j];
			ans += 1LL * qw[cq] * tre.query(ql[cq], qr[cq]);
		}
	}
	
	printf("%lld\n", ans);
}

int main()
{
#ifndef NON_FILE_IO
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
#endif
	int T;
	scanf("%d", &T);
	while(T --) solve();
	return 0;
}
