#include <bits/stdc++.h>
using namespace std;

#define rep(i, n) for(int i = 0; i < (n); i ++)
#define rep1(i, n) for(int i = 1; i <= (n); i ++)
typedef long long LL;
typedef pair<int, int> PII;

const LL INF = 0x3f3f3f3f3f3f3f3f;

int n, tp;
int a[500005];

namespace gao
{
	const int BASE = 1000000000;
	struct bigint
	{
		LL dat[4];
		bigint()
		{
			memset(dat, 0, sizeof(dat));
		}
	}ans;
	
	void add_sqr(bigint& a, LL x)
	{
		LL c0 = x % BASE, c1 = x / BASE;
		a.dat[0] += c0 * c0;
		a.dat[1] += 2 * c0 * c1;
		a.dat[2] += c1 * c1;
		rep(i, 3) {
			a.dat[i + 1] += a.dat[i] / BASE;
			a.dat[i] %= BASE;
		}
	}
	
	LL psum[40000005];
	int dp[40000005];
	int que[40000005], rr;
	
	void solve(bool tp)
	{
		if(!tp) rep(i, n) psum[i + 1] = psum[i] + a[i];
		
		dp[0] = 0;
		que[0] = 0;
		rr = 1;
		int cpos = 0;
		rep1(i, n) {
			cpos = min(cpos, rr - 1);
			while(cpos + 1 < rr) {
				int c0 = que[cpos + 1];
				if(psum[c0] * 2 - psum[dp[c0]] > psum[i]) break;
				cpos ++;
			}
			dp[i] = que[cpos];
			while(rr > 0) {
				int c0 = que[rr - 1];
				if(psum[c0] * 2 - psum[dp[c0]] < psum[i] * 2 - psum[dp[i]]) break;
				rr --;
			}
			que[rr ++] = i;
		}
		
		for(int i = n; i != 0; i = dp[i])
		add_sqr(ans, psum[i] - psum[dp[i]]);
		
		for(int i = 3; i >= 0; i --) if(ans.dat[i] != 0) {
			printf("%d", (int)ans.dat[i]);
			for(int j = i - 1; j >= 0; j --) printf("%09d", (int)ans.dat[j]);
			printf("\n");
			return;
		}
		printf("0\n");
	}
}

namespace rng
{
	int x, y, z, m, b1, b2;
	int p[100005], l[100005], r[100005];
	
	void gen_b()
	{
		rep1(i, m) for(int j = p[i - 1] + 1; j <= p[i]; j ++) {
			int ca = b1 % (r[i] - l[i] + 1) + l[i];
			int b3 = (1LL * x * b2 + 1LL * y * b1 + z) & (1 << 30) - 1;
			b1 = b2;
			b2 = b3;
			gao::psum[j] = gao::psum[j - 1] + ca;
		}
	}
}

int main()
{
#ifndef NON_FILE_IO
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
#endif
	scanf("%d%d", &n, &tp);
	if(tp == 0) rep(i, n) scanf("%d", &a[i]);
	else {
		scanf("%d%d%d%d%d%d", &rng::x, &rng::y, &rng::z, &rng::b1, &rng::b2, &rng::m);
		rep1(i, rng::m) scanf("%d%d%d", &rng::p[i], &rng::l[i], &rng::r[i]);
		rng::gen_b();
	}
	
	gao::solve(tp);
	return 0;
}
