#include<bits/stdc++.h>
using namespace std;

#define rep(i,n) for(int i=0;i<(n);i++)
#define REP(i,n) for(int i=1;i<=(n);i++)
#define mp make_pair
#define pb push_back
#define fst first
#define snd second
typedef long long ll;
typedef pair<int,int> pii;

namespace Io{
	const int size=1<<22|1;
	char iBuf[size],*iS,*iT,c;
	#define getc() (iS==iT?(iT=iBuf+fread(iS=iBuf,1,size,stdin),(iS==iT?EOF:(*iS++))):(*iS++))
	template<class T>void qread(T &x){
		int f=1;
		for(c=getc();c<'0'||c>'9';c=getc())
			if(c=='-')f=-1;
		for(x=0;c>='0'&&c<='9';c=getc())
			x=(x<<3)+(x<<1)+(c&15);
		x*=f;
	}
}

const int maxn=300005;
const int mlog=20;
int test,n,tot,rt,mx1,mx2;
int head[maxn],nxt[maxn*2],to[maxn*2];
int sz[maxn],par[maxn],go[maxn][mlog],u[maxn],v[maxn];
ll ans;
void addedge(int u,int v){
	tot++;
	nxt[tot]=head[u];
	to[tot]=v;
	head[u]=tot;
} 

void brute_sz(int x,int p){
	sz[x]=1;
	for(int i=head[x];i;i=nxt[i]){
		int y=to[i];
		if(y==p)continue;
		brute_sz(y,x);
		sz[x]+=sz[y];
	}
}
void brute_rt(int x,int p,int tot){
	int mx=tot-sz[x];
	for(int i=head[x];i;i=nxt[i]){
		int y=to[i];
		if(y==p)continue;
		brute_rt(y,x,tot);
		mx=max(mx,sz[y]); 
	}
	if(mx<=tot/2)ans+=x;
}

void calc_rt(int x,int p){
	sz[x]=1;
	int mx=0;
	for(int i=head[x];i;i=nxt[i]){
		int y=to[i];
		if(y==p)continue;
		calc_rt(y,x);
		mx=max(mx,sz[y]);
		sz[x]+=sz[y];
	}
	mx=max(mx,n-sz[x]);
	if(mx<=n/2)rt=x;
}
void calc_go(int x,int p){
	par[x]=p;
	sz[x]=1;
	rep(j,mlog)go[x][j]=0;
	for(int i=head[x];i;i=nxt[i]){
		int y=to[i];
		if(y==p)continue;
		calc_go(y,x);
		sz[x]+=sz[y];
		if(!go[x][0]||sz[y]>sz[go[x][0]])
			go[x][0]=y;
	}
	REP(j,mlog-1)go[x][j]=go[go[x][j-1]][j-1];
}
void calc_ans(int f,int x,int p){
	int cur=x;
	for(int j=mlog-1;j>=0;j--){
		int now=go[cur][j];
		if(now&&2*sz[now]>=sz[x])cur=now;
	}
	if(cur&&2*sz[cur]>=sz[x])ans+=cur;
	if(cur!=x&&par[cur]&&2*sz[par[cur]]>=sz[x]&&sz[cur]<=sz[x]/2)ans+=par[cur];
	if(f!=mx1)cur=mx1;
	else cur=mx2;
	if(max(sz[cur],sz[f]-sz[x])<=(n-sz[x])/2)ans+=rt;
	for(int j=mlog-1;j>=0;j--){
		int now=go[cur][j];
		if(now&&2*sz[now]>=n-sz[x])cur=now;
	}
	if(cur&&2*sz[cur]>=n-sz[x])ans+=cur;
	if(par[cur]!=rt&&par[cur]&&2*sz[par[cur]]>=n-sz[x]&&sz[cur]<=(n-sz[x])/2)ans+=par[cur];
	for(int i=head[x];i;i=nxt[i]){
		int y=to[i];
		if(y==p)continue;
		calc_ans(f,y,x);
	}
}

int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	Io::qread(test);
	while(test--){
		Io::qread(n);
		tot=mx1=mx2=ans=0;
		REP(i,n)head[i]=0;
		REP(i,n-1){
			Io::qread(u[i]);Io::qread(v[i]);
			addedge(u[i],v[i]);
			addedge(v[i],u[i]);
		}
		if(n<=2000){
			REP(i,n-1){
				brute_sz(u[i],v[i]);
				brute_rt(u[i],v[i],sz[u[i]]);
				brute_sz(v[i],u[i]);
				brute_rt(v[i],u[i],sz[v[i]]);
			}
			printf("%lld\n",ans);
			continue; 
		}
		calc_rt(1,0);
		calc_go(rt,0);
		for(int i=head[rt];i;i=nxt[i]){
			int y=to[i];
			if(sz[y]>=sz[mx1]){
				mx2=mx1;
				mx1=y;
			}
			else if(sz[y]>sz[mx2])mx2=y;
		}
		for(int i=head[rt];i;i=nxt[i])
			calc_ans(to[i],to[i],rt);
		printf("%lld\n",ans);
	}
	return 0;
}
