#include <bits/stdc++.h>
#define _rep(i, x, y) for(int i = x; i <= y; i++)
#define _per(i, x, y) for(int i = x; i >= y; i--)
#define LL long long
#define ULL unsigned long long
#define LD long double
using namespace std;
template <typename T>
inline void read(T &x) {
	x = 0; T f = (T) 1;
	char c = getchar();
	for(; !isdigit(c); c = getchar()) {
		if(c == '-') f = -f;
	}
	for(; isdigit(c); c = getchar()) x = x * 10 + c - '0';
	x *= f;
}
template <typename T>
inline void write(T x) {
	if(x < 0) {x = -x; putchar('-');}
	if(x > 9) write(x / 10);
	putchar(x % 10 + '0');
}
template <typename T>
inline void writesp(T x, char sp = '\n') {
	write(x); putchar(sp);
}
void file(string s) {
	freopen((s + ".in").c_str(), "r", stdin);
	freopen((s + ".out").c_str(), "w", stdout);
}
const int maxN = 299995 + 5;
int T, n;
struct Edge {
	int to, nxt;
} edge[maxN << 1];
int head[maxN], sz = 0;
void add_edge(int u, int v) {
	edge[++sz].to = v; edge[sz].nxt = head[u]; head[u] = sz;
}
int perm[49999];
bool chain = true;
int lx, ly;
int main() {
	file("centroid");
	read(T);
	while(T--) {
		memset(perm, 0, sizeof(perm));
		chain = true; lx = 0; ly = 0;
		read(n);
		_rep(i, 1, n - 1) {
			int x, y; read(x); read(y);
			perm[i] = x; perm[i + 1] = y;
			add_edge(x, y); add_edge(y, x);
			if(ly) chain = chain & (ly == x);
			ly = y;
		}
		if(chain) {
			LL ans = 0;
			_rep(i, 1, n - 1) {
				if(i % 2 == 0) {
					ans = (ans + perm[i / 2] + perm[i / 2 + 1]);
				} else {
					ans = (ans + perm[i / 2 + 1]);
				}
				int gap = (n - i) / 2;
				if((n - i) % 2 == 0) {
					ans = (ans + perm[i + 1 + gap - 1] + perm[i + 1 + gap]);
				} else {
					ans = (ans + perm[i + 1 + gap]);
				}
			}
			writesp(ans);
		}
	}
	return 0;
}

