#include<cstring>
#include<cstdio>
#include<vector>

const int
	MAXN = 6e5 + 10;
	
int
	T,n,ed,u[MAXN],v[MAXN],fst[MAXN],nxt[MAXN];
	
long long
	ans;
	
bool
	deleted[MAXN],vis[MAXN];
	
std :: vector <int>
	nds;
	
int
	read(){
		int
			x = 0,c = 0;
		while(c < '0' || c > '9')
			c = getchar();
		while(c >= '0' && c <= '9')
			x = x * 10 + c - '0',
				c = getchar();
		return
			x;
	}

void addedge(int x,int y){
	ed++;
	u[ed] = x;
	v[ed] = y;
	nxt[ed] = fst[u[ed]];
	fst[u[ed]] = ed;
	ed++;
	u[ed] = y;
	v[ed] = x;
	nxt[ed] = fst[u[ed]];
	fst[u[ed]] = ed;
}

long long
	tree_size(int x,bool flg){
		long long
			res = 1;
		vis[x] = true;
		if (flg)
			nds.push_back(x);
		for(register int i = fst[x];i != -1;i = nxt[i])
			if (!deleted[i] && !vis[v[i]]){
				res += tree_size(v[i],flg);
			}
		vis[x] = false;
		return
			res;
	}

long long
	calc(int x){
		nds.clear();
		long long
			ts = tree_size(x,true),
			res = 0;
		for(register int i = 0;i < nds.size();i++){
			bool
				able = true;
			for(register int j = fst[nds[i]];able && j != -1;j = nxt[j])
				if (!deleted[j]){
					deleted[(j - 1) / 2 * 2 + 1] = deleted[(j - 1) / 2 * 2 + 2] = true;
					if (tree_size(v[j],false) > ts / 2)
						able = false;
					deleted[(j - 1) / 2 * 2 + 1] = deleted[(j - 1) / 2 * 2 + 2] = false;
				}
			if (able)
				res += nds[i];
		}
		return
			res;
	}

int
	main(){
		freopen("centroid.in","r",stdin);
		freopen("centroid.out","w",stdout);
		T = read();
		while(T--){
			memset(fst,255,sizeof fst);
			ans = ed = 0;
			n = read();
			for(register int i = 1;i < n;i++)
				addedge(read(),read());
			for(register int i = 1;i < n;i++){
				deleted[i * 2] = deleted[i * 2 - 1] = true;
				ans += calc(u[i * 2]) + calc(v[i * 2]);
				deleted[i * 2] = deleted[i * 2 - 1] = false;
			}
			printf("%lld\n",ans);
		}
		return
			0;
	}

