#include <bits/stdc++.h>
#define pb push_back
#define pii pair<int, int>
#define fi first
#define se second
typedef long long LL;
const int MAXN = 100;
const int MAXM = 2000;
const int P = 998244353;
using namespace std;

inline int read() {
  int x = 0, w = 1; char c = getchar();
  while (!isdigit(c)) {
    if (c == '-') w = -1;
    c = getchar();
  }
  while (isdigit(c)) {
    x = (x << 1) + (x << 3) + (c ^ 48);
    c = getchar();
  }
  return x * w;
}

void enableFileIO() {
  freopen("meal.in", "r", stdin);
  freopen("meal.out", "w", stdout);
}

int n, m, a[MAXN + 5][MAXM + 5];

void init() {
  enableFileIO();
  
  n = read(), m = read();
  for (int i = 1; i <= n; ++i) {
    for (int j = 1; j <= m; ++j) {
      a[i][j] = read();
    }
  }
}

/*
namespace task1 {

const int MAXN = 40;
const int MAXM = 500;

int dp[MAXN + 5][MAXN  + 5][MAXN + 5][MAXN + 5], cnt[MAXM + 5];
int k;

int dfs(int i, int sum_i, int j, int cnt_j) {
  //if (sum_i == 3) cout << j << ' ' << cnt_j << ' ' << cnt[j] << endl;
  if (cnt_j > k / 2) return 0;
  if (i > n) {
    //cout << sum_i << endl;
    if (sum_i == k) return 1;
    return 0;
  }
  
  //if (~dp[i][sum_i][j][cnt_j]) return dp[i][sum_i][j][cnt_j];
  
  int ret = dfs(i + 1, sum_i, j, cnt_j);
  
  for (int x = 1; x <= m; ++x) {
    if (!a[i][x]) continue;
    
    int nxt_mx = j;
    ++cnt[x]; if (cnt[x] > cnt[nxt_mx]) nxt_mx = x;
    
    ret = (ret + dfs(i + 1, sum_i + 1, nxt_mx, cnt[nxt_mx]) * a[i][x]);
    --cnt[x];
  }
  
  return dp[i][sum_i][j][cnt_j] = ret;
}
void solve() {
  int ans = 0;
  
  for (k = 2; k <= n; ++k) {
    memset(dp, -1, sizeof(dp));
    ans += dfs(1, 0, 1, 0); 
    //cout << ans << endl;
  }
  printf("%d\n", ans);
}

}
*/
namespace task2 {
  
int cnt[MAXN + 5];
LL ans;

void dfs(int i, int mx, int sum, LL p) {
  if (mx > n / 2) return;
  if (i > n) {
    if (mx <= sum / 2 && sum >= 1) ans = (ans + p) % P;
    return;
  }
  
  dfs(i + 1, mx, sum, p);
  
  for (int x = 1; x <= m; ++x) {
    if (!a[i][x]) continue;
    int nxt_mx = mx;
    ++cnt[x]; if (cnt[x] > nxt_mx) nxt_mx = cnt[x];
    
    dfs(i + 1, nxt_mx, sum + 1, p * a[i][x] % P);
    
    --cnt[x];
  }
}

void solve() {
  ans = 0;
  dfs(1, 0, 0, 1);
  cout << ans << endl;
}

}

namespace task1 {

const int MAXN = 40;
int dp[MAXN + 5][MAXN + 5][MAXN + 5];

int dfs(int i, int sum0, int sum1) {
  int sumi = sum0 + sum1;
  if (i > n) {
    if (sumi > 1 && sum0 <= sumi / 2 && sum1 <= sumi / 2) return 1;
    return 0;
  }
  int &ret = dp[i][sum0][sum1];
  if (~ret) return ret;
  
  ret = dfs(i + 1, sum0, sum1);
  ret = (ret + 1LL * dfs(i + 1, sum0 + 1, sum1) * a[i][1] % P) % P;
  ret = (ret + 1LL * dfs(i + 1, sum0, sum1 + 1) * a[i][2] % P) % P;  
  return ret;
}

void solve() {
  memset(dp, -1, sizeof(dp));
  printf("%d\n", dfs(1, 0, 0));
}

}

namespace task3 {

const int MAXN = 40;
int dp[MAXN + 5][MAXN + 5][MAXN + 5][MAXN + 5];

int dfs(int i, int sum0, int sum1, int sum2) {
  int sumi = sum0 + sum1 + sum2;
  if (i > n) {
    if (sumi > 1 && sum0 <= sumi / 2 && sum1 <= sumi / 2 && sum2 <= sumi / 2) return 1;
    return 0;
  }
  int &ret = dp[i][sum0][sum1][sum2];
  if (~ret) return ret;
  
  ret = dfs(i + 1, sum0, sum1, sum2);
  ret = (ret + 1LL * dfs(i + 1, sum0 + 1, sum1, sum2) * a[i][1] % P) % P;
  ret = (ret + 1LL * dfs(i + 1, sum0, sum1 + 1, sum2) * a[i][2] % P) % P;
  ret = (ret + 1LL * dfs(i + 1, sum0, sum1, sum2 + 1) * a[i][3] % P) % P;   
  return ret;
}

void solve() {
  memset(dp, -1, sizeof(dp));
  printf("%d\n", dfs(1, 0, 0, 0));
}

}

int main() {
  init();
    
  if (n * m <= 20) {
    task2::solve();
  } else if (m == 2) {
    task1::solve();
  } else if (m == 3) {
    task3::solve();
  }
   
  return 0;
}

