#include <bits/stdc++.h>
#define pb push_back
#define pii pair<int, int>
#define fi first
#define se second
typedef long long LL;
const int MAXN = 200000;
const LL INF = (1LL << 50);
using namespace std;

inline int read() {
  int x = 0, w = 1; char c = getchar();
  while (!isdigit(c)) {
    if (c == '-') w = -1;
    c = getchar();
  }
  while (isdigit(c)) {
    x = (x << 1) + (x << 3) + (c ^ 48);
    c = getchar();
  }
  return x * w;
}

void enableFileIO() {
  freopen("partition.in", "r", stdin);
  freopen("partition.out", "w", stdout);
}

int n, a[MAXN + 5];
LL s[MAXN + 5];

void init() {
  enableFileIO();
  
  n = read();
  int type = read();
  if (type == 0) {
    for (int i = 1; i <= n; ++i) {
      a[i] = read();
      s[i] = s[i - 1] + a[i];
    }
  }
}

namespace task1 {

const int MAXN = 400;
LL dp[MAXN + 5][MAXN + 5];

void solve() {
  memset(dp, 0x3f, sizeof(dp));
  
  dp[0][0] = 0;
  for (int i = 1; i <= n; ++i) {
    for (int j = 0; j <= i; ++j) {
      for (int k = 0; k <= j; ++k) {
        if (s[i] - s[j] >= s[j] - s[k]) {
          dp[i][j] = min(dp[i][j], dp[j][k] + s[i] * s[i] - 2 * s[i] * s[j] + s[j] * s[j]);
        } 
      }
    }
  } 
  
  LL ans = INF;
  for (int i = 0; i < n; ++i) ans = min(ans, dp[n][i]);
  printf("%lld\n", ans);
}

}

int main() {
  init();
  
  if (n <= 400) {
    task1::solve();
  }
  
  return 0;
}

