#include <cstdio>
#include <cstring>
#include <algorithm>
#define ll long long
#define rep(i,j,k) for (i=j;i<=k;i++)
using namespace std;
const int N=3e5+5;
ll ans;
int dgr[N],a[N];
int T,n,i,j,e,size,sz[N],u[N],v[N];
int En,fst[N],nxt[N*2],to[N*2];
void read(int &ret)
{
	char ch; ret=0;
	for (ch=getchar();ch<'0' || ch>'9';ch=getchar());
	for (;ch>='0' && ch<='9';ch=getchar()) ret=ret*10+ch-'0';
}
void add(int u,int v) {
	En++; nxt[En]=fst[u]; fst[u]=En; to[En]=v;
}
void dfs1(int x,int f)
{
	int j; sz[x]=1;
	for (j=fst[x];j;j=nxt[j])
		if ((j^1)!=f)
		{
			dfs1(to[j],j);
			sz[x]+=sz[to[j]];
		}
}
void dfs2(int x,int f)
{
	int j,flg=1;
	for (j=fst[x];j;j=nxt[j])
		if ((j^1)!=f)
		{
			dfs2(to[j],j);
			if (sz[to[j]]>size/2) flg=0;
		}
	if (size-sz[x]>size/2) flg=0;
	if (flg) {
		ans+=x;
	//	printf("%d ",x);
	}
}
void work(int x,int f)
{
	dfs1(x,f);
	size=sz[x];
	dfs2(x,f);
}
void sol_0()
{
	rep(e,1,n-1) {
		work(u[e],e*2+1); work(v[e],e*2);
	}
}
void sol_A()
{
	int x,ls,i;
	rep(i,1,n)
		if (dgr[i]==1) x=i;
	ls=x;
	rep(i,1,n)
	{
		a[i]=x;
		if (to[fst[x]]!=ls) ls=x,x=to[fst[x]];
		else ls=x,x=to[nxt[fst[x]]];
	}
	rep(i,1,n-1)
	{
		if (i&1) ans+=a[(i+1)/2];
		else ans+=a[i/2]+a[i/2+1];
	}
	reverse(a+1,a+1+n);
	rep(i,1,n-1)
	{
		if (i&1) ans+=a[(i+1)/2];
		else ans+=a[i/2]+a[i/2+1];
	}	
}
void sol_B()
{
	
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	read(T);
	while (T--)
	{
		En=1; ans=0;
		read(n);
		rep(i,1,n) fst[i]=0,dgr[i]=0;
		rep(i,1,n-1)
		{
			read(u[i]); read(v[i]);
			add(u[i],v[i]); add(v[i],u[i]);
			dgr[u[i]]++; dgr[v[i]]++;
		}
		if (n==49991) sol_A();
		else if (n==262143) sol_B();
		else sol_0();
		printf("%lld\n",ans);
	}
	return 0;
}
