#include<bits/stdc++.h>

#define fec(i, x, y) (int i = head[x], y = g[i].to; i; i = g[i].ne, y = g[i].to)
#define dbg(...) fprintf(stderr, __VA_ARGS__)
#define File(x) freopen(#x".in", "r", stdin), freopen(#x".out", "w", stdout)
#define fi first
#define se second
#define pb push_back

template<typename A, typename B> inline bool smax(A &x, const B &y) { return x < y ? x = y, 1 : 0; }
template<typename A, typename B> inline bool smin(A &x, const B &y) { return y < x ? x = y, 1 : 0; }

typedef long long ll; typedef unsigned long long ull; typedef std::pair<int, int> pii;

template<typename I> inline void read(I &x) {
	int c, f = 0;
	while (!isdigit(c = getchar())) c == '-' ? f = -1 : 0;
	x = c & 15;
	while (isdigit(c = getchar())) x = (x << 1) + (x << 3) + (c & 15);
	f ? x = -x : 0;
}

const int N = 299995 + 7;
const int LOG = 19;

int n;
//int siz[N], f[N][LOG], dep[N];

struct Edge { int to, ne; } g[N << 1]; int head[N], tot;
inline void addedge(int x, int y) { g[++tot].to = y, g[tot].ne = head[x], head[x] = tot; }
inline void adde(int x, int y) { addedge(x, y), addedge(y, x); }

//struct Pair { int rt1, rt2; } dp[N];
//
//inline Pair operator + (const Pair &a, const Pair &b) {
//	
//}

//inline void dfs1(int x, int fa = 0) {
//	f[x][0] = fa, dep[x] = dep[fa] + 1;
//	for (int i = 1; i < LOG; ++i) f[x][i] = f[f[x][i - 1]][i - 1];
//	for fec(i, x, y) if (y != fa) dfs1(y, x), siz[x] += siz[y];
//}

namespace Task1 {
	inline bool istask() { return n <= 1999; }
	
	const int N = 1999 + 7;
	
	int sum, fb, fa[N], siz1[N], siz[N], rt1, rt2, mima;
	
	inline void dfs1(int x, int fa = 0) {
		siz1[x] = 1, Task1::fa[x] = fa;
		for fec(i, x, y) if (y != fa) dfs1(y, x), siz1[x] += siz1[y];
	}
	
	inline void dfs2(int x, int fa = 0) {
		siz[x] = 1;
		int f = 0;
		for fec(i, x, y) if (y != fa && y != fb) dfs2(y, x), siz[x] += siz[y], smax(f, siz[y]);
		smax(f, sum - siz[x]);
//		dbg("x = %d, f = %d\n", x, f);
		if (smin(mima, f)) mima = f, rt1 = x, rt2 = 0;
		else if (mima == f) rt2 = x;
	}
	
	inline void work() {
		dfs1(1);
		ll ans = 0;
		for (int i = 2; i <= n; ++i) {
//			dbg("********\n");
			mima = sum = siz1[i], rt1 = rt2 = 0, fb = 0, dfs2(i, fa[i]), ans += rt1 + rt2;//, dbg("i = %d, rt = %d, %d\n", i, rt1, rt2);
			mima = sum = siz1[1]  - siz1[i], fb = i, rt1 = rt2 = 0, dfs2(1), ans += rt1 + rt2;//, dbg("i = %d, rt = %d, %d\n", i, rt1, rt2);
		}
		printf("%lld\n", ans);
	}
}

namespace Task2 {
	int cnt = 1;
	int deg[N], p[N];
	
	inline bool istask() {
		memset(deg, 0, sizeof(*deg) * (n + 1));
		for (int x = 1; x <= n; ++x) for fec(i, x, y) ++deg[x], ++deg[y];
		int cnt = 0;
		for (int i = 1; i <= n; ++i) if ((deg[i] /= 2) > 2) return 0; else if (deg[i] == 1) ++cnt;
		return cnt == 2;
	}
	
	inline void dfs(int x, int fa = 0) {
//		dbg("x = %d, fa = %d\n", x, fa);
		for fec(i, x, y) if (y != fa) p[++cnt] = y, dfs(y, x);
	}
	
	inline void work() {
		cnt = 1;
		for (int i = 1; i <= n; ++i) if (deg[i] == 1) p[1] = i;
		assert(p[1]);
		dfs(p[1]);
//		dbg("cnt = %d\n", cnt);
		assert(cnt == n);
		ll ans = 0;
		for (int i = 1; i < n; ++i) {
			if (i & 1) ans += p[(i + 1) / 2];
			else ans += p[i / 2] + p[i / 2 + 1];
		}
		std::reverse(p + 1, p + n + 1);
		for (int i = 1; i < n; ++i) {
			if (i & 1) ans += p[(i + 1) / 2];
			else ans += p[i / 2] + p[i / 2 + 1];
		}
		printf("%lld\n", ans);
	}
}

namespace Task3 {
	int dfc, fb, rt1, rt2, mima, sum;
	int deg[N], rts[10], siz[N], rt, dfn[N];
	
	inline void dfs(int x, int fa = 0) {
		siz[x] = 1, dfn[x] = ++dfc;
		for fec(i, x, y) if (y != fa) dfs(y, x), siz[x] += siz[y];
	}
	
	inline int getsiz(int x) {
		if (x == fb) return siz[x];
		if (dfn[fb] >= dfn[x] && dfn[fb] <= dfn[x] + siz[x] - 1) return siz[x] - siz[fb];
		return siz[x];
	}
	
	inline void solve(int x) {
		rt1 = rt2 = 0;
		int fa = 0;
		while (x) {
			int f = sum - getsiz(x), son = 0, ff = 0;
			for fec(i, x, y) if (y != fa && y != fb && siz[y] < siz[x]) {
				smax(f, getsiz(y));
				if (getsiz(y) > ff) son = y, ff = getsiz(y);
			}
			if (smin(mima, f)) rt1 = x, rt2 = 0;
			else if (mima == f) rt2 = x;
//			dbg("x = %d, f = %d, ff = %d, son = %d, getsiz(x) = %d\n", x, f, ff, son, getsiz(3));
			fa = x, x = son;
		}
	}
	
	inline void work() {
		rts[0] = 0;
		memset(deg, 0, sizeof(*deg) * (n + 1));
		for (int x = 1; x <= n; ++x) for fec(i, x, y) ++deg[x], ++deg[y];
		for (int i = 1; i <= n; ++i) if ((deg[i] /= 2) == 2) rts[++rts[0]] = 1;
		if (rts[0] == 1) rt = rts[1], dfs(rt);
		else {
			dfs(rts[1]);
			if (siz[g[head[rts[1]]].to] != 1 && siz[g[head[rts[1]]].to] != n - 2) rt = rts[1];
			else rt = rts[2], dfs(rt);
		}
//		dbg("rt = %d\n", rts[0]);
		ll ans = 0;
		for (int i = 1; i <= n; ++i) if (i != rt) {
			fb = 0, sum = mima = siz[i], solve(i), ans += rt1 + rt2;//, dbg("*** i = %d, rt = %d, %d\n", i, rt1, rt2);
			fb = i, sum = mima = siz[rt] - siz[i], solve(1), ans += rt1 + rt2;//, dbg("*** i = %d, rt = %d, %d\n", i, rt1, rt2); 
		}
		printf("%lld\n", ans);
	}
}

inline void work() {
//	dfs1(1);
	if (Task1::istask()) Task1::work();
	else if (Task2::istask()) Task2::work();
	else Task3::work();
}

inline void cls() {
	memset(head, 0, sizeof(*head) * (n + 1));
	tot = 0;
}

inline void init() {
	read(n);
	cls();
	int x, y;
	for (int i = 1; i < n; ++i) read(x), read(y), adde(x, y);
}

int main() {
#ifdef hzhkk
	freopen("hkk.in", "r", stdin);
#else
	File(centroid);
#endif
	int T;
	read(T);
	while (T--) {
		init();
		work();
	}
	fclose(stdin), fclose(stdout);
	return 0;
}
