#include <bits/stdc++.h>
using namespace std;
const int SIZE=10005;
const int INF=0x3f3f3f3f;
#define ll long long
const int MOD=998244353;

int mu(int x,int y){return (x*y)%MOD;}
int ad(int x,int y){return (x+y)%MOD;}

int n,m,Ans=0;
int b[105][2005];

ll a[SIZE],ans[SIZE*4],tag[SIZE*4];

ll Ls(ll p){return p<<1;}
ll Rs(ll p){return p<<1|1;}

void pushup(ll p){ans[p]=ans[Ls(p)]+ans[Rs(p)];}
 
void build(ll p,ll L,ll R){
	ll mid=(L+R)>>1;
	if (L==R){ans[p]=a[L];return;}
	build(Ls(p),L,mid);
	build(Rs(p),mid+1,R);
	pushup(p);
	tag[p]=0;
}

void lazy(ll L,ll R,ll p,ll k){
	ans[p]+=(k*(R-L+1));
	tag[p]+=k;
}

void pushdown(ll L,ll R,ll p){
	ll mid=(L+R)>>1;
	lazy(L,mid,Ls(p),tag[p]);
	lazy(mid+1,R,Rs(p),tag[p]);
	tag[p]=0;
}
void add(ll L,ll R,ll l,ll r,ll p,ll k){
	if (L<=l && R>=r){
		ans[p]+=(k*(R-L+1));
		tag[p]+=k;
		return;
	}
	ll mid=(l+r)>>1;
	pushdown(l,r,p); 
	if (L<=mid) add(L,R,l,mid,Ls(p),k);
	if (R>mid)  add(L,R,mid+1,r,Rs(p),k);
	pushup(p);
}
ll query(ll L,ll R,ll l,ll r,ll p){
	if (L<=l && R>=r) return ans[p];
	ll mid=(l+r)>>1,ret=0;
	pushdown(l,r,p);
	if (L<=mid) ret+=query(L,R,l,mid,Ls(p));
	if (R>mid)  ret+=query(L,R,mid+1,r,Rs(p));
	return ret;
}

int work(int k){
	int retx=1,rety=1,xx=1,yy=1;
	for (int i=1;i<=k/2;i++){
		retx=mu(retx,query(xx,k,1,n,1));
		rety=mu(rety,query(yy,k,1,n,1));
		retx=mu(retx,query(1,xx,1,n,1));
		rety=mu(rety,query(1,yy,1,n,1));
	}
	return ad(retx,rety);
}

int main()
{
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);

	scanf("%d%d",&n,&m);
	for (int i=1;i<=n;i++){
		for (int j=1;j<=m;j++){
			scanf("%d",&b[i][j]);
			a[i]=ad(a[i],b[i][j]);
		}
	}
	build(1,1,n);
	for (int i=2;i<=n;i++){
		Ans=ad(Ans,work(i));
	}
	cout<<Ans<<endl;
	
	return 0;
}
