#include <bits/stdc++.h>
using namespace std;

const long long INF = 0x3f3f3f3f3f3f3f3f;

int a[500010];
long long dp[5010][5010];
long long minj[5010][5010];
long long sum[500010];
int n;

void solve1() {
	for (int i = 1; i <= n; i++) {
		sum[i] = sum[i - 1] + a[i];
	}
	memset(dp, 0x3f, sizeof(dp));
	for (int i = 1; i <= n; i++) {
		int k = 0;
		for (int j = 0; j < i; j++) {
			if (j == 0) dp[i][j] = sum[i] * sum[i];
			else {
				while (k < j && sum[j] - sum[k] > sum[i] - sum[j]) k++;
				dp[i][j] = j == k ? INF : minj[j][k] + (sum[i] - sum[j]) * (sum[i] - sum[j]);
				
			}
		}
		minj[i][i] = INF;
		for (int j = i - 1; j >= 0; j--) {
			minj[i][j] = min(minj[i][j + 1], dp[i][j]);
		}
	}
	long long ans = INF;
	for (int i = 0; i < n; i++) {
		ans = min(ans, dp[n][i]);
	}
	printf("%lld\n", ans);
}

long long ans;

long long dfs(int l, int r, long long last) {
	for (int i = r - 1; i >= l; i--) {
		if (sum[i] - sum[l - 1] >= last && sum[i] - sum[l - 1] <= sum[r] - sum[i]) {
			long long tmp = dfs(l, i, last);
			tmp = dfs(i + 1, r, tmp);
			ans += 2 * (sum[i] - sum[l - 1]) * (sum[r] - sum[i]);
			return tmp;
		}
	}
	return sum[r] - sum[l - 1];
}

int pos[500010], len;
long long sss[500010];

void solve2() {
	for (int i = 1; i <= n; i++) {
		sum[i] = sum[i - 1] + a[i];
	}
	long long last = 0, ans = 0;
	pos[len] = 1;
	for (int i = 1; i <= n; ) {
		int nxt = i;
		while (sum[nxt - 1] - sum[i - 1] < last) nxt++;
		sss[len++] = (sum[nxt - 1] - sum[i - 1]), pos[len] = nxt;
		i = nxt;
	}
	for (int i = len - 2; i >= 1; i--) {
		while (pos[i] < pos[i + 1] && (sss[i - 1] + a[i]) < (sss[i] - a[i])) pos[i]++, sss[i - 1] += a[i], sss[i] -= a[i];
	}
	for (int i = 0; i < len; i++) {
		ans += sss[i] * sss[i];
	}
	printf("%lld\n", ans);
}

int main() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	int type; scanf("%d%d", &n, &type);
	if (type == 0) {
		for (int i = 1; i <= n; i++) {
			scanf("%d", &a[i]);
		}
	}
	if (n <= 5000) solve1();
	else solve2();
	return 0;
}

