#include<bits/stdc++.h>
using namespace std;

const int N=105;
const int M=2005;
const int MOD=998244353;
int n,m,ans;
int a[N][M];
int t[N];
int dp1[N][N];
int dp2[N][N][N];
int dp3[N][N*2];

inline void add(int &x,int y){
	x+=y;
	if(x>=MOD) x-=MOD;
	if(x<0) x+=MOD;
}

void solve1(){
	dp1[0][0]=1;
	for(int i=0;i<n;i++) for(int j=0;j<=n;j++) if(dp1[i][j]!=0){
		add(dp1[i+1][j],dp1[i][j]);
		add(dp1[i+1][j+1],1ll*dp1[i][j]*t[i+1]%MOD);
	}
	for(int i=1;i<=n;i++) add(ans,dp1[n][i]);
	for(int i=1;i<=m;i++){
		memset(dp2,0,sizeof(dp2));
		dp2[0][0][0]=1;
		for(int j=0;j<n;j++) for(int k=0;k<=n;k++) for(int l=0;l<=n;l++) if(dp2[j][k][l]!=0){
			add(dp2[j+1][k+1][l+1],1ll*dp2[j][k][l]*a[j+1][i]%MOD);
			add(dp2[j+1][k+1][l],1ll*dp2[j][k][l]*((t[j+1]-a[j+1][i]+MOD)%MOD)%MOD);
			add(dp2[j+1][k][l],dp2[j][k][l]);
		}
		for(int j=1;j<=n;j++) for(int k=j/2+1;k<=j;k++) add(ans,-dp2[n][j][k]);
	}
	printf("%d\n",ans);
}

void solve2(){
	dp1[0][0]=1;
	for(int i=0;i<n;i++) for(int j=0;j<=n;j++) if(dp1[i][j]!=0){
		add(dp1[i+1][j],dp1[i][j]);
		add(dp1[i+1][j+1],1ll*dp1[i][j]*t[i+1]%MOD);
	}
	for(int i=1;i<=n;i++) add(ans,dp1[n][i]);
	for(int i=1;i<=m;i++){
		memset(dp3,0,sizeof(dp3));
		dp3[0][N]=1;
		for(int j=0;j<n;j++) for(int k=-n+N;k<=n+N;k++) if(dp3[j][k]!=0){
			add(dp3[j+1][k+1],1ll*dp3[j][k]*a[j+1][i]%MOD);
			add(dp3[j+1][k-1],1ll*dp3[j][k]*((t[j+1]-a[j+1][i]+MOD)%MOD)%MOD);
			add(dp3[j+1][k],dp3[j][k]);
		}
		for(int j=1+N;j<=n+N;j++) add(ans,-dp3[n][j]);
	}
	printf("%d\n",ans);
}

int main(){
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);
	scanf("%d%d",&n,&m);
	for(int i=1;i<=n;i++){
		for(int j=1;j<=m;j++){
			scanf("%d",&a[i][j]);
			t[i]=(1ll*t[i]+a[i][j])%MOD;
		}
	}
	if(n<=40&&m<=500) solve1();
	else solve2();
	return 0;
}
