#include<bits/stdc++.h>
using namespace std;

const int N=1e5+5;
const int N1=5005;
const long long INF=4000000000000000000ll;
int n,tp;
int a[N],sum[N];
long long dp[N1][N1];
long long ans;

inline long long m2(int x){return 1ll*x*x;}

struct Tree{
	Tree *left_child,*right_child;
	int left,right;
	long long val;
}*rt[N1];

void build(Tree *pos,int x,int y){
	pos->left=x;pos->right=y;pos->val=INF;
	if(x==y) return;
	int mid=(x+y)>>1;
	pos->left_child=new Tree();
	pos->right_child=new Tree();
	build(pos->left_child,x,mid);
	build(pos->right_child,mid+1,y);
}

void modify(Tree *pos,int x,long long v){
	if(pos->left>=x&&pos->right<=x){
		pos->val=min(v,pos->val);
		return;
	}
	if(pos->left>x||pos->right<x) return;
	modify(pos->left_child,x,v);
	modify(pos->right_child,x,v);
	pos->val=min(pos->left_child->val,pos->right_child->val);
}

long long query(Tree *pos,int x,int y){
	if(pos->left>=x&&pos->right<=y) return pos->val;
	if(pos->left>y||pos->right<x) return INF;
	return min(query(pos->left_child,x,y),query(pos->right_child,x,y));
}

void solve1(){
	ans=INF;
	for(int i=0;i<=n;i++) for(int j=0;j<=n;j++) dp[i][j]=INF;
	for(int i=1;i<=n;i++) dp[0][i]=m2(sum[i]);
	for(int i=0;i<=n;i++) for(int j=i+1;j<=n;j++) if(dp[i][j]!=0ll) for(int k=j+1;k<=n;k++) if(sum[k]-sum[j]>=sum[j]-sum[i]) dp[j][k]=min(dp[j][k],dp[i][j]+m2(sum[k]-sum[j]));
	for(int i=0;i<n;i++) ans=min(ans,dp[i][n]);
	printf("%lld\n",ans);
}

void solve2(){
	for(int i=0;i<=n;i++) for(int j=0;j<=n;j++) dp[i][j]=INF;
	for(int i=1;i<=n;i++){
		rt[i]=new Tree();
		build(rt[i],0,i-1);
		dp[0][i]=m2(sum[i]);
		modify(rt[i],0,dp[0][i]);
	}
	for(int i=1;i<=n;i++) for(int j=i+1;j<=n;j++){
		int sm=sum[j]-sum[i];
		int l=0,r=i-1;
		while(l<=r){
			int mid=(l+r)/2;
			if(sum[i]-sum[mid]>sm) l=mid+1;
			else r=mid-1;
		}
		r++;
		if(r<=i-1) dp[i][j]=query(rt[i],r,i-1)+m2(sm);
		modify(rt[j],i,dp[i][j]);
	}
	ans=INF;
	for(int i=0;i<n;i++) ans=min(ans,dp[i][n]);
	printf("%lld\n",ans);
}

int main(){
	freopen("partition.in","r",stdin);
	freopen("partition.out","w",stdout);
	scanf("%d%d",&n,&tp);
	for(int i=1;i<=n;i++){
		scanf("%d",a+i);
		sum[i]=sum[i-1]+a[i];
	}
	if(n<=400) solve1();
	else solve2();
	return 0;
}
