#include <bits/stdc++.h>
#define For(i, a, b) for(int i = (a); i <= (b); ++i)
#define Rof(i, a, b) for(int i = (a); i >= (b); --i)
#define INF 0x3f3f3f3f
#define LL long long
#define MaxN 600001
using namespace std;
int N, T, Head[MaxN], Cnt;
LL Ans;
struct Xjh {int Ver, Next; bool Ban;} E[MaxN << 1];
void Add_Edge(int u, int v) {E[++Cnt].Ver = v, E[Cnt].Next = Head[u], Head[u] = Cnt;} 

int Siz[MaxN], P[MaxN], MaxP, NN;
bool Col[MaxN];
void Dfs(int u, int f) {
	Siz[u] = 1;
	Col[u] = 1;
	for(int i = Head[u]; i; i = E[i].Next) {
		int v = E[i].Ver;
		if(v == f) continue;
		if(E[i].Ban) continue;
		Dfs(v, u);
		P[u] = max(P[u], Siz[v]);
		Siz[u] += Siz[v];
	}
}
void Work_40() {
	Ans = 0;
	For(i, 1, N - 1) {
		E[(i << 1)].Ban = E[(i << 1) | 1].Ban = 1;
		memset(P, 0, sizeof(P)); MaxP = INF;
		memset(Col, 0, sizeof(Col));
		Dfs(E[(i << 1)].Ver, E[(i << 1)].Ver); NN = Siz[E[(i << 1)].Ver];
		For(j, 1, N) if(Col[j]) P[j] = max(P[j], NN - Siz[j]), MaxP = min(MaxP, P[j]);
		For(j, 1, N) if(Col[j] && P[j] == MaxP) Ans += j;
		
		memset(P, 0, sizeof(P)); MaxP = INF;
		memset(Col, 0, sizeof(Col));
		Dfs(E[(i << 1) | 1].Ver, E[(i << 1) | 1].Ver); NN = Siz[E[(i << 1) | 1].Ver];
		For(j, 1, N) if(Col[j]) P[j] = max(P[j], NN - Siz[j]), MaxP = min(MaxP, P[j]);
		For(j, 1, N) if(Col[j] && P[j] == MaxP) Ans += j;
		E[(i << 1)].Ban = E[(i << 1) | 1].Ban = 0;
	}
	printf("%lld\n", Ans);
}

int Degree[MaxN], Dfn[MaxN], FD[MaxN], Tim;
void Tar(int u, int f) {
	Dfn[u] = ++Tim;
	FD[Tim] = u;
	for(int i = Head[u]; i; i = E[i].Next)
		if(E[i].Ver != f) Tar(E[i].Ver, u); 
}
void Work_Line() {
	Tim = 0;
	Ans = 0;
	memset(Dfn, 0, sizeof(Dfn));
	memset(FD, 0, sizeof(FD));
	For(i, 1, N) if(Degree[i] == 1) {
		Tar(i, i);
		break;
	}
	For(i, 1, N - 1) {
		if(i & 1) Ans += FD[(i + 1) >> 1];
		else Ans += FD[i >> 1] + FD[(i >> 1) + 1];
		
		if((N - i) & 1) Ans += FD[((N - i + 1) >> 1) + i];
		else Ans += FD[((N - i) >> 1) + i] + FD[((N - i) >> 1) + i + 1];
	}
	printf("%lld\n", Ans);
}
int Depth[MaxN];
void DB(int u, int f) {
	Depth[u] = Depth[f] + 1;
	for(int i = Head[u]; i; i = E[i].Next)
		if(E[i].Ver != f) DB(E[i].Ver, u); 
}
void Work_B() {
	memset(P, 0, sizeof(P)); MaxP = INF;
	memset(Depth, 0, sizeof(Depth));
	Dfs(1, 1);
	int Root;
	For(i, 1, N) if(P[i] == ((N + 1) >> 1) - 1) Root = i;
	DB(Root, Root);
	Ans = 0;
	For(i, 1, N) 
		if(Depth[i] <= 2) Ans += 1ll * 131072 * i;
		else Ans += i;
	printf("%lld\n", Ans);
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	scanf("%d", &T);
	while(T--) {
		int u, v;
		memset(Degree, 0, sizeof(Degree));
		memset(Head, 0, sizeof(Head)); Cnt = 1;
		scanf("%d", &N); 
		For(i, 1, N - 1) scanf("%d%d", &u, &v), Add_Edge(u, v), Add_Edge(v, u), ++Degree[u], ++Degree[v];
		if(N <= 2000) {
			Work_40();
			continue;
		}
		bool Flag_Line = 1;
		For(i, 1, N) if(Degree[i] > 2) Flag_Line = 0;
		if(Flag_Line) {
			Work_Line();
			continue;
		}
		if(N == 262143) {
			Work_B();
			continue;
		}
	}
	fclose(stdin); fclose(stdout);
	return 0;
}
