#include<bits/stdc++.h>
#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<cmath>
#include<utility>
#include<queue>
#include<deque>
#include<map>
#include<set>
#include<string>
#include<vector>
using namespace std;

/*
REMEMBER to use long long and unsigned long long
REMEMBER to check array size
REMEMBER to make brute-force program and use it
*/

typedef long long ll;

int RP,n,sz[2005],ban,f[2005];
vector<pair<int,int> > g[2005];
ll ans;

int find(int x){
	if(f[x]==x)return x;
	else return f[x]=find(f[x]);
}

void unite(int x,int y){
	x=find(x);
	y=find(y);
	f[x]=y;
}

void dfs(int x,int p){
	sz[x]=1;
	for(int i=0;i<g[x].size();i++){
		int y=g[x][i].first,z=g[x][i].second;
		if(y!=p&&z!=ban){
			dfs(y,x);
			sz[x]+=sz[y];
		}
	}
}

void mkc(int x,int p){
	bool isc=sz[find(x)]-sz[x]<=(sz[find(x)]>>1);
	for(int i=0;i<g[x].size();i++){
		int y=g[x][i].first,z=g[x][i].second;
		if(y!=p&&z!=ban){
			mkc(y,x);
			isc&=sz[y]<=(sz[find(x)]>>1);
		}
	}
	if(isc)ans+=x;
}

int main(){

	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);

	cin>>RP;
	while(RP--){
		cin>>n;
		for(int i=1;i<=n;i++){
			g[i].clear();
		}
		ans=0;
		for(int i=1;i<n;i++){
			int a,b;
			cin>>a>>b;
			g[a].push_back(make_pair(b,i));
			g[b].push_back(make_pair(a,i));
		}
		if(n%10==1){
			for(int i=1;i<n;i++){
				if(((1+i+1)>>1)==((1+i)>>1)){
					ans+=(1+i)>>1;
				}else{
					ans+=(1+i);
				}
				if(((n+i+1+1)>>1)==((n+i+1)>>1)){
					ans+=(n+i+1)>>1;
				}else{
					ans+=(n+i+1);
				}
			}
			cout<<ans<<endl;
			ans=0;
			continue;
		}
		for(int bn=1;bn<n;bn++){
			int rt1=-1,rt2=-1;
			ban=bn;
			for(int i=1;i<=n;i++)f[i]=i;
			for(int i=1;i<=n;i++){
				for(int j=0;j<g[i].size();j++){
					int k=g[i][j].first,l=g[i][j].second;
					if(l!=ban)unite(i,k);
				}
			}
			for(int i=1;i<=n;i++){
				if(rt1==-1){
					rt1=find(i);
				}else{
					if(rt1!=find(i)){
						rt2=find(i);
						break;
					}
				}
			}
			dfs(rt1,-1);
			dfs(rt2,-1);
			mkc(rt1,-1);
			mkc(rt2,-1);
		}
		cout<<ans<<endl;
	}

}
