#include <bits/stdc++.h>
#define LL		long long
#define Maxn	300500
using namespace std;
template <typename tn> void read(tn &a){
	tn x = 0, f = 1; char c = getchar();
	for (; !isdigit(c); c = getchar()) if (c == '-') f = -1;
	for (; isdigit(c); c = getchar()) x = x * 10 + c - 48;
	a = x * f;
}
template <typename tn> void cmax(tn &x, tn y){ if (x < y) x = y; }

struct Enode{ int u, v; } E[Maxn];
struct Edge{ int v, next; } edge[Maxn * 2];
int first[Maxn];
int n, Top;

void addedge(int u, int v){
	edge[++Top] = (Edge) {v, first[u]}, first[u] = Top;
	edge[++Top] = (Edge) {u, first[v]}, first[v] = Top;
}

namespace BF{
	#define N		10050
	int siz[N], wgt[N], del[N];
	int cnt; LL Ans;
	void dfs(int u, int fa){
		cnt++;
		for (int i = first[u], v; i; i = edge[i].next)
			if ((v = edge[i].v) != fa && !del[i]) dfs(v, u);
	}
	void gans(int u, int fa, int tot){
		siz[u] = 1, wgt[u] = 0;
		for (int i = first[u], v; i; i = edge[i].next)
			if ((v = edge[i].v) != fa && !del[i])
				gans(v, u, tot), siz[u] += siz[v], cmax(wgt[u], siz[v]);
		cmax(wgt[u], tot - siz[u]);
		if (wgt[u] <= tot / 2) Ans += u;
	}
	void update(int rt1, int rt2){
		cnt = 0, dfs(rt1, 0), gans(rt1, 0, cnt);
		cnt = 0, dfs(rt2, 0), gans(rt2, 0, cnt);
	}
	LL solve(){
		Ans = 0;
		for (int i = 1; i < n; i++){ 
			del[i * 2] = del[i * 2 - 1] = true;
			update(E[i].u, E[i].v);
			del[i * 2] = del[i * 2 - 1] = false; 
		}
		return Ans;
	}
	#undef N
};

namespace lian{
	int deg[Maxn], id[Maxn];
	int rt, tim = 0; LL Ans;
	bool check(){
		memset(deg, 0, sizeof deg);
		for (int i = 1; i < n; i++)
			deg[E[i].u]++, deg[E[i].v]++;
		for (int i = 1; i <= n; i++)
			if (deg[i] == 1) rt = i;
			else if (deg[i] > 2) return false;
		return true;
	}
	void dfs(int u, int fa){
		id[++tim] = u;
		for (int i = first[u], v; i; i = edge[i].next)
			if ((v = edge[i].v) != fa) dfs(v, u);
	}
	int calc(int l, int r){
		int len = r - l + 1, mid = (l + r) / 2;
		if (len % 2 == 1) return id[mid];
		return id[mid] + id[mid + 1];
	}
	LL solve(){
		tim = Ans = 0, dfs(rt, 0);
		for (int i = 1; i < n; i++)
			Ans += calc(1, i) + calc(i + 1, n);
		return Ans;
	}
};

void Clear(){
	memset(first, 0, sizeof first), Top = 0;
}

LL Solve(){
	if (n <= 2500) return BF :: solve();
	if (lian :: check()) return lian :: solve();
}

int main(){
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int TEST; read(TEST);
	while (TEST--){
		read(n), Clear();
		for (int i = 1, u, v; i < n; i++){
			read(u), read(v), addedge(u, v);
			E[i] = (Enode) {u, v};
		}
		cout << Solve() << '\n';
	}
	return 0;
}
