#include <bits/stdc++.h>
#define LL		long long
#define Maxn	500500
using namespace std;
template <typename tn> void read(tn &a){
	tn x = 0, f = 1; char c = getchar();
	for (; !isdigit(c); c = getchar()) if (c == '-') f = -1;
	for (; isdigit(c); c = getchar()) x = x * 10 + c - 48;
	a = x * f;
}
void cmin(LL &x, LL y){ if (x > y) x = y; }

const LL inf = 6e18;

LL s[Maxn];
int a[Maxn];
int n, typ;

LL sum(int l, int r){ return s[r] - s[l - 1]; }

namespace DP{
	LL f[5050][5050], Ans;
	LL solve(){
		for (int r = 1; r <= n; r++)
			f[1][r] = s[r] * s[r];
		for (int l = 2; l <= n; l++){
			LL Min = inf, pos = l;
			for (int r = l; r <= n; r++){
				LL tmp = sum(l, r);
				while (pos > 1 && tmp >= sum(pos - 1, l - 1))
					cmin(Min, f[--pos][l - 1]);
				f[l][r] = (Min == inf ? inf : tmp * tmp + Min);
			}
		}
		Ans = inf;
		for (int l = 1; l <= n; l++)
			cmin(Ans, f[l][n]);
		return Ans;
	}
};

namespace Greedy{
	struct pnode{ int l, r; } p[Maxn];
	int cp; LL Ans;
	LL sqr(LL x){ return x * x; }
	LL func(int id){ return sqr(sum(p[id].l, p[id].r)); }
	LL calc(int l, int mid, int r){	return sqr(sum(l, mid)) + sqr(sum(mid + 1, r)); }
	bool Try(int l, int mid, int r){
		if (calc(l, mid, r) > calc(l, mid + 1, r)) return true;
		return rand() % 100000 <= 10000;
	}
	bool GO(){ return rand() % 1000000 < 0; }
	void greed1(){
		for (int i = 1; i < cp; ++i){
			int l = p[i].l, mid = p[i].r, r = p[i + 1].r;
			while (mid + 1 < r && sum(l, mid + 1) <= sum(mid + 2, r) && Try(l, mid, r)) mid++;
			Ans -= func(i) + func(i + 1);
			p[i].r = mid, p[i + 1].l = mid + 1;
			Ans += func(i) + func(i + 1);
		}
	}
	void greed2(){
		for (int i = cp; i; --i){
			int l = p[i - 1].l, mid = p[i - 1].r, r = p[i].r;
			while (mid + 1 < r && sum(l, mid + 1) <= sum(mid + 2, r) && Try(l, mid, r)) mid++;
			Ans -= func(i - 1) + func(i);
			p[i - 1].r = mid, p[i].l = mid + 1;
			Ans += func(i - 1) + func(i);
		}
	}
	LL solve(){
		if (a[1] > sum(2, n)) return s[n] * s[n];
		Ans = 0;
		p[cp = 1] = (pnode) {1, 1}, Ans += (LL) a[1] * a[1];
		for (int l = 1, r = 1; r < n; ){
			LL lst = sum(l, r); l = r + 1, r = l;
			while (r < n && (sum(l, r) < lst || GO())) r++;
			if (r < n && sum(r + 1, n) < sum(l, r)) r = n;
			p[++cp] = (pnode) {l, r}, Ans += sum(l, r) * sum(l, r);
		}
		for (int i = 1; i <= 100; i++)
			greed1(), greed2();
		return Ans;
	}
};

LL Solve(){
	if (n <= 5040) return DP :: solve();
	return Greedy :: solve();
}

int main(){
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	srand(time(0)); read(n), read(typ);
	for (int i = 1; i <= n; i++)
		read(a[i]), s[i] = s[i - 1] + a[i];
	cout << Solve() << '\n';
	return 0;
}
