#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define mp make_pair
#define pb push_back

const int N = 45;
const int M = 505;
const int mod = 998244353;
int n, m;
int a[N][M];

int dp1[N][N][N];
void solve2() {
	dp1[0][0][0] = 1;
	for (int i = 1; i <= n; ++ i)
		for (int j = 0; j <= i; ++ j) for (int k = 0; k <= i; ++ k) {
			if (j) (dp1[i][j][k] += 1LL * dp1[i - 1][j - 1][k] * a[i][1] % mod) %= mod;
			if (k) (dp1[i][j][k] += 1LL * dp1[i - 1][j][k - 1] * a[i][2] % mod) %= mod;
			(dp1[i][j][k] += dp1[i - 1][j][k]) %= mod;
		}
	int ans = 0;
	for (int i = 0; i <= n; ++ i) for (int j = 0; j <= n; ++ j)
		if (i + j >= 1 && i <= (i + j) / 2 && j <= (i + j) / 2)
			(ans += dp1[n][i][j]) %= mod;
	printf("%d\n", ans);
}

int dp2[N][N][N][N];
void solve3() {
	dp2[0][0][0][0] = 1;
	for (int i = 1; i <= n; ++ i)
		for (int j = 0; j <= i; ++ j) for (int k = 0; k <= i; ++ k) for (int l = 0; l <= i; ++ l) {
			if (j) (dp2[i][j][k][l] += 1LL * dp2[i - 1][j - 1][k][l] * a[i][1] % mod) %= mod;
			if (k) (dp2[i][j][k][l] += 1LL * dp2[i - 1][j][k - 1][l] * a[i][2] % mod) %= mod;
			if (l) (dp2[i][j][k][l] += 1LL * dp2[i - 1][j][k][l - 1] * a[i][3] % mod) %= mod;
			(dp2[i][j][k][l] += dp2[i - 1][j][k][l]) %= mod;
		}
	int ans = 0;
	for (int i = 0; i <= n; ++ i) for (int j = 0; j <= n; ++ j) for (int k = 0; k <= n; ++ k)
		if (i + j + k >= 1 && i <= (i + j + k) / 2 && j <= (i + j + k) / 2 && k <= (i + j + k) / 2)
			(ans += dp2[n][i][j][k]) %= mod;
	printf("%d\n", ans);
}

int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	scanf("%d %d", &n, &m);
	for (int i = 1; i <= n; ++ i)
		for (int j = 1; j <= m; ++ j)
			scanf("%d", &a[i][j]);
	if (m == 2)
		solve2();
	else if (m == 3)
		solve3();
	return 0;
}
