#include<cstdio>
#include<cstring>
using namespace std;

#define _N 2010

#define Max(a,b) (a>b?a:b)

struct Side
{
	int to;
	int next;
	Side()
	{
		to=next=0;
	}
	Side(int a,int b)
	{
		to=a;
		next=b;
	}
};

int sidecnt=1;
int head[_N];
Side sides[2*_N];

int cutside=0;

int siz[_N];
int maxpart[_N]={0x3f3f3f3f};

void inline adde(int x,int y)
{
	sides[++sidecnt]=Side(y,head[x]);
	head[x]=sidecnt;
}

int center(int x,int father,int sum)
{
	int ans=0;
	int next=head[x];
	while(next!=0)
	{
		int y=sides[next].to;
		if(y!=father&&next!=cutside&&(next^1)!=cutside)
		{
			ans+=center(y,x,sum);
			maxpart[x]=Max(maxpart[x],siz[y]);
		}
		next=sides[next].next;
	}
	maxpart[x]=Max(maxpart[x],sum-siz[x]);
	if(maxpart[x]<=sum/2)
	{
		ans+=x;
	}
	return ans;
}
void size(int x,int father)
{
	siz[x]=1;
	maxpart[x]=0;
	int next=head[x];
	while(next!=0)
	{
		int y=sides[next].to;
		if(y!=father&&next!=cutside&&(next^1)!=cutside)
		{
			size(y,x);
			siz[x]+=siz[y];
		}
		next=sides[next].next;
	}
}

int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	scanf("%d",&T);
	while(T--)
	{
		sidecnt=1;
		memset(head,0x00,sizeof(head));
		memset(sides,0x00,sizeof(sides));
		cutside=0;
		memset(siz,0x00,sizeof(siz));
		memset(maxpart,0x00,sizeof(maxpart));
		maxpart[0]=0x3f3f3f3f;
		int n;
		scanf("%d",&n);
		for(int i=1;i<n;i++)
		{
			int u,v;
			scanf("%d%d",&u,&v);
			adde(u,v);
			adde(v,u);
		}
		int ans=0;
		for(int i=2;i<=sidecnt;i+=2)
		{
			cutside=i;
			size(sides[i].to,0);
			ans+=center(sides[i].to,0,siz[sides[i].to]);
			size(sides[i^1].to,0);
			ans+=center(sides[i^1].to,0,siz[sides[i^1].to]);
		}
		printf("%d\n",ans);
	}
	return 0;
} 
