#include <bits/stdc++.h>
using namespace std;
const int MAXN = 3e5 + 10;
template <class T>
inline void _read(T &x)
{
	x = 0;
	char t = getchar();
	while (!isdigit(t) && t != '-') t = getchar();
	if (t == '-')
	{
		_read(x);
		x *= -1;
		return ;
	}
	while (isdigit(t))
	{
		x = x * 10 + t - '0';
		t = getchar();
	}
}
int T, n;
vector <int> G[MAXN];
int from[MAXN], to[MAXN], deg[MAXN];
int size[MAXN], fa[MAXN], ro1, ro2, ans1, ans2;
inline void ae(int u, int v)
{
	G[u].push_back(v);
	G[v].push_back(u);
}
inline void cut(int u, int v)
{
	for (vector <int>::iterator i = G[u].begin(); i != G[u].end(); ++i)
		if (*i == v)
		{
			G[u].erase(i);
			break;
		}
	for (vector <int>::iterator i = G[v].begin(); i != G[v].end(); ++i)
		if (*i == u)
		{
			G[v].erase(i);
			break;
		}
}

inline void pls(int x, int fx)
{
	fa[x] = fx;
	size[x] = 1;
	for (vector <int>::iterator i = G[x].begin(); i != G[x].end(); ++i)
	{
		int u = *i;
		if (u != fx)
		{
			pls(u, x);
			size[x] += size[u];
		}
	}
}

long long ans = 0;
inline void chk(int x, int ro)
{
//	cout << "ro : " << ro << "x : " << x << " size : " << size[x] << endl;
	bool flag = 1;
	for (vector <int>::iterator i = G[x].begin(); i != G[x].end(); ++i)
	{
		int u = *i;
		if (u != fa[x])
		{
			chk(u, ro);
			if (size[u] > size[ro] / 2) flag = false;
		}
	}
	if (size[ro] - size[x] > size[ro] / 2)
	{
		flag = false;
//		cout << "failx : " << x << endl;
	}
	if (flag)
	{
//		cout << "ro : " << ro << "x : " << x << endl;
		ans += x;
	}
}
inline void work()
{
	ans = 0;
	for (int i = 1; i < n; ++i)
	{
		cut(from[i], to[i]);
		ro1 = from[i], ro2 = to[i];
		pls(from[i], 0), pls(to[i], 0);
		chk(ro1, ro1), chk(ro2, ro2);
		ae(from[i], to[i]);
	}
	printf("%lld\n", ans);
}
int dfn[MAXN], ti = 0;
inline void dfs(int x, int fx)
{
	dfn[++ti] = x;
	for (vector <int>::iterator i = G[x].begin(); i != G[x].end(); ++i)
	{
		int u = *i;
		if (u != fx)
			dfs(u, x);
	}
}
int main()
{
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	_read(T);
	while (T--)
	{
		_read(n);
		for (int i = 1; i <= n; ++i) G[i].clear();
		for (int i = 1, u, v; i < n; ++i)
		{
			_read(u), _read(v);
			from[i] = u, to[i] = v;
			G[u].push_back(v);
			G[v].push_back(u);
			++deg[u], ++deg[v];
		}
		int u = 0;
		bool flag1 = 1;
		for (int i = 1; i <= n; ++i)
		{
			if (deg[i] == 1)
			{
				u = i;
				break;
			}
		}
		for (int i = 1; i <= n; ++i)
		{
			if (deg[i] > 2) flag1 = 0;
		}
		if (flag1)
		{
			dfs(u, 0);
			ans = 0;
			for (int i = 1; i < n; ++i)
			{
				if (i & 1)
				{
//					cout << "pos : " << (i + 1) / 2 << endl;
					ans += dfn[(i + 1) / 2];
				}
				else
				{
					ans += dfn[i / 2] + dfn[i / 2 + 1];
//					cout << "pos : " << i / 2 << " " << i / 2 + 1 << endl;
				}
				if ((n - i) & 1)
				{
//					cout << "pos : " << i + (n - i + 1) / 2 << endl;
					ans += dfn[i + (n - i + 1) / 2];
				}
				else
				{
					ans += dfn[i + (n - i) / 2] + dfn[i + (n - i) / 2 + 1];
//					cout << "pos : " << i + (n - i) / 2 << " " << i + (n - i) / 2 + 1 << endl;
				}

			}
			printf("%lld\n", ans);
		}
		else
		{
			work();
		}
	}
	return 0;
}
