#include <iostream>
#include <cstdio>
#include <string.h>
#include <fstream>
using namespace std;
const long long MOD=998244353;
const long long MAXN=40;
inline long long read(){
	long long f=1,ans=0;
	char x=getchar();
	while (x<'0'||x>'9'){if (x=='-') f=-1;x=getchar();}
	while (x>='0'&&x<='9'){ans=ans*10+x-'0';x=getchar();}
	return f*ans;
}

long long n,m;
long long a[MAXN][MAXN];
bool choise[MAXN][MAXN];
long long ans=0;

bool check(){
	long long tot=0;
	for (long long i=1;i<=n;i++){
		long long flag=0;
		for (long long j=1;j<=m;j++){
			tot+=choise[i][j];
			flag+=choise[i][j];
			if (flag>=2) {/*cout<<"qwq";*/return false;}
		}
	}
	for (long long j=1;j<=m;j++){
		long long cnt=0;
		for (long long i=1;i<=n;i++) cnt+=choise[i][j];
		if (cnt>tot/2){
			//cout<<"QAQ";
			return false;
		}
	}
	return true;
}

void dfs(long long x,long long y){
	if (x==n+1){
		/*
		for (long long i=1;i<=n;i++){
			for (long long j=1;j<=m;j++){
				cout<<choise[i][j];
			}
			cout<<endl;
		}
		*/
		if (check()) ans++;
		//cout<<endl<<endl;
		return;
	}
	dfs(x+(y==m),y%m+1);
	if (a[x][y]){
		choise[x][y]=true;
		dfs(x+(y==m),y%m+1);
		choise[x][y]=false;
	}
}

int main()

{
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);
	ios::sync_with_stdio(false);
	n=read();m=read();
	for (long long i=1;i<=n;i++)
		for (long long j=1;j<=m;j++)
			a[i][j]=read();
	
	dfs(1,1);
	ans--;
	cout<<ans<<endl;
	return 0;
}

/*

5 5
1 0 0 1 1
0 1 0 1 0
1 1 1 1 0
1 0 1 0 1
0 1 1 0 1


namespace solution1
{
	long long a[50][50];
	long long ans=0;
	bool vis[50];
	bool tmp[50];
	
	void dfs(long long c,long long sum,long long ok){
		if (c==m+1){
			if (ok>=2) ans+=sum;
			ans%=MOD;
			return;
		}
		dfs(c+1,sum,ok);
		tmp[c]=true;
		for (long long i=1;i<=n;i++){
			if (!vis[i]&&a[i][c]>0){
				vis[i]=true;
				dfs(c+1,(sum*a[i][c])%MOD,ok+1);
				vis[i]=false;
			}
		}
		tmp[c]=false;
	}
	long long main()
	{
		memset(vis,false,sizeof(vis));
		memset(tmp,false,sizeof(tmp));
		for (long long i=1;i<=n;i++)
			for (long long j=1;j<=m;j++)
				a[i][j]=read();
		
		dfs(1,1,0);
		cout<<ans<<endl;
	}
}

namespace solution2
{
	long long ans=0;
	long long a[50][50];
	
	long long main()
	{
		for (long long i=1;i<=n;i++)
			for (long long j=1;j<=m;j++)
				a[i][j]=read();
		
		if (m==2){
			for (long long i=1;i<=n;i++){
				for (long long j=1;j<=n;j++){
					if (i==j) continue;
					ans=(ans+a[i][1]*a[j][2])%MOD;
				}
			}
			cout<<ans<<endl;
		}
		else{
			a[0][1]=a[0][2]=a[0][3]=1;
			for (long long i=0;i<=n;i++){
				for (long long j=0;j<=n;j++){
					for (long long k=0;k<=n;k++){
						if (i+j==0||j+k==0||i+k==0) continue;
						if (i==j||j==k||i==k) continue;
						long long sum=a[i][1]*a[j][2]*a[k][3];
						//cout<<i<<" "<<j<<" "<<k<<" "<<sum<<endl;
						ans=(ans+sum)%MOD;
					}
				}
			}
			cout<<ans<<endl;
		}
		return 0;
	}
}
*/
