#include<bits/stdc++.h>
using namespace std;

template <typename Tp>
void read(Tp &x){
	x=0;char ch=1;int fh;
	while(ch!='-'&&(ch<'0'||ch>'9')) ch=getchar();
	if(ch=='-') ch=getchar(),fh=-1;
	else fh=1;
	while(ch>='0'&&ch<='9') x=x*10+ch-'0',ch=getchar();
	x*=fh;
}

const int maxn=299997;
const int maxm=299995*2+7;

int T;
long long ans;
int n;
int Head[maxn],to[maxm],Next[maxm],tot;

void add(int x,int y){
	to[++tot]=y,Next[tot]=Head[x],Head[x]=tot;
}

void reset(){
	tot=1;ans=0;
	memset(Head,0,sizeof(Head));
	memset(Next,0,sizeof(Next));
}

void Init(){
	read(n);
	for(int i=1,x,y;i<n;i++){
		read(x);read(y);
		add(x,y);add(y,x);
	}
}

bool del[maxn];
int sz;
int size[maxn];
void find(int x,int f){
	size[x]=1;int mx=-1;
	for(int i=Head[x];i;i=Next[i]){
		if(del[i]) continue;
		int y=to[i];
		if(y==f) continue;
		find(y,x);size[x]+=size[y];
		mx=max(mx,size[y]);
	}
	mx=max(mx,sz-size[x]);
	if(mx<=sz/2) ans+=x;
}

void dfs(int x,int f){
	sz++;
	for(int i=Head[x];i;i=Next[i]){
		if(to[i]==f) continue;
		if(del[i]) continue;
		dfs(to[i],x);
	}
}

namespace Subtask1{
	
	void Main(){
		for(int i=1;i<n;i++){
			del[i*2]=del[i*2+1]=1;
			sz=0;dfs(to[i*2],0);find(to[i*2],0);
			sz=0;dfs(to[i*2+1],0);find(to[i*2+1],0);
			del[i*2]=del[i*2+1]=0;
		}
		printf("%lld\n",ans);
	}
}

namespace Subtask2{
	int p[5],cnt;
	int dep[maxn],pr[maxn];
	void ser(int x,int f){
		bool son=false;
		for(int i=Head[x];i;i=Next[i]){
			if(to[i]==f) continue;
			son=true;ser(to[i],x);
		}
		if(!son) p[++cnt]=x;
	}
	void mark(int x,int f,int dp){
		dep[x]=dp;pr[dp]=x;
		for(int i=Head[x];i;i=Next[i]){
			if(to[i]==f) continue;
			mark(to[i],x,dp+1);
		}
	}
	void Main(){
		cnt=0; 
		ser(1,0);
		mark(p[1],0,1);
		for(int i=1;i<n;i++){
			int x=to[i*2],y=to[i*2+1];
			if(dep[x]>dep[y]) swap(x,y);
			int ss=dep[x];
			if(ss&1){
				ans+=pr[ss/2+1];
			}
			else ans+=pr[ss/2]+pr[ss/2+1];
			ss=n-dep[y]+1;
			if(ss&1) ans+=pr[dep[y]+ss/2];
			else ans+=pr[dep[y]+ss/2]+pr[dep[y]+ss/2-1];
		}
		printf("%lld\n",ans);
	}
}

void solve(){
	if(n<=1999) Subtask1::Main();
	if(n==49991) Subtask2::Main();
}

int main(){
	freopen("centroid.in","r",stdin);freopen("centroid.out","w",stdout);
	read(T);
	while(T--){
		reset();Init();
		solve();
	}
	return 0;
}

