#include<bits/stdc++.h>
using namespace std;

#define LL long long
#define debug(x) cerr<<#x<<": "<<x<<endl;
#define fgx cerr<<"--------------"<<endl;
#define dgx cerr<<"=============="<<endl;

inline int read(){
	int x=0,f=1; char c=getchar();
	for (;!isdigit(c);c=getchar()) if (c=='-') f=-1;
	for (;isdigit(c);c=getchar()) x=x*10+c-'0';
	return x*f;
}

const int MAXN = 300010;

struct Edge{int x,y;}G[MAXN];

int to[MAXN<<1],nxt[MAXN<<1],head[MAXN];
int N,cnte;

inline void add(int x,int y){
	to[++cnte]=y; nxt[cnte]=head[x]; head[x]=cnte;
}

namespace BF{
	int sz[MAXN],Mx[MAXN];
	int s1,s2;
	inline void Gets(int x,int Fa){
		sz[x]=1;
		for (int i=head[x];i;i=nxt[i]){
			int y=to[i]; if (y!=Fa){Gets(y,x); sz[x]+=sz[y];}
		}
	}
	inline void Getrt1(int x,int Fa){
		Mx[x]=0; sz[x]=1;
		for (int i=head[x];i;i=nxt[i]){
			int y=to[i];
			if (y!=Fa){
				Getrt1(y,x); sz[x]+=sz[y]; Mx[x]=max(Mx[x],sz[y]);
			}
		} Mx[x]=max(Mx[x],s1-sz[x]);
	}
	inline void Getrt2(int x,int Fa){
		Mx[x]=0; sz[x]=1;
		for (int i=head[x];i;i=nxt[i]){
			int y=to[i];
			if (y!=Fa){
				Getrt2(y,x); sz[x]+=sz[y]; Mx[x]=max(Mx[x],sz[y]);
			}
		} Mx[x]=max(Mx[x],s2-sz[x]);
	}
	inline void Main(){
		int ans=0;
		for (int i=1;i<N;++i){
			int x=G[i].x,y=G[i].y;
			Gets(x,y); s1=sz[x]; Gets(y,x); s2=sz[y];
			memset(Mx,0x3f,sizeof(Mx)); Getrt1(x,y);
			for (int j=1;j<=N;++j) if (Mx[j]<=s1/2) ans+=j;
			memset(Mx,0x3f,sizeof(Mx)); Getrt2(y,x);
			for (int j=1;j<=N;++j) if (Mx[j]<=s2/2) ans+=j;
		} cout<<ans<<endl;
	}
}
namespace Subtask1{
	int deg[MAXN],seq[MAXN],Rt,cnt;
	LL ans;
	inline bool Check(){
		int cnt1=0,cnt2=0;
		memset(deg,0,sizeof(deg));
		for (int i=1;i<N;++i){
			++deg[G[i].x]; ++deg[G[i].y];
		} for (int i=1;i<=N;++i)
			if (deg[i]==1) ++cnt1;
			else if (deg[i]==2) ++cnt2;
			else return false;
		if (cnt1!=2||cnt2!=N-2) return false;
		for (int i=1;i<=N;++i) if (deg[i]==1) Rt=i;
		return true;
	}
	inline void dfs(int x,int Fa){
		seq[++cnt]=x;
		for (int i=head[x];i;i=nxt[i]){
			int y=to[i]; if (y!=Fa) dfs(y,x);
		}
	}
	inline void Main(){
		//printf("%d\n",Rt);
		cnt=0; dfs(Rt,0); ans=0;
		for (int i=1;i<cnt;++i)
			if (i&1) ans+=seq[i/2+1]; else ans+=seq[i/2]+seq[i/2+1];
		reverse(seq+1,seq+cnt+1);
		for (int i=1;i<cnt;++i)
			if (i&1) ans+=seq[i/2+1]; else ans+=seq[i/2]+seq[i/2+1];
		cout<<ans<<endl;
	}
}
namespace Subtask2{
	int dep[MAXN],deg[MAXN],Rt;
	void dfs(int x,int Fa){
		dep[x]=dep[Fa]+1;
		for (int i=head[x];i;i=nxt[i]){
			int y=to[i]; if (y!=Fa) dfs(y,x);
		}
	}
	void Main(){
		memset(deg,0,sizeof(deg));
		for (int i=1;i<N;++i){++deg[G[i].x]; ++deg[G[i].y];}
		for (int i=1;i<=N;++i)
			if (deg[i]==2){Rt=i; break;}
		dfs(Rt,0); LL tmp=(N+1)>>1,ans=0;
		for (int i=1;i<=N;++i)
			if (dep[i]<=2) ans+=1LL*i*tmp; else ans+=i;
		cout<<ans<<endl;
	}
}
inline void solve(){
	N=read(); memset(head,cnte=0,sizeof(head));
	for (int i=1;i<N;++i){
		int x=read(),y=read();
		add(x,y); add(y,x);
		G[i].x=x; G[i].y=y;
	} if (N<=2000){
		BF::Main(); return;
	} if (Subtask1::Check()){
		Subtask1::Main(); return;
	} Subtask2::Main(); return;
}
int main(){
	freopen("centroid.in","r",stdin); freopen("centroid.out","w",stdout);
	int T=read();
	while (T--) solve();
	return 0;
}

