#include <fstream>
#include <iostream>
#include <cstring>
#include <vector>
#include <map>
using namespace std;
const int MAXN=300010;
int n,t;
long long ans;
vector<int> adj[MAXN]; 
map<pair<int,int>,bool> mp;
int d[MAXN];
void search(int root,int fob)
{
//  cout<<"root:"<<root<<endl;
  d[root]=1;
  for(int i=0;i<adj[root].size();i++)
  {
  	int u=adj[root][i];
  	if(u!=fob)
  	{
  	  search(u,root);
  	  d[root]+=d[u];
	}
  }
}

bool iscen(int node,int fob,int tot)
{
  if(tot-d[node]>tot/2)  return 0;
//  cout<<"y1"<<endl;
  for(int i=0;i<adj[node].size();i++)
  {
  	int t=adj[node][i];
  	if(t!=fob)
  	{
  	  if(d[t]>tot/2)  return 0;
	}
  }
//  cout<<"y2"<<endl;
  return 1;
}

long long mop(int node,int fob,int tot)
{
  long long anp=0;
//  cout<<node<<" "<<tot<<" "<<d[node]<<endl;
  if(iscen(node,fob,tot))
  {
// 	cout<<node<<endl;
  	anp+=node;
  }
  for(int i=0;i<adj[node].size();i++)
  {
  	int t=adj[node][i];
  	if(t!=fob)
  	{
  	  anp+=mop(t,node,tot);
    }
  }
  return anp;
}


int main()
{
  ifstream fin("centroid.in");
  ofstream fout("centroid.out");
  fin>>t;
  for(int q=1;q<=t;q++)
  {
  	fin>>n;
  	ans=0;
  	mp.clear();
  	memset(d,0,sizeof(d));
  	for(int i=1;i<=n;i++)
  	  adj[i].clear();
  	for(int i=1;i<n;i++)
  	{
  	  int x,y;
  	  fin>>x>>y;
  	  adj[x].push_back(y);
  	  adj[y].push_back(x);
	}
  	for(int i=1;i<=n;i++)
  	{
  	  for(int j=0;j<adj[i].size();j++)
  	  {
  	  	int u=adj[i][j];
  	  	if(mp[make_pair(i,u)]==0)
  	  	{
  	  	  mp[make_pair(i,u)]=0;
  	  	  mp[make_pair(u,i)]=0;
//  	  	  cout<<"now::"<<i<<" "<<u<<endl;
  	  	  search(i,u);
//  	  	  for(int r=1;r<=n;r++)  cout<<d[r]<<" ";
//  	  	  cout<<endl;
  	  	  ans+=mop(i,u,d[i]);
  	  	  search(u,i); 
  	  	  ans+=mop(u,i,d[u]);
		}
	  }
	}
	fout<<ans/2<<endl;
//	cout<<endl;
//	cout<<endl;
  }
  fin.close();
  fout.close();
  return 0;
}
