#include <bits/stdc++.h>

using namespace std;

namespace LZZio {
	template <class T> inline void read(T &x) {
		T flg = 1; x = 0; char ch = getchar();
		for (; !isdigit(ch); ch = getchar()) if (ch == '-') flg = -1;
		for (; isdigit(ch); ch = getchar()) x = x * 10 + ch - '0';
		x *= flg;
	}

	template <class T> inline void write(T x) {
		if (x < 0) putchar('-'), x = -x;
		if (x > 9) write(x / 10);
		putchar(x % 10 + '0');
	}

	template <class T> inline void writeln(T x, char c = '\n') { write(x); putchar(c); }
	template <class T> inline void chkmax(T &x, const T y) { x = x > y ? x : y; }
	template <class T> inline void chkmin(T &x, const T y) { x = x < y ? x : y; }

	#define Ms(arr, opt) memset(arr, opt, sizeof(arr))
	typedef long long ll;
	typedef unsigned long long ull;
} using namespace LZZio;

const ll mod = 998244353;
int n, m, a[55][1005]; ll f[42][22][22][22][42], ans = 0;
int h[2005];

inline void dfs(int dep, int cai, ll ss, bool s) { bool flg = true;
	if (cai >= 1 && !s) {
		for (int i = 1; i <= m && flg; i++) flg &= (h[i] <= cai / 2);
		if (flg) ans = (ans + ss) % mod;
	} if (dep > n) return; dfs(dep + 1, cai, ss, flg);
	for (int i = 1; i <= m; i++) {
		if (a[dep][i] == 0) continue;
		if (h[i] + 1 > n / 2) continue;
		++h[i]; dfs(dep + 1, cai + 1, ss * 1ll * a[dep][i] % mod, false); --h[i];
	} 
}

int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	read(n), read(m); Ms(h, 0);
	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= m; j++) read(a[i][j]);
	
	if (n > 10 && m == 2) {Ms(f, 0);
	f[0][0][0][0][0] = 1;
		for (int i = 1; i <= n; i++) { f[i - 1][0][0][0][0] = 1;
//			if (a[i][1])
			for (int s = 1; s <= i; s++) {
				for (int j = 1; j <= s; j++) f[i][j][s - j][0][s] = f[i - 1][j][s - j][0][s];
			} 
			for (int s = 1; s <= i; s++) {
				for (int j = 1; j <= s; j++) {
					if (j > s) break;
					int k = s - j;
					f[i][j][k][0][s] = (f[i][j][k][0][s] + f[i - 1][j - 1][k][0][s - 1] * 1ll * a[i][1] % mod) % mod;
	//				if (j <= s / 2 && k <= s / 2) ans = (ans + f[i][j][k][0][s]) % mod; cout << s << ' '<< j << ' ' << k << ' '; writeln(f[i][j][k][0][s]);
				}
			}
			
//			if (a[i][2])
			for (int s = 1; s <= i; s++) {
				for (int j = 1; j <= s; j++) {
					if (j > s) break;
					int k = s - j;
					f[i][k][j][0][s] = (f[i][k][j][0][s] + f[i - 1][k][j - 1][0][s - 1] * 1ll * a[i][2] % mod) % mod;
	//				if (j <= s / 2 && k <= s / 2) ans = (ans + f[i][k][j][0][s]) % mod; cout << s << ' ' << k << ' ' << j << ' '; writeln(f[i][k][j][0][s]);
				}
			}
		}
		for (int s = 1; s <= n; s++) {
			for (int i = 1; i <= s / 2; i++)
			if (s - i <= s / 2) ans = (ans + f[4][i][s - i][0][s]) % mod;
		} writeln(ans); return 0;
	} dfs(1, 0, 1, 0); writeln(ans);
	return 0;
}

/*
10 3
60 25 75
160 53 102
231 219 100
215 122 124
230 115 13
134 180 146
83 2 77
116 141 5
202 184 18
210 76 8

147 149 25
99 119 232
177 18 176
85 206 209
96 223 13

5 5
1 0 0 1 1
0 1 0 1 0
1 1 1 1 0
1 0 1 0 1
0 1 1 0 1

4 2
123 0
0 32
132 0
0 32

*/

