#include <bits/stdc++.h>

using namespace std;

namespace LZZio {
	template <class T> inline void read(T &x) {
		T flg = 1; x = 0; char ch = getchar();
		for (; !isdigit(ch); ch = getchar()) if (ch == '-') flg = -1;
		for (; isdigit(ch); ch = getchar()) x = x * 10 + ch - '0';
		x *= flg;
	}

	template <class T> inline void write(T x) {
		if (x < 0) putchar('-'), x = -x;
		if (x > 9) write(x / 10);
		putchar(x % 10 + '0');
	}

	template <class T> inline void writeln(T x, char c = '\n') { write(x); putchar(c); }
	template <class T> inline void chkmax(T &x, const T y) { x = x > y ? x : y; }
	template <class T> inline void chkmin(T &x, const T y) { x = x < y ? x : y; }

	#define Ms(arr, opt) memset(arr, opt, sizeof(arr))
	typedef long long ll;
	typedef unsigned long long ull;
} using namespace LZZio;

const int Maxn = 40000005;
int n, type, a[Maxn], sum[Maxn];

inline ll dfs(int u, int lims) {
	if (u == 0) return 0ll; ll s = 1ll << 60, s2;
	if (a[u] > lims) return 1ll << 61;
	for (int i = u; i >= 1; i--) {
		s2 = sum[u] - sum[i - 1];
		if (s != 1ll << 60) break;
		if (s2 <= lims) chkmin(s, 1ll * s2 * s2 + dfs(i - 1, s2));
		else break;
	} return s;
} 

int main() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	read(n), read(type); sum[0] = 0;
	for (int i = 1; i <= n; i++) read(a[i]), sum[i] = sum[i - 1] + a[i];
	writeln(dfs(n, sum[n]));
	return 0;
}

