#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef pair<int,int> pii;
typedef pair<int,ll> pil;
typedef pair<ll,int> pli;
typedef pair<ll,ll> pll;
typedef vector<int> vi;
#define rep(i,n) for (int i=0;i<(n);++i)
#define REP(i,n) for (int i=1;i<=(n);++i)
#define ALL(x) x.begin(),x.end()
#define mp make_pair
#define pb push_back
#define F first
#define S second
#define read(x) scanf("%d",&x)
#define RII(x,y) scanf("%d%d",&x,&y);
int T;
int n;
ll ans=0;
// for Small
vector<int> G[262150];
int sz[2005];
pii E[2005];
inline void dfs(int u,int pa){
	sz[u]=1;
	for (int i=0;i<G[u].size();++i){
		int v=G[u][i];
		if (v!=pa){
			dfs(v,u);sz[u]+=sz[v];
		}
	}
	return;
}
inline void getCen(int u,int pa,int SZ){
	bool good=1;
	if (SZ-sz[u]>SZ/2) good=0;
	for (int i=0;i<G[u].size();++i){
		int v=G[u][i];
		if (v!=pa){
			getCen(v,u,SZ);
			if (sz[v]>SZ/2) good=0;
		}
	}
	if (good) ans+=u;
}
inline void solveSmall(){
	REP(i,n) G[i].clear();
	REP(i,n-1){
		int x,y;RII(x,y);
		E[i]=mp(x,y);
		G[x].pb(y);G[y].pb(x);
	}
	REP(i,n-1){
		int u=E[i].F,v=E[i].S;
		memset(sz,0,sizeof(sz));
		dfs(u,v);dfs(v,u);
		getCen(u,v,sz[u]);getCen(v,u,sz[v]);
	}
	cout<<ans<<endl;
}
// for List
int deg[262150];
int a[50005];
inline void solveList(){
	REP(i,n) G[i].clear();
	memset(deg,0,sizeof(deg));
	REP(i,n-1){
		int x,y;RII(x,y);
		++deg[x];++deg[y];
		G[x].pb(y);G[y].pb(x);
	}
	REP(i,n) if (deg[i]==1){
		a[1]=i;
		for (int j=1;j<n;++j){
			for (int k=0;k<G[a[j]].size();++k){
				int nxt=G[a[j]][k];
				if (nxt!=a[j-1]) a[j+1]=nxt;
			}
		}
		break;
	}
	for (int i=1;i<=n-1;++i){
		// break i and i+1
		if (i&1) ans+=a[(i+1)>>1];
		else ans+=a[i>>1]+a[(i>>1)+1];
		if ((n-i)&1) ans+=a[(n+i+1)>>1];
		else ans+=a[(n+i)>>1]+a[((n+i)>>1)+1];
	}
	cout<<ans<<endl;
}
// for Complete
int id[262150];
bool cnt[262150];
inline void solveComplete(){
	REP(i,n) G[i].clear();
	memset(deg,0,sizeof(deg));
	memset(cnt,0,sizeof(cnt));
	REP(i,n-1){
		int x,y;RII(x,y);
		++deg[x];++deg[y];
		G[x].pb(y);G[y].pb(x);
	}
	int a,b,c;
	REP(u,n){
		if (deg[u]==2){
			// u is root
			a=u;
			b=G[u][0];
			c=G[u][1];
		}
	}
	ans=(ll)(n-1)/2*(a+b+c);
	ans+=(ll)n*(n+1)/2;
	cout<<ans<<endl;
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	read(T);
	while(T--){
		read(n);
		ans=0;
		if (n<=2000) solveSmall();
		else if (n%10==1) solveList();
		else if (n%10==3) solveComplete();
	} 
	return 0;
}
