#include<iostream>
#include<cstdio>
#include<cstring>
#include<vector>
using namespace std;

int n,a[1000010],deg[100010];
long long ans=0;
vector<int>e[100010];

void dfs(int cur,int ind,int fa)
{
	a[ind]=cur;
	for(int i=0;i<e[cur].size();i++)
	{
		if(e[cur][i]==fa)
			continue;
		dfs(e[cur][i],ind+1,cur);
	}
}

int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	scanf("%d",&T);
	while(T--)
	{
		ans=0;
		memset(a,0,sizeof a);
		memset(deg,0,sizeof deg);
		for(int i=0;i<100010;i++)
			e[i].clear();
		scanf("%d",&n);
		int x,y;
		for(int i=1;i<n;i++)
		{
			scanf("%d%d",&x,&y);
			e[x].push_back(y);
			e[y].push_back(x);
			deg[x]++;
			deg[y]++;
		}
		for(int i=1;i<=n;i++)
			if(deg[i]==1)
			{
				dfs(i,1,-1);
				break;
			}
		for(int i=1;i<n;i++)
		{
			int L=i,R=n-i;
			if(L%2==0)
				ans+=(a[L/2]+a[L/2+1]);
			else
				ans+=a[L/2+1];
			if(R%2==0)
				ans+=(a[R/2+i]+a[R/2+i+1]);
			else
				ans+=a[R/2+1+i];
		}
		cout<<ans<<endl;
	}
}
