#include<bits/stdc++.h>

using namespace std;
#define File(x) freopen(#x".in", "r", stdin), freopen(#x".out", "w", stdout)
#define dbg(x) cerr << #x <<" = " <<x <<endl
#define int long long
const int MAXN = 1e6 + 10;
const int MAXM = 2e6 + 10;
int head[MAXM], nxt[MAXM], to[MAXM], ind;
inline void add_edge(int u, int v){
	nxt[++ ind] = head[u]; head[u] = ind; to[ind] = v;
}
int deg[MAXN];
int n;
#define zero(x)  memset(x, 0, sizeof(x))
inline void Clear(void){
	zero(head); zero(nxt); zero(to); ind = 1; zero(deg);
}
int ans;
inline void init(void){
	scanf("%lld", &n);
	int u, v;
	Clear();
	for(register int i = 1; i < n; ++ i){
		scanf("%lld%lld", &u, &v);
		add_edge(u, v); add_edge(v, u);
		deg[u] ++; deg[v] ++;
	}
	ans = 0;
}
namespace Subtask1{
int dfn[MAXN], num, siz1[MAXN];
void dfs1(int node, int fa){
	dfn[node] = ++ num; siz1[node] = 1;
 	for(register int i = head[node]; i; i = nxt[i]){
		int j = to[i]; if(j == fa) continue;
		dfs1(j, node);
		siz1[node] += siz1[j];
	}
}
int maxp[MAXN], sz[MAXN];
void calc(int node, int fa, int tot, int del){
	maxp[node] = 0; sz[node] = 1;
	for(register int i = head[node]; i; i = nxt[i]){
		int j = to[i]; if((j == fa) || (i == del) || (i == (del ^ 1)))  continue;
		calc(j, node, tot, del);
		sz[node] += sz[j];
		maxp[node] = max(maxp[node], sz[j]); 
 	}
 	maxp[node] = max(maxp[node], tot - sz[node]);
 	if(maxp[node] <= tot / 2) ans += node; 
}	
void Solve(void){
	num = 0; ans = 0; dfs1(1, 0);
	for(register int i = 2; i <= ind; i += 2){
		int u = to[i], v = to[i ^ 1];
		if(dfn[u] > dfn[v]) swap(u, v);
		calc(v, 0, siz1[v], i); calc(u, 0, n - siz1[v], i);
	}
	printf("%lld\n", ans);
}
} 
int rt;
namespace Subtask2{
	
inline int findroot(void){
	int ret = -1;
	for(register int i = 1; i <= n; ++ i) {
		if(deg[i] > 2) return -1;
		if(deg[i] == 1) ret = i;
	}
	return ret;
}

int depth[MAXN], turn[MAXN];
void dfs1(int node, int fa){
	depth[node] = depth[fa] + 1; turn[depth[node]] = node;
 	for(register int i = head[node]; i; i = nxt[i]){
		int j = to[i]; if(j == fa) continue;
		dfs1(j, node);
	}
}

inline void calc(int fir, int sec){
	int dep = sec - fir + 1;
	//if((dep % 2) == 1)
 	ans += turn[(fir + sec) / 2];
	//else ans += turn[(fir + sec) / 2] + 
	if((dep % 2) == 0) ans += turn[(fir + sec) / 2 + 1];
}
void Solve(void){
	//cerr << "Correct   !! " <<endl; 
	dfs1(rt, 0);
	for(register int i = 2; i <= ind; i += 2){
		//cerr << i << "    " <<ind << endl;
		int u = to[i], v = to[i ^ 1];
		if(depth[u] > depth[v]) swap(u, v);
		calc(1, depth[u]); calc(depth[v], n);
		///dbg(ans);
	}
	printf("%lld\n", ans);
	//cerr << ans << endl;
}

}
inline void work(void){
	rt = Subtask2::findroot();
	//for(register int i = 1; i <= n; ++ i) if(depth[i] == n) cerr << "Correct  " <<endl;
 	if(rt != -1) Subtask2::Solve();
	else Subtask1::Solve();
}
#undef int 
int main(){
	//File(centroid1);
	freopen("centroid.in","r", stdin);
	freopen("centroid.out", "w", stdout);
	int T;
	scanf("%d", &T);
	while(T--){
		init();
		work();
	}
	fclose(stdin); fclose(stdout);
	return 0;
}

