#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
const int N=3e5+5;
inline int read(){
	int x=0,f=1;
	char c=getchar();
	for(;!isdigit(c);c=getchar())if(c=='-')f=-1;
	for(;isdigit(c);c=getchar())x=(x<<3)+(x<<1)+c-48;
	return x*f;
}
vector<int>edge[N],Son[N];
int u[N],v[N];
int vis[N],l[N],tot,sz[N];
ll ans;
queue<int>q;
void build(int s){
	memset(vis,0,sizeof(vis));
	vis[s]=1,l[1]=s,tot=1;
	while(q.size())q.pop();
	q.push(s);
	while(q.size()){
		int x=q.front();
		q.pop();
		for(int i=0;i<edge[x].size();i++){
			int y=edge[x][i];
			if(vis[y])continue;
			vis[y]=1,l[++tot]=y;
			q.push(y);
		}
	}
}
void Init(int x,int b){
	for(int i=0;i<edge[x].size();i++){
		int y=edge[x][i];
		if(vis[y]||y==b)continue;
		vis[y]=1;
		Son[x].push_back(y);
		Init(y,b);
		sz[x]+=sz[y];
	}
	sz[x]++;
}
void dfs(int x,int root){
	int mx=sz[root]-sz[x];
	for(int i=0;i<Son[x].size();i++){
		int y=Son[x][i];
		mx=max(mx,sz[y]);
		dfs(y,root);
	}
	if(mx<=sz[root]/2)ans+=x;
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T=read();
	while(T--){
		int n=read();
		for(int i=1;i<=n;i++)edge[i].clear();
		for(int i=1;i<n;i++){
			u[i]=read(),v[i]=read();
			edge[u[i]].push_back(v[i]),edge[v[i]].push_back(u[i]);
		}
		if(n==49991){
			ans=0;
			for(int i=1;i<=n;i++)
				if(edge[i].size()==1){
					build(i);
					break;
				}
			for(int i=1;i<n;i++){
				if((i+1)%2==0)ans+=l[(i+1)/2];
				else ans+=l[i/2]+l[i/2+1];
				if((i+1+n)%2==0)ans+=l[(i+1+n)/2];
				else ans+=l[(i+1+n)/2]+l[(i+1+n)/2+1];
			}
			cout<<ans<<endl;
			continue;
		}
		ans=0;
		for(int i=1;i<n;i++){
			memset(vis,0,sizeof(vis));
			memset(sz,0,sizeof(sz));
			vis[u[i]]=1,vis[v[i]]=1;
			for(int j=1;j<=n;j++)Son[j].clear();
			Init(u[i],v[i]),Init(v[i],u[i]);
			dfs(u[i],u[i]),dfs(v[i],v[i]);
		}
		cout<<ans<<endl;
	}
	return 0;
}
