//This amazing code is written by Primo.Jay.Pan
//CSP-S 2019 Day2 T3 centroid
#include <iostream>
#include <cstring>
#include <cstdio>
#include <queue>
#include <stack>
#include <algorithm>
#include <cmath>
#include <set>
#define ll long long
#define ull unsigned long long
#define maxn 300005
#define mst(a) memset(a,0,sizeof(a))
using namespace std;

int T;
int head[maxn];
struct Edge{
	int next,to;
}edges[maxn*2];
int D[maxn];
int a[maxn];
int n,x,y,b_cnt;
ll ans=0;
int cur=0;
int rt,lc,rc;

struct T3{

		inline void clear()
		{
			mst(a);
			mst(edges);
			mst(head);
			mst(D);
			cur=0;
			b_cnt=0;
			n=0;
			ans=0;
		}

		inline void addedge(int u,int v)
		{
			edges[++b_cnt].next=head[u];
			edges[b_cnt].to=v;
			head[u]=b_cnt;
			D[u]++;
		}

		inline void dfs1(int u,int fa)
		{
			a[++cur]=u;
			for (int i=head[u];i;i=edges[i].next)
			{
				int v=edges[i].to;
				if (v!=fa)
					dfs1(v,u);
			}
		}

		inline void ptA()//链
		{
			for (int i=1;i<=n;i++)
			{
				if (D[i]==1)
				{
					dfs1(i,i);
					break;
				}
			}
			for (int i=1;i<n;i++)
			{
				int l1=1,r1=i,l2=i+1,r2=n;
				x=l1+r1,y=l2+r2;
				if (x%2==0)
					ans+=a[x/2];
				if (x%2==1)
					ans+=a[x/2]+a[x/2+1];
				if (y%2==0)
					ans+=a[y/2];
				if (y%2==1)
					ans+=a[y/2]+a[y/2+1];
			}

		}






		inline void DFS(int u,int fa,int tp)
		{
			int sz=0;
			for (int i=head[u];i;i=edges[i].next)
			{
				int v=edges[i].to;
				if (v!=fa)
				{
					DFS(v,u,tp);
					sz++;
				}
			}
			ans+=u;
			if (sz==0)
			{
				ans+=rt;
			}
			if (tp==0) ans+=rc;
			else ans+=lc;
			return ;
		}


		inline void solve()
		{
			scanf("%d",&n);
			for (int i=1;i<n;i++)
			{
				scanf("%d%d",&x,&y);
				addedge(x,y);
				addedge(y,x);
			}
		 	if (n==49991 && n!=262143)	
			{
				ptA();
			}
			if (n==262143){
			for (int i=1;i<=n;i++)
			{
				if (D[i]==2) 
				{
					rt=i;
					break;
				}
			}
			int cur=0;
			for (int i=head[rt];i;i=edges[i].next)
			{
				int v=edges[i].to;
				if (cur==0) lc=v;
				else rc=v;
				cur++;
			}
			DFS(lc,rt,0);
			DFS(rc,rt,1);}
		}


		inline void print()
		{
			cout<<ans<<endl;
		}

}centroid;


int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	while (T--)
	{
		centroid.clear();
		centroid.solve();
		centroid.print();
	}
	return 0;
}

