#include<bits/stdc++.h>
using namespace std;
typedef pair < int , int > pii;
typedef long long LL;
#define mpr make_pair
#define FS first
#define SC second
int readint(){
	int ret=0;
	char c=getchar();
	while(c==' '||c=='\n') c=getchar();
	while(c>='0' && c<='9'){
		ret=ret*10+(c-'0');
		c=getchar();
	}
	return ret;
}
// duo ce bu qing kong, bao ling liang hang lei.
int n;
vector < int > adj[300005];
int dep[300005],fa[20][300005];
int sz[300005],nsz[300005];
int mxs[300005],smxs[300005];
int lca(int u,int v){
	int i;
	if(dep[u]<dep[v]) swap(u,v);
	for(i=19;i>=0;--i){
		if(fa[i][u]!=-1 && dep[fa[i][u]]>=dep[v])
			u=fa[i][u];
	}
	if(u==v) return u;
	for(i=19;i>=0;--i){
		if(fa[i][u]!=fa[i][v]){
			u=fa[i][u];
			v=fa[i][v];
		}
	}
	return fa[0][u];
}
int cen[300005];
LL res;
int getcen(int u,int v,int f,int ts,bool c){
	int i,j,k;
	if(f==-1) f=lca(u,v);
	for(i=19;i>=0;--i){
		int t=fa[i][v];
		if(t!=-1 && dep[t]>=dep[f] && nsz[t]*2<ts){
			v=t;
		}
	}
	if(nsz[v]*2<ts) v=fa[0][v];
	if(v!=-1 && (dep[v]<dep[f] || nsz[v]*2<ts)) v=-1;
	for(i=19;i>=0;--i){
		int t=fa[i][u];
		if(t!=-1 && dep[t]>=dep[f] && nsz[t]*2>ts){
			u=t;
		}
	}
	if(v==-1){
		if(c) res+=(LL)(u+1);
		if(c && u!=f && nsz[fa[0][u]]*2==ts) res+=(LL)(fa[0][u]+1);
		return u;
	}
	else if(v==f && u!=f){
		if(c) res+=(LL)(u+1+v+1);
		return u;
	}
	else if(v==f && u==f){
		if(c) res+=(LL)(f+1);
		return f;
	}
	else{// now v!=f
		if(c) res+=(LL)(v+1);
		if(c && nsz[v]*2==ts) res+=(LL)(fa[0][v]+1);
		return v;
	}
}
void dfs(int v,int f){
	int i;
	dep[v]=(f==-1?0:(dep[f]+1));
	fa[0][v]=f;
	sz[v]=1;
	mxs[v]=smxs[v]=-1;
	for(i=0;i<(int)adj[v].size();++i){
		int u=adj[v][i];
		if(u!=f){
			dfs(u,v);
			sz[v]+=sz[u];
			if(mxs[v]==-1 || sz[u]>sz[mxs[v]]){
				smxs[v]=mxs[v];
				mxs[v]=u;
			}
			else if(smxs[v]==-1 || sz[u]>sz[smxs[v]]){
				smxs[v]=u;
			}
		}
	}
	nsz[v]=sz[v];
}
void rdfs(int v,int f){
	int i;
	for(i=0;i<(int)adj[v].size();++i){
		int u=adj[v][i];
		if(u!=f){
			rdfs(u,v);
		}
	}
	if(mxs[v]==-1){
		cen[v]=v;
		if(f!=-1) res+=(LL)(v+1);
	}
	else{
		cen[v]=getcen(v,cen[mxs[v]],v,nsz[v],f!=-1);
	}
	if(f!=-1){
		int fs=n-sz[v];
		if(mxs[v]==-1 || fs>nsz[mxs[v]]){
			smxs[v]=mxs[v];
			mxs[v]=f;
		}
		else if(smxs[v]==-1 || fs>nsz[smxs[v]]){
			smxs[v]=f;
		}
	}
}
void rrdfs(int v,int f){
	int i,oldcen=cen[v];
	for(i=0;i<(int)adj[v].size();++i){
		int u=adj[v][i];
		if(u!=f){
			nsz[v]-=nsz[u];
			nsz[u]+=nsz[v];
			int ss=(mxs[v]==u?smxs[v]:mxs[v]);
			if(ss!=-1)
				cen[v]=getcen(v,cen[ss],-1,nsz[v],1);
			else{
				cen[v]=v;
				res+=(LL)(v+1);
			}
			// updating cen[u] is of no use
			rrdfs(u,v);
			nsz[u]-=nsz[v];
			nsz[v]+=nsz[u];
			cen[v]=oldcen;
		}
	}
}
void solve(){
	int i,j,k;
	n=readint();
	for(i=0;i<n;++i) adj[i].clear();
	for(i=0;i<n-1;++i){
		int u,v;
		u=readint()-1;
		v=readint()-1;
		adj[u].push_back(v);
		adj[v].push_back(u);
	}
	dfs(0,-1);
	for(i=1;i<20;++i){
		for(j=0;j<n;++j){
			if(fa[i-1][j]==-1)
				fa[i][j]=-1;
			else
				fa[i][j]=fa[i-1][fa[i-1][j]];
		}
	}
	res=0ll;
	rdfs(0,-1);
	rrdfs(0,-1);
	printf("%lld\n",res);
	// duo ce bu qing kong, bao ling liang hang lei.
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int t=readint();
	while(t--) solve();
	return 0;
}
