#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
struct Edge
{
	int u,v,next;
};
int n;
Edge e[600010];
int head[300010],cnt;
int size[300010];
void addedge(int u,int v)
{
	cnt++;
	e[cnt].u=u;
	e[cnt].v=v;
	e[cnt].next=head[u];
	head[u]=cnt;
}
void dfs1(int u,int fa)
{
	size[u]=1;
	for(int i=head[u];i;i=e[i].next)
	{
		int v=e[i].v;
		if(v==fa)continue;
		dfs1(v,u);
		size[u]+=size[v];
	}
}
int rtsize;
ll ans;
void dfs2(int u,int fa)
{
	bool ok=true;
	if(rtsize-size[u]>rtsize/2)ok=false;
	for(int i=head[u];i;i=e[i].next)
	{
		int v=e[i].v;
		if(v==fa)continue;
		dfs2(v,u);
		if(size[v]>rtsize/2)ok=false;
	}
	if(ok)ans+=u;
}
void work1()
{
	for(int i=1;i<2*n-1;i+=2)
	{
		dfs1(e[i].u,e[i].v);
		rtsize=size[e[i].u];
		dfs2(e[i].u,e[i].v);
		dfs1(e[i].v,e[i].u);
		rtsize=size[e[i].v];
		dfs2(e[i].v,e[i].u);
	}
	printf("%lld\n",ans);
}
int deg[500010];
int chain[50010];
void work2()
{
	int u,last=0,ptr=0;
	for(int i=1;i<=n;i++)
	{
		if(deg[i]==1)u=i;
	}
	while(1)
	{
		chain[++ptr]=u;
		bool end=true;
		for(int i=head[u];i;i=e[i].next)
		{
			if(e[i].v!=last)
			{
				last=u;
				u=e[i].v;
				end=false;
				break;
			}
		}
		if(end)break;
	}
	for(int i=1;i<n;i++)
	{
		if((i-1)%2)ans+=chain[i/2]+chain[i/2+1];
		else ans+=chain[i/2+1];
		if((n-i)%2)ans+=chain[(i+n)/2]+chain[(i+n)/2+1];
		else ans+=chain[(i+n)/2+1];
	}
	printf("%lld\n",ans);
}
int t,rt;
void dfs3(int u,int fa)
{
	ans+=t+u;
	if(deg[u]==1)ans+=rt;
	for(int i=head[u];i;i=e[i].next)
	{
		int v=e[i].v;
		if(v==fa)continue;
		dfs3(v,u);
	}
}
void work3()
{
	ans=0;
	for(int i=1;i<=n;i++)
	{
		if(deg[i]==2)rt=i;
	}
	int s1=0,s2=0;
	for(int i=head[rt];i;i=e[i].next)
	{
		int v=e[i].v;
		if(!s1)s1=v;
		else s2=v;
	}
	t=s2;
	dfs3(s1,rt);
	t=s1;
	dfs3(s2,rt);
	printf("%lld\n",ans);
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	scanf("%d",&T);
	while(T--)
	{
		memset(head,0,sizeof(head));cnt=0;
		memset(deg,0,sizeof(deg));
		ans=0;
		scanf("%d",&n);
		for(int i=1;i<n;i++)
		{
			int u,v;
			scanf("%d%d",&u,&v);
			addedge(u,v);
			addedge(v,u);
			deg[u]++;
			deg[v]++;
		}
		if(n==49991)work2();
		else if(n==262143)work3();
		else work1();
	}
	return 0;
}
