#include <bits/stdc++.h>
using namespace std;

long long ans;
int cases;
int n,deg[300010],h[300010],sz[300010],w1[300010],w2[300010];
vector<int> v[300010],res;
vector<pair<int,int> > edges;

inline void dfs(int x,int pr)
{
	sz[x]=1;
	for(int i=0;i<v[x].size();i++) if(v[x][i]!=pr){
		int g=v[x][i];
		dfs(g,x);
		sz[x]+=sz[g];
	}
}

inline void dfs1(int x,int pr,int num)
{
	w1[x]=1;
	bool flag=false;
	for(int i=0;i<v[x].size();i++) if(v[x][i]!=pr){
		int g=v[x][i];
		dfs1(g,x,num);
		w1[x]+=w1[g];
		if(w1[g]>num/2) flag=true;
	}
	if(num-w1[x]>num/2) flag=true;
	if(!flag) ans+=(long long)x;
}

inline void dfs2(int x,int pr,int num)
{
	w2[x]=1;
	bool flag=false;
	for(int i=0;i<v[x].size();i++) if(v[x][i]!=pr){
		int g=v[x][i];
		dfs2(g,x,num);
		w2[x]+=w2[g];
		if(w2[g]>num/2) flag=true;
	}
	if(num-w2[x]>num/2) flag=true;
	if(!flag) ans+=(long long)x;
}

inline void dfs3(int x,int pr)
{
	res.push_back(x);sz[x]=1;
	for(int i=0;i<v[x].size();i++) if(v[x][i]!=pr){
		dfs3(v[x][i],x);
		sz[x]+=sz[v[x][i]];
	}
}

inline void dfs4(int x,int pr,int cur)
{
	h[x]=cur;
	for(int i=0;i<v[x].size();i++) if(v[x][i]!=pr){
		dfs4(v[x][i],x,cur);
	}
}

int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
    scanf("%d",&cases);
    for(int t=1;t<=cases;t++){
    	scanf("%d",&n);
    	edges.clear();
    	for(int i=1;i<=n;i++) v[i].clear();
    	memset(deg,0,sizeof(deg));
    	for(int i=1;i<n;i++){
    		int x,y;
    		cin>>x>>y;
    		v[x].push_back(y);
    		v[y].push_back(x);
    		deg[x]++;deg[y]++;
    		edges.push_back(make_pair(x,y));
		}
		int num=n%10;
		if(num==1){
			ans=0ll;res.clear();
			int root=0;
			for(int i=1;i<=n;i++) if(deg[i]==1){
				root=i;
				break;
			}
			dfs3(root,-1);
			for(int i=0;i<edges.size();i++){
				int x=edges[i].first,y=edges[i].second;
				if(sz[x]<sz[y]) swap(x,y);
				int valx=n-sz[x]+1,valy=sz[y];
				if(valx%2==0){
					ans+=(long long)res[valx/2];
					ans+=(long long)res[valx/2-1];
				}
				else{
					ans+=(long long)res[valx/2];
				}
				if(valy%2==0){
					ans+=(long long)res[res.size()-valy/2];
					ans+=(long long)res[res.size()-valy/2-1];
				}
				else{
					ans+=(long long)res[res.size()-valy/2-1];
				}
			}
			printf("%lld\n",ans);
		}
		else if(num==3){
			ans=0ll;res.clear();
			int root=0;
			for(int i=1;i<=n;i++) if(deg[i]==2){
				root=i;
				break;
			}
			dfs(root,-1);
			memset(h,0,sizeof(h));
			int xa=v[root][0],xb=v[root][1];
			dfs4(xa,root,xb);dfs4(xb,root,xa);
			for(int i=1;i<=n;i++) if(i!=root){
				if(deg[i]==1){
					ans+=(long long)i;
					ans+=(long long)root;
					ans+=(long long)h[i];
				}
				else{
					ans+=(long long)i;
					ans+=(long long)h[i];
				}
			}
			printf("%lld\n",ans);
		}
		else{
			dfs(1,-1);ans=0ll;
			for(int i=0;i<edges.size();i++){
				int x=edges[i].first,y=edges[i].second;
				if(sz[x]>sz[y]) swap(x,y);
				dfs1(x,y,sz[x]);
				dfs2(y,x,n-sz[x]);
			}
			printf("%lld\n",ans);
		}
	}
	return 0;
}
