#include<cstdio>
#include<cctype>
#include<algorithm>

typedef long long LL;

const int MOD = 998244353;

int n, m, a[1010][1010], mx, t[1010];
LL fac[1010], inv[1010], ans;

inline int read() {
	int x = 0, f = 1; char c = getchar();
	for (; !isdigit(c); c = getchar()) if (c == '-') f = -1;
	for (; isdigit(c); c = getchar()) x = x * 10 + c - '0';
	return x * f;
}

inline LL C(int n, int m) {
	return fac[n] * inv[m] % MOD * inv[n - m] % MOD; 
}

void dfs(int x, int y, LL cnt) {
	if (x > n) {
		ans = (ans + cnt) % MOD;
		return ;
	}
	for (int i = 1; i <= m; ++i) 
		for (int j = 1; j <= std::min(m / 2 - t[i], n - y); ++j) {
			//printf("%d\n", x);
			//printf("%d %d %d %d %d\n", i, j, cnt, a[x][i], x);
			t[i] += j, 
			dfs(x + 1, y + j, cnt * C(a[x][i], j) % MOD), 
			t[i] -= j;
		}
}

inline LL ksm(LL x, int p) {
	LL ret = 1;
	for (; p; p >>= 1, x = x * x % MOD)
		if (p & 1) ret = ret * x % MOD;
	return ret;
}

int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	n = read(); m = read();
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j)
			a[i][j] = read(), mx = std::max(mx, a[i][j]);
	fac[0] = 1;
	for (int i = 1; i <= mx; ++i) fac[i] = fac[i - 1] * i;
	inv[mx] = ksm(fac[mx], MOD - 2);
	for (int i = mx - 1; i; --i) inv[i] = inv[i + 1] * (i + 1) % MOD;
	dfs(1, 0, 1);
	printf("%lld\n", ans);
	return 0;
}

