#include<cstdio>
#include<cctype>
#include<algorithm>
#define MaxN 500010

typedef long long LL;

int n, type, a[MaxN];
LL ans = 1e18, Sum[MaxN];

inline int read() {
	int x = 0, f = 1; char c = getchar();
	for (; !isdigit(c); c = getchar()) if (c == '-') f = -1;
	for (; isdigit(c); c = getchar()) x = x * 10 + c - '0';
	return x * f;
}

void dfs(int dep, int lst, int sum, LL tot) {
	if (dep == n) {
		if (sum >= lst) ans = std::min(ans, tot + 1LL * sum * sum);
		return ;
	}	
	if (tot + 1LL * sum * sum + Sum[n] - Sum[dep] >= ans) return ;
	if (sum >= lst) dfs(dep + 1, sum, a[dep + 1], tot + 1LL * sum * sum);
	if (tot + 1LL * (sum + a[dep + 1]) * (sum + a[dep + 1]) < ans) dfs(dep + 1, lst, sum + a[dep + 1], tot);
}

int main() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	n = read(); type = read();
	for (int i = 1; i <= n; ++i) a[i] = read(), Sum[i] = Sum[i - 1] + 1LL * a[i] * a[i];
	dfs(1, 0, a[1], 0);
	printf("%lld\n", ans);
	return 0;
}

