#include <cstdio>
#include <cstring>
#include <fstream>
#include <iostream>
#include <algorithm>
#define fi(i,l,r) for(int i=l;i<=r;i++)
#define fd(i,r,l) for(int i=r;i>=l;i--)

using namespace std;
const int maxn=300005;
const int maxm=600005;
const int INF=0x3f3f3f3f;

int T,n;
long long ans;
int fa[maxn],out[maxn];
int siz[maxn],s[maxn],dep[maxn];
int x,y;

struct edge{
	int u,v,nex;
}e[maxm];
int hd[maxn],tot;
inline void Addedge(int x,int y)
{
	e[++tot].v=y;e[tot].u=x;e[tot].nex=hd[x];hd[x]=tot;
}

template<typename T>void Read(T &x)
{
	x=0;char c=getchar();
	while(c<'0'||c>'9') c=getchar();
	while(c>='0'&&c<='9') x=(x<<3)+(x<<1)+(c^48),c=getchar();
}

template<typename T>void Print(T x)
{
	if(x<0) {putchar('-');Print(-x);return;} if(x>9) Print(x/10);putchar((x%10)^48);
}

void Dfs1(int x,int fa)
{
	for(int k=hd[x];k;k=e[k].nex)
	{
		if(e[k].v!=fa)
		{
			Dfs1(e[k].v,x);
			siz[x]+=siz[e[k].v];
		}
	}
	siz[x]++;
}

void Dfs2(int x,int No,int fa,int num)
{
	int mson=0;
	for(int k=hd[x];k;k=e[k].nex)
	{
		if(e[k].v!=fa&&e[k].v!=No)
		{
			Dfs2(e[k].v,No,x,num);
			mson=max(mson,s[e[k].v]);
			s[x]+=s[e[k].v];
		}
	}
	s[x]++;
	if(mson<=(num>>1)&&num-s[x]<=(num>>1))
	  ans+=(long long)x;
}


void Work1()
{
	Dfs1(1,-1);
	for(int i=1;i<=tot;i+=2)
	{
		x=e[i].u;y=e[i].v;
		if(siz[x]>siz[y]) swap(x,y); //xǽС 
		memset(s,0,sizeof(s));
		Dfs2(x,y,-1,siz[x]);
		Dfs2(y,x,-1,n-siz[x]);
	}
	Print(ans);putchar(10);
}

void Dfs3(int x,int fa,int step)
{
	while(step!=n+1)
	{
		for(int k=hd[x];k;k=e[k].nex)
		{
			if(e[k].v!=fa)
			{
				dep[step]=e[k].v;
			//	Print(e[k].v);putchar(32);
				fa=x;x=e[k].v;step++; 
				break;
			}
		}
	}
	
}

void Work2()
{
	memset(dep,0,sizeof(dep));
	int now;
	fi(i,1,n) if(out[i]==1) {now=i;break;}
	dep[1]=now;
	Dfs3(now,-1,2);
	int k=(49991+1)>>1;
	ans=((((1+(long long)49991)*((long long)49991))>>1))*3-(dep[1]+dep[k]+dep[n]);
	Print(ans);putchar(10);
}

int main ()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	Read(T);
	while(T--)
	{
//		memset(e,0,sizeof(e));
		memset(out,0,sizeof(out));
		memset(siz,0,sizeof(siz));
		memset(hd,0,sizeof(hd));
		tot=0;ans=0;
		Read(n);
		fi(i,1,n-1)
		{
			Read(x);Read(y);
			Addedge(x,y);Addedge(y,x);
			out[x]++;out[y]++;
		}
		if(n==49991) {Work2();continue;}
		if(n<=10005) {Work1();continue;}
	}
	return 0;
}
