#include <bits/stdc++.h>
using namespace std;
typedef long long lint;
typedef unsigned int uint;
typedef unsigned long long ulint;
typedef pair<int, int> pii;
typedef pair<lint, lint> pll;
#define endl '\n'
#define fst first
#define sed second
#define pb push_back
#define mp make_pair
#define SZ(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rep(it, ff, ee) for (int it = (ff); it <= (ee); ++it)
#define per(it, ff, ee) for (int it = (ff); it >= (ee); --it)
const int MAXN = 5e5 + 20;
int n, tp, a[MAXN];
ulint cnt[MAXN];
namespace DP {
	const ulint MUL = 2e9 + 1;
	const ulint INF = 4e18 + 233;
	ulint dp[5010][5010], sufmin[5010][5010];
	inline void solve() {
		rep (i, 0, n) {
			rep (j, 0, n) {
				dp[i][j] = INF;
			}
		}
		dp[0][0] = 0;
		rep (i, 1, n) {
			int pos = i;
			per (j, i - 1, 1) {
				pos = min(pos, j);
				while (pos > 0 && cnt[j] - cnt[pos - 1] <= cnt[i] - cnt[j]) --pos;
				if (pos != j) {
					ulint r1 = INF;
					if (cnt[i] - cnt[j] < MUL) {
						r1 = (cnt[i] - cnt[j]) * (cnt[i] - cnt[j]);
					}
					dp[i][j] = min(INF, sufmin[j][pos] + r1);
				}
			}
			if (cnt[i] >= MUL) {
				dp[i][0] = INF;
			} else {
				dp[i][0] = cnt[i] * cnt[i];
			}
			sufmin[i][i - 1] = dp[i][i - 1];
			per (j, i - 2, 0) {
				sufmin[i][j] = sufmin[i][j + 1];
				sufmin[i][j] = min(sufmin[i][j], dp[i][j]);
			}
		}
		ulint res = INF;
		rep (i, 0, n - 1) {
			res = min(res, dp[n][i]);
		}
		cout << res << endl;
	}
}
namespace WA {
	const int SIZE = (1 << 20) + 5;
	struct Segtree {
		#define lson (root << 1)
		#define rson (root << 1 | 1)
		int val[SIZE];
		inline void build() {
			memset(val, 0, sizeof(val));
		}
		inline void modify(int l, int r, int v, int root = 1, int sl = 1, int sr = n) {
			if (l <= sl && sr <= r) {
				val[root] = max(val[root], v);
				return;
			}
			int mid = (sl + sr) >> 1;
			if (l <= mid) modify(l, r, v, lson, sl, mid);
			if (r > mid) modify(l, r, v, rson, mid + 1, sr);
		}
		inline int query(int x, int root = 1, int sl = 1, int sr = n) {
			if (sl == sr) {
				return val[root];
			}
			int mid = (sl + sr) >> 1;
			if (x <= mid) return max(val[root], query(x, lson, sl, mid));
			else return max(val[root], query(x, rson, mid + 1, sr));
		}
		#undef lson
		#undef rson
	}	tr;
	inline void solve() {
		tr.build();
		int pos = 1;
		rep (i, 1, n) {
			int bk = tr.query(i);
			pos = max(pos, i + 1);
			while (pos <= n && cnt[pos] - cnt[i] < cnt[i] - cnt[bk]) ++pos;
			if (pos <= n) tr.modify(pos, n, i);
		}
		int now = n;
		ulint res = 0;
		while (now) {
			int bk = tr.query(now);
			res += (cnt[now] - cnt[bk]) * (cnt[now] - cnt[bk]);
			now = bk;
		}
		cout << res << endl;
	}
}
int main() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	scanf("%d%d", &n, &tp);
	if (tp == 1) {
	//	getInput();
	} else rep (i, 1, n) {
		scanf("%d", a + i);
	}
	rep (i, 1, n) {
		cnt[i] = cnt[i - 1] + a[i];
	}
	if (n <= 5000) {
		DP :: solve();
		return 0;
	}
	WA :: solve();
	return 0;
}
