#include <stdio.h>
#include <ctype.h>

typedef unsigned long long uint64;
typedef long long int64;

const int P = 998244353;

int n, m;
int a[101][2001];
int na[2001], cnt[2001];
uint64 ans;

template<typename T> void qread(T& t) {
	t = 0;
	int symbol = 1;
	char c;
	while(!isdigit(c = getchar())) {
		if(c == '-') {
			symbol = -1;
		}
	}
	while(isdigit(c)) {
		t = t * 10 + c - '0';
		c = getchar();
	}
	t *= symbol;
}

void init() {
	qread(n); qread(m);
	for(int i = 1; i <= n; ++i) {
		for(int j = 1; j <= m; ++j) {
			qread(a[i][j]);
		}
	}
}

void dfs2(int dep, uint64 cns, int k) {
	if(dep == k) {
		ans += cns;
		ans %= P;
		return;
	}
	for(int i = 1; i <= m; ++i) {
		if(a[na[dep]][i]) {
			++cnt[i];
			if(cnt[i] <= k / 2) {
				dfs2(dep + 1, cns * a[na[dep]][i] % P, k);
			}
			--cnt[i];
		}
	}
}

void dfs1(int len, int cur, int k) {
	if(len == k) {
		dfs2(0, 1, k);
		return;
	}
	if(k - len > n - cur)
		return;
	for(int i = cur + 1; i <= n; ++i) {
		na[len] = i;
		dfs1(len + 1, i, k);
	}
}

int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	init();
	for(int k = 2; k <= n; ++k)
		dfs1(0, -1, k);
	printf("%llu", ans);
	return 0;
}

