#include <stdio.h>
#include <ctype.h>
#include <limits.h>

typedef unsigned long long uint64;
typedef long long int64;

template<typename T> void qread(T& t) {
	t = 0;
	int symbol = 1;
	char c;
	while(!isdigit(c = getchar())) {
		if(c == '-') {
			symbol = -1;
		}
	}
	while(isdigit(c)) {
		t = t * 10 + c - '0';
		c = getchar();
	}
	t *= symbol;
}

int n, type, a[500000];
int arr[500000], cnt = 0;
uint64 ans = ULLONG_MAX;

void dfs(int pos, uint64 mx) {
	if(pos == n - 1) {
		uint64 res = 0ull;
		for(int i = 0; i < cnt; ++i) {
			res += (uint64)arr[i] * arr[i];
		}
		if(res < ans) {
			ans = res;
		}
		return;
	}
	uint64 tmp = 0;
	for(int i = pos + 1; i < n; ++i) {
		tmp += a[i];
		if(tmp >= mx) {
			arr[cnt++] = tmp;
			dfs(i, tmp);
			--cnt;
		}
	}
}

int main() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	qread(n); qread(type);
	if(type == 0) {
		for(int i = 0; i < n; ++i) {
			qread(a[i]);
		}
	}
	else {
		// TODO: ...
	}
	dfs(-1, 0);
	printf("%llu", ans);
	return 0;
}
