#include <bits/stdc++.h>

using namespace std;

#define ll long long

const int maxn = 3e5 + 10, maxm = maxn << 1;

int n;
int SIZ[maxn], col[maxn], Maxs[maxn], s[maxn];
bool Cant[maxm];
int deep[maxn], num[maxn];
int to[maxm], nxt[maxm], head[maxn], tot;
int U[maxn], V[maxn];
int KK[maxn], Ds[maxn];

void addedge(int u, int v){
	to[++tot] = v;
	nxt[tot] = head[u];
	head[u] = tot;
}

void dfs_work1(int x, int fa, int C){
	s[x] = 1; Maxs[x] = 0; col[x] = C;
	for (int i = head[x], p; i; i = nxt[i]){
		p = to[i];
		if (p != fa && !Cant[i]){
			dfs_work1(p, x, C);
			s[x] += s[p];
			Maxs[x] = max(Maxs[x], s[p]);
		}
	}
}

void dfs_init(int x, int fa, int dep){
	SIZ[x] = 1; deep[x] = dep;
	for (int i = head[x], p; i; i = nxt[i]){
		p = to[i];
		if (p != fa){
			dfs_init(p, x, dep + 1);
			SIZ[x] += SIZ[p];
		}
	}
}

void work1(){
	ll ans = 0;
	dfs_init(1, 0, 1);
	for (int i = 1; i < n; i++){
		Cant[num[i]] = Cant[num[i] + 1] = 1;
		dfs_work1(1, 0, 1);
		int root2 = deep[U[i]] > deep[V[i]] ? U[i] : V[i];
		dfs_work1(root2, 0, 2);
		int siz1 = SIZ[1] - SIZ[root2], siz2 = SIZ[root2];
		for (int j = 1; j <= n; j++){
			if (col[j] == 1){
				if (siz1 - siz1 / 2 <= s[j] && Maxs[j] <= siz1 / 2) ans += j;
			} else {
				if (siz2 - siz2 / 2 <= s[j] && Maxs[j] <= siz2 / 2) ans += j;
			}
		}
		Cant[num[i]] = Cant[num[i] + 1] = 0;
	}
	printf("%lld\n", ans);
}

void work2(int RO){
	dfs_init(RO, 0, 1);
	ll ans = 0;
	for (int i = 1; i <= n; i++) KK[deep[i]] = i;
	for (int i = 1, s1, s2; i < n; i++){
		s1 = i; s2 = n - i;
		if (s1 & 1) ans += KK[i / 2 + 1];
		else ans += KK[i / 2] + KK[i / 2 + 1];
		if (s2 & 1) ans += KK[i + s2 / 2 + 1];
		else ans += KK[i + s2 / 2] + KK[i + s2 / 2 + 1];
	}
	printf("%lld\n", ans);
}

void Work(){
	tot = 0; memset(head, 0, sizeof head);
	memset(Ds, 0, sizeof Ds);
	scanf("%d", &n);
	for (int i = 1, u, v; i < n; i++){
		scanf("%d%d", &u, &v);
		addedge(u, v);
		num[i] = tot;
		addedge(v, u);
		U[i] = u; V[i] = v;
		Ds[u]++;
		Ds[v]++;
	}
	int p = 0; bool f = 1;
	for (int i = 1; i <= n && !p && f; i++)
		if (Ds[i] == 1) p = i;
		else if (Ds[i] > 2) f = 0;
	if (p && f) work2(p);
	else work1();
}

int main(){
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T; scanf("%d", &T);
	while (T--) Work();
	return 0;
}
