#include<bits/stdc++.h>
using namespace std;
vector<int> E[50000]; 
struct edge{
	int x;
	int y;
	edge(int x=0,int y=0):x(x),y(y){}
};
vector<edge> v;
int n;
inline int depth(int u,int fa)
{
	for(int i=0;i<E[u].size();++i)
	{
		int v=E[u][i];
		if(v==fa)
		{
			continue;
		}
		return depth(v,u)+1;
	}
	return 1;
}
inline int look(int u,int fa,int dis,int ndis)
{
	if(ndis==dis)
	{
		return u;
	}
	for(int i=0;i<E[u].size();++i) 
	{
		int v=E[u][i];
		if(v==fa)
		{
			continue;
		}
		return look(v,u,dis,ndis+1);
	}
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	ios::sync_with_stdio(false);cin.tie(NULL);
	int t;
	cin>>t;
	while(t--)
	{
		cin>>n;
		for(int i=1;i<n;++i)
		{
			int x,y;
			cin>>x>>y;
			v.push_back(edge(x,y));
			E[x].push_back(y);
			E[y].push_back(x);
		}
//		if(n!=49991)
//		{
//			continue;
//		}
		int res=0; 
		for(int i=0;i<v.size();++i)
		{
			int bx=v[i].x,by=v[i].y;
			int L=depth(bx,by),R=depth(by,bx);
			if(L%2==1)
			{
				res+=look(bx,by,(L+1)/2,1);
			}
			else
			{
				res+=look(bx,by,L/2,1)+look(bx,by,L/2+1,1);
			}
			if(R%2==1)
			{
				res+=look(by,bx,(R+1)/2,1);
			}
			else
			{
				res+=look(by,bx,R/2,1)+look(by,bx,R/2+1,1);
			} 
		}
		cout<<res<<'\n';
	}
	return 0;
}

