#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const int inf=0x3f3f3f3f;
const ll infll=0x3f3f3f3f3f3f3f3fll;
const ll mod=998244353;

int n,m;
ll a[110][2010];

int read(){
	int ff=1,x=0;char ss=getchar();
	while(ss<'0'||ss>'9'){if(ss=='-')ff=-1;ss=getchar();}
	while(ss>='0'&&ss<='9'){x=x*10+ss-'0';ss=getchar();}
	return ff*x;
}

namespace task1{
	ll sum[3]={0};
	ll ans;
	
	void solve(){
		for (int i=1;i<=n;i++){
			for (int j=1;j<=m;j++){
				sum[j]=(sum[j]+a[i][j])%mod;
			}
		}
		ans=(sum[1]*sum[2])%mod;
//		cout<<sum[1]<<' '<<sum[2]<<endl;
		for (int i=1;i<=n;i++)ans=(ans-a[i][1]*a[i][2]%mod)%mod;
		while(ans<0)ans+=mod;
		printf("%lld\n",ans);
	}
}

namespace task2{
	ll sum[4]={0};
	ll s=0;
	ll ans;
	
	void solve(){
		for (int i=1;i<=n;i++){
			for (int j=1;j<=n;j++){
				if (i==j)continue;
				ans=(ans+a[1][i]*a[2][j]%mod+a[1][i]*a[3][j]%mod+a[2][i]*a[3][j]%mod);
			}
		}
		while (ans<0)ans+=mod;
		if (n>=3){
			for (int i=1;i<=n;i++){
				for (int j=1;j<=n;j++){
					if (i==j)continue;
					for (int k=1;k<=n;k++){
						if (i==k || j==k)continue;
						ans=(ans+a[1][i]*a[2][j]%mod*a[3][k]%mod)%mod;
					}
				}
			}
		}
		printf("%lld\n",ans);
	}
}

namespace task3{
	int mk[2010];
	ll maxx;
	ll ans;
	
	void dfs(int x,int k,ll mul){
		if (!mul)return ;
		if (!k){ans=(ans+mul)%mod;return ;}
		if (x>n)return ;
		for (int i=1;i<=n;i++){
			if (mk[i]!=maxx){
				mk[i]++;
				dfs(x+1,k-1,mul*a[x][i]%mod);
				mk[i]--;
			}
		}
		dfs(x+1,k,mul);
	}
	
	void solve(){
		for (int k=1;k<=n;k++){
			if ((k+n-1)/n<=k/2){
				maxx=k/2;
				dfs(1,k,1);
			}
		}
		
		printf("%lld\n",ans);
	}
}

int main()
{
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);
	n=read();m=read();
	for (int i=1;i<=n;i++){
		for (int j=1;j<=m;j++){
			a[i][j]=read();
		}
	}
	if (m==2)task1::solve();
	else if (n<=10)task3::solve();
	else if (m==3)task2::solve();
	else task3::solve();
	
	return 0;
}
/*
4 2
1 2
3 4
5 6
7 8
*/

