#include<cstdio>
#include<iostream>
#include<string>
#include<cstring>
#include<cstdlib>
#include<queue>
#include<set>
#include<map>
#include<algorithm>
#include<cmath>
//#include<ctime>
using namespace std;

typedef long long ll;

const int INF=0x3f3f3f3f;
const int MAXINT=2147483647;
const ll INFLL=0x3f3f3f3f3f3f3f3fll;
const double EPS=1e-6;
const int MAXN=40000005;

int read(){
	int s=0,f=1;
	char c=getchar();
	while (c<'0' || c>'9'){if (c=='-') f=-1;c=getchar();}
	while (c>='0' && c<='9'){s=s*10+c-'0';c=getchar();}
	s=s*f;
	return s;
}

int readu(){
	int s=0;
	char c=getchar();
	while (c<'0' || c>'9') c=getchar();
	while (c>='0' && c<='9'){s=s*10+c-'0';c=getchar();}
	return s;
}

ll readll(){
	ll s=0,f=1;
	char c=getchar();
	while (c<'0' || c>'9'){if (c=='-') f=-1;c=getchar();}
	while (c>='0' && c<='9'){s=s*10+c-'0';c=getchar();}
	s=s*f;
	return s;
}

ll readull(){
	ll s=0;
	char c=getchar();
	while (c<'0' || c>'9') c=getchar();
	while (c>='0' && c<='9'){s=s*10+c-'0';c=getchar();}
	return s;
}

int n,type;
ll a[MAXN],ans=INFLL,dp[MAXN];

void solve1(){
	for (register int i=1;i<=n;++i){
		a[i]=readull();
	}
	dp[0]=0;
	for (register int i=1;i<=n;++i){
		ll s=a[i];
		for (register int j=i-1;j>=0;--j){
			if (dp[j]<=s){
				dp[i]=s;
				break;
			}
			s=s+a[j];
		}
//		printf("%lld ",dp[i]);
	}
//	printf("\n");
	ll s=0;
	ans=0;
	for (register int i=n;i>=1;--i){
		if (s==0){
			s=dp[i];
			ans+=s*s;
		}
		s-=a[i];
	}
	printf("%lld\n",ans);
}

struct Node{
	int id;
	ll s;
	Node (int a=0,ll b=0){
		id=a;
		s=b;
	}
	bool operator <(const Node &x)const{
		return x.s>s;
	}
};

priority_queue <Node> q;
ll pre[MAXN];

void solve2(){
	for (register int i=1;i<=n;++i){
		a[i]=readull();
		pre[i]=pre[i-1]+a[i];
	}
	dp[1]=a[1];
	int p=0;
	q.push(Node(0,0));
	q.push(Node(1,-pre[1]-dp[1]));
	for (register int i=2;i<=n;++i){
//		printf("%d:\n",i);
		while (!q.empty() && q.top().s+pre[i]>=0){
//			printf("%d,%lld ",q.top().id,q.top().s);
			p=max(p,q.top().id);
			q.pop();
		}
//		printf("\n");
		dp[i]=pre[i]-pre[p];
		q.push(Node(i,-pre[i]-dp[i]));
	}
//	printf("\n");
	/*
	for (register int i=1;i<=n;++i){
		printf("%lld ",dp[i]);
	}
	printf("\n");
	*/
	ll s=0;
	ans=0;
	for (register int i=n;i>=1;--i){
		if (s==0){
			s=dp[i];
			ans+=s*s;
		}
		s-=a[i];
	}
	printf("%lld\n",ans);
}

int main(){
	freopen("partition.in","r",stdin);
	freopen("partition.out","w",stdout);
	n=readu();
	type=readu();
	if (type==0){
		if (n<=5000){
			solve1();
		}
		else{
			solve2();
		}
	}
	return 0;
}

