#include<bits/stdc++.h>
using namespace std;
const int N=200005;
vector<int>e[N];
int n;
namespace solve1
{
	int fa[N],sz[N],rk[N],tot;
	void dfs(int u,int f)
	{
		fa[u]=f,sz[u]=1;
		for(int i=0;i<(int)e[u].size();i++)
		{
			int v=e[u][i];
			if(v==f)
				continue;
			dfs(v,u);
			sz[u]+=sz[v];
		}
	}
	long long ans;
	void calc(int u,int f)
	{
		int flag=1;
		rk[u]=1;
		for(int i=0;i<(int)e[u].size();i++)
		{
			int v=e[u][i];
			if(v==f)
				continue;
			calc(v,u);
			rk[u]+=rk[v];
			if(rk[v]>tot/2)
				flag=0;
		}
		if(tot-rk[u]>tot/2)
			flag=0;
		if(flag)
			ans+=u;
	}
	void main()
	{
		dfs(1,0);
		ans=0;
		for(int i=2;i<=n;i++)
		{
			tot=sz[i];
			calc(i,fa[i]);
			tot=n-sz[i];
			calc(fa[i],i);
		}
		printf("%lld\n",ans);
	}
}
namespace solve2
{
	int dfn[N],a[N];
	void dfs(int u,int f)
	{
		dfn[u]=dfn[f]+1;
		a[dfn[u]]=u;
		for(int i=0;i<(int)e[u].size();i++)
		{
			int v=e[u][i];
			if(v==f)
				continue;
			dfs(v,u);
		}
	}
	long long ans;
	void main()
	{
		ans=0;
		for(int i=1;i<=n;i++)
		{
			if(e[i].size()==1)
			{
				dfs(i,0);
				break;
			}
		}
		for(int i=1;i<n;i++)
		{
			if(i&1)
			{
				ans+=a[i/2];
				ans+=a[i+(n-i)/2]+a[i+(n-i)/2+1];
			}
			else
			{
				ans+=a[i+(n-i)/2+1];
				ans+=a[i/2]+a[i/2+1];
			}
		}
		printf("%lld\n",ans);
	}
}
namespace solve3
{
	void main()
	{
		long long ro,le,ri;
		for(int i=1;i<=n;i++)
		{
			if(e[i].size()==2)
			{
				ro=i;
				le=e[i][0],ri=e[i][1];
				break;
			}
		}
		long long ans=0;
		ans+=n*(n+1)/2-ro;
		ans+=ro*(1ll<<17)+((1ll<<16)-1)*(le+ri);
		printf("%lld\n",ans);
	}
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	scanf("%d",&T);
	while(T--)
	{
		scanf("%d",&n);
		for(int i=1;i<=n;i++)
			e[i].clear();
		for(int i=1;i<n;i++)
		{
			int u,v;
			scanf("%d%d",&u,&v);
			e[u].push_back(v);
			e[v].push_back(u);	
		}	
		if(n<=2000) solve1::main();
		if(n==49991) solve2::main();
		if(n==99995) solve3::main();
	}
	return 0;
}

