#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef double db;
const int N=300010,M=10000010,P=1e9+7;
const db eps=1e-9,pi=asin(1)*2;
const int inf=0x3f3f3f3f;
const int INF=0xcfcfcfcf;
inline ll read();
#define mem(a,b) memset(a,b,sizeof(a))
#define mem(a,b) memset(a,b,sizeof(a))
inline ll ADD(ll a,ll b) { return a+b>=P?a+b-P:a+b; }
inline ll MINUS(ll a,ll b) { return a-b<0?a-b+P:a-b; }
#define plus(a,b) a=ADD(a,b)
#define minus(a,b) a=MINUS(a,b)
#define mul(a,b) a=(a*(b))%P
#define cmax(a,b) a=max(a,b)
#define cmin(a,b) a=min(a,b)

int head[N],ver[M],nxt[M],du[N];
int n,m,tot=1;
inline void add(int x,int y)
{
	ver[++tot]=y,nxt[tot]=head[x],head[x]=tot,du[y]++;
}





inline void init()
{
	mem(head,0);
	mem(du,0);
	tot=1; 
}

#define FILE "centroid"
#ifdef FILE
const int READ_SIZE=1<<20;
char buf[READ_SIZE],*p1=buf,*p2=buf;
#define getchar() p1==p2&&(p2=(p1=buf)+fread(buf,1,READ_SIZE,stdin),p1==p2)?EOF:*p1++
#endif
inline ll read()
{
	ll s=0;
	bool flag=false;
	char ch=getchar();
	for(;ch<'0'||ch>'9';ch=getchar()) if(ch=='-') flag=true;
	for(;'0'<=ch&&ch<='9';ch=getchar()) s=(s<<3)+(s<<1)+(ch^'0');
	if(flag) return -s;
	return s;
}

bool deleted[M];
int size[N],maxp[N],Size=0,maxsize=0; 
inline void get_size(int x,int fa)
{
	size[x]=1,maxp[x]=0;
	for(int i=head[x];i;i=nxt[i])
	{
		int y=ver[i];
		if(deleted[i]||y==fa) continue;
		get_size(y,x);
		size[x]+=size[y];
		cmax(maxp[x],size[y]);
	}
}
inline void subtask1()
{
	ll ans=0,tmp=0;
	for(int i=1;i<n;i++)
	{
		deleted[i<<1]=deleted[i<<1|1]=true;
		for(int j=1;j<=n;j++) size[j]=0;
		get_size(ver[i<<1],0);
		tmp=0,Size=size[ver[i<<1]],maxsize=inf;
//		cerr<<" "<<Size<<" ";
		for(int j=1;j<=n;j++)
		{
			cmax(maxp[j],Size-size[j]);
			if(maxp[j]==maxsize) tmp+=j;
			if(maxp[j]<maxsize) maxsize=maxp[j],tmp=j;
		}
		ans+=tmp;
		
		for(int j=1;j<=n;j++) size[j]=0;
		get_size(ver[i<<1|1],0);
		tmp=0,Size=size[ver[i<<1|1]],maxsize=inf;
//		cerr<<Size<<"\n";
		for(int j=1;j<=n;j++)
		{
			if(!size[j]) continue;
			cmax(maxp[j],Size-size[j]);
			if(maxp[j]==maxsize) tmp+=j;
			if(maxp[j]<maxsize) maxsize=maxp[j],tmp=j;
		}
		ans+=tmp;
		deleted[i<<1]=deleted[i<<1|1]=false;
//		cerr<<ans<<" ";
	}
//	cerr<<"\n";
	printf("%lld\n",ans);
}


int id[N],rk[N];
inline void dfs2(int x,int fa)
{
	id[x]=id[fa]+1,rk[id[x]]=x;
	for(int i=head[x];i;i=nxt[i])
	{
		int y=ver[i];
		if(y==fa) continue;
		dfs2(y,x);
	} 
}
inline void subtask2()
{
	ll ans=0;
	int root=0;
	for(int i=1;i<=n;i++)
		if(du[i]==1) root=i;
	dfs2(root,0);
	for(int i=1;i<n;i++)
	{
		if(i&1) ans+=rk[i+1>>1];
		else ans+=rk[i>>1]+rk[(i>>1)+1];
		
		if(n-i&1) ans+=rk[n-(n-i>>1)];
		else ans+=rk[n-(n-i>>1)]+rk[n-(n-i>>1)+1];
	}
//	for(int i=1;i<=n;i++) ans+=(du[i]+1)*i;
	printf("%lld\n",ans);
}




int root=0;
inline void get_root(int x,int fa)
{
	size[x]=1,maxp[x]=0;
	for(int i=head[x];i;i=nxt[i])
	{
		int y=ver[i];
		if(y==fa) continue;
		get_root(y,x);
		size[x]+=size[y];
		cmax(maxp[x],size[y]);
	}
	cmax(maxp[x],Size-size[x]);
	if(!root||maxp[x]<maxp[root]) root=x;
}
inline void subtask3()
{
	Size=n,root=0;
	get_root(1,0);
//	cerr<<root<<" ";
	ll sum=0;
	for(int i=head[root];i;i=nxt[i]) sum+=ver[i];
//	cerr<<sum<<"\n";
	ll ans=sum*(n-1>>1)%P;
//	cerr<<ans<<" ";
	ll x=1;
	while((x<<1)<=n) x<<=1;
	plus(ans,(x-1)*root%P);
//	cerr<<ans<<" ";
	plus(ans,(ll)n*(n+1)/2%P);
//	cerr<<ans<<"\n";
	printf("%lld\n",ans);
}

int main()
{
#ifdef FILE
	freopen(FILE ".in","r",stdin);
	freopen(FILE ".out","w",stdout);
#endif
	int T=read();
	while(T--)
	{
		init();
		n=read();
		for(int i=1;i<n;i++)
		{
			int x=read(),y=read();
			add(x,y),add(y,x);
		}
//*
		if(n<=2000)
		{
			subtask1();
			continue;
		}
//*/
		bool yes=true;
		for(int i=1;i<=n;i++)
			if(du[i]>2) yes=false;
//*
		if(yes)
		{
			subtask2();
			continue;
		}
//*/
		subtask3();
	}
	return 0;
}
/*
2
5
1 2
2 3
2 4
3 5
7
1 2
1 3
1 4
3 5
3 6
6 7
*/
