#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <vector>
#include <queue>
#include <map>
using namespace std;

typedef long long ll;
const int maxn = 1e6 + 17;
int T, n;
int tot, to[maxn], nxt[maxn], hd[maxn];
int cnt, sz[maxn], mxs[maxn], vis[maxn], mk[maxn];
ll ans;


void fileio() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
}

void addedge(int u, int v) {
	tot++, to[tot] = v, nxt[tot] = hd[u], hd[u] = tot;
}

void init() {
	tot = 0;
	ans = 0;
	memset(to, 0, sizeof(to));
	memset(nxt, 0, sizeof(nxt));
	memset(hd, 0, sizeof(hd));
//	memset(, 0, sizeof());
}

void dfs(int u) {
	vis[u] = 1, mk[u] = 1;
	cnt++;
	sz[u] = 0, mxs[u] = 0;
	for(int i = hd[u]; i; i = nxt[i]) {
		int v = to[i];
		if(vis[v]) continue;
		dfs(v);
		sz[u] += sz[v];
		mxs[u] = max(mxs[u], sz[v]);
	}
	sz[u]++;
	vis[u] = 0;
}

void tsk1() {
 	for(int i = 1; i <= tot; i += 2) {
 		int u = to[i], v = to[i + 1];
// 		printf("\n%d %d\n", u, v);
 		cnt = 0;
 		vis[v] = 1;
 		dfs(u);
// 		printf("%d\n", cnt);
 		for(int i = 1; i <= n; i++) if(mk[i]) {
 			if(cnt - sz[i] <= cnt / 2 && mxs[i] <= cnt / 2) {
 				ans += 1ll * i;
// 				printf("%d %d\n", u, i);
			}
 			mk[i] = 0;
		}
//		printf("%lld ", ans);
		vis[v] = 0;
		
		cnt = 0;
 		vis[u] = 1;
 		dfs(v);
// 		printf("%d\n", cnt);
 		for(int i = 1; i <= n; i++) if(mk[i]) {
 			if(cnt - sz[i] <= cnt / 2 && mxs[i] <= cnt / 2) {
 				ans += 1ll * i;
// 				printf("%d %d\n", v, i);
			}
 			mk[i] = 0;
		}
 		vis[u] = 0;
// 		printf("%lld\n", ans);
	 }
//	 for(int i = 1; i <= n; i++) {
//	 	printf("%d %d %d %d\n", sz[i], mk[i], mxs[i], vis[i]);
//	 }
 }
int main() {
	fileio();
	scanf("%d", &T);
	while(T--) {
		scanf("%d", &n);
		init();
		for(int i = 1; i < n; i++) {
			int u, v;
			scanf("%d%d", &u, &v);
			addedge(u, v), addedge(v, u);
		}
		if(n <= 2000) tsk1();
		printf("%lld\n", ans);
	}
	
	return 0;
}
