//S3-010JS-00515
#include <cctype>
#include <cfloat>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#define ll long long
#define pb push_back
#define mp make_pair
using namespace std;
const int inf=1e9+7;
const int mod=998244353;//hp=[int] hp=[hp] hp%[int] hp/[int]

struct hp {
	int len;
	int num[105];
	void operator = (const int x) {
		memset((*this).num,0,sizeof (*this).num);
		if(x>=10000) {
			(*this).len=2;
			(*this).num[2]=x/10000;
		} else {
			(*this).len=1;
		}
		(*this).num[1]=x%10000;
		return ;
	}
	void operator = (const hp x) {
		for(int i=1; i<=x.len; i++) {
			(*this).num[i]=x.num[i];
		}
		(*this).len=x.len;
		return ;
	}
	bool operator == (const hp x) const {
		hp p=(*this);
		if(x.len!=p.len) {
			return 0;
		}
		for(int i=1; i<=x.len; i++) {
			if(x.num[i]!=p.num[i]) {
				return 0;
			}
		}
		return 1;
	}
	bool operator < (const hp x) const {
		hp p;
		p=(*this);
		if(x.len!=p.len) {
			return p.len<x.len;
		}
		for(int i=1; i<=x.len; i++) {
			if(x.num[i]!=p.num[i]) {
				return p.num[i]<x.num[i];
			}
		}
		return 0;
	}
	bool operator < (const int y) const {
		hp p,x;
		p=(*this);
		x=y;
		if(x.len!=p.len) {
			return p.len<x.len;
		}
		for(int i=1; i<=x.len; i++) {
			if(x.num[i]!=p.num[i]) {
				return p.num[i]<x.num[i];
			}
		}
		return 0;
	}
	bool operator > (const hp x) const {
		return !(((*this)==x)||((*this)<x));
	}
	bool operator > (const int y) const {
		hp x;
		x=y;
		return !(((*this)==x)||((*this)<x));
	}
	hp operator + (const int y) const {
		hp x,p;
		x=y;
		p=(*this);
		for(int i=1; i<=max(p.len,x.len); i++) {
			x.num[i]+=p.num[i];
			int k=0;
			while(x.num[i+k]>=10000) {
				x.num[i+k+1]+=(x.num[i+k]/10000);
				x.num[i+k]=x.num[i+k]%10000;
				k++;
			}
		}
		for(x.len=100; x.len>1; x.len--) {
			if(x.num[x.len]>0) {
				break;
			}
		}
		return x;
	}
	hp operator + (hp x) const {
		hp p;
		p=(*this);
		for(int i=1; i<=max(p.len,x.len); i++) {
			x.num[i]+=p.num[i];
			int k=0;
			while(x.num[i+k]>=10000) {
				x.num[i+k+1]+=(x.num[i+k]/10000);
				x.num[i+k]=x.num[i+k]%10000;
				k++;
			}
		}
		for(x.len=100; x.len>1; x.len--) {
			if(x.num[x.len]>0) {
				break;
			}
		}
		return x;
	}
	hp operator * (const hp x) const {
		hp res;
		res=0;
		hp p=(*this);
		for(int i=1; i<=p.len; i++) { //p
			for(int j=1; j<=x.len; j++) { //x
				res.num[i+j-1]=p.num[i]*x.num[j];
				int k=-1;
				while(res.num[i+j+k]>=10000) {
					res.num[i+j+k+1]+=(res.num[i+j+k]/10000);
					res.num[i+j+k]=res.num[i+j+k]%10000;
					k++;
				}
			}
		}
		for(res.len=100; res.len>1; res.len--) {
			if(res.num[res.len]>0) {
				break;
			}
		}
		return res;
	}
	hp operator * (const int y) const {
		hp res,x;
		res=0;
		x=y;
		hp p=(*this);
		for(int i=1; i<=p.len; i++) { //p
			for(int j=1; j<=x.len; j++) { //x
				res.num[i+j-1]=p.num[i]*x.num[j];
				int k=-1;
				while(res.num[i+j+k]>=10000) {
					res.num[i+j+k+1]+=(res.num[i+j+k]/10000);
					res.num[i+j+k]=res.num[i+j+k]%10000;
					k++;
				}
			}
		}
		for(res.len=100; res.len>1; res.len--) {
			if(res.num[res.len]>0) {
				break;
			}
		}
		return res;
	}
	hp operator / (const int x) const {
		hp p,ans;
		ll d=0;
		p=(*this);
		ans=0;
		for(int i=p.len; i>=1; i--) {
			d=d*10000;
			d=d+p.num[i];
			if(d<x) {
				continue;
			}
			ans.num[i]=d/x;
			int k=0;
			while(ans.num[i+k]>=10000) {
				ans.num[i+k+1]+=(ans.num[i+k]/10000);
				ans.num[i+k]=ans.num[i+k]%10000;
				k++;
			}
			d=d-d/x*x;
		}
		for(ans.len=100; ans.len>1; ans.len--) {
			if(ans.num[ans.len]>0) {
				break;
			}
		}
		return ans;
	}
	int operator % (const int x) const {
		hp p,ans;
		ll d=0;
		p=(*this);
		ans=0;
		for(int i=p.len; i>=1; i--) {
			d=d*10000;
			d=d+p.num[i];
			if(d<x) {
				continue;
			}
			ans.num[i]=d/x;
			int k=0;
			while(ans.num[i+k]>=10000) {
				ans.num[i+k+1]+=(ans.num[i+k]/10000);
				ans.num[i+k]=ans.num[i+k]%10000;
				k++;
			}
			d=d-d/x*x;
		}
		return d;
	}
};
int n,m;
ll sum=0;
ll a[45][505];//Way,Food
int pr[]= {inf,2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,73,79,83,89,97,101,103,107,109,113,127,131,137,139,149,151,157,163,167,173,179,181,191,193,197,199,211,223,227,229,233,239,241,251,257,263,269,271,277,281,283,293,307,311,313,317,331,337,347,349,353,359,367,373,379,383,389,397,401,409,419,421,431,433,439,443,449,457,461,463,467,479,487,491,499,503,509,521,523,541,547,557,563,569,571,577,587,593,599,601,607,613,617,619,631,641,643,647,653,659,661,673,677,683,691,701,709,719,727,733,739,743,751,757,761,769,773,787,797,809,811,821,823,827,829,839,853,857,859,863,877,881,883,887,907,911,919,929,937,941,947,953,967,971,977,983,991,997,1009,1013,1019,1021,1031,1033,1039,1049,1051,1061,1063,1069,1087,1091,1093,1097,1103,1109,1117,1123,1129,1151,1153,1163,1171,1181,1187,1193,1201,1213,1217,1223,1229,1231,1237,1249,1259,1277,1279,1283,1289,1291,1297,1301,1303,1307,1319,1321,1327,1361,1367,1373,1381,1399,1409,1423,1427,1429,1433,1439,1447,1451,1453,1459,1471,1481,1483,1487,1489,1493,1499,1511,1523,1531,1543,1549,1553,1559,1567,1571,1579,1583,1597,1601,1607,1609,1613,1619,1621,1627,1637,1657,1663,1667,1669,1693,1697,1699,1709,1721,1723,1733,1741,1747,1753,1759,1777,1783,1787,1789,1801,1811,1823,1831,1847,1861,1867,1871,1873,1877,1879,1889,1901,1907,1913,1931,1933,1949,1951,1973,1979,1987,1993,1997,1999,2003,2011,2017,2027,2029,2039,2053,2063,2069,2081,2083,2087,2089,2099,2111,2113,2129,2131,2137,2141,2143,2153,2161,2179,2203,2207,2213,2221,2237,2239,2243,2251,2267,2269,2273,2281,2287,2293,2297,2309,2311,2333,2339,2341,2347,2351,2357,2371,2377,2381,2383,2389,2393,2399,2411,2417,2423,2437,2441,2447,2459,2467,2473,2477,2503,2521,2531,2539,2543,2549,2551,2557,2579,2591,2593,2609,2617,2621,2633,2647,2657,2659,2663,2671,2677,2683,2687,2689,2693,2699,2707,2711,2713,2719,2729,2731,2741,2749,2753,2767,2777,2789,2791,2797,2801,2803,2819,2833,2837,2843,2851,2857,2861,2879,2887,2897,2903,2909,2917,2927,2939,2953,2957,2963,2969,2971,2999,3001,3011,3019,3023,3037,3041,3049,3061,3067,3079,3083,3089,3109,3119,3121,3137,3163,3167,3169,3181,3187,3191,3203,3209,3217,3221,3229,3251,3253,3257,3259,3271,3299,3301,3307,3313,3319,3323,3329,3331,3343,3347,3359,3361,3371,3373,3389,3391,3407,3413,3433,3449,3457,3461,3463,3467,3469,3491,3499,3511,3517,3527,3529,3533,3539,3541,3547,3557,3559,3571,3581,3583,3593,3607,3613,3617};
void dfs(int x,int dep,hp val,ll vall,ll sm) {
	if(x>n) {
		return ;
	}
	if(dep>=2) {
		bool ok=1;
		int cnt;
		hp pval=val;
		for(int i=1; i<=500; i++) {
			cnt=0;
			while(val%pr[i]==0) {
				val=val/pr[i];
				cnt++;
			}
			if(cnt>int(dep/2)) {
				ok=0;
				break;
			}
		}
		if(ok) {
			sum+=sm;
			sum%=mod;
		}
		val=pval;
	}
	for(int i=x+1; i<=n; i++) {
		for(int j=1; j<=m; j++) {
			if(a[i][j]!=0) {
				dfs(i,dep+1,val*pr[j],vall*pr[j],sm*a[i][j]);
			}
		}
	}
	return ;
}
int main() {
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	scanf("%d%d",&n,&m);
	for(int i=1; i<=n; i++) {
		for(int j=1; j<=m; j++) {
			scanf("%lld",&a[i][j]);
		}
	}
	hp p;
	p=1;
	dfs(0,0,p,1,1);
	printf("%lld",sum);
	return 0;
}

