#include<bits/stdc++.h>
using namespace std;
const int maxn=5005;
int T,n,ans,num;
vector<int> edge[maxn];
pair<int,int> edges[maxn];
int countTree(int rt,int fa,int forbid){
	num++;
	for (int i=0;i<edge[rt].size();i++){
		int v=edge[rt][i];
		if (v==fa||v==forbid) continue;
		countTree(v,rt,forbid);
	}
	return num;
}
bool checkTree(int rt,int forbid){
	num=0;
	int k=countTree(rt,forbid,forbid);
	for (int i=0;i<edge[rt].size();i++){
		int v=edge[rt][i];
		if (v==forbid) continue;
		num=0;
		if (countTree(v,rt,forbid)>k/2) return false;
	}
	return true;
}
void buildTree(int rt,int fa,int forbid){
	if (checkTree(rt,forbid)) ans+=rt;
	for (int i=0;i<edge[rt].size();i++){
		int v=edge[rt][i];
		if (v==fa||v==forbid) continue;
		buildTree(v,rt,forbid);
	}
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	while (T--){
		scanf("%d",&n);
		ans=0;
		for (int i=1;i<=n;i++) edge[i].clear();
		for (int i=1;i<n;i++){
			int x,y;
			scanf("%d%d",&x,&y);
			edges[i].first=x;
			edges[i].second=y;
			edge[x].push_back(y);
			edge[y].push_back(x);
		}
		for (int i=1;i<n;i++){
			int x=edges[i].first,y=edges[i].second;
			buildTree(x,y,y);
			buildTree(y,x,x);
		}
		printf("%d\n",ans);
	} 
	return 0;
}

