#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#define repo(i,a,b) for(int i = a;i <= b;++i)
#define ll long long
using namespace std;

inline int read(){
	int s=0,w=1;
	char ch = getchar();
	while(ch < '0'||ch > '9'){if(ch == '-')w = -1;ch = getchar();}
	while(ch >= '0' && ch <= '9'){s = s*10+(ch-'0');ch = getchar();}
	return s*w;
}

const int maxn = 50005,maxm = 100005;

int T;
int n,m;
int tot;
int head[maxn],ver[maxm],from[maxm],nex[maxm];
bool vis[maxn];
int du[maxn],id[maxn];
int fa[maxn],size[maxn];

inline void add(int x,int y){
	ver[++tot] = y,nex[tot] = head[x],head[x] = tot,from[tot] = x;
}

void dfs(int f,int x){
	fa[x] = f;
	vis[x] = 1;
	size[x] = 1;
	for(int i = head[x];i && !vis[ver[i]];i = nex[i]){
		dfs(x,ver[i]);
		size[x] += size[ver[i]];
	}
}

void dfs_lian(int x,int d){
	id[d] = x;
	vis[x] = 1;
	for(int i = head[x];i && !vis[ver[i]];i = nex[i]){
		dfs_lian(ver[i],d+1);
	}
}

int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	T = read();
	while(T--){
		n = read();
		memset(head,0,sizeof(head));
		memset(ver,0,sizeof(ver));
		memset(from,0,sizeof(from));
		memset(nex,0,sizeof(nex));
		memset(vis,0,sizeof(vis));
		memset(du,0,sizeof(du));
		memset(fa,0,sizeof(fa));
		memset(size,0,sizeof(size));
		memset(id,0,sizeof(id));
		int x,y;
		
		if(true){
			repo(i,1,n-1){
				x = read(),y = read();
				add(x,y);
				add(y,x);
				du[x]++;
				du[y]++;
			}
			int root;
			for(int i = 1;i <= n;++i){
				if(du[i]==1){
					root = i;
					break;
				}
			}
			id[1] = root;
			dfs_lian(root,1);
			int ans = 0;
			for(int i = 1;i < n;++i){
				if(i & 1){
					ans += id[i/2+1];
					ans += id[n-(n-i)/2]+id[n-(n-i)/2+1]; 
				}else{
					ans += id[i/2]+id[i/2+1];
					ans += id[n-(n-i)/2];
				}
			}
			printf("%d\n",ans);
		}
		
	}
	return 0;
}
