#include <bits/stdc++.h>
#define ll long long
using namespace std;
inline ll rd() {
	ll x = 0;
	char ch = getchar();
	for (; !isdigit(ch); ch = getchar());
	for (; isdigit(ch); ch = getchar()) {
		x = (x << 1) + (x << 3) + (ch ^ 48);
	}
	return x;
}
struct node {
	ll nxt, to;
} edge[600010];
ll T, n, ans, head[300010], tot, du[300010], siz[300010], s, fa[300010], st, lian[300010], yi;
void init() {
	ans = 0;
	memset(head, 0, sizeof(head));
	tot = 0;
	memset(du, 0, sizeof(du));
	memset(siz, 0, sizeof(siz));
	memset(fa, 0, sizeof(fa));
	memset(lian, 0, sizeof(lian));
}
void add(ll from, ll to) {
	edge[++tot].nxt = head[from];
	edge[tot].to = to;
	head[from] = tot;
}
void df(ll u, ll fath) {
	fa[u] = fath;
	for (ll i = head[u]; i; i = edge[i].nxt) {
		ll v = edge[i].to;
		if (v == fath) {
			continue;
		}
		df(v, u);
	}
}
void dfs(ll u, ll ct) {
	siz[u] = 1;
	for (ll i = head[u]; i; i = edge[i].nxt) {
		ll v = edge[i].to;
		if (v == fa[u] || v == ct) {
			continue;
		}
		dfs(v, ct);
		siz[u] += siz[v];
	}
}
bool check(ll x, ll ct) {
	if (s - siz[x] > (s >> 1)) {
		return 0;
	}
	for (ll i = head[x]; i; i = edge[i].nxt) {
		ll v = edge[i].to;
		if (v == fa[x] || v == ct) {
			continue;
		}
		if (siz[v] > (s >> 1)) {
			return 0;
		}
	}
	return 1;
}
void dfs1(ll u, ll ct) {
	if (check(u, ct)) {
		ans += u;
	}
	for (ll i = head[u]; i; i = edge[i].nxt) {
		ll v = edge[i].to;
		if (v == fa[u] || v == ct) {
			continue;
		}
		dfs1(v, ct);
	}
}
bool checklian() {
	st = 0;
	ll sum = 0;
	for (ll i = 1; i <= n; i++) {
		if (du[i] == 1) {
			sum++;
			st = i;
		}
	}
	if (sum == 2) {
		return 1;
	}
	return 0;
}
void dfs2(ll u, ll fath) {
	lian[++lian[0]] = u;
	for (ll i = head[u]; i; i = edge[i].nxt) {
		ll v = edge[i].to;
		if (v == fath) {
			continue;
		}
		dfs2(v, u);
	}
}
bool checkercha() {
	st = 0;
	yi = 0;
	ll sum = 0;
	for (ll i = 1; i <= n; i++) {
		if (du[i] == 2) {
			st = i;
			sum++;
		} else if (du[i] == 1) {
			yi++;
		}
	}
	if (sum == 1) {
		return 1;
	}
	return 0;
}
int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	T = rd();
	while (T--) {
		init();
		n = rd();
		for (ll i = 1; i < n; i++) {
			ll x = rd(), y = rd();
			add(x, y);
			add(y, x);
			du[x]++;
			du[y]++;
		}
		if (n <= 5000) {
			df(1, 0);
			for (ll i = 2; i <= n; i++) {
				dfs(1, i);
				dfs(i, i);
				s = siz[1];
				dfs1(1, i);
				s = siz[i];
				dfs1(i, i);
			}
			cout << ans << endl;
		} else if (checklian()) {
			dfs2(st, 0);
			for (ll i = 1; i < n; i++) {
				if (i & 1) {
					ans += lian[(i + 1) >> 1];
				} else {
					ans += lian[i >> 1] + lian[(i >> 1) + 1];
				}
				if ((n - i) & 1) {
					ans += lian[(i + 1 + n) >> 1];
				} else {
					ans += lian[(i + 1 + n) >> 1] + lian[((i + 1 + n) >> 1) + 1];
				}
			}
			cout << ans << endl;
		} else if (checkercha()) {
			ll ch[10];
			ch[0] = 0;
			for (ll i = head[st]; i; i = edge[i].nxt) {
				ll v = edge[i].to;
				ch[++ch[0]] = v;
			}
			ans += yi * st;
			ans += (n >> 1) * ch[2];
			ans += (n >> 1) * ch[1];
			for (ll i = 1; i <= n; i++) {
				if (i != st) {
					ans += i;
				}
			}
			cout << ans << endl;
		}
	}
	return 0;
}

