#include<bits\stdc++.h>
#define ll long long
#define fir(a, b, c) for (int a = b; a <= c; ++ a)
using namespace std;
inline int read() {
	int x = 0; bool flg = 1; char c = getchar();
	for (; !isdigit(c); c = getchar()) if (c == '-') flg = 0;
	for (; isdigit(c); c = getchar()) x = x * 10 + c - '0';
	return flg ? x : -x;
}

const int N = 3e6 + 10;
int T, n, head[N], l;
struct node {
	int v, nxt;
}e[2*N];
int si[N];
inline void add(int x, int y) {
	++ l; e[l].v = y; e[l].nxt = head[x]; head[x] = l;
}
int fa[N];

void dfs(int p) {
	for (int i = head[p]; i; i = e[i].nxt) {
		int y = e[i].v;
		if (y == fa[p]) continue;
		fa[y] = p;
		dfs(y);
	}
}

int dx, dy, m;
ll ans = 0;

void work1(int p, int pre) {
	++ m;
	for (int j = head[p]; j; j = e[j].nxt) {
		int y = e[j].v;
		if ((p == dx && y == dy) || (p == dy && y == dx) || (y == pre)) continue;
		work1(y, p);
	}
}

void work2(int p, int pre) {
	si[p] = 1;
	int ms = -1;
	for (int j = head[p]; j; j = e[j].nxt) {
		int y = e[j].v;
		if ((p == dx && y == dy) || (p == dy && y == dx) || (y == pre)) continue;
		work2(y, p);
		si[p] += si[y];
		ms = max(ms, si[y]);
	}
	ms = max(ms, m-si[p]);
	if (ms <= (m/2)) ans += (ll)p;
}

int du[N], xi;
int ff = 0;

void ddf(int p, int pre) {
	ans += xi*p;
	xi ++;
	if (ff != 0) {
		if (ff == 2) {
			xi = (n+1)/2;
			ff = 0;
		}
		else if (n % 2 == 0) {
				xi = 2; ff = 2;
			}	
		else {
			xi = (n+1)/2;
			ff = 0;
		}
	}
	else if (xi > (n+1)/2) xi = 2, ff = 1;
	
	for (int j = head[p]; j; j = e[j].nxt) {
		int y = e[j].v;
		if (y == pre) continue;
		ddf(y, p);
	}
}

int main() {
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	T = read();
	while (T --) {
		ans = 0;
		n = read(); memset(head, 0, sizeof(head));
		l = 0;
		fir (i, 2, n) {
			int x, y; x = read(); y = read();
			add (x, y); add (y, x);
			du[x]++; du[y]++;
		}
		bool bo = 0;
		fir (i, 1, n) {
			if (du[i] > 2) {
				bo = 1; break;
			}
		}
		if (n >= 30000) {
			int x = 1;
			xi = 2; ff = 0;
			fir (i, 1, n) if (du[i] ==  1) {
				x = i; break;
			}
			ff = 0;
			ddf(x, 0);
			cout<<ans<<endl;
			continue;
		}
		dfs(1);
		fir (i, 2, n) {
			dx = i, dy = fa[i];
			m = 0;
			work1(i, dy);
			memset(si, 0, sizeof(si));
			work2(i, dy);
			m = 0;
			memset(si, 0, sizeof(si));
			work1(fa[i], dx);
			work2(fa[i], dx);
		}
		printf("%lld\n", ans);
	}
	return 0;
}

