#include <iostream>
#include <cstdio>
#include <vector>
#include <cmath>
#include <map>

#define MAGIC 998244353

using namespace std;

int n, m, a[102][2002], tmp;

bool vis_n[102];
int cnt_m[2002];
int max_m = 0;
int rslt = 0;

void dfs(int depth, int stat, int i_s) {
	
	if (stat == 0) return;
	
	if (max_m << 1 <= depth && depth != 0) {
		rslt += stat;
		if (rslt > MAGIC) rslt %= MAGIC;
	}
	
	for (register int i = i_s; i < n; ++ i) {
		if (vis_n[i]) continue;
		vis_n[i] = true;
		for (register int j = 0; j < m; ++ j) {
			cnt_m[j] ++;
			register int last_max_m = max_m;
			max_m = max(max_m, cnt_m[j]);
			dfs(depth + 1, stat * a[i][j], i);
			max_m = last_max_m;
			cnt_m[j] --;
		}
		vis_n[i] = false;
	}
	
}

int main() {
	
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	
	cin >> n >> m;
	
	for (register int i = 0; i < n; ++ i) {
		for (register int j = 0; j < m; ++ j) {
			cin >> a[i][j];
		}
	}
	
	dfs(0, 1, 0);
	
	cout << (rslt % MAGIC);
	
	return 0;
	
}
