#include<bits/stdc++.h>
using namespace std;
#define dbg(x) cout << #x << " : " << x << endl
typedef long long LL;
const int N = 5000 + 10, M = 5e5 + 10;
const LL INF = 4e18;

int type, n;
LL a[M], sum[M], f[N][N], ans;

void solve1(){
	for(int i = 0; i <= 5000; ++ i){
		for(int j = 0; j <= 5000; ++ j){
			f[i][j] = INF;
		}
	}
	for(int i = 0; i <= n; ++ i) f[i][i] = sum[i] * sum[i];
	for(int i = 1; i <= n; ++ i){
		for(int j = 1; j <= i; ++ j){
			int last = i - j;
			for(int k = 1; k <= last; ++ k){
				if(sum[i] - sum[last] < sum[last] - sum[last - k]) break;
				f[i][j] = min(f[i][j],
						      f[last][k] + (sum[i] - sum[last]) * (sum[i] - sum[last]));
//				printf("%d ", f[i][j]);
			}
//			printf("\n");
		}
		
	}
	ans = INF;
	for(int i = 1; i <= n; ++ i){
		ans = min(ans, f[n][i]);
	}
	printf("%lld", ans);
}


void solve2(){
	for(int i = 1; i <= n; ++ i){
		if(a[i] >= a[i - 1]) ans += a[i] * a[i];
		else {
			int y = a[i - 1], x = a[i];
			while(a[i] < y && i < n){
				i ++;
				a[i] += a[i - 1];
			}
			if((x + y) * (x + y) <= a[i] * a[i]) ans -= y * y, ans += (x + y) * (x + y), a[i] -= x;
			else ans += a[i] * a[i];
		}
	}
	printf("%lld", ans);
}

int main()
{
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	scanf("%d%d", &n, &type);
	for(int i = 1; i <= n; ++ i){
		scanf("%lld", &a[i]);
		sum[i] = sum[i - 1] + a[i];
	}
	if(n <= 5000) solve1();
	else solve2();
	fclose(stdin);
	fclose(stdout);
	return 0;
}
