#include <bits/stdc++.h>
using namespace std;

typedef pair<int,int> pii;
typedef long long ll;

const ll mod=1e9+7;
const int maxn=100005;

template<class T>ostream& operator<<(ostream& out,vector<T> _v) {
	for(int i=0; i<_v.size(); ++i)out<<_v[i]<<' ';
	return out;
}
template<class T1,class T2>ostream& operator<<(ostream& out,pair<T1,T2> _p) {
	out<<_p.first<<' '<<_p.second;
	return out;
}
ll fastp(ll b,int x) {
	if(x==0)return 1ll;
	ll tmp=fastp(b,x>>1);
	if(x&1)return tmp*tmp%mod*b%mod;
	return tmp*tmp%mod;
}

int wson[2005],sz[2005],par[2005],color[2005];
pii edge[2005];
vector<int> G[2005];

int n;
int d1,d2;
ll ans;

bool isdel(int x,int y) {
	if(x==d1&&y==d2)return true;
	if(x==d2&&y==d1)return true;
	return false;
}

void dfs(int x,int p,int c) {
	sz[x]=1;
	color[x]=c;
	par[x]=p;
	for(int i=0; i<G[x].size(); ++i) {
		int u=G[x][i];
		if(u==p)continue;
		dfs(u,x,c);
		sz[x]+=sz[u];
		if(wson[x]==-1||sz[u]>sz[wson[x]])wson[x]=u;
	}
}

void MAIN() {
	for(int i=0; i<2005; ++i)G[i].clear();
	scanf("%d",&n);
	ans=0;
	for(int i=0; i<n-1; ++i) {
		int x,y;
		scanf("%d%d",&x,&y);
		--x,--y;
		edge[i]=pii(x,y);
		G[x].push_back(y);
		G[y].push_back(x);
	}
	for(int i=0; i<n-1; ++i) {
		memset(wson,-1,sizeof(wson));
		memset(sz,0,sizeof(sz));
		memset(par,-1,sizeof(par));
		memset(color,0,sizeof(color));
		d1=edge[i].first,d2=edge[i].second;
		dfs(d1,d2,1);
		dfs(d2,d1,2);
		par[d1]=-1;
		par[d2]=-1;
		int cnt1=0,cnt2=0;
//		assert(sz[d1]+sz[d2]==n);
		for(int j=0; j<n; ++j) {
			if(color[j]==1) {
				if(par[j]==-1) {
					if(wson[j]==-1||sz[wson[j]]<=sz[d1]/2)ans+=j+1,cnt1++;
				} else if(wson[j]==-1) {
					if(sz[d1]-sz[j]<=sz[d1]/2)ans+=j+1,cnt1++;
				} else {
					if(max(sz[wson[j]],sz[d1]-sz[j])<=sz[d1]/2)ans+=j+1,cnt1++;
				}
			} else {
				if(par[j]==-1) {
					if(wson[j]==-1||sz[wson[j]]<=sz[d2]/2)ans+=j+1,cnt2++;
				} else if(wson[j]==-1) {
					if(sz[d2]-sz[j]<=sz[d2]/2)ans+=j+1,cnt2++;
				} else {
					if(max(sz[wson[j]],sz[d2]-sz[j])<=sz[d2]/2)ans+=j+1,cnt2++;
				}
			}
//			assert(cnt1<=2);
//			assert(cnt2<=2);
		}
	}
	printf("%lld\n",ans);
}

int main() {
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	scanf("%d",&T);
	while(T--)MAIN();
	return 0;
}

