#include <bits/stdc++.h>
using namespace std;

typedef pair<int,int> pii;
typedef long long ll;

const ll mod=1e9+7;
const int maxn=100005;

template<class T>ostream& operator<<(ostream& out,vector<T> _v){for(int i=0;i<_v.size();++i)out<<_v[i]<<' ';return out;}
template<class T1,class T2>ostream& operator<<(ostream& out,pair<T1,T2> _p){out<<_p.first<<' '<<_p.second;return out;}
ll fastp(ll b,int x){if(x==0)return 1ll;ll tmp=fastp(b,x>>1);if(x&1)return tmp*tmp%mod*b%mod;return tmp*tmp%mod;}

struct SegTree{
	ll val;
	SegTree():val(0){}
}tree[5005][5005*4];

void build(int x,int id,int l,int r){
	if(l==r){
		tree[x][id].val=5e18;
		return;
	}
	int mid=l+r>>1;
	build(x,id<<1,l,mid);
	build(x,id<<1|1,mid+1,r);
	tree[x][id].val=min(tree[x][id<<1].val,tree[x][id<<1|1].val);
}

ll query(int x,int id,int l,int r,int L,int R){
	if(L>r||R<l)return 5e18;
	if(L<=l&&r<=R)return tree[x][id].val;
	int mid=l+r>>1;
	return min(query(x,id<<1,l,mid,L,R),query(x,id<<1|1,mid+1,r,L,R));
}

void modify(int x,int id,int l,int r,int pos,ll val){
	if(pos<l||pos>r)return;
	if(l==r){
		tree[x][id].val=val;
		return;
	}
	int mid=l+r>>1;
	modify(x,id<<1,l,mid,pos,val);
	modify(x,id<<1|1,mid+1,r,pos,val);
	tree[x][id].val=min(tree[x][id<<1].val,tree[x][id<<1|1].val);
}

int n,type;
int a[500005];
ll dp[5005][5005];
ll sum[5005];

ll getsum(int x,int y){
	if(x==0)return sum[y];
	return sum[y]-sum[x-1];
}

void task60(){
	for(int i=1;i<=n;++i)sum[i]+=sum[i-1]+a[i];
	memset(dp,-1,sizeof(dp));
	for(int i=1;i<=n;++i){
		build(i,1,1,i+1);
		for(int j=0;j<i;++j){
			if(j==0){
				dp[i][j]=getsum(1,i)*getsum(1,i);
				modify(i,1,1,i+1,j+1,dp[i][j]);
			}
			int st=j+1;
			ll s=getsum(st,i);
			int l=0,r=j-1,mni=-1;
			while(l<=r){
				int mid=l+r>>1;
				if(getsum(mid+1,j)<=s)r=mid-1,mni=mid;
				else l=mid+1;
			}
			if(mni==-1)continue;
			if(query(j,1,1,j+1,mni+1,j+1)>4e18)continue;
			dp[i][j]=query(j,1,1,j+1,mni+1,j+1)+s*s;
			modify(i,1,1,i+1,j+1,dp[i][j]);
		}
	}
	ll ans=5e18;
	for(int i=0;i<n;++i){
		if(dp[n][i]!=-1)ans=min(ans,dp[n][i]);
	}
	printf("%lld\n",ans);
}

void task1(){
	for(int i=1;i<=n;++i)scanf("%d",a+i);
	if(n<=5000)task60();
}

void task2(){
	
}

int main(){
	freopen("partition.in","r",stdin);
	freopen("partition.out","w",stdout);
	scanf("%d%d",&n,&type);
	if(type==0){
		task1();
	}
	else{
		task2();
	}
	return 0;
}

