#include<bits/stdc++.h>
using namespace std;
const int MAXN = 4e7 + 5;
const int MAXM = 1e5 + 5;
typedef long long ll;
template <typename T> void read(T &x) {
	x = 0; int f = 1;
	char ch = getchar();
	for (; !isdigit(ch); ch = getchar()) if (ch == '-') f = -f;
	for (; isdigit(ch); ch = getchar()) x = x * 10 + ch - '0';
	x *= f;
}
namespace Explore { /// Not used in program, Just to record it.
	const int MAXN = 55;
	const long long INF = 1e18;
	void chkmin(ll &x, int &a, ll y, int b) {
		if (y < x) x = y, a = b;
	}
	int n, type, a[MAXN], nxt[MAXN][MAXN], where[MAXN][MAXN]; 
	ll dp[MAXN][MAXN], s[MAXN];
	void main() {
		read(n), read(type);
		for (int i = 1; i <= n; i++)
			read(a[i]), s[i] = s[i - 1] + a[i];
		for (int i = 0; i <= n; i++)
		for (int j = 0; j <= n; j++)
			dp[i][j] = INF, where[i][j] = -1;
		for (int i = 1; i <= n; i++) {
			nxt[i][i] = i + 1;
			for (int j = i - 1; j >= 0; j--) {
				nxt[i][j] = nxt[i][j + 1];
				while (nxt[i][j] <= n && s[nxt[i][j]] - s[i] < s[i] - s[j]) nxt[i][j]++;
			}
		}
		dp[0][1] = s[1] * s[1];
		for (int i = 0; i <= n; i++)
		for (int j = i + 1; j <= n; j++) {
			chkmin(dp[i][j + 1], where[i][j + 1], dp[i][j] + (s[j + 1] - s[i]) * (s[j + 1] - s[i]) - (s[j] - s[i]) * (s[j] - s[i]), i);
			chkmin(dp[j][nxt[j][i]], where[j][nxt[j][i]], dp[i][j] + (s[nxt[j][i]] - s[j]) * (s[nxt[j][i]] - s[j]), i);
		}
		for (int i = 1; i <= n; i++) {
			for (int j = 1; j <= n; j++)
				printf("%4d", where[i][j]);
			printf("\n");
		}
		ll ans = INF;
		for (int i = 0; i <= n; i++)
			ans = min(ans, dp[i][n]);
		cout << ans << endl;
	}
}
namespace Squared { // O(N ^ 2) Version of the program, Not used in program
	const int MAXN = 55;
	const long long INF = 1e18;
	int n, type, a[MAXN]; ll s[MAXN];
	int pos[MAXN]; ll dp[MAXN];
	void main() {
		read(n), read(type);
		for (int i = 1; i <= n; i++)
			read(a[i]), s[i] = s[i - 1] + a[i];
		for (int i = 1; i <= n; i++) {
			dp[i] = dp[pos[i]] + (s[i] - s[pos[i]]) * (s[i] - s[pos[i]]);
			for (int j = i + 1; j <= n; j++)
				if (s[j] - s[i] >= s[i] - s[pos[i]]) pos[j] = i;
		}
		cout << dp[n] << endl;
	}
}
const int P = 1e9;
struct INT {int a[4]; };
INT get(ll x) {
	INT ans;
	ans.a[0] = x % P;
	ans.a[1] = x / P;
	ans.a[2] = 0;
	ans.a[3] = 0;
	return ans;
}
INT sqr(ll x) {
	int a = x % P, b = x / P;
	INT ans; ll res = 0;
	res += 1ll * a * a;
	ans.a[0] = res % P; res /= P;
	res += 2ll * a * b;
	ans.a[1] = res % P; res /= P;
	res += 1ll * b * b;
	ans.a[2] = res % P;
	ans.a[3] = res /= P;
	return ans;
}
INT operator + (INT a, INT b) {
	for (int i = 0; i <= 3; i++) {
		a.a[i] += b.a[i];
		if (a.a[i] >= P) {
			a.a[i] -= P;
			a.a[i + 1] += 1;
		}
	}
	return a;
}
INT operator * (INT a, INT b) {
	INT ans; ll res = 0;
	for (int i = 0; i <= 3; i++) {
		for (int j = 0; j <= i; j++)
			res += 1ll * a.a[j] * b.a[i - j];
		ans.a[i] = res % P;
		res /= P;
	}
	return ans;
}
void print(INT ans) {
	for (int i = 3; i >= 0; i--)
		if (ans.a[i]) {
			printf("%d", ans.a[i]);
			for (int j = i - 1; j >= 0; j--)
				printf("%09d", ans.a[j]);
			printf("\n");
			return;
		}
	puts("0");
}
ll s[MAXN]; int n, m, type, dp[MAXN];
int main() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	read(n), read(type);
	if (type == 0) {
		for (int i = 1; i <= n; i++)
			read(s[i]), s[i] += s[i - 1];
	} else {
		int x, y, z; read(x), read(y), read(z);
		read(s[1]), read(s[2]), read(m);
		for (int i = 3; i <= n; i++)
			s[i] = (x * s[i - 1] + y * s[i - 2] + z) & ((1 << 30) - 1);
		static int p[MAXM], l[MAXM], r[MAXM];
		for (int i = 1; i <= m; i++) {
			read(p[i]), read(l[i]), read(r[i]);
			for (int j = p[i - 1] + 1; j <= p[i]; j++) {
				s[j] = s[j] % (r[i] - l[i] + 1) + l[i];
				s[j] += s[j - 1];
			}
		}
	}
	static int q[MAXN]; int l = 0, r = 0;
	for (int i = 1; i <= n; i++) {
		while (l + 1 <= r && s[i] >= 2 * s[q[l + 1]] - s[dp[q[l + 1]]]) l++;
		dp[i] = q[l]; ll tmp = 2 * s[i] - s[dp[i]];
		while (l <= r && tmp <= 2 * s[q[r]] - s[dp[q[r]]]) r--;
		q[++r] = i;
	}
	INT ans = get(0);
	for (int i = n; i != 0; i = dp[i])
		ans = ans + sqr(s[i] - s[dp[i]]);
	print(ans);
	return 0;
}
