#include <bits/stdc++.h>
#define ll long long
using namespace std;
template <typename T> void chkmax(T &x, T y) {x = x > y ? x : y;}
template <typename T> void chkmin(T &x, T y) {x = x < y ? x : y;}
template <typename T> void read(T &x) {
	x = 0; int f = 1; char c = getchar();
	while (!isdigit(c)) {if (c == '-') f = -1; c = getchar();}
	while (isdigit(c)) x = x * 10 + c - '0', c = getchar(); x *= f;
}
const int N = 300010, inf = 1 << 30;
int n, cnt, head[N];
struct Edge {int next, num;} e[N * 3];
void add(int x, int y) {e[++cnt] = (Edge) {head[x], y}, head[x] = cnt;}
namespace bf {
	int rt, now, f[N], siz[N]; ll ans;
	void getsiz(int x, int fa) {
		siz[x] = 1;
		for (int p = head[x]; p; p = e[p].next) {
			int y = e[p].num;
			if (y ^ fa) getsiz(y, x), siz[x] += siz[y];
		}
	}
	void getr(int x, int fa) {
		f[x] = 0;
		for (int p = head[x]; p; p = e[p].next) {
			int y = e[p].num; if (y == fa) continue;
			getr(y, x), chkmax(f[x], siz[y]);
		}
		chkmax(f[x], now - siz[x]);
		if (f[x] < f[rt]) rt = x;
	}
	void work(int x, int fa) {
		for (int p = head[x]; p; p = e[p].next) {
			int y = e[p].num; if (y == fa) continue;
			for (int i = 1; i <= n; i++) f[i] = inf;
			getsiz(x, y), f[rt = 0] = inf, now = siz[x], getr(x, y);
			for (int i = 1; i <= n; i++) if (f[i] == f[rt]) ans += i;
			for (int i = 1; i <= n; i++) f[i] = inf;
			getsiz(y, x), f[rt = 0] = inf, now = n - siz[x], getr(y, x);
			for (int i = 1; i <= n; i++) if (f[i] == f[rt]) ans += i;
			work(y, x);
		}
	}
	void solve() {ans = 0, work(1, 0), cout << ans << '\n';}
}
namespace subtask1 {
	int len, a[N], s[N], id[N];
	bool check() {
		memset(s, 0, sizeof(s));
		for (int i = 1; i <= n; i++)
			for (int p = head[i]; p; p = e[p].next)
				s[i]++, s[e[p].num]++;
		for (int i = 1; i <= n; i++) if ((s[i] /= 2) > 2) return false;
		return true;
	}
	void dfs(int x, int fa) {
		a[++len] = x;
		for (int p = head[x]; p; p = e[p].next)
			if (e[p].num != fa) dfs(e[p].num, x);
	}
	void solve() {
		int rt;
		for (int i = 1; i <= n; i++)
			if (s[i] == 1) {rt = i; break;}
		len = 0, dfs(rt, 0); ll ans = 0;
		for (int i = 1; i < n; i++) {
			if (i & 1) ans += a[(i + 1) / 2]; else ans += a[i / 2] + a[i / 2 + 1];
			if ((n - i) & 1) ans += a[i + (n - i + 1) / 2]; else ans += a[i + (n - i) / 2] + a[i + (n - i) / 2 + 1];
		}
		cout << ans << '\n';
	}
}
void solve() {
	read(n), cnt = 0;
	memset(head, 0, sizeof(head)), memset(e, 0, sizeof(e));
	for (int i = 1; i < n; i++) {
		int x, y; read(x), read(y);
		add(x, y), add(y, x);
	}
	if (n <= 2000) return bf::solve(), void();
	if (subtask1::check()) return subtask1::solve(), void();
}
int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T; read(T);
	while (T--) solve();
	return 0;
}
