#include <bits/stdc++.h>
#define ll long long
using namespace std;
template <typename T> void chkmax(T &x, T y) {x = x > y ? x : y;}
template <typename T> void chkmin(T &x, T y) {x = x < y ? x : y;}
template <typename T> void read(T &x) {
	x = 0; int f = 1; char c = getchar();
	while (!isdigit(c)) {if (c == '-') f = -1; c = getchar();}
	while (isdigit(c)) x = x * 10 + c - '0', c = getchar(); x *= f;
}
const int N = 110, M = 2010, mod = 998244353;
int n, m, a[N][M];
void add(int &x, const int &y) {x = x + y >= mod ? x + y - mod : x + y;}
namespace subtask1 {
	const static int MAXN = 50;
	int f[MAXN][MAXN][MAXN];
	void solve() {
		f[0][0][0] = 1;
		for (int i = 0; i < n; i++)
			for (int j = 0; j <= i; j++)
				for (int k = 0; k <= i; k++) {
					if (!f[i][j][k]) continue; int t = f[i][j][k];
					add(f[i + 1][j][k], t);
					add(f[i + 1][j + 1][k], 1ll * t * a[i + 1][1] % mod);
					add(f[i + 1][j][k + 1], 1ll * t * a[i + 1][2] % mod);
				}
		int ans = 0;
		for (int i = 0; i <= n; i++)
			for (int j = 0; j <= n; j++) {
				int s = i + j;
				if (s && i <= s / 2 && j <= s / 2) add(ans, f[n][i][j]);
			}
		cout << ans << '\n';
	}
}
namespace subtask2 {
	const static int MAXN = 50;
	int f[MAXN][MAXN][MAXN][MAXN];
	void solve() {
		f[0][0][0][0] = 1;
		for (int i = 0; i < n; i++)
			for (int j = 0; j <= i; j++)
				for (int k = 0; k <= i; k++)
					for (int l = 0; l <= i; l++) {
						if (!f[i][j][k][l]) continue; int t = f[i][j][k][l];
						add(f[i + 1][j][k][l], t);
						add(f[i + 1][j + 1][k][l], 1ll * t * a[i + 1][1] % mod);
						add(f[i + 1][j][k + 1][l], 1ll * t * a[i + 1][2] % mod);
						add(f[i + 1][j][k][l + 1], 1ll * t * a[i + 1][3] % mod);
					}
		int ans = 0;
		for (int i = 0; i <= n; i++)
			for (int j = 0; j <= n; j++)
				for (int k = 0; k <= n; k++) {
					int s = i + j + k;
					if (s && i <= s / 2 && j <= s / 2 && k <= s / 2) add(ans, f[n][i][j][k]);
				}
		cout << ans << '\n';
	}
}
int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	read(n), read(m);
	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= m; j++)
			read(a[i][j]);
	if (m == 2) return subtask1::solve(), 0;
	if (m == 3) return subtask2::solve(), 0;
	return 0;
}
