#include<bits/stdc++.h>
#define F first
#define S second
#define mp make_pair
#define pb push_back
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int,int> pii;
typedef vector<int> vi;
const int INF=0x3f3f3f3f;
const ll INF64=9e18;
const int maxn=1e5+5;
inline int read(){
	char ch=getchar(); int sum=0; int f=1;
	while(!isdigit(ch)) f=ch=='-'?-1:1,ch=getchar();
	while(isdigit(ch)) sum=sum*10+ch-'0',ch=getchar();
	return sum*f;
}
int n,type;
int a[maxn];
namespace Segmentree{
	struct Tree{
		ll val;
		int l,r;
		Tree(){
			val=INF64;
			l=r=0;
		}
	}tree[5000*5000+5];
	int tot;
	int root[maxn];
	inline void push_up(int k){
		if(!tree[k].r) tree[k].val=tree[tree[k].l].val;
		else if(!tree[k].l) tree[k].val=tree[tree[k].r].val;
		else tree[k].val=min(tree[tree[k].l].val,tree[tree[k].r].val);
	}
	inline void update(int& k,int l,int r,int x,ll val){
		if(!k) k=++tot;
		if(l==r){
			tree[k].val=min(tree[k].val,val);
			return;
		}
		int mid=(l+r)>>1;
		if(x<=mid) update(tree[k].l,l,mid,x,val);
		else update(tree[k].r,mid+1,r,x,val);
		push_up(k);
	}
	inline ll query(int k,int l,int r,int x,int y){
		if(x<=l&&r<=y) return tree[k].val;
		int mid=(l+r)>>1;
		ll res=INF64;
		if(x<=mid) res=min(res,query(tree[k].l,l,mid,x,y));
		if(y>mid) res=min(res,query(tree[k].r,mid+1,r,x,y));
		return res;
	}
}
using namespace Segmentree;
namespace Subtask1{
	ll dp[5005][5005];
	ll sum[5005];
	inline void solve(){
	//	cout<<INFu<<endl;
		for(int i=1;i<=n;i++) sum[i]=sum[i-1]+a[i];
		for(int i=1;i<=n;i++)
			for(int j=1;j<=i;j++) dp[i][j]=INF64;
		for(int i=1;i<=n;i++){
			dp[i][1]=1ll*sum[i]*sum[i];
			update(root[i],1,i,1,dp[i][1]);
			for(int j=2;j<=i;j++){
				int l=1; int r=j-1;
				int mid=0;
				while(l<=r){
					mid=(l+r)>>1;
					if(sum[j-1]-sum[mid-1]>sum[i]-sum[j-1]) l=mid+1;
					else r=mid-1;
				}
			//	cout<<l<<' '<<r<<' '<<mid<<' '<<i<<' '<<j<<endl;
				dp[i][j]=query(root[j-1],1,j-1,l,j-1)+1ll*(sum[i]-sum[j-1])*(sum[i]-sum[j-1]);
				update(root[i],1,i,j,dp[i][j]);
			}
		}
		/*for(int i=1;i<=n;i++){
			for(int j=1;j<=i;j++) cout<<dp[i][j]<<' ';
			cout<<endl;
		}*/
		ll ans=INF64;
		for(int i=1;i<=n;i++) ans=min(ans,dp[n][i]);
		printf("%lld\n",ans);
	}
}	
int main(){
	freopen("partition.in","r",stdin);
	freopen("partition.out","w",stdout);
	n=read(); type=read();
	if(!type){
		for(int i=1;i<=n;i++) a[i]=read();
		Subtask1::solve(); 
	}
	return 0;
}
