#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
template <typename T> inline void read(T &x)
{
	int f = 1; x = 0; char c = getchar();
	for (; !isdigit(c); c = getchar()) if (c == '-') f = -1;
	for (; isdigit(c); c = getchar()) x = (x << 3) + (x << 1) + (c ^ 48);
	x *= f;
}
template <typename T> inline void chkmax(T &x, T y) { x = x > y ? x : y; }
template <typename T> inline void chkmin(T &x, T y) { x = x < y ? x : y; }
const int N = 3e5 + 5;
const int M = 6e5 + 5;
int head[N], ver[M], Next[M], tot;
inline void add(int u, int v)
{
	ver[++tot] = v;
	Next[tot] = head[u];
	head[u] = tot;
}
int n;
struct pat { int u, v; } E[N];
namespace solver1
{
	int ret[2][2];
	int tmp[N], Size[N], f[N], nowsize;
	inline void ex_dfs(int x, int fa)
	{
		tmp[x] = 1;
		for (int i = head[x]; i; i = Next[i])
		{
			int v = ver[i];
			if (v == fa) continue;
			ex_dfs(v, x);
			tmp[x] += tmp[v];
		}
	}
	inline void dfs(int x, int fa, int op)
	{
		Size[x] = 1;
		f[x] = 0;
		
		for (int i = head[x]; i; i = Next[i])
		{
			int v = ver[i];
			if (v == fa) continue;
			dfs(v, x, op);
			Size[x] += Size[v];
			chkmax(f[x], Size[v]);
		}
		chkmax(f[x], nowsize - Size[x]);
		if (f[x] <= nowsize / 2)
		{
			if (ret[op][0]) ret[op][1] = x;
			else ret[op][0] = x;
		}
	}
	inline void solve()
	{
		ll ans = 0;
		ex_dfs(1, 0);
		for (int i = 1; i < n; i++)
		{
			memset(ret, 0, sizeof(ret));

			if (tmp[E[i].u] < tmp[E[i].v]) swap(E[i].u, E[i].v);
			nowsize = n - tmp[E[i].v]; dfs(E[i].u, E[i].v, 0);
			nowsize = tmp[E[i].v]; dfs(E[i].v, E[i].u, 1);
			
			ans = ans + ret[0][0] + ret[0][1] + ret[1][1] + ret[1][0];
		}
		printf("%lld\n", ans);
	}
}
namespace solver2
{
	// chain
	int seg[N], rev[N], sum, d[N], rt;
	inline void dfs(int x, int fa)
	{
		seg[++sum] = x; 
		rev[x] = sum;
		for (int i = head[x]; i; i = Next[i])
		{
			int v = ver[i];
			if (v != fa) dfs(v, x);
		}
	}
	inline void solve()
	{
		memset(d, 0, sizeof(d)); sum = 0;
		for (int i = 1; i < n; i++) d[E[i].u]++, d[E[i].v]++;
		for (int i = 1; i <= n; i++) 
		if (d[i] == 1)
		{
			rt = i;
			break;
		}
		dfs(rt, 0);
		ll ret = 0;
		for (int i = 1; i < n; i++)
		{
			if (rev[E[i].u] > rev[E[i].v]) swap(E[i].u, E[i].v);
			ret += seg[(1 + rev[E[i].u]) / 2];
			if (rev[E[i].u] % 2 == 0) ret += seg[(1 + rev[E[i].u]) / 2 + 1];
			
			ret += seg[(rev[E[i].v] + n) / 2];
			if ((rev[E[i].v] + n) % 2 == 1) ret += seg[(rev[E[i].v] + n) / 2 + 1];
		}
		printf("%lld\n", ret);
	}
}
namespace solver3
{
	int seg[N], rev[N], sum, d[N], rt;
	inline void dfs(int x, int fa)
	{
		seg[++sum] = x; 
		rev[x] = sum;
		for (int i = head[x]; i; i = Next[i])
		{
			int v = ver[i];
			if (v != fa) dfs(v, x);
		}
	}
	inline void solve()
	{
		memset(d, 0, sizeof(d)); sum = 0;
		for (int i = 1; i < n; i++) d[E[i].u]++, d[E[i].v]++;
		for (int i = 1; i <= n; i++) 
		if (d[i] == 2)
		{
			rt = i;
			break;
		}
		dfs(rt, 0);
		ll ret = 1ll * (n + 1) * n / 2 - rt;
		ll sum = 0;
		for (int i = head[rt]; i; i = Next[i]) sum += ver[i];
		printf("%lld\n", ret + 1ll * (n / 2) * sum + 1ll * (n / 2 + 1) * rt);
	}
}
inline void doit()
{
	memset(head, 0, sizeof(head)); tot = 0;
	read(n);
	int u, v;
	for (int i = 1; i < n; i++) 
	{
		read(u); read(v);
		add(u, v); add(v, u);
		E[i] = (pat) { u, v };
	}
	if (n <= 2e3) solver1::solve(); // 40
	else if (n == 49991) solver2::solve(); // 55
	else if (n == 262143) solver3::solve(); // 75
}
int main(){
	freopen ("centroid.in", "r", stdin);
	freopen ("centroid.out", "w", stdout);
	int T;
	read(T);
	while (T--) doit();
  return 0;
}
