#include<iostream>
#include<cstdio>
#include<cstring>
using namespace std;
const int maxn=300000;
int t,n,eid,tmp;
long long ans;
int p[maxn],size[maxn];
struct edge
{
	int v,next,len;
}E[2*maxn];
void init()
{
	ans=0;
	eid=0;
	memset(p,-1,sizeof(p));
}
void insert(int u,int v)
{
	E[eid].len=1;
	E[eid].v=v;
	E[eid].next=p[u];
	p[u]=eid++;
}
void dfs(int u,int fa)
{
	size[u]=1;
	for(int i=p[u];i+1;i=E[i].next)
	{
		int v=E[i].v;
		if(v!=fa&&E[i].len!=-1)
		{
			dfs(v,u);
			size[u]+=size[v];
		}		
	}
}
void find(int u,int fa)
{
	if(tmp-size[u]*2>0)
	{
		return;
	}
	bool eoq=1;
	for(int i=p[u];i+1;i=E[i].next)
	{
		int v=E[i].v;
		if(E[i].len!=-1&&v!=fa)
		{
			if(size[v]<(tmp>>1))
			{
				continue;
			}
			if(size[v]>(tmp>>1))
			{
				eoq=0;
			}			
			find(v,u);
		}
	}
	if(eoq)
	{
		ans+=u;
	}
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&t);
	while(t--)
	{
		init();
		scanf("%d",&n);
		for(int i=1;i<n;i++)
		{
			int u,v;
			scanf("%d%d",&u,&v);
			insert(u,v);
			insert(v,u);
		}
		for(int i=0;i<eid;i+=2)
		{
			memset(size,0,sizeof(size));
			E[i].len=E[i^1].len=-1;
			for(int j=1;j<=n;j++)
			{
				if(!size[j])
				{
					dfs(j,0);
					tmp=size[j];
					find(j,0);
				}
			}
			E[i].len=E[i^1].len=1;
		}
		printf("%d\n",ans);
	}
	return 0;
}
