#include<iostream>
#include<stdio.h>
#include<algorithm>
#include<string.h>
#include<vector>
#include<set>
#include<map>
#include<utility>
#include<math.h>
#include<queue>
#include<stack>
using namespace std;
const int INF=1e9;

vector<int> vec[5005];
bool vis[5005]; 
vector<int> td[5005];
int dx[5005];
int ans;
void dfs(int x)
{
	vis[x]=1;
	dx[x]=1;
	for(int i=0;i<vec[x].size();i++)
	{
		if(vec[x][i]==0)
		{
			continue;
		}
		if(!vis[vec[x][i]])
		{
			dfs(vec[x][i]);
			dx[x]+=dx[vec[x][i]];
		}
	}
}
void cta(int x,int zong)
{
	bool flag=1;
	if(zong-dx[x]>(zong/2))
	{
		flag=false;
	}
	dx[x]=0;
	for(int i=0;i<vec[x].size();i++)
	{
		if(vec[x][i]==0)
		{
			continue;
		}
		if(!dx[vec[x][i]])
			continue;
		if(dx[vec[x][i]]>(zong/2))
		{
			flag=false;
		}
		cta(vec[x][i],zong);
	}
	if(flag)
	{
		ans+=x;
	}
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	cin>>T;
	while(T--)
	{
		ans=0;
		int n;
		cin>>n;
		for(int i=1;i<=n;i++)
		{
			vec[i].clear();
			td[i].clear();
		}
		for(int i=1;i<n;i++)
		{
			int u,v;
			scanf("%d%d",&u,&v);
			vec[u].push_back(v);
			vec[v].push_back(u);
			td[u].push_back(vec[v].size()-1);
			td[v].push_back(vec[u].size()-1);
		}
		for(int i=1;i<=n;i++)
		{
			for(int j=0;j<vec[i].size();j++)
			{
				memset(vis,0,sizeof(vis));
				memset(dx,0,sizeof(dx));
				int fr=i;
				int to=vec[i][j];
				vec[i][j]=0;
				vec[to][td[i][j]]=0;
				dfs(fr);
				cta(fr,dx[fr]);
				dfs(to);
				cta(to,dx[to]);
				vec[i][j]=to;
				vec[to][td[i][j]]=fr;
			}
		}
		cout<<ans/2<<endl;
	}
	return 0;
}

