#include <bits/stdc++.h>
using namespace std;
#define LL long long
#define LD long double
#define pii pair<int, int>
#define fi first
#define se second
template <typename T> void read(T &x)
{
	x = 0; int f = 1; char c = getchar();
	for ( ; !isdigit(c); c = getchar()) if (c == '-') f = -f;
	for ( ; isdigit(c); c = getchar()) x = x * 10 + c - '0';
	x *= f;
}
const int N = 300005;
int fir[N], fa[N], siz[N], tot[N], mxs[N], que[N], cd[N];
struct edge { int to, nxt; } e[N << 1];
int n, cnt, al, tim;
LL ans;
void Ade(int u, int v)
{
	e[++cnt] = (edge) { v, fir[u] }, fir[u] = cnt;
	e[++cnt] = (edge) { u, fir[v] }, fir[v] = cnt;
}
void Dfs(int u, int ff)
{
	fa[u] = ff; siz[u] = 1; que[++tim] = u;
	for (int i = fir[u], v; ~i; i = e[i].nxt)
		if ((v = e[i].to) != ff) Dfs(v, u), siz[u] += siz[v];
}
void Dfs1(int u, int ff)
{
	tot[u] = 1; mxs[u] = 0;
	for (int i = fir[u], v; ~i; i = e[i].nxt)
		if ((v = e[i].to) != ff)
		{
			Dfs1(v, u);
			tot[u] += tot[v];
			if (tot[v] > mxs[u]) mxs[u] = tot[v];
		}
	if (al - tot[u] > mxs[u]) mxs[u] = al - tot[u];
	if (mxs[u] <= al / 2) ans += u;
}
queue <int> q;
int vis[N];
void Bfs(int x)
{
	vis[x] = 1; q.push(x);
	int u;
	while (!q.empty())
	{
		que[++tim] = u = q.front(); q.pop();
		for (int i = fir[u], v; ~i; i = e[i].nxt)
			if (!vis[v = e[i].to])
				q.push(v), vis[v] = 1;
	}
}
int main()
{
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T; read(T); while (T--)
	{
		read(n);
		cnt = -1; ans = tim = 0;
		for (int i = 1; i <= n; ++i)
			fir[i] = -1, cd[i] = 0;
			
		for (int i = 1, x, y; i < n; ++i)
			read(x), read(y), cd[x]++, cd[y]++, Ade(x, y);
		
		if (n <= 2000)
		{
			Dfs(1, 0);
			for (int i = 2; i <= n; ++i)
			{
				al = siz[i]; Dfs1(i, fa[i]);
				al = n - siz[i]; Dfs1(fa[i], i);
			}
			cout << ans << '\n';
		}
		if (n == 49991)
		{
			for (int i = 1; i <= n; ++i)
				if (cd[i] == 1) { Dfs(i, 0); break; }
			for (int i = 2, j; i <= n; ++i)
			{
				if (i & 1) ans += que[i / 2] + que[i / 2 + 1];
				else ans += que[i / 2]; 
				j = n - i;
				if (j & 1) ans += que[i + j / 2] + que[i + j / 2 + 1];
				else ans += que[i + j / 2];
			}
			cout << ans << '\n';
		}
		if (n == 262143)
		{
			for (int i = 1; i <= n; ++i)
				vis[i] = 0;
			for (int i = 1; i <= n; ++i)
				if (cd[i] == 2) { Bfs(i); break; }
			al = n / 2;
			ans = 1ll * al * (que[1] + que[2] + que[3]);
			for (int i = 1; i <= n; ++i)
				ans += que[i];
			cout << ans << '\n'; 
		}
	}
	return 0;
}

