#include <cstdio>
#include <algorithm>
typedef long long int64;

const int SZ = 5e5 + 7;
const int64 INF = 4e18 + 7; 

int n, a[SZ];
int64 ans = INF;

void dfs(int x, int64 limit, int64 s) {
	if (x > n) {
		ans = std::min(ans, s);
		return;
	}
	if (s > INF - 7 || s >= ans)
		return;
	int64 tmp = 0;
	for (int i = x; i <= n; i++) {
		tmp += a[i];
		if (tmp >= limit)
			dfs(i + 1, tmp, s + tmp * tmp);
	}
}

int main() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	int tmp;
	scanf("%d%d", &n, &tmp);
	for (int i = 1; i <= n; i++)
		scanf("%d", a + i);
	dfs(1, 0, 0);
	printf("%lld", ans);
	return 0;
}
