#include<iostream>
#include<cstdio>
#include<map>
using namespace std;

int n;
long long dp[5005][5005];
long long mn[5005][5005];//s[i][k]-s[i][j-1]min
long long sum[5005];
long long a[5005];
int find(int t, long long u)
{
	if (t==0) return 0;
	int l=1,r=t;
	if (l==r) 
	{
		if (a[l]>u) return 1e7;
		else return 1;
	}
	int ans=1e7;
	while (l<r) 
	{
		int mid=(l+r)>>1;
		if ((sum[t]-sum[mid-1])<=u) 
		{
			ans=min(ans,mid);
			r=mid;
		}
		else l=mid+1;
	}
	if (sum[t]-sum[l-1]<=u) ans=min(ans,l);
	return ans;
}

int main()
{
	freopen("partition.in","r",stdin);
	freopen("partition.out","w",stdout);
	int tt;
	cin>>n>>tt;
	for (int i=1;i<=n;i++) cin>>a[i];
	for (int i=1;i<=n;i++) sum[i]=sum[i-1]+a[i];
	for (int i=1;i<=n;i++) for (int j=1;j<=n;j++) dp[i][j]=4e18;
//	cout<<find(1,6)<<endl;
//	cout<<find(4,9)<<endl;
//	cout<<find(3,9)<<endl;
	for (int i=1;i<=n;i++)
	{
		dp[i][1]=sum[i]*sum[i];
		for (int j=2;j<=i;j++)
		{
			int pos=find(j-1,sum[i]-sum[j-1]);
			if (pos==1e7) continue;
			long long val=(sum[i]-sum[j-1])*(sum[i]-sum[j-1]);
			dp[i][j]=min(dp[i][j],mn[j-1][pos]+val);
		}
		long long minans=8e18;
		for (int j=i;j>=1;j--)
		{
			minans=min(minans,dp[i][j]);
			mn[i][j]=minans;
		}
//		for (int j=1;j<=i;j++) cout<<dp[i][j]<<' ';
//		cout<<endl;
	}
	cout<<mn[n][1]<<endl;
	return 0;
}

