#include <bits/stdc++.h>
//#include <windows.h>
using namespace std;
#define int long long
#define bug cout<<"bug "<<__LINE__<<endl
#define index xedni
const int inf=1e9+7;
const int MOD=1e9+7;
const int MAXN=300050;
struct edge
{
	int next;
	int from;
	int to;
	bool can;
}g[MAXN<<1];
int cnt;
int head[MAXN];
void AddEdge(int a,int b)
{
	g[++cnt].next=head[a];
	g[cnt].from=a;
	g[cnt].to=b;
	g[cnt].can=1;
	head[a]=cnt;
}
int n,ans,sz[MAXN];
bool can[MAXN];
void Dfs1(int u,int fa)
{
	can[u]=1;
	sz[u]=1;
	for(int e=head[u];e;e=g[e].next)
	{
		if(!g[e].can) continue;
		int v=g[e].to;
		if(v==fa) continue;
		Dfs1(v,u);
		sz[u]+=sz[v];
	}
}
void Dfs2(int u,int fa,int root)
{
	if((sz[root]-sz[u])>((sz[root])/2)) can[u]=0;
	for(int e=head[u];e;e=g[e].next)
	{
		if(!g[e].can) continue;
		int v=g[e].to; if(v==fa) continue;
		Dfs2(v,u,root);
	}
	if(sz[u]>((sz[root])/2)) can[fa]=0;
}
int du[MAXN],e[MAXN],index;
void Dfs3(int u,int fa)
{
	e[++index]=u;
	for(int e=head[u];e;e=g[e].next)
	{
		int v=g[e].to;
		if(v==fa) continue;
		Dfs3(v,u); 
	}
}
bool usedd[MAXN];
signed main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int T; cin>>T;
	while(T--)
	{
		memset(g,0,sizeof(g));
		memset(head,0,sizeof(head));
		memset(du,0,sizeof(du));
		ans=cnt=0;
		cin>>n;
		for(int i=1;i<n;i++)
		{
			int x,y; cin>>x>>y;
			AddEdge(x,y); AddEdge(y,x);
			du[x]++,du[y]++;
		}
		int fdu2=0;
		bool flag2=1;
		for(int i=1;i<=n;i++)
		{
			if(du[i]==2) continue;
			if(du[i]==1) fdu2++;
			else flag2=0;
		}
		if(fdu2!=2) flag2=0;
		if(flag2)
		{
			memset(usedd,0,sizeof(usedd));
			int pos=0;
			for(int i=1;i<=n;i++) if(du[i]==1) pos=i;
			index=0;
			while(1)
			{
				int nxt=-1;
				usedd[pos]=1;
				e[++index]=pos;
				for(int e=head[pos];e;e=g[e].next)
				{
					if(usedd[g[e].to]) continue;
					nxt=g[e].to;
				}
				if(nxt==-1) break;
				pos=nxt;
			}
			for(int i=1;i<n;i++)
			{
				int ll=1,lr=i,rl=i+1,rr=n;
				int llen=lr-ll+1,rlen=rr-rl+1;
				int tmp1=0,tmp2=0;
				if(llen%2==1) tmp1=e[llen/2+1];
				else tmp1=e[llen/2]+e[llen/2+1];
				if(rlen%2==0) tmp2=e[rr-rlen/2]+e[rr-rlen/2+1];
				else tmp2=e[rr-rlen/2];
				ans+=tmp1+tmp2;
			}
			cout<<ans<<endl;
			continue;
		}
		for(int i=1;i<n;i++)
		{
			g[i*2-1].can=false;
			g[i*2].can=false;

			memset(can,0,sizeof(can));
			Dfs1(g[i*2].from,0);
			Dfs2(g[i*2].from,0,g[i*2].from);
			for(int j=1;j<=n;j++) if(can[j]) ans+=j;
			
			memset(can,0,sizeof(can));
			Dfs1(g[i*2].to,0);
			Dfs2(g[i*2].to,0,g[i*2].to);
			for(int j=1;j<=n;j++) if(can[j]) ans+=j;
			g[i*2-1].can=true;
			g[i*2].can=true;
		}
		cout<<ans<<endl;
	}
	return 0;
}
