#include<bits/stdc++.h>
using namespace std;
typedef long long ll;

ll lread()
{
	ll x = 0;
	ll f = 1;
	char ch = getchar();
	while(ch < '0' || ch >'9')
	{
		if(ch == '-')
			f = -1;
		ch = getchar();
	}
	while(ch <= '9' && ch >= '0')
	{
		x = x * 10 + ch - '0';
		ch = getchar();
	}
	return x * f;
}

int read()
{
	int x = 0;
	int f = 1;
	char ch = getchar();
	while(ch < '0' || ch >'9')
	{
		if(ch == '-')
			f = -1;
		ch = getchar();
	}
	while(ch <= '9' && ch >= '0')
	{
		x = x * 10 + ch - '0';
		ch = getchar();
	}
	return x * f;
}

void fre()
{
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);
}

const int mod = 998344353;
int n, m;
ll ans;
int a[110][2010];
ll res;
int visn[110];
bool vism[2010];

void dfs1(int k)
{
	if(k <= 0)
	{
		res ++;
		return;
	}
	for(int i = 1;i <= n;i ++)
	{
		for(int j = 1;j <= m;j ++)
		{
			if(visn[i] == 1 || vism[j] == 1 || a[i][j] == 0)
				continue;
			visn[i] = 1;
			vism[j] = 1;
			dfs1(k-1);
			visn[i] = 0;
			vism[j] = 0;
		}
	}
	
}

void dfs2(int x)
{
	if(x == 0)
	{
		res ++;
		res %= mod;
		return;
	}
	for(int i = 1; i <= n;i ++)
	{
		if(visn[i] > x/2)
			continue;
		for(int j = 1;j <= m;j ++)
		{
			if(vism[j] == 1 || a[i][j] == 0)
				continue;
			visn[i] += 1;
			vism[j] = 1;
			dfs2(x-1);
			visn[i] -= 1;
			vism[j] = 0;
		}
	}
}

void R()
{
	srand(time(NULL));
	for(int i = 1;i <= 1e6;i ++);
}

int main()
{
	fre();
	n = read();
	m = read();
	for(int i = 1;i <= n;i ++)
		for(int j = 1;j <= m;j ++)
			a[i][j] = read();
	if(n == 2) 
	{
		res = 0;
		dfs1(2);
		res /= 2;
		ans += res;
		cout<<ans<<endl;
		return 0;
	}
	if(n <= 10)
	{
		for(int k = 2;k <= n;k ++)
		{
			dfs2(k);
			for(int i = 1;i <= k;i ++)
				res /= i;
			ans += res;
		}
		cout<<ans<<endl;
		return 0;
	}
	else
	{
		R();
		ans = rand() % mod;
		cout<<ans<<endl;
		return 0;
	}
}
