#include<bits/stdc++.h>
#define rep(i, n) for(int i = 0; i < n; i++)
using namespace std;

int n;
vector<int> v[300005];
vector< pair<int, int> > edge; 
int grand[300005];
int sz[300005];
long long ans = 0LL;

void dfs1(int now, int par){
	sz[now] = 1;
	rep(i, v[now].size()){
		if(v[now][i] != par){
			grand[v[now][i]] = grand[now];
			dfs1(v[now][i], now);
			sz[now] += sz[v[now][i]];
		}
	}
}

void dfs2(int now, int par){
	bool ok = 1;
	rep(i, v[now].size()){
		if(v[now][i] != par){
			dfs2(v[now][i], now);
			if(sz[v[now][i]] > sz[grand[now]] / 2) ok = 0;
		}
	}
	if(sz[grand[now]] - sz[now] > sz[grand[now]] / 2) ok = 0;
	if(ok) ans += (now+1);
}

void subtask40(){
	ans = 0LL;
	rep(i, n-1){
		int pnt1 = edge[i].first, pnt2 = edge[i].second;
		grand[pnt1] = pnt1; dfs1(pnt1, pnt2);
		grand[pnt2] = pnt2; dfs1(pnt2, pnt1);
		dfs2(pnt1, pnt2);
		dfs2(pnt2, pnt1);
	}
	printf("%lld\n", ans);
}

int posnow = 0;
int chn[300300];
void subtask15(){
	ans = 0LL;
	posnow = 0;
	int st = -1; 
	rep(i, n)
		if((int)v[i].size() == 1){
			st = i;
			break;
		}
	if(st < 0) printf("4972194419293431240859891640\n");
	else {
		int pre = -1;
		for(int now = st; posnow < n; ){
			chn[posnow++] = now;
			bool upd = 0;
			rep(i, v[now].size()) if(v[now][i] != pre){
				pre = now;
				now = v[now][i];
				upd = 1;
				break;
			}
			if(!upd) break;
		}
		if(posnow != n) printf("4972194419293431240859891641\n");
		rep(i, n-1){
			int sz1 = i+1, sz2 = n-i-1;
			if(sz1 & 1) ans += (chn[i/2] + 1);
			else ans += ((chn[i/2]+1) + (chn[i/2 + 1] + 1));
			if(sz2 & 1) ans += (chn[n - 1 - sz2/2] + 1);
			else ans += ((chn[n - 1 - sz2/2]+1) + (chn[n - sz2/2] + 1));
		}
		printf("%lld\n", ans);
	} 
}

int main(){
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T;
	scanf("%d", &T);
	while(T--){
		ans = 0LL;
		scanf("%d", &n);
		rep(i, n) v[i].clear();
		edge.clear(); 
		rep(i, n-1){
			int x, y;
			scanf("%d%d", &x, &y);
			x--, y--;
			v[x].push_back(y);
			v[y].push_back(x);
			edge.push_back(make_pair(x, y));
		}
		if(n <= 2000) subtask40(); 
		else subtask15();
	}
	return 0;
} 
