#include <bits/stdc++.h>
using namespace std;

#define il inline
#define ri register int
#define ll long long
const int MAX_N = 600000 + 10;
int Head[MAX_N], Next[MAX_N], V[MAX_N], U[MAX_N], tot, n;
ll sz[MAX_N], szo[MAX_N], sml, cen, ans;
ll deg[MAX_N], seq[MAX_N];
bool vis[MAX_N];

il void Add(int u, int v) {
	U[++tot] = u, V[tot] = v, Next[tot] = Head[u], Head[u] = tot;
}

il void Init1() {
	memset(Head, 0, sizeof Head);
	tot = ans = 0;
}

il void Init2() {
	cen = 0, sml = 0x3f3f3f3f;
}

il void dfso(int u, int fa) {
	szo[u] = 1;
	for (ri i = Head[u]; i; i = Next[i]) {
		int v = V[i];
		if (v == fa) continue;
		dfso(v, u);
		szo[u] += szo[v];
	}
}

il void dfs(int u, int fa, int sum) {
	sz[u] = 1; ll cur = -1;
	for (ri i = Head[u]; i; i = Next[i]) {
		int v = V[i];
		if (v == fa) continue;
		dfs(v, u, sum);
		cur = max(cur, sz[v]);
		sz[u] += sz[v];
	}
	cur = max(cur, sum - sz[u]);
	if (cur < sml) cen = u, sml = cur;
	else if (cur == sml) cen += u;
}

il void lian() {
	int u, v;
	memset(vis, 0, sizeof vis);
	for (ri i = 1; i < n; ++i) {
		scanf("%d%d", &u, &v);
		Add(u, v), Add(v, u);
		++deg[u], ++deg[v];
	}
	for (u = 1; u <= n; u++)
		if (deg[u] == 1) break;
	seq[1] = u, vis[u] = true;
	for (ri i = 2; i <= n; ++i) {
		for (u = Head[seq[i - 1]]; vis[V[u]]; u = Next[u]);
		vis[V[u]] = true;
		seq[i] = V[u];
	}
	for (ri i = 1; i < n; ++i) {
		if (i % 2) {
			ans += seq[(i + 1) / 2];
			ans += seq[(i + n) / 2];
			ans += seq[(i + n) / 2 + 1];
		} else {
			ans += seq[i / 2];
			ans += seq[i / 2 + 1];
			ans += seq[(i + n + 1) / 2];
		}
	}
	printf("%lld\n", ans);
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T;
	scanf("%d", &T);
	while (T--) {
		Init1();
		int u, v;
		scanf("%d", &n);
		if (n == 49991) {lian(); continue; }
		for (ri i = 1; i < n; ++i) {
			scanf("%d%d", &u, &v);
			Add(u, v), Add(v, u);
		}
		dfso(1, 0);
		for (ri i = 1; i <= tot; i += 2) {
			u = U[i], v = V[i];
			if (szo[u] > szo[v]) {
				Init2(), dfs(u, v, n - szo[v]), ans += cen;
				Init2(), dfs(v, u, szo[v]), ans += cen;
			}
			else {
				Init2(), dfs(v, u, n - szo[u]), ans += cen;
				Init2(), dfs(u, v, szo[u]), ans += cen;
			}
		}
		printf("%lld\n", ans);
	}
	return 0;
}
