#include<bits/stdc++.h>
#define ll long long
ll P,Start,S1,S2,Ans,Cnt,n,T,x,y,Head[300010],Next[600010],To[600010],Degree[300010],Son[300010],Dep[300010],D[300010];
using namespace std;
struct Node{
	ll x,y,Id;
}Edge[300010];
template<typename T>
inline ll Read(T &x){
	x=0;
	ll f=1;
	char c=getchar();
	while(!isdigit(c)){
		if(c=='-'){
			f=-f;
		}
		c=getchar();
	}
	while(isdigit(c)){
		x=x*10+c-'0';
		c=getchar();
	}
	x*=f;
	if(c=='\n'){
		return 1;
	}
	else{
		return 0;
	}
}
inline void Write(ll x){
	if(x<0){
		x=-x;
		putchar('-');
	}
	if(x>9){
		Write(x/10);
	}
	putchar(x%10+'0');
}
inline void Add(ll x,ll y){
	To[++Cnt]=y;
	Next[Cnt]=Head[x];
	Head[x]=Cnt;
	To[++Cnt]=x;
	Next[Cnt]=Head[y];
	Head[y]=Cnt;
}
inline bool Line(){
	ll a=0,b=0;
	for(ll i=1;i<=n;i++){
		if(Degree[i]==1){
			a++;
		}
		if(Degree[i]==2){
			b++;
		}
	}
	if(a==2&&b==n-2){
		return 1;
	}
	else{
		return 0;
	}
}
inline bool BST(){
	ll a=0,b=0,c=0;
	for(ll i=1;i<=n;i++){
		if(Degree[i]==1){
			a++;
		}
		if(Degree[i]==2){
			b++;
		}
		if(Degree[i]==3){
			c++;
		}
	}
	//cout<<"a="<<a<<" b="<<b<<" c="<<c<<endl; 
	if(a==(n+1)/2&&(c+2)==((n+1)/2)&&b==1){
		return 1;
	} 
	else{
		return 0;
	}
}
inline void Dfs1(ll x,ll Fa,ll p){
	ll y;
	Son[x]=1;
	for(ll i=Head[x];i;i=Next[i]){
		y=To[i];
		if((i==p)||((i^1)==p)){
			continue;
		}
		if(y==Fa){
			continue;
		}
		//cout<<"x="<<x<<" y="<<y<<endl;
		Dfs1(y,x,p);
		Son[x]+=Son[y];
		//cout<<"x="<<x<<" y="<<y<<" Son[x]="<<Son[x]<<" Son[y]="<<Son[y]<<endl; 
	}
}
inline void Dfs2(ll x,ll Fa,ll p,ll S){
	ll y,a,b;
	ll Pd=1;
	for(ll i=Head[x];i;i=Next[i]){
		y=To[i];
		if((i==p)||((i^1)==p)){
			continue;
		}
		if(Son[y]>(S/2)){
			Pd=0;
			break;
		}
	}
	if(Pd){
		Ans+=x;
	}
	//cout<<"   "<<x<<endl;
	/*for(ll j=1;j<=n;j++){
		Write(Son[j]);
		putchar(' '); 
	}*/
	//puts("");
	for(ll i=Head[x];i;i=Next[i]){
		y=To[i];
		if((i==p)||((i^1)==p)){
			continue;
		}
		if(y==Fa){
			continue;
		}
		a=Son[x];
		b=Son[y];
		Son[y]+=(a-b);
		Son[x]-=b;
		Dfs2(y,x,p,S);
		Son[y]-=(a-b);
		Son[x]+=b;
	}
}
inline void Dfs3(ll x,ll Fa){
	ll y;
	Dep[x]=Dep[Fa]+1;
	D[Dep[x]]=x;
	for(ll i=Head[x];i;i=Next[i]){
		y=To[i];
		if(y==Fa){
			continue;
		}
		Dfs3(y,x);
	}
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	Read(T);
	while(T--){
		Cnt=1;
		Ans=0;
		Read(n);
		for(ll i=1;i<n;i++){
			Read(x);
			Read(y);
			Degree[x]++;
			Degree[y]++; 
			Add(x,y);
			Edge[i].x=x;
			Edge[i].y=y;
			Edge[i].Id=Cnt-1;
		}
		if(Line()){
			Start=0;
			for(ll i=1;i<=n;i++){
				if(Degree[i]==1){
					Start=i;
					break;
				}
			}
			Dep[0]=0;
			Dfs3(Start,0);
			/*for(ll i=1;i<=n;i++){
				Write(Dep[i]);
				putchar(' ');
			}
			putchar('\n');
			for(ll i=1;i<=n;i++){
				Write(D[i]);
				putchar(' ');
			}
			putchar('\n');*/
			for(ll i=1;i<n;i++){
				x=Edge[i].x;
				y=Edge[i].y;
				if(Dep[x]>Dep[y]){
					swap(x,y);
				}
				if(Dep[x]&1){
					Ans+=(D[(Dep[x]+1)/2]);
					//cout<<"eee"<< D[(Dep[x]+1)/2]<<endl;
				}
				else{
					Ans+=(D[(Dep[x])/2]+D[(Dep[x]+2)/2]);
					//cout<<"eee"<<D[(Dep[x])/2] <<" "<< D[(Dep[x])/2]<<endl;
				}
				P=n-Dep[y]+1;
				if(P&1){
					Ans+=(D[Dep[y]+(P-1)/2]);
					//cout<<"eee"<< D[Dep[y]+(P-1)/2]<<endl;
				} 
				else{
					Ans+=(D[Dep[y]+P/2]+D[Dep[y]+P/2-1]);
					//cout<<"eee"<< D[Dep[y]+P/2]<<" "<<D[Dep[y]+P/2-1] <<endl;
				}
			}
		}
		else{
			if(BST()){
				P=n/2;
				Ans=P*5+(P+1)+(n+1)*n/2-1;
			}
			else{
				for(ll i=1;i<n;i++){
					Dfs1(Edge[i].x,Edge[i].y,Edge[i].Id);
					Dfs1(Edge[i].y,Edge[i].x,Edge[i].Id);
					//cout<<"x="<<Edge[i].x<<" y="<<Edge[i].y<<' '<<Edge[i].Id<<endl;
					/*for(ll j=1;j<=n;j++){
						Write(Son[j]);
						putchar(' '); 
					}
					putchar('\n');*/
					S1=Son[Edge[i].x];
					S2=Son[Edge[i].y];
					Dfs2(Edge[i].x,0,Edge[i].Id,S1);
					Dfs2(Edge[i].y,0,Edge[i].Id,S2);
				}
			}
		}
		Write(Ans);
		putchar('\n');
		for(ll i=1;i<=Cnt;i++){
			Next[i]=0;
		}
		for(ll i=1;i<=n;i++){
			Head[i]=0;
			Degree[i]=0;
		}
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}
