#include<bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<int,int> pii;
typedef vector<int> vii;

inline int read(){
	int X=0;char ch=getchar();
	while(ch<'0'||ch>'9')ch=getchar();
	while(ch>='0'&&ch<='9')X=(X<<1)+(X<<3)+(ch^48),ch=getchar();
	return X;
}

int head[50003],deg[50003],sz,n;
struct EDGE{
	int to,nxt;
}edge[100003];
void addedge(int u,int v){
	edge[++sz].to=v;edge[sz].nxt=head[u];head[u]=sz;
}
int u[50003],v[50003],siz[2003];

void dfs(int u,int pre){
	int to;siz[u]=1;
	for(int i=head[u];i;i=edge[i].nxt){
		to=edge[i].to;
		if(to==pre) continue;
		dfs(to,u);
		siz[u]+=siz[to];
	}
}
int MN,ROOT;
ll res,sum;
void dfs2(int u,int pre){
	int to,mx=0;
	for(int i=head[u];i;i=edge[i].nxt){
		to=edge[i].to;
		if(to==pre) continue;
		dfs2(to,u);
		mx=max(mx,siz[to]);
	}
	mx=max(mx,siz[ROOT]-siz[u]);
	if(mx<MN)sum=0,MN=mx;
	if(mx==MN)sum+=u;
}
void cut(int id){
	memset(siz,0,sizeof(siz));
	ROOT=u[id];MN=0x3f3f3f3f;sum=0;
	dfs(u[id],v[id]);
	dfs2(u[id],v[id]);
//	printf("%d %d %lld ",u[id],v[id],sum);
	res+=sum;
	ROOT=v[id];MN=0x3f3f3f3f;sum=0;
	dfs(v[id],u[id]);
	dfs2(v[id],u[id]);
	res+=sum;
//	printf("%lld *\n",sum);
}

int a[50003],len;
void getline(int u,int pre=0){
//	printf("%d !\n",len);
	a[++len]=u;int to;
	for(int i=head[u];i;i=edge[i].nxt){
		to=edge[i].to;
		if(to==pre) continue;
//		printf("%d %d *\n",u,to);
		getline(to,u);
	}
}

void getres(){
	for(int i=1;i<=n;++i){
		if(2*i<n)res+=a[i];
		if(i!=1&&2*i-2<n)res+=a[i];
		if(2*i-1<n)res+=a[i];
	}
}

int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T_T;scanf("%d",&T_T);
	while(T_T--){
		n=read();
		sz=0;
		memset(head,0,sizeof(head));
		memset(deg,0,sizeof(deg));
		for(int i=1;i<n;++i){
			u[i]=read();v[i]=read();
			addedge(u[i],v[i]);
			addedge(v[i],u[i]);
			++deg[u[i]];++deg[v[i]];
		}
		if(n<=2000){
//			puts("^^^");
			res=0;
			for(int i=1;i<n;++i)cut(i);
			printf("%lld\n",res);
			continue;
		}
		int st,cnt=0;bool flag=true;
		for(int i=1;i<=n;++i){
			if(deg[i]>2)flag=false;
			if(deg[i]==1){
				++cnt;
				if(cnt>2)flag=false;
				if(cnt==1)st=i;
			}
		}
		if(flag){
//			puts("***");
//			printf("%d %d !!\n",n,st);
			len=0;res=0;
			getline(st);
//			for(int i=1;i<=n;++i)printf("%d ",a[i]);puts("^");
//			puts("^^^");
			getres();
			for(int i=1;i<=n/2;++i)
				swap(a[i],a[n-i+1]);
//			for(int i=1;i<=n;++i)printf("%d ",a[i]);puts("^");
			getres();
			printf("%lld\n",res);
			continue;
		}
//		puts("WTF");
	}
	return 0;
}
/*
2
5
1 2
2 3
2 4
3 5
7
1 2
1 3
1 4
3 5
3 6
6 7



1
7
4 7
7 2
2 1
1 3
3 6
6 5
*/

