#include<bits/stdc++.h>
using namespace std;
#define LL long long
#define pb push_back
#define chmax(a,b) a=max(a,b)
#define chmin(a,b) a=min(a,b)
const int N=5e4;

int Tc,n;
int u[N],v[N];
vector<int> e[N];
LL p[N]; int ook[N];

int sz_tree,mx[N],sz[N];
int cal_sz(int u,int last)
{
	int ret=1;
	for(int i=0;i<e[u].size();i++)
	{
		int v=e[u][i];
		if(v==last) continue;
		ret+=cal_sz(v,u);
	}
	return ret;
}
void dfs(int u,int last)
{
	sz[u]=1;
	for(int i=0;i<e[u].size();i++)
	{
		int v=e[u][i];
		if(v==last) continue;
		dfs(v,u);
		sz[u]+=sz[v];
		chmax(mx[u],sz[v]);
	}
	chmax(mx[u],sz_tree-sz[u]);
}
int Centroid(int u)
{
	sz_tree=cal_sz(u,0);
	for(int i=0;i<=n;i++)
		mx[i]=-1,sz[i]=0;
	dfs(u,0);
	int mnn=1e9,ret=0;
	for(int i=1;i<=n;i++)
		if(mx[i]!=-1) chmin(mnn,mx[i]);
	for(int i=1;i<=n;i++)
		if(mx[i]==mnn) ret+=i;
	return ret;
}
void func1()
{
	int ans=0;
	for(int i=1;i<n;i++)
	{
		for(int j=0;j<=n;j++)
			e[j].clear();
		for(int j=1;j<n;j++)
		{
			if(i==j) continue;
			e[u[j]].pb(v[j]);
			e[v[j]].pb(u[j]);
		}
		ans+=Centroid(u[i])+Centroid(v[i]);
	}
	cout<<ans<<'\n';
}

bool lian()
{
	memset(ook,0,sizeof(ook));
	for(int i=1;i<n;i++)
	{
		ook[u[i]]++;
		ook[v[i]]++;
	}
	for(int i=1;i<=n;i++)
		if(ook[i]>2) return 0;
	return 1;
}
void adfs(int num,int u,int last)
{
	for(int i=0;i<e[u].size();i++)
		if(e[u][i]!=last)
		{
			p[num]=e[u][i];
			adfs(num+1,e[u][i],u);
		}
}
void func2()
{
	LL ans=0;
	memset(p,0,sizeof(p));
	memset(e,0,sizeof(e));
	for(int i=1;i<n;i++)
	{
		e[u[i]].pb(v[i]);
		e[v[i]].pb(u[i]);
	}
	for(int i=1;i<=n;i++)
		if(ook[i]==1)
		{
			p[1]=i;
			adfs(2,i,0);
			break;
		}
	for(int i=1;i<n;i++)
		if(i&1) ans+=p[i/2+1];
		else ans+=p[i/2]+p[i/2+1];
	reverse(p+1,p+n+1);
	for(int i=1;i<n;i++)
		if(i&1) ans+=p[i/2+1];
		else ans+=p[i/2]+p[i/2+1];
	cout<<ans<<'\n';
}

int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	
	cin>>Tc;
	while(Tc--)
	{
		cin>>n;
		memset(u,0,sizeof(u));
		memset(v,0,sizeof(v));
		for(int i=1;i<n;i++)
			cin>>u[i]>>v[i];
		if(n<=2000) func1();
		if(n<=2000) continue;
		if(lian()) func2();
		if(lian()) continue;
	}
	
	return 0;
}
/*
2
5
1 2
2 3
2 4
3 5
7
1 2
1 3
1 4
3 5
3 6
6 7
*/
/*
1
11
7 8
8 6
6 10
10 3
3 5
5 4
4 9
9 1
1 11
11 2
*/
