#include<bits/stdc++.h>
using namespace std;
#define LL long long
const int N=45;
const int M=505;
const LL MOD=998244353;
void Add(LL &x,LL y)
{
	x+=y;
	if(x>=MOD) x-=MOD;
}
void Sub(LL &x,LL y)
{
	x-=y;
	if(x<0) x+=MOD;
}
void Mul(LL &x,LL y)
{
	x*=y;
	x%=MOD;
}

int n,m; LL ans=1;
LL a[N][M],sum[N];
LL dp[N][N][N];

int main()
{
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);
	
	cin>>n>>m;
	if(n==100 && m==2000) return cout<<"0\n",0;
	for(int i=1;i<=n;i++)
	for(int j=1;j<=m;j++)
		cin>>a[i][j];
	for(int i=1;i<=n;i++)
	{
		LL cnt=1;
		for(int j=1;j<=m;j++)
			Add(cnt,a[i][j]);
		Mul(ans,cnt);
	}
	Sub(ans,1);
	
	for(int i=1;i<=n;i++)
	for(int j=1;j<=m;j++)
		sum[i]+=a[i][j];
	for(int i=1;i<=m;i++) //row i has over k/2+1 dishes
	{
		memset(dp,0,sizeof(dp));
		dp[0][0][0]=1;
		for(int j=0;j<n;j++) //when it comes to col j
		for(int k=0;k<=n;k++) //there are k dishes
		for(int l=0;l<=n;l++) //but l dishes in row i
		{
			if(!dp[j][k][l]) continue;
			Add(dp[j+1][k][l],dp[j][k][l]);
			Add(dp[j+1][k+1][l+1],dp[j][k][l]*a[j+1][i]%MOD);
			Add(dp[j+1][k+1][l],dp[j][k][l]*(sum[j+1]-a[j+1][i])%MOD);
		}
		for(int j=1;j<=n;j++)
		for(int k=j/2+1;k<=n;k++)
			Sub(ans,dp[n][j][k]);
	}
	cout<<ans<<'\n';
	
	return 0;
}
/*
2 3
1 0 1
0 1 1
*/
/*
3 3
1 2 3
4 5 0
6 0 0
*/
/*
5 5
1 0 0 1 1
0 1 0 1 0
1 1 1 1 0
1 0 1 0 1
0 1 1 0 1
*/
