#include<bits/stdc++.h>
using namespace std;

template <typename tn> void read(tn &a) {
	tn x = 0, f = 1; char c = getchar();
	for (; !isdigit(c); c = getchar()) if (c == '-') f = -1;
	for (; isdigit(c); c = getchar()) x = x * 10 + c - 48;
	a = x * f;
}

const int MAXN = 3e5 + 10;
struct node{
	int len, frm;
};
int n, mx, mxi;
int xx[MAXN], yy[MAXN];
node f[MAXN][3];
vector<int>v[MAXN];

void AddEdge(int x, int y) {
	v[x].push_back(y);
}

void clr() {
	for (int i = 1; i <= n; ++i) v[i].clear();
}

void doit(int x, int fa) {
	for (int i = 0; i < v[x].size(); ++i) {
		int y = v[x][i]; if (y == fa) continue;
		doit(y, x); int tt = f[y][0].len + 1;
		if (tt > f[x][0].len) {f[x][1] = f[x][0]; f[x][0] = (node){tt, y};}
		else if (tt > f[x][1].len) f[x][1] = (node){tt, y};
	}
	if (f[x][0].len + f[x][1].len >= mx) {
		mx = f[x][0].len + f[x][1].len;
		mxi = x;
	}
}

int getans() {
	int ret = 0;
	if (mx % 2) {
		int t = mxi;
		for (int i = 1; i <= f[mxi][0].len - mx / 2 - 1; ++i) t = f[t][0].frm;
		ret += t + f[t][0].frm;
//		cerr << t << " " << f[t][0].frm << " ";
	}
	else {
		int t = mxi;
		for (int i = 1; i <= f[mxi][0].len - mx / 2; ++i) t = f[t][0].frm;
		ret += t;
//		cerr << t << " ";
	}
	return ret;
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T; cin >> T;
	while (T--) {
		cin >> n; clr();
		for (int i = 1; i < n; ++i) {
			read(xx[i]); read(yy[i]);
			AddEdge(xx[i], yy[i]); AddEdge(yy[i], xx[i]);
		}
		
		int ans = 0;
		for (int i = 1; i < n; ++i) {
//			cerr << "cnt: " << xx[i] << " " << yy[i] << endl;
			for (int j = 1; j <= n; ++j) f[j][0] = f[j][1] = (node){0, 0};
			mx = mxi = 0;
			doit(xx[i], yy[i]); ans += getans();
//			cerr << mx << " " << mxi << endl;
			for (int j = 1; j <= n; ++j) f[j][0] = f[j][1] = (node){0, 0};
			mx = mxi = 0;
			doit(yy[i], xx[i]); ans += getans();
//			cerr << mx << " " << mxi << endl;
//			cerr << endl;
		}
		cout << ans << endl;
	}

	return 0;
}
/*
2
5
1 2
2 3
2 4
3 5
7
1 2
1 3
1 4
3 5
3 6
6 7
*/
