#include<iostream>
#include<cstdio>
#include<cstring>
#define ll long long int 
using namespace std;

const ll maxn = 400005;

ll n, m, tm;
ll st[maxn], to[maxn], nx[maxn], in[maxn], mi;

void cle() {
	n=m=tm=mi=0;
	memset(st, 0, sizeof(st));
	memset(to, 0, sizeof(to));
	memset(nx, 0, sizeof(nx));
	memset(in, 0, sizeof(in));
}

void adde(ll a, ll b) {
	tm++; nx[tm]=st[a]; st[a]=tm; to[tm]=b; in[b]++;
}

void init() {
	cin>>n;
	ll i, u, v;
	for(i=1; i < n; i++) {
		cin>>u>>v;
		adde(u, v);
		adde(v, u);
	}
	for(i=1; i <= n; i++) {
		mi=max(mi, in[i]);
	}
	return;
}

namespace sub1 {
	int siz[maxn], ans, ms[maxn], ss;
	void dfs(int x, int fa) {
		int i;
		siz[x]=1;
		for(i=st[x]; i != 0; i=nx[i]) {
			if(to[i] != fa) {
				dfs(to[i], x);
				//cout<<x<<' '<<to[i]<<endl;
				siz[x]+=siz[to[i]];
				ms[x]=max(ms[x], siz[to[i]]);
			}
		}
		return;
	}
	void dfs_count(int x, int fa) {
		int i;
		ms[x]=max(ms[x], ss-siz[x]);
		//cout<<"  "<<x<<' '<<ms[x]<<' '<<siz[x]<<endl;
		if(ms[x] <= ss/2) ans+=x;// cout<<"   "<<x<<endl;
		for(i=st[x]; i != 0; i=nx[i]) {
			if(to[i] != fa) dfs_count(to[i], x);
		}
		return;
	}
	void do_it() {
		ans=0;
		int i, tu, tv;
		for(i=1; i <= (n-1)*2; i+=2) {
			memset(siz, 0, sizeof(siz));
			memset(ms, 0, sizeof(ms));
			tu=to[i]; tv=to[i+1];
			to[i]=0; to[i+1]=0;
			dfs(tu, 0); dfs(tv, 0);
			//cout<<' '<<tu<<' '<<tv<<endl;
			ss=siz[tu]; dfs_count(tu, 0);
			ss=siz[tv]; dfs_count(tv, 0);
			to[i]=tu; to[i+1]=tv;
		}
		cout<<ans<<endl;
		return;
	}
}

namespace sub2 {
	int num[maxn], tn;
	void dfs(int x, int fa) {
		int i; tn++; num[tn]=x;
		for(i=st[x]; i != 0; i=nx[i]) {
			if(to[i] != fa) dfs(to[i], x);
		}
		return;
	}
	void do_it() {
		memset(num, 0, sizeof(num));
		tn=0;
		int i, root, j, ans=0;
		for(i=1; i <= n; i++) {
			if(in[i] == 1) root=i;
		}
		dfs(root, 0);
		for(i=1; i < n; i++) {
			if(i%2 == 1) ans+=num[(i+1)/2];//cout<<num[(i+1)/2]<<endl;
			else ans+=num[i/2]+num[i/2+1];//cout<<num[i/2]<<endl<<num[i/2+1]<<endl;
			//cout<<endl;
		}
		for(i=1; i <= n/2; i++) swap(num[i], num[n-i+1]);
		for(i=1; i < n; i++) {
			if(i%2 == 1) ans+=num[(i+1)/2];//cout<<num[(i+1)/2]<<endl;
			else ans+=num[i/2]+num[i/2+1];//cout<<num[i/2]<<endl<<num[i/2+1]<<endl;
			//cout<<endl;
		}
		cout<<ans<<endl;
		return;
	}
}

namespace sub3 {
	void do_it() {
		ll ans=0, i, root;
		for(i=1; i <= n; i++) 
			if(in[i] == 2) root=i;
		ans+=root*(n+1ll)/2ll;
		for(i=st[root]; i != 0; i=nx[i]) {
			ans+=to[i]*(n-1ll)/2ll;
		}
		for(i=1; i <= n; i++) {
			if(i != root) ans+=i;
		}
		cout<<ans<<endl;
		return;
	}
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	ll I, T;
	cin>>T;
	for(I=1; I <= T; I++) {
		cle();
		init();
		if(n <= 5005) sub1::do_it();
		else if(mi == 2) sub2::do_it();
		else sub3::do_it();
	}
	return 0;
}
