#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
const int N = 3e5+500;
#define fr(i,a,b) for(int i = a;i <= b; ++i)
#define nfr(i,a,b) for(int i = a;i >= b; --i)
#define pb push_back
#define max(a,b) (a) > (b) ? (a) : (b)

template<typename T> inline void read(T &x){
	T out = 0;
	int sgn = 1; char ch;
	for(ch = getchar();ch > '9' || ch < '0';ch = getchar())
		if(ch == '-')sgn = -1;
	for(;ch >= '0' && ch <= '9';ch = getchar())
		out = (out<<3)+(out<<1)+(ch&15);
	x = out*sgn;
}

int n;
struct edge{
	int nxt[N*2],head[N],to[N*2],tot;
	void init(){
		memset(head,0,sizeof head); tot = 0;
	}
	inline void add_edge(int x,int y){
		to[++tot] = y; nxt[tot] = head[x]; head[x] = tot;
		to[++tot] = x; nxt[tot] = head[y]; head[y] = tot;
	}
}e;

int hson[N];
int siz[N],mxv[N];

int st[N][22];
int f[N];

void dfs1(int x,int fa){
	siz[x] = 1; f[x] = fa;
	for(int i = e.head[x];i;i = e.nxt[i]){
		int y = e.to[i];
		if(y == fa)continue ;

		dfs1(y,x); siz[x] += siz[y];
		if(siz[y] > siz[hson[x]])hson[x] = y;
		mxv[x] = max(mxv[x],siz[y]);
	}
	st[x][0] = hson[x];
	fr(i,1,20)st[x][i] = st[st[x][i-1]][i-1];
}

int res;
int rt;
void dfs2(int x,int fa,int totsz){
	siz[x] = 1;
	for(register int i = e.head[x];i;i = e.nxt[i]){
		int y = e.to[i];
		if(y == fa)continue ;
		dfs2(y,x,totsz); mxv[x] = max(mxv[x],siz[y]); siz[x] += siz[y];
	}
	mxv[x] = max(mxv[x],totsz-siz[x]);
	if(mxv[x] <= totsz/2)rt = x;
}

int s1,s2;
ll ans;

int r1,r2;

void calc(int x,int fa,int crt){
//	cerr << x <<' ' << hson[x] << endl;
	r1 = x;
	nfr(i,20,0){
		if(siz[st[r1][i]] > siz[x]/2)r1 = st[r1][i];
	}
	ans += r1;
	if(hson[r1] && (siz[x]-siz[hson[r1]]) <= siz[x]/2)ans += hson[r1];
//	cerr << x <<' ' << r1 << endl;
	
	bool flag = false;
	if(crt != s1){
		r2 = s1;
	} else {
		if(siz[s1]-siz[x] > siz[s2])r2 = s1,flag = true;
		else r2 = s2;
	}
	
//	cerr << r2 <<' ' << crt << "c r2\n";
	nfr(i,20,0){
		if(siz[st[r2][i]] > (n-siz[x])/2)r2 = st[r2][i];
	}
	
//	cerr << flag << endl;
	if(!flag && (n-siz[x]-siz[r2]) <= (n-siz[x])/2)ans += r2;
	if(flag && (n-siz[r2]) <= (n-siz[x])/2)ans += r2;
	if(hson[r2] && (n-siz[x]-siz[hson[r2]]) <= (n-siz[x])/2)ans += hson[r2];
	
	if(crt != s1){
		if(siz[s1] <= (n-siz[x])/2)ans += rt;
	} else {
		if(max(siz[s1]-siz[x],siz[s2]) <= (n-siz[x])/2)ans += rt;
	}
//	cerr << r2 << endl;
	
	for(register int i = e.head[x];i;i = e.nxt[i]){
		int y = e.to[i];
		if(y == fa)continue;
		calc(y,x,crt);
	}
}

void solve(){
	read(n); rt = 0;
//	cerr << n << endl;
	memset(mxv,0,sizeof mxv);
	memset(hson,0,sizeof hson);
	memset(siz,0,sizeof siz);

	e.init();
	fr(i,1,n-1){
		int u,v; read(u); read(v);
		e.add_edge(u,v);
	}
	dfs2(1,0,n); 
	dfs1(rt,0);
	
	s1 = s2 = 0;
	for(register int i = e.head[rt];i;i = e.nxt[i]){
		int y = e.to[i];
		if(siz[y] > siz[s1])s2 = s1,s1 = y;
		else if(siz[y] > siz[s2])s2 = y;
	}
	
	ans = 0;
	for(register int i = e.head[rt];i;i = e.nxt[i]){
		int y = e.to[i];
		calc(y,rt,y);
	}
//	cerr << rt << endl;
	printf("%lld\n",ans);
	return ;
}

int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int t; read(t);
	while(t--)solve();
	return 0;
}
