#include<bits/stdc++.h>
using namespace std;
#define ff first
#define ss second
#define pb push_back
#define mp make_pair
typedef long long LL;
typedef unsigned long long uLL;
typedef pair<int,int> pii;

const int maxn=300111;

int head[maxn],nxt[maxn<<1],to[maxn<<1],etot;
void addedge(int u,int v)
{
	nxt[++etot]=head[u];head[u]=etot;to[etot]=v;
	nxt[++etot]=head[v];head[v]=etot;to[etot]=u;
}

int pa[20][maxn];
int fa[maxn],dep[maxn],sz[maxn],dfn[maxn],edfn[maxn],timer,n;

namespace bf
{
	int seq[2111],tot;
	void dfs(int x,int f)
	{
		fa[x]=f;seq[++tot]=x;sz[x]=1;
		for(int i=head[x];i;i=nxt[i])if(to[i]!=f)
		{
			dfs(to[i],x);
			sz[x]+=sz[to[i]];
		}
	}
	
	int cen(int x,int v)
	{
		tot=0;
		dfs(x,v);
		int mx=0;
		for(int i=1;i<=tot;i++)if(sz[seq[i]]*2>=tot&&(mx==0||sz[mx]>sz[seq[i]]))mx=seq[i];
		if(sz[mx]*2==tot)return mx+fa[mx];
		else return mx;
	}
	
	void solve()
	{
		int ans=0;
		for(int e=1;e<n;e++)
		{
			ans+=cen(to[e*2],to[e*2+1]);
			ans+=cen(to[e*2+1],to[e*2]);
		}
		printf("%d\n",ans);
	}
}

int getlca(int u,int v)
{
	if(dep[u]<dep[v])swap(u,v);
	for(int i=19;i>=0;i--)if(dep[u]-dep[v]>>i)u=pa[i][u];
	if(u==v)return u;
	for(int i=19;i>=0;i--)if(pa[i][u]!=pa[i][v])
	{
		u=pa[i][u];
		v=pa[i][v];
	}
	return fa[u];
}

pii find_partial_centroid_down(int rt,int u,int v,int all)
{
	int cand=0;
	
	if(sz[u]*2>=all&&u!=rt)cand=u;
	else if(sz[v]*2>=all&&v!=rt)cand=v;
	else
	{
		for(int i=19;i>=0;i--)if(dep[pa[i][u]]>dep[rt]&&sz[pa[i][u]]*2<all)u=pa[i][u];
		for(int i=19;i>=0;i--)if(dep[pa[i][v]]>dep[rt]&&sz[pa[i][v]]*2<all)v=pa[i][v];
		if(fa[u]!=rt&&u!=rt)cand=fa[u];
		else if(fa[v]!=rt&&v!=rt)cand=fa[v];
		else cand=rt;
//		printf("u= %d v= %d\n",u,v);
	}
	if(sz[cand]*2==all)return mp(cand,fa[cand]);
	else return mp(cand,0);
}

int go_up(int x,int d)
{
	if(d==-1)return 0;
	for(int i=19;i>=0;i--)if((d>>i)&1)x=pa[i][x];
	return x;
}

pii find_centroid_up(int discard,int u,int v)
{
	int lca=getlca(u,v),all=n-sz[discard];
	int cand=0,upv=go_up(v,dep[v]-dep[lca]-1),lsz=n-sz[discard]-sz[upv];
	if(lsz*2==all)return mp(lca,upv);
	if(lsz*2>all)//lca is ok
	{
		if(fa[discard]==u)lsz=sz[u]-sz[discard];else lsz=sz[u];
		if(lsz*2>=all)
		{
			if(lsz*2==all)return mp(u,fa[u]);
			else return mp(u,0);
		}
		for(int i=19;i>=0;i--)
		{
			int p=pa[i][u],cursz;
			if(dep[p]<=dep[lca])continue;
			if(dfn[p]<=dfn[discard]&&edfn[p]>=dfn[discard])cursz=sz[p]-sz[discard];
			else cursz=sz[p];
			if(cursz*2<all)u=p;
		}
		if(fa[u]==lca)return mp(lca,0);
		cand=fa[u];
		if(dfn[cand]<=dfn[discard]&&edfn[cand]>=dfn[discard])lsz=sz[cand]-sz[discard];
		else lsz=sz[cand];
		if(lsz*2==all)return mp(cand,fa[cand]);
		else return mp(cand,0);
	}
	else//lca!=v,lca not ok
	{
		if((n-sz[discard]-sz[v])*2<all)return mp(v,0);
		for(int i=19;i>=0;i--)
		{
			int p=pa[i][v],cursz=n-sz[discard]-sz[p];
			if(dep[p]<=dep[lca])continue;
			if(cursz*2>=all)v=p;
		}
		lsz=n-sz[discard]-sz[v];
		if(lsz*2==all)return mp(fa[v],v);
		else return mp(fa[v],0);
	}
}

pii cen[maxn],up[maxn];

int ch[maxn],tot;
LL ans;

void dfs(int x,int f,int d)
{
	pa[0][x]=fa[x]=f;
	for(int i=1;i<20;i++)pa[i][x]=pa[i-1][pa[i-1][x]];
	dep[x]=d;dfn[x]=++timer;sz[x]=1;
	cen[x]=mp(x,0);
	for(int i=head[x];i;i=nxt[i])if(to[i]!=f)
	{
		dfs(to[i],x,d+1);
		sz[x]+=sz[to[i]];
		cen[x]=find_partial_centroid_down(x,cen[x].ff,cen[to[i]].ff,sz[x]);
	}
	edfn[x]=timer;
	if(fa[x])ans+=cen[x].ff+cen[x].ss;
//	printf("x= %d cen= %d %d\n",x,cen[x].ff,cen[x].ss);
}

pii cen_right[maxn];
void dfs2(int x)
{
	ans+=up[x].ff+up[x].ss;
//	if(x==2)printf("x= %d up= %d %d\n",x,up[x].ff,up[x].ss);
	tot=0;
	for(int i=head[x];i;i=nxt[i])if(to[i]!=fa[x])ch[++tot]=to[i];
	pii cur=mp(x,0);int cursz=1;
	for(int i=tot;i>=1;i--)
	{
		cen_right[ch[i]]=cur;
		cursz+=sz[ch[i]];
		cur=find_partial_centroid_down(x,cur.ff,cen[ch[i]].ff,cursz);
//		printf("ch= %d cen= %d %d\n",ch[i],cen_right[ch[i]].ff,cen_right[ch[i]].ss);
	}
	cur=mp(x,0);cursz=1;
	for(int i=head[x];i;i=nxt[i])if(to[i]!=fa[x])
	{
		up[to[i]]=find_partial_centroid_down(x,cur.ff,cen_right[to[i]].ff,sz[x]-sz[to[i]]);
//		if(to[i]==2)printf("to= %d up= %d %d\n",to[i],up[to[i]].ff,up[to[i]].ss);
		if(up[x].ff)up[to[i]]=find_centroid_up(to[i],up[to[i]].ff,up[x].ff);
		
		cursz+=sz[to[i]];
		cur=find_partial_centroid_down(x,cur.ff,cen[to[i]].ff,cursz);
	}
//	puts("");
	for(int i=head[x];i;i=nxt[i])if(to[i]!=fa[x])dfs2(to[i]);
}

void solve()
{
	scanf("%d",&n);
	etot=1;memset(head,0,sizeof(head));
	for(int i=1,u,v;i<n;i++)
	{
		scanf("%d%d",&u,&v);
		addedge(u,v);
	}
	if(n<=2000)
	{
		bf::solve();
		return;
	}
	
	ans=0;
	dfs(1,0,0);
	dfs2(1);
	printf("%lld\n",ans);
}
int main()
{
#ifndef EEEEEericKKK
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
#endif
	int tc=1;scanf("%d",&tc);
	while(tc--)solve();
	return 0;
}
