#include<bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<int,int> pii;
typedef pair<ll,int> pli;
typedef vector<int> vi;
typedef vector<pii> vpii;
typedef vector<pli> vpli;

#define FOR(i,a,b) for(int i=a;i<(b);++i)
#define RE cout<<"I_Love_Hashimoto_Kanna\n";
#define MP(a,b) make_pair(a,b)
#define inf (1000000000)
#define linf (1000000000000000000ll)
#define mod (1000000007)

int n;
int u[266666],v[266666];
int deg[266666];

namespace subtask1{

int sz[2222][2222];
vi g[2222];
ll ans;
void build(int x,int pre,int anc){
	sz[anc][x]=1;
//	cout<<x<<" "<<pre<<" "<<anc<<endl;
	FOR(i,0,g[x].size()){
		int to=g[x][i];
		if(to==pre)continue;
		build(to,x,anc);
		sz[anc][x]+=sz[anc][to];
	}
}
void dfs(int x,int pre,int val,int anc){
	int m=n-val;
	bool is=1;
	FOR(i,0,g[x].size()){
		int to=g[x][i];
		int rua=sz[x][to];
		if(to==pre)rua-=val;
		if(rua>m/2){
			is=0;
			break;
		}
	}
	if(is)ans+=x+1;
	FOR(i,0,g[x].size()){
		int to=g[x][i];
		if(to==pre)continue;
		dfs(to,x,val,anc);
	}
}
void solve(){
	ans=0;
	memset(sz,0,sizeof(sz));
	FOR(i,0,2222){
		g[i].clear();
	}
	FOR(i,1,n){
		g[u[i]].push_back(v[i]);
		g[v[i]].push_back(u[i]);
	}
	FOR(i,0,n){
		build(i,-1,i);
	}
	FOR(i,1,n){
		dfs(u[i],v[i],sz[u[i]][v[i]],u[i]);
		swap(u[i],v[i]);
		dfs(u[i],v[i],sz[u[i]][v[i]],u[i]);
		swap(u[i],v[i]);
	}
	cout<<ans<<endl;
}
}

namespace subtask2{
int root;
vi a;
vi g[55555];
void bfs(int root){
	a.push_back(root);
	a.push_back(g[root][0]);
	FOR(i,2,n){
		int x=a[a.size()-1];
		int to=g[x][0]+g[x][1]-a[a.size()-2];
		a.push_back(to);
	}
	FOR(i,0,n){
		a[i]++;
	}
}
void solve(){
	a.clear();
	FOR(i,0,55555){
		g[i].clear();
	}
	FOR(i,1,n){
		g[u[i]].push_back(v[i]);
		g[v[i]].push_back(u[i]);
	}
	FOR(i,0,n)if(deg[i]==1)root=i;
	bfs(root);
	ll ans=0;
	FOR(i,1,n){
		if(i%2)ans+=a[i/2];
		else ans+=a[i/2]+a[i/2-1];
	}
	reverse(a.begin(),a.end());
	FOR(i,1,n){
		if(i%2)ans+=a[i/2];
		else ans+=a[i/2]+a[i/2-1];
	}
	cout<<ans<<endl;
}
}

namespace subtask3{
int root;
ll ans=0;
void solve(){
	FOR(i,0,n)if(deg[i]==2)root=i;
	int ls=-1,rs=-1;
	FOR(i,1,n){
		if(u[i]==root){
			if(ls==-1)ls=v[i];
			else rs=v[i];
		}
		if(v[i]==root){
			if(ls==-1)ls=u[i];
			else rs=u[i];
		}
	}
	FOR(i,1,n+1)ans+=i;
	root++;ls++;rs++;
	ans-=root;
	ans+=(n-1)/2ll*1ll*(ls+rs);
	ans+=(n+1)/2ll*1ll*root;
	cout<<ans<<endl;
}
}

void solve(){
	memset(deg,0,sizeof(deg));
	scanf("%d",&n);
	FOR(i,1,n){
		scanf("%d",&u[i]);u[i]--;deg[u[i]]++;
		scanf("%d",&v[i]);v[i]--;deg[v[i]]++;
	}
	if(n<=2000){
		subtask1::solve();
		return ;
	}
	bool is=1;
	FOR(i,0,n)if(deg[i]>2){
		is=0;
		break;
	}
	if(is){
		subtask2::solve();
		return ;
	}
	subtask3::solve();
}
int main(){
	freopen("centroid.in","r",stdin);freopen("centroid.out","w",stdout);
	int T;
	scanf("%d",&T);
	while(T--)solve();
	return 0;
}

