#include <algorithm>
#include <iostream>
#include <cstring>
#include <string>
#include <cstdio>
#include <vector>
#include <stack>
#include <queue>
#include <ctime>
#include <map>

#define submit

using std::cin;
using std::cout;
using std::endl;

template <typename T>
void read(T& x)
{
    x = 0;
    char c = getchar();
    for (; !isdigit(c); c = getchar());
    for (; isdigit(c); x = x * 10 + (c ^ 48), c = getchar());
}

int n, type;
long long ans = 0x7f7f7f7f7f7f7f7f;
long long a[10010], s[10010], u[10010];

void judge()
{
    long long last = 0, curAns = 0;
    u[n] = 1;
    for (int i = 1; i <= n; ++i)
    {
        if (u[i])
        {
            long long val = 0;
            for (int j = i - 1; j; --j)
            {
                if (u[j])
                    break;
                val += a[j];
            }
            val += a[i];
            if (val < last)
                return;
            last = val;
            curAns += val * val;
        }
    }
    ans = std::min(ans, curAns);
}

void dfs(int dep)
{
    if (dep > n)
    {
        judge();
        return;
    }
    u[dep] = 1;
    dfs(dep + 1);
    u[dep] = 0;
    dfs(dep + 1);
}

int main()
{
#ifdef submit
    freopen("partition.in", "r", stdin);
    freopen("partition.out", "w", stdout);
#endif
    read(n); read(type);
    for (int i = 1; i <= n; ++i)
    {
        read(a[i]);
        s[i] = s[i - 1] + a[i];
    }
    if (n <= 10)
    {
        dfs(1);
        cout << ans << endl;
        return 0;
    }
    for (int i = 1; i < n; ++i)
    {
        long long last = s[i], cur = 0, curAns = 0;
        for (int j = i + 1; j <= n; ++j)
        {
            cur += a[j];
            if (cur >= last)
            {
                curAns += last * last;
                last = cur;
                cur = 0;
            }
        }
        if (cur == 0)
            curAns += last * last;
        else if (cur < last)
            continue;
        curAns += cur * cur;
        ans = std::min(ans, curAns);
    }
    cout << std::min(ans, s[n] * s[n]) << endl;
    return 0;
}
