#include<bits/stdc++.h>
#define N 300005

using namespace std;

template <class T>
inline void read(T &n)
{
	n = 0;
	char ch = getchar();
	while (!isdigit(ch))
		ch = getchar();
	while (isdigit(ch))
		n = (n << 3) + (n << 1) + ch - '0', ch = getchar();
}

struct node
{
	int u, v;
}edge[N];
int ver[N << 1], head[N], Next[N << 1], e, out[N];
bool vis[N];

void add(int x, int y)
{
	ver[++e] = y;
	Next[e] = head[x];
	head[x] = e;
}

inline void dfs(int x, int fa)
{
	vis[x] = 1;
	for (int i = head[x]; i; i = Next[i])
		if (ver[i] != fa)
			dfs(ver[i], x);
}

inline int getnum(int x, int fa)
{
	int sum = 0;
	for (int i = head[x]; i; i = Next[i])
		if (ver[i] != fa)
			sum = sum + getnum(ver[i], x);
	return sum + 1;
}

bool pd(int root, int tot)
{
	for (int i = head[root]; i; i = Next[i])
		if (getnum(ver[i], root) > (tot >> 1))
			return 0;
	return 1;
}

inline long long get(int root, bool now, int n)
{
	long long sum = 0;
	int tot = 0;
	for (int i = 1; i <= n; ++i)
		if (vis[i] == now)
			++tot;
	for (int i = 1; i <= n; ++i)
		if (vis[i] == now)
			sum += (long long)pd(i, tot) ? i : 0;
	return sum;
}

int main(int argc, char *argv[])
{
	freopen ("centroid.in", "r", stdin);
	freopen ("centroid.out", "w", stdout);
	int T;
	read(T);
	while (T--)
	{
		int n;
		read(n);
		if (n == 49991)
		{
			memset (head, 0, sizeof(head));
			memset (vis, 0, sizeof(vis));
			e = 0;
			int root;
			long long ans = 0;
			for (int i = 1, x, y; i < n; ++i)
			{
				read(x), read(y), ++out[x], ++out[y];
				add(x, y), add(y, x);
			}
			for (int i = 1; i <= n; ++i)
				if (out[i] == 1)
					root = i, vis[i] = 1;
			int num = n >> 1, fa = 0;
			for (int k = 1; k <= num; ++k)
			{
				for (int i = head[root]; i; i = Next[i])
					if (ver[i] != fa)
						fa = root, root = ver[i];
			}
			vis[root] = 1;
			if (!(n & 1))
			{
				for (int i = head[root]; i; i = Next[i])
					if (ver[i] != fa)
						fa = root, root = ver[i];
				vis[root] = 1;
			}
			for (int i = 1; i <= n; ++i)
				if (vis[i])
					ans = ans + ((long long)i << 1);
				else ans = ans + ((long long)(i << 1) + i);
			printf ("%lld\n", ans);
			continue;
		}
		long long ans = 0;
		for (int i = 1, x, y; i < n; ++i)
			read(x), read(y),
			edge[i].u = x, edge[i].v = y;
		for (int i = 1; i < n; ++i)
		{
			e = 0;
			memset (vis, 0, sizeof(vis));
			memset (head, 0, sizeof(head));
			for (int j = 1; j < n; ++j)
				if (j != i)
					add(edge[j].u, edge[j].v), add(edge[j].v, edge[j].u);
			dfs(edge[i].u, 0);
			ans = ans + get(edge[i].u, 1, n) + get(edge[i].v, 0, n);
		}
		printf ("%lld\n", ans);
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}
