#include <stdio.h>
#include <vector>
#include <algorithm>
using namespace std;
vector<pair<int,int> > mp[2000];
pair<int,int> edges[2000];
int sts[2000],ban,mxsts[2000];
void calcsts(int u,int p)
{
	sts[u]=1;
	mxsts[u]=0;
	for (size_t i=0;i<mp[u].size();++i)
	{
		int v=mp[u][i].first;
		if (v!=p&&mp[u][i].second!=ban)
		{
			calcsts(v,u);
			sts[u]+=sts[v];
			mxsts[u]=max(mxsts[u],sts[v]);
		}
	}
}
int findv(int u,int numv)
{
	int p=-1;
	while (true)
	{
		bool fnd=false;
		for (size_t i=0;i<mp[u].size();++i)
		{
			int v=mp[u][i].first;
			if (v!=p&&mp[u][i].second!=ban&&sts[v]>numv/2)
			{
				fnd=true;
				p=u;
				u=v;
				break;
			}
		}
		if (!fnd)
			return u;
	}
}
int getcensum(int rt)
{
	calcsts(rt,0);
	int numv=sts[rt];
	rt=findv(rt,numv);
	for (size_t i=0;i<mp[rt].size();++i)
	{
		int v=mp[rt][i].first;
		if (mp[rt][i].second!=ban&&mxsts[v]<=numv/2&&numv-sts[v]<=numv/2)
			return rt+v;
	}
	return rt;
}
int main()
{
	int T;
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	while (T--)
	{
		int n;
		scanf("%d",&n);
		for (int i=1;i<=n;++i)
			mp[i].clear();
		for (int i=1;i<n;++i)
		{
			int u,v;
			scanf("%d%d",&u,&v);
			edges[i]=make_pair(u,v);
			mp[u].push_back(make_pair(v,i));
			mp[v].push_back(make_pair(u,i));
		}
		long long ans=0;
		for (ban=1;ban<n;++ban)
		{
			int u=edges[ban].first,v=edges[ban].second;
			ans+=getcensum(u)+getcensum(v);
		}
		printf("%lld\n",ans);
	}
	return 0;
}
