#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;
const int N=3000,M=6000;
int head[N],e[M],nxt[M],tot;
int sz[N],vis[N],va[N],n;
int ans;
inline void addedge(int u,int v){e[++tot]=v;nxt[tot]=head[u];head[u]=tot;}

void dfs(int u,int fa)
{
	sz[u]=vis[u]=1;
	for(int i=head[u];i;i=nxt[i])
	{
		int v=e[i];if(v==fa) continue;
		dfs(v,u);sz[u]+=sz[v];
	};
}


void work(int x,int y)
{
	dfs(x,y);
	int sum=sz[x],cur=n+1;
	for(int u=1;u<=n;++u)
		if(vis[u])
		{
			int val=0;
			for(int i=head[u];i;i=nxt[i])
			{
				int v=e[i];if(sz[v]>sz[u]||v==y) continue;
				val=max(sz[v],val);
			};
			val=max(val,sum-sz[u]);
			va[u]=val;
			cur=min(cur,val);	
		};
	for(int u=1;u<=n;++u)
		if(vis[u]) 
		{
			if(va[u]==cur){ans+=u;}
			vis[u]=0;
		};
//	puts("");
}

int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout); 
	int T;scanf("%d",&T);
	while(T--)
	{
		scanf("%d",&n);
		ans=0;tot=1;memset(head,0,sizeof(head));	
		for(int i=1,u,v;i<n;++i) scanf("%d %d",&u,&v),addedge(u,v),addedge(v,u);
		for(int i=2;i<=tot;i+=2)
		{
//			printf("%d %d:\n",e[i],e[i^1]);
			work(e[i],e[i^1]);
			work(e[i^1],e[i]);
		};
		printf("%d\n",ans);
	};
	fclose(stdin);
	fclose(stdout);
	return 0;
}
