#include <iostream>
#include <stdio.h>
#include <queue>
#include <algorithm>
#include <cmath>
#include <cstring>
using namespace std;

const int N=5000000;
struct node{
	int u,v,next;
}edge[N];
int t,n,s,u[N],v[N];
int head[N],cnt,vis[N];
int zishu1,zishu2;
int zhong1,zhong2;
int ans;

void addedge(int u,int v){
	edge[++cnt].v=v;
	edge[cnt].u=u;
	edge[cnt].next=head[u];
	head[u]=cnt;
}

void dfs1(int u,int ban,int stp){
	//cout<<1<<endl;
	zishu1=max(zishu1,stp);
	for(int i=head[u];i;i=edge[i].v){
		int v=edge[i].v;
		if(!vis[v]&&v!=ban)
			vis[v]=1,dfs1(v,ban,stp+1);
	}
}

void dfs2(int u,int ban,int stp){
	zishu2=max(zishu2,stp);
	for(int i=head[u];i;i=edge[i].v){
		int v=edge[i].v;
		if(!vis[v]&&v!=ban)
			vis[v]=2,dfs2(v,ban,stp+1);
	}
}

void find1(){
	for(int i=1;i<=n;i++)
		if(vis[i]==1){
			int ban=i;
			int maxsum=0;
			for(int j=head[ban];j;j=edge[j].next){
				//cout<<edge[j].next;
				int v=edge[i].v;
				int sum=0;
				for(int k=head[v];k;k=edge[k].next) sum++;
				maxsum=max(sum,maxsum);
				if(maxsum<=floor(1.0*zishu1/2)) zhong1+=ban;
			}
		}
}

void find2(){
	for(int i=1;i<=n;i++)
		if(vis[i]==2){
			int ban=i;
			int maxsum=0;
			for(int j=head[ban];j;j=edge[j].next){
				//cout<<edge[j].next;
				int v=edge[i].v;
				int sum=0;
				for(int k=head[v];k;k=edge[k].next) sum++;
				maxsum=max(sum,maxsum);
				if(maxsum<=floor(1.0*zishu1/2)) zhong2+=ban;
			}
		}
}

int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&t);
	while(t--){
		ans=0;
		scanf("%d",&n);
		memset(edge,0,sizeof(edge));
		memset(head,0,sizeof(head));
		cnt=0;
		for(int i=1;i<n;i++){
			scanf("%d%d",&u[i],&v[i]);
			addedge(u[i],v[i]);
			addedge(v[i],u[i]);
		}
		for(int i=1;i<n;i++){//ban 
			//int sum=0;
			zishu1=0,zishu2=0;//ֱ 
			zhong1=0,zhong2=0;
			memset(vis,0,sizeof(vis));//ʼ 
			dfs1(u[i],v[i],1); dfs2(v[i],u[i],1);//Ⱦɫ 
			//cout<<zishu1<<" "<<zishu2<<endl;
			//Ⱦ꿪ʼ 
			find1();find2();
			ans+=zhong1+zhong2;
		}
		cout<<ans<<endl;
	}
	return 0;
}
