#include <bits/stdc++.h>
#define pb push_back
#define pii pair<int, int>
#define fi first
#define se second
typedef long long LL;
const int MAXN = 2000;
using namespace std;

inline int read() {
  int x = 0, w = 1; char c = getchar();
  while (!isdigit(c)) {
    if (c == '-') w = -1;
    c = getchar();
  }
  while (isdigit(c)) {
    x = (x << 1) + (x << 3) + (c ^ 48);
    c = getchar();
  }
  return x * w;
}

void enableFileIO() {
  freopen("centroid.in", "r", stdin);
  freopen("centroid.out", "w", stdout);
}

vector < int > res;
bool banned[MAXN + 5];
int n, rt, sum, ans, tree_rt;

namespace tree {
const int MAXM = 2 * MAXN;
struct Edge {
  int to, nxt;
  Edge() {}
  Edge(int _to, int _nxt): to(_to), nxt(_nxt) {}
} edge[MAXM + 5];

int tot, head[MAXN + 5];
void init() {
  tot = 0, memset(head, -1, sizeof(head));
}
void addEdge(int u, int v) {
  edge[tot] = Edge(v, head[u]), head[u] = tot++;
  edge[tot] = Edge(u, head[v]), head[v] = tot++;
}

int sz[MAXN + 5], mx[MAXN + 5];

void dfs1(int u, int fa) {
  sz[u] = 1;
  for (int i = head[u]; ~i; i = edge[i].nxt) {
    int v = edge[i].to; if (v == fa) continue;
    if (!banned[i]) dfs1(v, u);
    sz[u] += sz[v];
  }
}
void dfs2(int u, int fa) {
  for (int i = head[u]; ~i; i = edge[i].nxt) {
    int v = edge[i].to; if (v == fa) continue;
    if (!banned[i]) dfs2(v, u);
  }
  
  mx[u] = max(sz[u] - 1, sz[tree_rt] - sz[u]);
  if (mx[u] <= sz[tree_rt] / 2) res.pb(u);
}

}

void init() {
  tree::init();
  n = read();
  for (int i = 1; i < n; ++i) {
    int u = read(), v = read();
    tree::addEdge(u, v);
  }
}

bool vis[MAXN + 5];
int tmp[MAXN + 5], cnt;

int main() {
  enableFileIO();
  int t = read();
  
  while (t--) {
    init();

    LL ans = 0;
    for (int i = 0; i < tree::tot; i += 2) {
      banned[i] = true, banned[i ^ 1] = true;
      cnt = 0;
      
      for (int j = 1; j <= n; ++j) {
        tree_rt = j;
        memset(tree::sz, 0, sizeof(tree::sz)), res.clear();
        sum = 0, rt = 0, tree::dfs1(tree_rt, 0), tree::dfs2(tree_rt, 0);
        for (int j = 0; j < res.size(); ++j) {
          if (!vis[res[j]]) sum += res[j], vis[res[j]] = true, tmp[++cnt] = res[j];
        }
        ans += sum;
      }
      
      for (int j = 1; j <= cnt; ++j) vis[tmp[j]] = false;
      banned[i] = false, banned[i ^ 1] = false;
    }
    printf("%d\n", ans);
  }
  return 0;
}

