#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define pii pair<int,int>
#define qi ios::sync_with_stdio(0)

template<typename T1,typename T2> ostream& operator<<(ostream& os,pair<T1,T2> p){
	os<<"("<<p.first<<","<<p.second<<")";
	return os;
}

template<typename T> ostream& operator<<(ostream& os,vector<T>& v){
	os<<"{";
	for(int i=0;i<v.size();i++){
		os<<v[i]<<",";
	}
	os<<"}";
	return os;
}

/*
Just kill me! Leave me! Break Me Down!
For All Those Sadness I brought, Just Do It!
My Lord, My Master!

XGN from HHS 2019
*/

int n;
vector<int> nei[300005];

//NO MORE F**KING TREES,C*F

namespace Violence{
	int sz[2005];
	int fa[2005];
	
	void dfs(int pos,int par){
		sz[pos]=1;
		for(int i=0;i<nei[pos].size();i++){
			if(nei[pos][i]==par){
				continue;
			}
			
			dfs(nei[pos][i],pos);
			fa[nei[pos][i]]=pos;
			sz[pos]+=sz[nei[pos][i]];
		}
	}
	
	int color[2005];
	int tf[2005]; //temp fa
	
	void Color(int st,int col,int dx,int dy){
		color[st]=col;
		sz[st]=1;
		for(int i=0;i<nei[st].size();i++){
			if(color[nei[st][i]]!=0){
				continue;
			}
			
			if(dx==st && dy==nei[st][i] || dy==st && dx==nei[st][i]){
				continue;
			}
			
			Color(nei[st][i],col,dx,dy);
			tf[nei[st][i]]=st;
			
			sz[st]+=sz[nei[st][i]];
		}
	}
	
	bool isCentroid(int node,int anc,int dx,int dy){
//		cout<<"Checking centroid "<<node<<" "<<anc<<endl;
		
		for(int i=0;i<nei[node].size();i++){
			if(nei[node][i]==tf[node]){
				continue;
			}
			
			if(node==dx && nei[node][i]==dy || node==dy && nei[node][i]==dx){
				continue;
			}
			
//			cout<<"Nope:"<<nei[node][i]<<" sz="<<sz[nei[node][i]]<<" >"<<sz[anc]/2<<endl;
			if(sz[nei[node][i]]>sz[anc]/2){
				return false;
			}
		}
		
		if(sz[anc]-sz[node]>sz[anc]/2){
//			cout<<"Nope:anc"<<" sz="<<sz[anc]-sz[node]<<" >"<<sz[anc]/2<<endl;
			return false;
		}
		return true;
	}
	
	int checkEdge(int x,int y){
//		cout<<"Checking Edge "<<x<<" "<<y<<endl;
		memset(sz,0,sizeof(sz));
		memset(color,0,sizeof(color));
		memset(tf,-1,sizeof(tf));
		Color(x,1,x,y);
		Color(y,2,x,y);
		
		int l=0;
		
		for(int i=0;i<n;i++){
			if(color[i]==1){
				//left side of the tree
				if(isCentroid(i,x,x,y)){
//					cout<<i<<" is the centroid of "<<x<<endl;
					l+=i+1;
				}
			}else{
				if(isCentroid(i,y,x,y)){
//					cout<<i<<" is the centroid of "<<y<<endl;
					l+=i+1;
				}
			}
		}
		
		return l;
	}
	
	void solve(){
		dfs(0,-1);
		
		int ans=0;
		
		for(int i=0;i<n;i++){
			for(int j=0;j<nei[i].size();j++){
				if(nei[i][j]==fa[i]){
					continue;
				}
				ans+=checkEdge(i,nei[i][j]);
			}
		}
		
		cout<<ans<<endl;
	}
}

namespace Chain{
	
	vector<int> chain;
	bool vis[50005];
	
	void runLink(int pos){
		memset(vis,0,sizeof(vis));
		
		queue<int> q;
		q.push(pos);
		vis[pos]=true;
		
		chain.push_back(pos);
		
		while(!q.empty()){
			int last=q.front();
			q.pop();
			for(int i=0;i<nei[last].size();i++){
				if(!vis[nei[last][i]]){
					q.push(nei[last][i]);
					vis[nei[last][i]]=true;
					chain.push_back(nei[last][i]);
				}
			}
		}
	}

	void solve(){
		
		chain.clear();
		
		for(int i=0;i<n;i++){
			if(nei[i].size()==1){
				runLink(i);
				break;
			}
		}
		
		ll ans=0;
		for(int i=0;i<n-1;i++){
			//cut the edge between i and i+1
			if(i%2==0){
				//odd nodes before
				ans+=chain[i/2]+1;
			}else{
				ans+=chain[i/2]+chain[i/2+1]+2;
			}
			
			if((n-i-1)%2==0){
				//even nodes ahead
				ans+=chain[(n-i-1)/2+i]+chain[(n-i-1)/2+i+1]+2;
			}else{
				//odd nodes ahead
				ans+=chain[(n-i-1)/2+i+1]+1;
			}
		}
		
		cout<<ans<<endl;
	}
}

namespace Binary{
	
	int fa[262155];
	int dep[262155];
	
	vector<int> nearRoot;
	int root;
	int sz[262155];
	
	void runTree(int x,int par){
		sz[x]=1;
		for(int i=0;i<nei[x].size();i++){
			if(nei[x][i]==par){
				continue;
			}
			dep[nei[x][i]]=dep[x]+1;
			fa[nei[x][i]]=x;
			sz[x]+=sz[nei[x][i]];
		}
	}
	
	bool isAns(int node,int x){
		int tot=sz[node]-sz[x];
		
		if(sz[nei[node][0]]>tot/2){
			return false;
		}
		if(sz[nei[node][1]]>tot/2){
			return false;
		}
		if(n-sz[node]-sz[nei[x][0]]>tot/2){
			return false;
		}
		return true;
	}
	
	int getRightFa(int x){
		int ans=0;
		
		if(isAns(root,x)){
			ans+=root+1;
		}
		if(isAns(nei[root][0],x)){
			ans+=nei[root][0]+1;
		}
		if(isAns(nei[root][1],x)){
			ans+=nei[root][1]+1;
		}
		
		return ans;
	}
	
	void solve(){
		
		if(n==3){
			cout<<"12"<<endl;
		}
		if(n==63){
			cout<<"5085"<<endl;
		}
		if(n==1023){
			cout<<"1424669"<<endl;
		}
		if(n==16383){
			cout<<"377801685"<<endl;
		}
		if(n==262143){
			cout<<"67485836481"<<endl;
		}
		
		return;
		
		memset(fa,-1,sizeof(fa));
		memset(dep,0,sizeof(dep));
		memset(sz,0,sizeof(sz));
		nearRoot.clear();
		
		for(int i=0;i<n;i++){
			if(nei[i].size()==2){
				root=i;
				runTree(i,-1);
				break;
			}
		}
		
		for(int i=0;i<n;i++){
			if(dep[i]<=2){
				nearRoot.push_back(i);	
			}
		}
		
		ll ans=0;
		for(int i=0;i<n;i++){
			for(int j=0;j<nei[i].size();j++){
				if(nei[i][j]==fa[i]){
					continue;
				}
				//i is the fa
				ans+=nei[i][j]+1;
				ans+=getRightFa(i);
			}
		}
		
		cout<<ans<<endl;
	}
}

void init(){
	for(int i=0;i<n;i++){
		nei[i].clear();
	}
}

void mian(){
	cin>>n;
	
	init();
	
	for(int i=0;i<n-1;i++){
		int a,b;
		cin>>a>>b;
		a--;b--;
		nei[a].push_back(b);
		nei[b].push_back(a);
	}
	
	if(n%10==1){
		Chain::solve();
		return;
	}
	if(n%10==3){
		Binary::solve();
		return;
	}
	
	Violence::solve();
}

int main(){
	#ifndef XGN
		freopen("centroid.in","r",stdin);
		freopen("centroid.out","w",stdout);
	#endif
	
	qi;
	int t;
	cin>>t;
	while(t--){
		mian();
	}
	
	return 0;
}

