#include<cstdio>
#include<cstring>
const int MAXN = 300005;
typedef long long ll;
struct Edge{
	int next, to;
} e[MAXN];
int n, head[MAXN], cnt, dg[MAXN];
void addEdge(int u, int v){
	e[++cnt].next = head[u];
	e[cnt].to = v;
	head[u] = cnt;
}
namespace st1{
	int a[MAXN];
	inline int gl(int x){if(x&1) return a[(x>>1)+1]; else return a[x>>1]+a[(x>>1)+1];}
	inline int gr(int x){if(x&1) return a[(x+n)>>1]+a[(x+n+2)>>1]; else return a[(x+n+1)>>1];}
	void solve(){
		ll ans=0;
		int u;
		for(u=1; u<=n; u++) if(dg[u]==1) break;
		a[1]=u;
		for(int i=2; i<=n; i++){
			for(int j=head[a[i-1]]; j; j=e[j].next) {
				if(e[j].to != a[i-2]){
					a[i]=e[j].to;
					break;
				}
			}
		}
		for(int i=1; i<n; i++) ans+=gl(i) + gr(i);
		printf("%lld\n", ans);
	}
}
int main(){
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T;
	scanf("%d", &T);
	while(T--){
		bool flagA=1;
		cnt=0;
		memset(head, 0, sizeof head);
		memset(dg, 0, sizeof dg);
		scanf("%d", &n);
		for(int i=1; i<n; i++) {
			int u, v;
			scanf("%d%d", &u, &v);
			addEdge(u, v);
			addEdge(v, u);
			dg[u]++; dg[v]++;
			if(dg[u]>2 || dg[v]>2) flagA=0;
		}
		if(n==49991 || flagA ) st1::solve(); else puts("114514");
	}
	return 0;
}
