#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef pair<int,int> pii;

const int INF = 0x3f3f3f3f;
const int MAXN = 1e5 + 5;

int n,len,T;
int head[MAXN],cnt[MAXN];

struct Edge{
	int to,next;
} e[MAXN << 1];

struct Edg{
	int u,v;
} edge[MAXN];

void add(int u,int v){
	e[++len].to = v;
	e[len].next = head[u];
	head[u] = len;
}

namespace SubTask1{
	int rt1,rt2;
	int f[MAXN],vis[MAXN],size[MAXN];
	
	void dfs1(int u,int fa){
		size[u] = 1;
		for(int i = head[u];i != -1;i = e[i].next){
			int v = e[i].to;
			if(v == fa || vis[i])
			    continue;
			f[v] = u;
			dfs1(v,u);
			size[u] += size[v];
		}
	}
	
	void dfs2(int u,int sz){
		int mx = 0;
		for(int i = head[u];i != -1;i = e[i].next){
			int v = e[i].to;
			if(v == f[u] || vis[i])
			    continue;
			mx = max(mx,size[v]);
			dfs2(v,sz);
		}
		mx = max(mx,sz - size[u]);
		//cout << mx << " ";
		if(mx <= sz / 2){
			if(!rt1)
			    rt1 = u;
			else if(!rt2)
			    rt2 = u;
		}
	}
	
	int calc(int x){
		memset(size,0,sizeof(size));
		memset(f,0,sizeof(f));
		rt1 = rt2 = 0;
		dfs1(x,0);
		dfs2(x,size[x]);
		return rt1 + rt2;
	}
	
	void solve(){
		int res = 0;
		for(int i = 1;i < n;i++){
			int x = edge[i].u,y = edge[i].v;
			vis[2 * i] = vis[2 * i - 1] = 1;
			res += calc(x);
			res += calc(y);
			vis[2 * i] = vis[2 * i - 1] = 0;
		}
		printf("%d\n",res);
	}
}

namespace SubTask2{
	int tot,S;
	int a[MAXN];
	
	void dfs(int u,int fa){
		a[++tot] = u;
		for(int i = head[u];i != -1;i = e[i].next){
			int v = e[i].to;
			if(v == fa)
			    continue;
			dfs(v,u);
		}
	}
	
	void solve(){
		tot = 0;
		for(int i = 1;i <= n;i++){
			if(cnt[i] == 1)
			    S = i;
		}
		dfs(S,0);
		ll res = 0;
//		for(int i = 1;i <= n;i++)
//		    cout << a[i] << " ";
//		cout << endl;
		for(int i = 1;i < n;i++){
			int Llen = i - 1 + 1;
			int Rlen = n - i;
			//cout << Llen << " " << Rlen << endl;
			if(Llen == 1)
				res += a[1];//,cout << a[1] << " ";
			else if(Llen & 1)
				res += a[1 + Llen >> 1];//,cout << a[1 + Llen >> 1] << " ";
			else
			    res += a[Llen >> 1] + a[(Llen >> 1) + 1];//,cout << a[Llen >> 1] << " " << a[(Llen >> 1) + 1] << " ";
			if(Rlen == 1)
			    res += a[n];//,cout << a[n] << " ";
			else if(Rlen & 1)
			    res += a[i + 1 + (Rlen >> 1)];//,cout << "R2 : " << a[i + 1 + (Rlen >> 1)] << " ";
			else
			    res += a[i + (Rlen >> 1)] + a[i + (Rlen >> 1) + 1];//,cout << "R3 : " << a[i + (Rlen >> 1)] << " " << a[i + (Rlen >> 1) + 1] << " ";
			//cout << endl;
		}
		printf("%lld\n",res);
	}
}

int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	while(T--){
		memset(head,-1,sizeof(head));
		len = 0;
		scanf("%d",&n);
		memset(cnt,0,sizeof(cnt));
		int flag = 1;
		for(int i = 1;i < n;i++){
			int x,y;
			scanf("%d%d",&x,&y);
			add(x,y);
			add(y,x);
			edge[i] = (Edg){x,y};
			cnt[x]++;
			cnt[y]++;
			if(cnt[x] > 2 || cnt[y] > 2)
			    flag = 0;
		}
		if(!flag)
		    SubTask1::solve();
		else
		    SubTask2::solve();
	}
	return 0;
}

