#include<bits/stdc++.h>
using namespace std;
typedef long long LL;
const int MAXN=5005;
const LL INF=4e18;
int N,type,M;
LL a[MAXN],sum[MAXN];
struct BIT {
	LL minv[MAXN];
	inline void update(int x,LL c) {
		/*minimize*/
		x=M-x;
		while(x<=M) {
			minv[x]=min(minv[x],c);
			x+=x&-x;
		}
	}
	inline LL query(int x) {
		x=M-x;
		LL ret=INF;
		while(x) {
			ret=min(ret,minv[x]);
			x-=x&-x;
		}
		return ret;
	}
} T[MAXN];
LL f[MAXN][MAXN],ans=INF;
LL sq(LL x) {
	return x*x;
}
int main() {
	freopen("partition.in","r",stdin);
	freopen("partition.out","w",stdout);
	scanf("%d%d",&N,&type);
	for(int i=1; i<=N; i++) {
		scanf("%lld",a+i);
		sum[i]=sum[i-1]+a[i];
	}
	M=N+1;
	for(int i=1; i<=N; i++) {
		for(int j=1; j<=M; j++) {
			T[i].minv[j]=INF;
		}
	}
	T[0].update(0,0);
	for(int i=1; i<=N; i++) {
		for(int j=0; j<i; j++) {
			/*transform from j to i*/
			int q=lower_bound(sum,sum+N+1,2*sum[j]-sum[i])-sum;
			f[i][j]=T[j].query(q)+sq(sum[i]-sum[j]);
			T[i].update(j,f[i][j]);
		}
	}
	for(int i=0; i<N; i++) {
		ans=min(ans,f[N][i]);
	}
	printf("%lld",ans);
	return 0;
}
