#include <iostream>
#include <cstdio>
#include <cstring>
using namespace std;
const int MAXN = 50005;
struct Edge{
  int to,next,no;
}e[MAXN<<1];
int head[MAXN],n,cnt,vis[MAXN],mx[MAXN],size[MAXN];
long long ans=0;
inline void insert(int u,int v)
{
  e[++cnt].to=v,e[cnt].next=head[u],head[u]=cnt;
  e[++cnt].to=u,e[cnt].next=head[v],head[v]=cnt;
}
int now=0;
void dfs(int x)
{
  vis[x]=now;
  size[x]=1;
  for(int i=head[x];i;i=e[i].next){
    if(e[i].no)continue;
    int v=e[i].to;
    if(vis[v]==now)continue;
    dfs(v),size[x]+=size[v];
    if(size[v]>size[mx[x]])mx[x]=v;
  }  
}
bool chain=true;
int d[MAXN],a[MAXN];
void getchain(int x,int fa)
{
  a[++a[0]]=x;
  for(int i=head[x];i;i=e[i].next){
    if(e[i].to!=fa)getchain(e[i].to,x);
  }
}
int main()
{
  freopen("centroid.in","r",stdin);
  freopen("centroid.out","w",stdout);
  int T;
  cin>>T;
  while(T--){
    chain=true;
    ans=0;
    memset(head,0,sizeof(head));
    memset(d,0,sizeof(d));
    cnt=0;
    scanf("%d",&n);
    for(int i=1;i<n;++i){
      int u,v;
      scanf("%d%d",&u,&v);
      ++d[v],++d[u];
      insert(u,v);
    }
    for(int i=1;i<=n;++i)if(d[i]>2)chain=false;
    if(chain){
      int root=0;
      a[0]=0;
      for(int i=1;i<=n;++i)if(d[i]==1){root=i;break;}
      getchain(root,0);
      for(int i=1;i<n;++i){
	if(i&1)ans+=a[i/2+1];
	else ans+=a[i/2]+a[i/2+1];
	if((n-i)&1)ans+=a[i+(n-i)/2+1];
	else ans+=a[i+(n-i)/2]+a[i+(n-i)/2+1];
      }
      cout<<ans<<endl;
      continue;
    }
    for(int i=1;i<n;++i){
      e[i*2-1].no=1,e[i*2].no=1;
      memset(vis,0,sizeof(vis));
      memset(size,0,sizeof(size));
      memset(mx,0,sizeof(mx));
      now=0;
      int v=0;
      for(int i=1;i<=n;++i){
	if(!vis[i]){
	  ++now;
	  dfs(i);
	  int root=i;
	  for(int i=1;i<=n;++i)
	    if(vis[i]==now){
	      if(max(size[mx[i]],size[root]-size[i])<=size[root]/2)ans+=i;
	    }
	}
      }
      e[i*2-1].no=e[i*2].no=0;
    }
    cout<<ans<<endl;
  }
  return 0;
}
