#include <bits/stdc++.h>
using namespace std;
#define rint register int
#define rep(i, n) for (rint (i) = (0); (i) < (n); ++(i))
#define rep1(i, n) for (rint (i) = (1); (i) <= (n); ++(i))
#define Rep(i, a, b) for (rint (i) = (a); (i) <= (b); ++(i))
#define per(i, n) for (rint (i) = ((n) - 1); (i) >= (0); --(i))
#define per1(i, n) for (rint (i) = (n); (i) >= (1); --(i))
#define Per(i, a, b) for (rint (i) = (a); (i) >= (b); --(i))
#define fillset(a, val) memset(a, val, sizeof(a))
#define SZ(s) ((int)s.size())
#define All(a) a.begin(), a.end()
#define MP make_pair
#define pb push_back
#ifdef LOCAL_JUDGE
#define printf(...) (printf(__VA_ARGS__) & fprintf(stderr, __VA_ARGS__) & fflush(stderr))
#define eprintf(...) (fprintf(stderr, __VA_ARGS__) & fflush(stderr))
#else
#define eprintf(...)
#endif
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, int> pli;
typedef pair<int, ll> pil;
typedef pair<ll, ll> pll;
const int inf = 0x3f3f3f3f;
const ll lnf = 0x3f3f3f3f3f3f3f3fLL;
const int mod1 = 1000000007, mod2 = 998244353;

const int Maxn = 300000;

int n;
vector<int> g[Maxn];

namespace solution1 {

int mn, szz, sz[Maxn];
vector<int> root;
int get_sz(int u, int par) {
  int res = 1;
  rep(i, SZ(g[u])) {
    int v = g[u][i];
    if (v == par) continue;
    res += get_sz(v, u);
  }
  return res;
}
void get_root(int u, int par) {
  sz[u] = 1;
  int mxson = 0;
  rep(i, SZ(g[u])) {
    int v = g[u][i];
    if (v == par) continue;
    get_root(v, u);
    sz[u] += sz[v];
    mxson = max(mxson, sz[v]);
  }
  mxson = max(mxson, szz - sz[u]);
  if (mxson < mn) {
    root.clear();
    root.pb(u);
    mn = mxson;
  }
  else if (mxson == mn)
    root.pb(u);
}

int main() {
  ll ans = 0;
  rep1(u, n) rep(j, SZ(g[u])) {
    int v = g[u][j];
    if (u > v) continue;
    szz = get_sz(u, v);
    root.clear();
    mn = inf;
    get_root(u, v);
    rep(i, SZ(root)) ans += root[i];
    
    szz = get_sz(v, u);
    root.clear();
    mn = inf;
    get_root(v, u);
    rep(i, SZ(root)) ans += root[i];
  }
  printf("%lld\n", ans);
}

}

namespace solution2 {

bool vis[Maxn];
int main() {
  int st = -1, ed = -1;
  rep1(i, n)
    if (SZ(g[i]) == 1)
      ((!~st) ? st : ed) = i;
  fillset(vis, 0);
  vector<int> arr;
  while (st != ed) {
    arr.pb(st);
    vis[st] = true;
    int sum = 0;
    rep(i, SZ(g[st]))
      if (!vis[g[st][i]]) {
        st = g[st][i];
        break;
      }
  }
  arr.pb(ed);
  ll ans = 3LL * n * (n + 1) / 2;
  int sz = SZ(arr);
  ans -= (arr[0] + arr[sz - 1]);
  ans -= arr[sz / 2];
  printf("%lld\n", ans);
}

}

namespace solution3 {

int mn, szz, sz[Maxn];
vector<int> root;
int get_sz(int u, int par) {
  int res = 1;
  rep(i, SZ(g[u])) {
    int v = g[u][i];
    if (v == par) continue;
    res += get_sz(v, u);
  }
  return res;
}
void get_root(int u, int par) {
  sz[u] = 1;
  int mxson = 0;
  rep(i, SZ(g[u])) {
    int v = g[u][i];
    if (v == par) continue;
    get_root(v, u);
    sz[u] += sz[v];
    mxson = max(mxson, sz[v]);
  }
  mxson = max(mxson, szz - sz[u]);
  if (mxson < mn) {
    root.clear();
    root.pb(u);
    mn = mxson;
  }
  else if (mxson == mn)
    root.pb(u);
}

int main() {
  mn = inf;
  root.clear();
  szz = get_sz(1, -1);
  get_root(1, -1);
  int rt = root[0];
  ll sum = 0;
  rep(i, SZ(g[rt]))
    sum += g[rt][i];
  ll ans = sum * (n - 1) / 2;
  ans += 1LL * rt * (n + 1) / 2;
  ans += 1LL * n * (n + 1) / 2 - rt;
  printf("%lld\n", ans);
}

}

void solve() {
  scanf("%d", &n);
  rep1(i, n) g[i].clear();
  rep1(i, n - 1) {
    int u, v;
    scanf("%d%d", &u, &v);
    g[u].push_back(v);
    g[v].push_back(u);
  }
  if (n < 2000) {
    solution1::main();
    return;
  }
  if (n == 49991) {
    solution2::main();
    return;
  }
  if (n == 262143) {
    solution3::main();
    return;
  }
}

int main() {
  freopen("centroid.in", "r", stdin);
  freopen("centroid.out", "w", stdout);
  int tests;
  scanf("%d", &tests);
  while (tests--) solve();
  return 0;
}

