#include <bits/stdc++.h>
using namespace std;
#define rint register int
#define rep(i, n) for (rint (i) = (0); (i) < (n); ++(i))
#define rep1(i, n) for (rint (i) = (1); (i) <= (n); ++(i))
#define Rep(i, a, b) for (rint (i) = (a); (i) <= (b); ++(i))
#define per(i, n) for (rint (i) = ((n) - 1); (i) >= (0); --(i))
#define per1(i, n) for (rint (i) = (n); (i) >= (1); --(i))
#define Per(i, a, b) for (rint (i) = (a); (i) >= (b); --(i))
#define fillset(a, val) memset(a, val, sizeof(a))
#define SZ(s) ((int)s.size())
#define All(a) a.begin(), a.end()
#define MP make_pair
#define pb push_back
#ifdef LOCAL_JUDGE
#define printf(...) (printf(__VA_ARGS__) & fprintf(stderr, __VA_ARGS__) & fflush(stderr))
#define eprintf(...) (fprintf(stderr, __VA_ARGS__) & fflush(stderr))
#else
#define eprintf(...)
#endif
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, int> pli;
typedef pair<int, ll> pil;
typedef pair<ll, ll> pll;
const int inf = 0x3f3f3f3f;
const ll lnf = 0x3f3f3f3f3f3f3f3fLL;
const int mod1 = 1000000007, mod2 = 998244353;

const int Maxn = 500005;

int n, input_type;
ll a[Maxn], dp[Maxn];
ll sum[Maxn];
int pre[Maxn];
inline ll get_sum(int l, int r) {
  return sum[r] - sum[l - 1];
}

struct TreeDot {
  ll mn, lazy;
} tr[Maxn << 2];
#define ls (p << 1)
#define rs (p << 1 | 1)
#define mid (l + r >> 1)
inline void pushup(int p) {
  tr[p].mn = min(tr[ls].mn, tr[rs].mn);
}
void build(int p, int l, int r) {
  tr[p].mn = lnf;
  tr[p].lazy = 0;
  if (l == r) return;
  build(ls, l, mid);
  build(rs, mid + 1, r);
  pushup(p);
}
inline void get_lazy(int p, ll val) {
  tr[p].mn -= val;
  tr[p].lazy += val;
}
inline void pushdown(int p, int l, int r) {
  if (tr[p].lazy == 0) return;
  get_lazy(ls, tr[p].lazy);
  get_lazy(rs, tr[p].lazy);
  tr[p].lazy = 0;
}
void update(int p, int l, int r, int pos, ll val) {
  if (l == r) {
    tr[p].mn = val;
    return;
  }
  pushdown(p, l, r);
  if (pos <= mid)
    update(ls, l, mid, pos, val);
  else
    update(rs, mid + 1, r, pos, val);
  pushup(p);
}
void modify(int p, int l, int r, int L, int R, ll val) {
  if (L > r || l > R) return;
  if (L <= l && r <= R) {
    get_lazy(p, val);
    return;
  }
  pushdown(p, l, r);
  modify(ls, l, mid, L, R, val);
  modify(rs, mid + 1, r, L, R, val);
  pushup(p);
}
int query(int p, int l, int r) {
  if (l == r) return l;
  pushdown(p, l, r);
  if (tr[rs].mn <= 0) return query(rs, mid + 1, r);
  else if (tr[ls].mn <= 0) return query(ls, l, mid);
  else return -1;
}

int main() {
  freopen("partition.in", "r", stdin);
  freopen("partition.out", "w", stdout); 
  scanf("%d%d", &n, &input_type);
  rep1(i, n) scanf("%lld", a + i);
  rep1(i, n) sum[i] = sum[i - 1] + a[i];
  build(1, 1, n);
  dp[0] = 0;
  pre[0] = -1;
  rep1(i, n) {
    dp[i] = dp[i - 1] + a[i];
    pre[i] = pre[i - 1];
    if (pre[i] == -1) pre[i] = 0;
    modify(1, 1, n, 1, i - 1, a[i]);
    int pos = query(1, 1, n);
//    eprintf("pos = %d\n", pos);
    if (~pos) {
      ll val = get_sum(pos + 1, i);
      if (val < dp[i]) {
        dp[i] = val;
        pre[i] = pos;
      }
    }
    if (sum[i] < dp[i]) {
      dp[i] = sum[i];
      pre[i] = 0;
    }
    update(1, 1, n, i, dp[i]);
//    eprintf("dp[%d] = %d\n", i, dp[i]);
//    eprintf("pre[%d] = %d\n", i, pre[i]);
  }
  ll ans = 0;
  {
    int i = n;
    while (~pre[i]) {
      ans += dp[i] * dp[i];
      i = pre[i];
    }
  }
  printf("%lld\n", ans);
  return 0;
}

