#include <bits/stdc++.h>
using namespace std;
const int SIZE=500005;
const int INF=0x3f3f3f3f;
#define ll unsigned long long

int sum[SIZE],n,Type,tot=0,a[SIZE],ans[SIZE*4],tag[SIZE*4];
int t[SIZE],L[SIZE],R[SIZE],s=0;

ll Ls(ll p){return p<<1;}
ll Rs(ll p){return p<<1|1;}

void pushup(ll p){ans[p]=ans[Ls(p)]+ans[Rs(p)];}

void build(ll p,ll L,ll R){
	ll mid=(L+R)>>1;
	if (L==R){ans[p]=a[L];return;}
	build(Ls(p),L,mid);
	build(Rs(p),mid+1,R);
	pushup(p);
	tag[p]=0;
}

void lazy(ll L,ll R,ll p,ll k){
	ans[p]+=(k*(R-L+1));
	tag[p]+=k;
}

void pushdown(ll L,ll R,ll p){
	ll mid=(L+R)>>1;
	lazy(L,mid,Ls(p),tag[p]);
	lazy(mid+1,R,Rs(p),tag[p]);
	tag[p]=0;
}

bool check(int x){
	s=0;tot=0;
	memset(t,0,sizeof(t));
	for (int i=1;i<=n;i++){
		for (int j=i;j<=n;j++){
			L[i]=i; R[i]=j;
		}
		t[++tot]=sum[R[i]]-sum[L[i]];
		for (int j=1;j<=tot;j++)
			if (t[j]<t[j-1]) return false;
		for (int j=1;j<=tot;j++){
			s+=t[i]*t[i];
		}
	}
	if (s<=x) return true;
	else	  return false;
}

int main()
{
	freopen("partition.in","r",stdin);	
	freopen("partition.out","w",stdout);
	memset(sum,0,sizeof(sum));	
	scanf("%d%d",&n,&Type);
	if (Type==0){
		for (int i=1;i<=n;i++){	
			scanf("%d",&a[i]);
			sum[i]=sum[i-1]+a[i];	
			L[i]=i;	
			R[i]=i;	
		}
			
	}	
	int l=1,r=sum[n]*sum[n];			
	while (l<=r){
		ll mid=(l+r)>>1;		
		if (check(mid)) r=mid;	
		else			l=mid+1;
	}	
	cout<<r<<endl;	
	return 0;
}																															
