#include <bits/stdc++.h>
using namespace std;

int n;
vector <int> from[300010];
int size[300010], max_s[300010];

void dfs(int x, int last) {
	size[x] = 1, max_s[x] = 0;
	for (int i = 0; i < from[x].size(); i++) {
		int v = from[x][i];
		if (v == last) continue;
		dfs(v, x), size[x] += size[v], max_s[x] = max(max_s[x], size[v]);
	}
}

int calc(int x, int last) {
	memset(size, -1, sizeof(size));
	dfs(x, last);
	int ans = 0;
	for (int i = 1; i <= n; i++) {
		if (~size[i] && max(size[x] - size[i], max_s[i]) <= size[x] / 2) ans += i;
	}
	return ans;
}

void solve1() {
	int ans = 0;
	for (int i = 1; i <= n; i++) {
		for (int j = 0; j < from[i].size(); j++) {
			int v = from[i][j];
			if (i < v) ans += calc(i, v), ans += calc(v, i);
		}
	}
	printf("%d\n", ans);
}

vector <int> a;

void dfs2(int x, int last) {
	a.push_back(x);
	for (int i = 0; i < from[x].size(); i++) {
		int v = from[x][i];
		if (v == last) continue;
		dfs2(v, x);
	}
}

void solve2() {
	int x = -1;
	for (int i = 1; i <= n; i++) {
		if (from[i].size() == 1) {
			x = i;
			break;
		}
	}
	dfs2(x, x);
	long long ans = 0;
	for (int i = 1; i < n; i++) {
		ans += (i & 1 ? a[i / 2] : a[i / 2] + a[i / 2 - 1]);
		ans += (n - i & 1 ? a[n + i >> 1] : a[n + i >> 1] + a[(n + i) / 2 - 1]);
	}
	printf("%lld\n", ans);
}

long long ans;

void dfs(int x, int last, int deep) {
	if (deep <= 1) ans += 1ll * (n - 1) * x;
	else ans += 1ll * (18 - deep) * x;
	for (int i = 0; i < from[x].size(); i++) {
		int v = from[x][i];
		if (v == last) continue;
		dfs(v, x, deep + 1);
	}
}

void solve3() {
	int x = -1;
	for (int i = 1; i <= n; i++) {
		if (from[i].size() == 2) x = i;
	}
	ans = 0;
	dfs(x, x, 0);
	printf("%lld\n", ans);
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T; scanf("%d", &T);
	while (T--) {
		scanf("%d", &n);
		for (int i = 1; i <= n; i++) {
			from[i].clear();
		}
		for (int i = 2; i <= n; i++) {
			int u, v; scanf("%d%d", &u, &v);
			from[u].push_back(v);
			from[v].push_back(u);
		}
		if (n <= 2000) solve1();
		else if (n == 49991) solve2();
		else if (n == 262143) solve3();
	}
	return 0;
}
/*
2
5
1 2
2 3
2 4
3 5
7
1 2
1 3
1 4
3 5
3 6
6 7

*/
