#include <bits/stdc++.h>
using namespace std;

const int mod = 998244353;

int a[110][2010];
long long dp[110][110][110];
long long sum[110];
int n, m;

long long MOD(long long a) {return a - a / mod * mod;}

void solve1() {
	long long ans = 1;
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			(sum[i] += a[i][j]) %= mod;
		}
		ans = ans * (sum[i] + 1) % mod;
	}
	ans = (ans - 1 + mod) % mod;
	for (int pos = 1; pos <= m; pos++) {
		for (int i = 1; i <= n; i++) {
			swap(a[i][1], a[i][pos]);
		}
		memset(dp, 0, sizeof(dp));
		dp[0][0][0] = 1;
		for (int i = 1; i <= n; i++) {
			for (int j = 0; j <= i; j++) {
				for (int k = j; k <= i; k++) {
					// choose 1
					if (j && k) dp[i][j][k] += MOD(dp[i - 1][j - 1][k - 1] * a[i][1]);
					// choose other
					if (k) {
						dp[i][j][k] += MOD(dp[i - 1][j][k - 1] * (sum[i] - a[i][1] + mod));
						if (dp[i][j][k] >= mod) dp[i][j][k] -= mod;
					}
					// choose nothing
					dp[i][j][k] += dp[i - 1][j][k];
					if (dp[i][j][k] >= mod) dp[i][j][k] -= mod;
				}
			}
		}
		for (int j = 1; j <= n; j++) {
			for (int k = j; k <= n; k++) {
				if (j * 2 > k) {
					ans -= dp[n][j][k];
					if (ans < 0) ans += mod;
				}
			}
		}
		for (int i = 1; i <= n; i++) {
			swap(a[i][1], a[i][pos]);
		}
	}
	printf("%lld\n", ans);
}

int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	scanf("%d%d", &n, &m);
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			scanf("%d", &a[i][j]);
		}
	}
	solve1();
	return 0;
}

