#include<iostream>
#include<cstdio>
#include<cstring>
#include<cmath>
#include<algorithm>
#include<queue>
using namespace std;

struct edge
{
	int u,v;
	int next;
}E[100000];
int t,n;
int header[50000],tot=0;
int co[50000],pos,d[50000],v[50000];
long long ans=0;

void addEdge(int u,int v)
{
	E[++tot].u=u;E[tot].v=v;
	E[tot].next=header[u];header[u]=tot;
}

void bfs(int x)
{
	queue <int> q;int ccc=0;
	d[++ccc]=x;q.push(x);v[x]=1;
	while(q.size())
	{
		int y=q.front();q.pop();
		for(int i=header[y];i;i=E[i].next)
		{
			int z=E[i].v;
			if(v[z]) continue;
			d[++ccc]=z;v[z]=1;
			q.push(z);
		}
	}
}

int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&t);
	while(t>0)
	{
		--t;
		scanf("%d",&n);
		for(int i=1;i<=n;++i)
		{
			int u,v;
			scanf("%d%d",&u,&v);
			addEdge(u,v);addEdge(v,u);
			++co[u];++co[v];
		}
		for(int i=1;i<=n;++i)
		{
			if(co[i]==1)
			{
				pos=i;
				break;
			}
		}
		bfs(pos);
		for(int i=1;i<=n-1;++i)
		{
			if(i%2==1)
			{
				ans+=d[i/2+1]+d[n/2+i/2+1];
			}
			else
			{
				ans+=d[i/2+1]+d[i/2]+d[n/2+i/2+1]+d[n/2+i/2];
			}
		}
	}
	return 0;
}

