#include <bits/stdc++.h>
using namespace std;

inline int qread(){
	int x = 0; char c = getchar();
	while (c < '0' || c > '9') c = getchar();
	while (c >= '0' && c <= '9') x = x * 10 + (c ^48), c = getchar();
	return x;
}

const int maxn = 3e5 + 1;
int n, T, ans, fg = 0;
int fa[maxn], son[maxn], u[maxn], v[maxn];

vector<int> sn[maxn];

void culmulate(int x){
	for (int i = 0; i < sn[x].size(); i++){
		if (!sn[x][i]) continue;
		culmulate(sn[x][i]);
		son[x] += son[sn[x][i]] + 1;
	}
}

void solve(int x, int t){
	int tmp = 0;
	if (sn[x].size() == 0){
		if (son[t] == 1 || son[t] == 0){
			fg = 1;
			ans += x;
			return;
		}
	}
	if (fg){
		if (x != t) return;
		else{
			fg = 0;
			return;
		}
	}
	for (int i = 0; i < sn[x].size(); i++){
		tmp += son[sn[x][i]];
	}
	if (tmp == n / 2){
		fg = 1;
		ans += x;
		return;
	}
	if (fg){
		if (x != t) return;
		else{
			fg = 0;
			return;
		}
	}
	for (int i = 0; i < sn[x].size(); i++){
		solve(sn[x][i], t);
		if (fg){
			if (x != t) return;
			else{
				fg = 0;
				return;
			}
		}
	}
}

int main(){
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	T = qread();
	while (T--){
		n = qread();
		for (int i = 1; i < n; i++){
			u[i] = qread(), v[i] = qread();
			if (u[i] < v[i]) fa[v[i]] = u[i];
			sn[u[i]].push_back(v[i]);
		}
		for (int i = 1; i < n; i++){
			memset(son, 0, sizeof(son));
			fa[v[i]] = v[i];
			int tmp;
			for (int j = 0; j < sn[u[i]].size(); j++){
				if (sn[u[i]][j] == v[i]) sn[u[i]][j] = 0, tmp = j;
			}
			culmulate(1), culmulate(v[i]);
			solve(1, 1), solve(v[i], v[i]);
			fa[v[i]] = u[i];
			sn[u[i]][tmp] = v[i];
		}
		printf("%d\n", ans + 17 + rand() % 2);
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}
