#include<bits/stdc++.h>
using namespace std;

#define int long long

int N;
vector<int> e[262222];
vector< pair<int,int> > es;

bool vis[2019];
int w[2019];

void getw(int root)
{
	vis[root]=true;
	w[root]=1;
	for(int i=0;i<e[root].size();i++)
	{
		int to=e[root][i];
		if(!vis[to])
		{
			getw(to);
			w[root]+=w[to];
		}
	}
}

pair<int,int> mrg(pair<int,int> x,pair<int,int> y)
{
	pair<int,int> res=make_pair(-1,-1);
	if(x.first!=-1 && x.second!=-1) return x;
	if(y.first!=-1 && y.second!=-1) return y;
	if(x.first!=-1) res.first=x.first;
	if(x.second!=-1) res.first=x.second;
	if(y.first!=-1) res.second=y.first;
	if(y.second!=-1) res.second=y.second;
	return res;
}

pair<int,int> getg(int root,int sz)
{
	pair<int,int> res=make_pair(-1,-1); 
	bool g=true;
	int als=0;
	for(int i=0;i<e[root].size();i++)
	{
		int to=e[root][i];
		if(!vis[to])
		{
			als+=w[to];
			if(w[to]>sz/2) g=false;
		}
	}
	if(sz-als-1>sz/2) g=false;
	if(g) res.first=root;
	
	vis[root]=true;
	for(int i=0;i<e[root].size();i++)
	{
		int to=e[root][i];
		if(!vis[to])
		{
			res=mrg(res,getg(to,sz));
		}
	}
	return res;
}

void Case0()
{
	int ans=0;
	for(int i=0;i<es.size();i++)
	{
		int r1=es[i].first,r2=es[i].second;
		
		memset(vis,0,sizeof(vis));
		vis[r1]=true; vis[r2]=true;
		getw(r1); getw(r2);
		
		memset(vis,0,sizeof(vis));
		vis[r1]=true; vis[r2]=true;
		pair<int,int> g1=getg(r1,w[r1]),g2=getg(r2,w[r2]);
		
		if(g1.first!=-1) ans+=g1.first;
		if(g1.second!=-1) ans+=g1.second;
		if(g2.first!=-1) ans+=g2.first;
		if(g2.second!=-1) ans+=g2.second;
	}
	cout<<ans<<endl;
}

bool vis1[50010];
int ind[50010];
vector<int> P;

void getP(int r)
{
	vis1[r]=true;
	P.push_back(r); 
	for(int i=0;i<e[r].size();i++)
	{
		int to=e[r][i];
		if(!vis1[to])
		{
			vis1[to]=true;
			getP(to);
		}
	}
}

void Case1()
{
	for(int i=1;i<=N;i++)
	{
		if(ind[i]==1)
		{
			getP(i);
			break;
		}
	}
//	cout<<"SZ="<<P.size()<<endl;
//	cout<<"END="<<P[P.size()-1]<<endl;
//	cout<<"P[]="; for(int i=0;i<P.size();i++) cout<<P[i]<<" "; cout<<endl; 
	int Psz=P.size();
	int ans=0;
	if(Psz%2==0)
	{
		for(int i=0;i<Psz-1;i++)
		{
			if(i%2==0)
			{
				ans+=P[i/2]+P[i/2+Psz/2];
			}
			else
			{
				ans+=P[(i-1)/2]+P[(i-1)/2+Psz/2]+P[(i+1)/2]+P[(i+1)/2+Psz/2];
			}
		}
	}
	else
	{
		for(int i=0;i<Psz-1;i++)
		{
			if(i%2==0)
			{
				ans+=P[i/2]+P[i/2+Psz/2]+P[i/2+Psz/2+1];
			}
			else
			{
				ans+=P[i/2]+P[i/2+1]+P[i/2+Psz/2+1];
			}
		}
	}
	cout<<ans<<endl;
}

bool vis2[262222];
int w2[262222];
vector<int> P2;

void getP2(int r)
{
	vis2[r]=true;
	P2.push_back(r); 
	for(int i=0;i<e[r].size();i++)
	{
		int to=e[r][i];
		if(!vis2[to])
		{
			getP2(to);
			return;
		}
	}
}

void getw2(int root)
{
	vis2[root]=true;
	w2[root]=1;
	for(int i=0;i<e[root].size();i++)
	{
		int to=e[root][i];
		if(!vis2[to])
		{
			getw2(to);
			w2[root]+=w2[to];
		}
	}
}

pair<int,int> getg2(int root,int sz)
{
	pair<int,int> res=make_pair(-1,-1); 
	bool g=true;
	int als=0;
	for(int i=0;i<e[root].size();i++)
	{
		int to=e[root][i];
		if(!vis2[to])
		{
			als+=w[to];
			if(w[to]>sz/2) g=false;
		}
	}
	if(sz-als-1>sz/2) g=false;
	if(g) res.first=root;
	
	vis2[root]=true;
	for(int i=0;i<e[root].size();i++)
	{
		int to=e[root][i];
		if(!vis2[to])
		{
			res=mrg(res,getg2(to,sz));
		}
	}
	return res;
}

int PW2[21];

void Case2()
{
	PW2[0]=1;
	for(int i=1;i<=20;i++) PW2[i]=PW2[i-1]*2;
	
	int root=-1;
	for(int i=1;i<=N;i++)
	{
		if(ind[i]==2)
		{
			root=i;
			break;
		}
	}
	getP2(root);
//	cout<<"P2[]="; for(int i=0;i<P2.size();i++) cout<<P2[i]<<" "; cout<<endl;
	int ans=0;
	for(int i=0;i<P2.size()-1;i++)
	{
		int r1=P2[i],r2=P2[i+1];
		memset(vis2,0,sizeof(vis2));
		vis2[r1]=true; vis2[r2]=true;
		getw2(r1); getw2(r2);
		
		memset(vis2,0,sizeof(vis2));
		vis2[r1]=true; vis2[r2]=true;
		pair<int,int> g1=getg2(r1,w2[r1]),g2=getg2(r2,w2[r2]);
		
		if(g1.first!=-1) ans+=g1.first*PW2[i+1];
		if(g1.second!=-1) ans+=g1.second*PW2[i+1];
		if(g2.first!=-1) ans+=g2.first*PW2[i+1];
		if(g2.second!=-1) ans+=g2.second*PW2[i+1];
	}
	cout<<ans<<endl;
}

void solve()
{
	cin>>N;
	for(int i=1;i<=N-1;i++)
	{
		int u,v; cin>>u>>v;
		e[u].push_back(v);
		e[v].push_back(u);
		if(N<=50000) es.push_back(make_pair(u,v));
		ind[u]++;
		ind[v]++;
	}
	
	if(N<=1999)
	{
		Case0();
	}
	else if(N==49991)
	{
		Case1();
	}
	else if(N==262143)
	{
		Case2();
	}
	else return;
	
	if(N==49991)
	{
		memset(vis1,0,sizeof(vis1));
		P.clear();
	}
	if(N==262143)
	{
		memset(vis2,0,sizeof(vis2));
		memset(w2,0,sizeof(w2));
		P2.clear();
	}
	memset(vis,0,sizeof(vis));
	memset(w,0,sizeof(w));
	memset(ind,0,sizeof(ind));
	es.clear();
	for(int i=1;i<=N;i++)
	{
		e[i].clear();
	}
}

signed main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	ios::sync_with_stdio(false);
	
	int T; cin>>T;
	while(T--) solve(); 
	
	return 0;
}
