#include<bits/stdc++.h>
using namespace std;

#define int long long

const int mod=998244353;

int N,M;
int a[110][2010];

bool usedx[110];
int usedy[2010];

inline pair<int,int> nxt(pair<int,int> pos)
{
	if(pos.first==N && pos.second==M) return make_pair(-1,-1);
	if(pos.second==M) return make_pair(pos.first+1,1);
	return make_pair(pos.first,pos.second+1);
}

int DFS(pair<int,int> pos,int sum,int lft)
{
	int x=pos.first,y=pos.second;
	if(x==-1 && y==-1)
	{
		if(!lft)
		{
//			cout<<endl;
//			for(int i=1;i<=N;i++)
//			{
//				for(int j=1;j<=M;j++)
//				{
//					cout<<a[i][j]<<" ";
//				}
//				cout<<endl;
//			}
//			cout<<endl;
			return 1;
		}
		else return 0;
	}
	int res=0;
	if(lft && a[x][y] && !usedx[x] && usedy[y]<=sum/2-1)
	{
		usedx[x]=true;
		usedy[y]++;
		int t=a[x][y]; a[x][y]=0;
		
		res+=(DFS(nxt(pos),sum,lft-1)*t)%mod;
		
		usedx[x]=false;
		usedy[y]--;
		a[x][y]=t;
	}
	res+=DFS(nxt(pos),sum,lft)%mod;
	return res;
}

void Case0()
{
	int ans=0;
	for(int i=1;i<=N;i++)
	{
		ans+=DFS(make_pair(1,1),i,i);
	}
	cout<<ans<<endl;
}

inline void ADD(int& x,int y)
{
	if(y>=mod*2) y=y%mod;
	else if(y>=mod) y-=mod;
	x+=y;
	if(x>=mod) x-=mod;
}

int dp[42][42][42][42];

void Case1()
{
	dp[0][0][0][0]=1;
	for(int i=1;i<=N;i++)
	{
		for(int j=0;j<=i;j++)
		{
			for(int k=0;k<=i;k++)
			{
				for(int l=0;l<=i;l++)
				{
					int s=dp[i-1][j][k][l];
					ADD(dp[i][j][k][l],s);
					if(a[i][1]) ADD(dp[i][j+1][k][l],a[i][1]*s);
					if(a[i][2]) ADD(dp[i][j][k+1][l],a[i][2]*s);
					if(a[i][3]) ADD(dp[i][j][k][l+1],a[i][3]*s);
				}
			}
		}
	}
	int ans=0;
	for(int j=0;j<=N;j++)
	{
		for(int k=0;k<=N;k++)
		{
			for(int l=0;l<=N;l++)
			{
				int t=(j+k+l)/2;
				if(t && j<=t && k<=t && l<=t && dp[N][j][k][l]>0)
				{
					ADD(ans,dp[N][j][k][l]);
				}
			}
		}
	}
	cout<<ans<<endl;
}

signed main()
{
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);
	ios::sync_with_stdio(false);
	
	cin>>N>>M;
	for(int i=1;i<=N;i++)
	{
		for(int j=1;j<=M;j++)
		{
			cin>>a[i][j];
		}
	}
	if(N<=10)
	{
		Case0();
	}
	else if(M<=3)
	{
		Case1();
	}
	
	return 0;
}
