#include<bits/stdc++.h>
using namespace std;

#define int long long

const int inf=10001001001;
const int maxn=500010;

int N,ty;
int a[maxn];
int presum[maxn];

inline void cmin(int& x,int y)
{
	if(y!=-1 && (x==-1 || x>y)) x=y;
}

inline int getsum(int l,int r)
{
	return presum[r]-presum[l-1];
}

int dp0[410][410];

void Case0()
{
	memset(dp0,-1,sizeof(dp0));
	dp0[1][0]=0;
	for(int i=1;i<=N;i++)
	{
		for(int j=0;j<=i-1;j++)
		{
			if(dp0[i][j]==-1) continue;
			
			int s=getsum(i-1-j,i-1),p=-1;
			
			int L=i,R=N,mid;
			while(R-L>=4)
			{
				mid=(L+R)>>1;
				if(getsum(i,mid)<s) L=mid;
				else R=mid;
			}
			for(int k=L;k<=R;k++)
			{
				if(getsum(i,k)>=s)
				{
					p=k;
					break;
				}
			}
			if(p==-1) continue;
			
			for(int k=p;k<=N;k++)
			{
				cmin(dp0[k+1][k-i],dp0[i][j]+getsum(i,k)*getsum(i,k));
			}
		}
	}
	int ans=-1;
	for(int i=0;i<=N-1;i++)
	{
		cmin(ans,dp0[N+1][i]);
	}
	cout<<ans<<endl;
	
//	for(int i=1;i<=N+1;i++)
//	{
//		for(int j=0;j<=N-1;j++)
//		{
//			cout<<setw(5)<<left<<dp[i][j];
//		}
//		cout<<endl;
//	}
}

int dp[5010][2];

void Case1()
{
	a[N+1]=inf;
	
	memset(dp,-1,sizeof(dp));
	dp[1][0]=0; dp[1][1]=0;
	for(int i=1;i<=N+1;i++)
	{
		int s=dp[i][0],p=-1;
		if(s==-1) continue;
		
		int L=i,R=N,mid;
		while(R-L>=4)
		{
			mid=(L+R)>>1;
			if(getsum(i,mid)<s) L=mid;
			else R=mid;
		}
		for(int k=L;k<=R;k++)
		{
			if(getsum(i,k)>=s)
			{
				p=k;
				break;
			}
		}
		if(p==-1) continue;
		
		for(int j=p;j<=N;j++)
		{
			if(dp[j+1][0]==-1 || dp[j+1][0]>getsum(i,j))
			{
				dp[j+1][0]=getsum(i,j);
				dp[j+1][1]=dp[i][1]+getsum(i,j)*getsum(i,j);
			}
		}
	}
	cout<<dp[N+1][1]<<endl;
//	for(int i=1;i<=N+1;i++)
//	{
//		cout<<dp[i][0]<<" "<<dp[i][1]<<endl;
//	}
}

signed main()
{
	freopen("partition.in","r",stdin);
	freopen("partition.out","w",stdout);
	ios::sync_with_stdio(false);
	
	cin>>N>>ty;
	for(int i=1;i<=N;i++)
	{
		cin>>a[i];
		presum[i]=presum[i-1]+a[i];
	}
	if(N<=400)
	{
		Case0();
	}
	else if(N<=5000)
	{
		Case1();
	}
	
	return 0;
}












