#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int mo = 998244353;
template <class T>
inline void _read(T &x)
{
	x = 0;
	char t = getchar();
	while (!isdigit(t) && t != '-') t = getchar();
	if (t == '-')
	{
		_read(x);
		x *= -1;
		return ;
	}
	while (isdigit(t))
	{
		x = x * 10 + t - '0';
		t = getchar();
	}
}
int n, m;
const int MAXN = 1e2 + 10, MAXM = 2e3 + 10;
ll sum[MAXN][MAXM];
ll a[MAXN][MAXM];
inline ll fpm(ll x, ll y)
{
	ll res = 1;
	while (y)
	{
		if (y & 1) res = res * x % mo;
		x = x * x % mo;
		y >>= 1;
	}
	return res;
}
ll fac[MAXN * MAXM];
ll invfac[MAXN * MAXM];
ll f[2][MAXN][MAXM];
inline ll C(ll x, ll y)
{
	return fac[x] * invfac[y] % mo * invfac[x - y] % mo;
}
inline void work1()
{
	for (int i = 1; i <= n * m; ++i) fac[i] = 1ll * i * fac[i - 1] % mo;
//	for (int i = 1; i <= n * m; ++i)
//		cout << fac[i] << " ";
	invfac[n * m] = fpm(fac[n * m], mo - 2);
	for (int i = n * m - 1; i > 0; --i) invfac[i] = fpm(fac[i], mo - 2);
	for (int i = 1; i <= n; ++i)
		for (int j = 2; j <= m; ++j)
			sum[i][j] += sum[i][j - 1];
	memset(f, 0, sizeof f);
	for (int p = 1; p <= 2; ++p)
	{
		f[p][0][0] = 1;
		for (int i = 1; i <= n; ++i)
		{
			for (int j = 0; j <= sum[i - 1][p]; ++j)
				for (int add = 0; add <= a[i][p]; ++add)
				{
					(f[p][i][j + add] += C(a[i][p], add) * f[p][i - 1][j]) %= mo;
//						cout << "add : " << add << endl;
//						cout << "f: " << f[p][i][j + add] << endl;
				}
		}
	}
	ll ans = 0;
	for (int i = 1; i <= n / 2; ++i)
		(ans += f[1][i][sum[i][1]] + f[2][i][sum[i][2]]) %= mo;
	printf("%lld\n", ans);
}
int cho[MAXN * MAXM];
int ans = 0;
inline bool chk()
{
//	for (int r = 1; r <= n; ++r)
//			{
//				for (int c = 1; c <= m; ++c) cout << cho[(r - 1) * m + c] << " ";
//				cout << endl;
//			}
//			cout << "tmp" << endl;
	int tot = 0;
	for (int i = 1; i <= n * m; ++i) tot += cho[i] != 0;
	if (tot < 1) return 0;
	for (int c = 1; c <= m; ++c)
	{
		int tmp = 0;
		for (int r = 1; r <= n; ++r)
		{
			tmp += cho[(r - 1) * m + c] != 0;
		}
		if (tmp > (int)(tot / 2)) return 0;
	}
	for (int r = 1; r <= n; ++r)
	{
		int tmp = 0;
		for (int c = 1; c <= m; ++c)
			tmp += cho[(r - 1) * m + c] != 0;
		if (tmp > 1) return 0;
	}
	return 1;
}
inline void dfs(int dep)
{
	if (dep > n * m)
	{
		if (chk())
		{
			++ans;
		}
		return ;
	}
	int r = (dep - 1) / m + 1, c = dep - (r - 1) * m;
//	cout << "dep : " << dep << " r : " << r << " c : " << c << endl;
	for (int i = 0; i <= a[r][c]; ++i)
	{
		cho[dep] = i;
		dfs(dep + 1);
	}
}
int main()
{
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	_read(n), _read(m);
	ans = 0;
	memset(sum, 0, sizeof sum);
	memset(a, 0, sizeof a);
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j)
			_read(a[i][j]), sum[i][j] = a[i][j];
	fac[0] = invfac[0] = 1;
	if (n * m <= 30)
	{
		dfs(1);
		printf("%d\n", ans);
	}
	else
	{
		work1();
	}
	return 0;
}
