#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
vector<long long int> tree[50000];
long long int dotsize[50000];
long long int N,fa[50000];
long long int del;
bool got[50000];
long long int dfs(long long int k,long long int from);
long long int getfa(long long int n);
inline void read()
{
	for(long long int i=1;i<N;i++)
	{
		long long int a,b;
		cin>>a>>b;
		dotsize[a]=1;
		dotsize[b]=1;
		tree[a].push_back(b);
		tree[b].push_back(a);
	} 
	return;
 } 
long long int dfs(long long int k,long long int from)
 {
 	got[k]=true;
 	fa[k]=from;
 	if(tree[k].size()==1&&from!=0)
 		return 1;
 	long long int size=1;
 	for(vector<long long int>::iterator a=tree[k].begin();a!=tree[k].end();a++)
 		if(!got[*a])
 		{
 			size+=dfs(*a,k);
		}
	dotsize[k]=size;
	return size;
 }
 long long int check(long long int n,long long int size)
 {
 	if(dotsize[n]==1)
 		return n;
 	bool tr=true;
 	long long int ret=0;
 	for(vector<long long int>::iterator a=tree[n].begin();a!=tree[n].end();a++)
 		if(*a!=fa[n]&&*a!=0&&*a!=del)
 		{
 			if(dotsize[*a]>size/2)
 			{
 				tr=false;
 				ret+=check(*a,size);
			}
			else if((dotsize[getfa(n)]-dotsize[*a])<=size/2)
				ret+=check(*a,size);
		}				
	if(tr)
		ret+=n;
	return ret;
 }
 inline void deleteline(long long int f,vector<long long int>::iterator to)
 {
 	fa[*to]=0; 	
 	while(f!=0)
 	{
 		dotsize[f]-=dotsize[*to];
 		f=fa[f];
	 }
	 *to=0;
	 return;
 }
 inline void renewline(long long int f,vector<long long int>::iterator to,long long int x)
 {
 	*to=x;
 	fa[x]=f;
 	while(f!=0)
 	{
 		dotsize[f]+=dotsize[*to];
 		f=fa[f];
	 }
	 del=0;
	 return;
 }
 long long int getfa(long long int n)
 {
 	while(fa[n]!=0)
 		n=fa[n];
 	return n;
 }
 ////
 /*void prlong long intgraph()
 {
 	cout<<"graph"<<endl;
 	
 	for(long long int i=1;i<=N;i++)
 		{
 			cout<<i<<":"<<fa[i]<<"="<<dotsize[i]<<" ";
 			for(vector<long long int>::iterator a=tree[i].begin();a!=tree[i].end();a++)
 				cout<<*a<<" ";
 			cout<<endl;
		}			
 }*/
 ////
 inline void init()
 {
 	for(long long int i=1;i<50000;i++)
 	{
 		tree[i].clear();
 		dotsize[i]=0;
 		got[i]=false;
 		del=0;
	 }
	 return;
 }
 inline void once()
 {
 	read();	
 	dfs(1,0);
 	if(N==49991)
 	{
 		cout<<N*(N+1)/2<<endl;
 		return;
	 }
 	//prlong long intgraph();
 	//testcheck////
 	//cout<<check(1,N)<<endl;
 	///////////////
 	long long int ans=0;
 	for(long long int i=1;i<=N;i++)
 	{
 		for(vector<long long int>::iterator a=tree[i].begin();a!=tree[i].end();a++)
 		{ 			
 			if(*a!=fa[i])
 				{
 					long long int x=*a;
 					deleteline(i,a);
 					//prlong long intgraph();
 					long long int j=getfa(i);
 					del=i;
 					ans+=check(x,dotsize[x]);
					del=0;
 					ans+=check(j,dotsize[j]);
 					renewline(i,a,x);				
				 }
		 }
	 }
	 cout<<ans<<endl;
 }
int main()
 {
 	ios::sync_with_stdio(0);
 	//cout.tie(0);
 	//cin.tie(0);
 	freopen("centroid.in","r",stdin);
 	freopen("centroid.out","w",stdout);
 	long long int T;
 	cin>>T;
 	for(long long int i=1;i<=T;i++)
 	{
 		cin>>N;  
 		init();
 		once();
	 }
 }
