#include <iostream>
#include <cstdio>
#include <string.h>
#include <fstream>
using namespace std;
inline long long read(){
	long long f=1,ans=0;
	char x=getchar();
	while (x<'0'||x>'9'){if (x=='-') f=-1;x=getchar();}
	while (x>='0'&&x<='9'){ans=ans*10+x-'0';x=getchar();}
	return f*ans;
}
long long n,qwqwqwq;
long long a[5005];

namespace solution1
{
	const long long MAXN=405;
	long long tree[MAXN];
	long long dp[MAXN][MAXN];

	inline long long lowbit(long long x){
		return x&(-x);
	}
	
	inline void add(long long x,long long c){
		while (x<=n){
			tree[x]+=c;
			x+=lowbit(x);
		}
	}
	
	inline long long query(long long x){
		long long ans=0;
		while (x>0){
			ans+=tree[x];
			x-=lowbit(x);
		}
		return ans;
	}
	
	long long main()
	{
		for (long long i=1;i<=n;i++){
			for (long long j=1;j<=n;j++){
				dp[i][j]=1e18;
			}
		}
		memset(dp[0],0,sizeof(dp[0]));
		for (long long i=1;i<=n;i++)
			add(i,a[i]);
		
		dp[1][1]=a[1]*a[1];
		for (long long i=2;i<=n;i++){
			
			for (long long j=1;j<=i;j++){
				long long sum=query(i)-query(j-1);
				long long mn=1e18,pos;
				for (long long k=1;k<j;k++){
					long long sum2=query(j-1)-query(k-1);
					//cout<<"qwq:"<<k<<" "<<j-1<<" "<<sum2<<" "<<dp[j-1][k]<<endl;
					
					if (sum2<=sum){
						mn=min(dp[j-1][k],mn);
						pos=k;
					}
				}
				if (j==1){
					dp[i][j]=sum*sum;
					//cout<<"w"<<i<<" "<<j<<" "<<dp[i][j]<<endl;
					continue;
				}
				if (mn==1e18) continue;
				dp[i][j]=mn+sum*sum;
				//cout<<"i:"<<i<<" j:"<<j<<" pos:"<<pos<<" dp:"<<dp[i][j]<<endl;
			}
		}
		
		long long ans=1e18;
		for (long long i=1;i<=n;i++)
			ans=min(ans,dp[n][i]);
		if (ans==1e18){
			long long sum=query(n);
			return sum*sum;
		}
		return ans;
	}
}

int main()

{
	freopen("partition.in","r",stdin);
	freopen("partition.out","w",stdout);
	ios::sync_with_stdio(false);
	n=read();qwqwqwq=read();
	for (long long i=1;i<=n;i++)
		a[i]=read();
	
	cout<<solution1::main()<<endl;
	return 0;
}
