#include<bits/stdc++.h>

using namespace std;
#define FILEIO(x) freopen(x ".in","r",stdin); freopen(x ".out","w",stdout);
template<typename T>
void in(T&x)
{
	int flg=1;
	char c=getchar();
	for (;!isdigit(c)&&c!='-';c=getchar());
	if (c=='-') flg=-1,c=getchar();
	for (;isdigit(c)&&c!='-';c=getchar())x=x*10+c-48;
	x*=flg;
}
template<typename T>
void out(T x)
{
	if (x==0) putchar('0');
	char buf[32];
	int k=0;
	while(x)
	{
		buf[k++]=x%10+48;
		x/=10;
	}
	for (char *pc=buf+k-1;pc>=buf;pc--) putchar(*pc);
}
const int MAXN=3e5;
vector<int> G[MAXN];
pair<int,int> edges[MAXN];

int n;

namespace smallTest1
{
int ban,sz[5000],treeSize,cnt[5000];
inline void dfs(int u,int p)
{
	//cout << u <<" " << p  << endl;	
	sz[u]=0;
	cnt[u]=0;
	for (int i=0;i<G[u].size();i++)
	{
		int v=G[u][i];
		if (v==p) continue;
		if (edges[ban].first==u&&edges[ban].second==v) continue; 
		if (edges[ban].first==v&&edges[ban].second==u) continue; 
		dfs(v,u);
		sz[u]+=sz[v];
		cnt[u]=max(cnt[u],sz[v]);
	}
	sz[u]++;
	cnt[u]=max(treeSize-sz[u],cnt[u]);
}
inline void dfs2(int u,int p,int &cnt)
{
	//cout << "!" << u << " " << p << endl;
	cnt++;
	for (int i=0;i<G[u].size();i++)
	{
		int v=G[u][i];
		if (v==p) continue;
		if (edges[ban].first==u&&edges[ban].second==v) continue; 
		if (edges[ban].first==v&&edges[ban].second==u) continue; 
		dfs2(v,u,cnt);
	}
}
vector<pair<int,int> > tmp;
inline pair<int,int> getCentroid(int u)
{
	treeSize=0;
	dfs2(u,-1,treeSize);
	memset(cnt,-1,sizeof(cnt));
	dfs(u,-1);
	tmp.clear();
	for (int i=0;i<n;i++)
	{
		if (cnt[i]!=-1)tmp.push_back(make_pair(cnt[i],i));
	}
	sort(tmp.begin(),tmp.end());
	if (tmp.size()>=2&&tmp[0].first==tmp[1].first) return make_pair(tmp[0].second+1,tmp[1].second+1);
	else return make_pair(tmp[0].second+1,0);
}
void solve()
{
	long long ans=0;
	for (int i=0;i<n-1;i++)
	{
		ban=i;
		pair<int,int> tmp=getCentroid(edges[i].first);
		ans+=tmp.first+tmp.second;	
		tmp=getCentroid(edges[i].second);
		ans+=tmp.first+tmp.second;	
	}	
	out(ans);
	puts("");
} 
}

void solve()
{
	scanf("%d",&n);
	for (int i=0;i<n;i++) G[i].clear();
	for (int i=0;i<n-1;i++)
	{
		int x,y;
		scanf("%d%d",&x,&y);
		--x,--y;
		G[x].push_back(y);
		G[y].push_back(x);
		edges[i]=make_pair(x,y);
	}
	smallTest1::solve();
}
int main()
{
	FILEIO("centroid")
	int T;
	scanf("%d",&T);
	while(T--){solve();}	
	return 0;
}

