#include<bits/stdc++.h>
#define MAXN 2005
#define inf 0x3f3f3f3f
#define ll long long
#define mod 998244353
#define ls root<<1
#define rs root<<1|1
#define max(a,b) a>b?a:b
#define min(a,b) a<b?a:b
using namespace std;
int n,m;
ll a[105][MAXN],now;
ll ans;
struct Segment_tree
{
	int c[MAXN<<2];
	inline void init(){memset(c,0,sizeof(c));}
	inline void Pushup(int root)
	{
		c[root]=max(c[ls],c[rs]);
		return;
	}
	void Update(int root,int l,int r,int x,int val)
	{
		if(l==r){
			c[root]+=val;
			return;
		}
		int mid=(l+r)>>1;
		if(x<=mid) Update(ls,l,mid,x,val);
		else Update(rs,mid+1,r,x,val);
		Pushup(root);
	}
	int Query(int root,int l,int r,int L,int R)
	{
		if(L<=l && r<=R) return c[root];
		int mid=(l+r)>>1,ans=0;
		if(L<=mid) ans+=Query(ls,l,mid,L,R);
		if(R>mid) ans+=Query(rs,mid+1,r,L,R);
		return ans;
	}
}T;
inline ll read()
{
	ll res=0;
	char c=getchar();
	while(c<'0' || c>'9') c=getchar();
	while(c>='0' && c<='9') res=res*10+c-'0',c=getchar();
	return res;
}
void dfs(int x,int k,ll t)
{
	if(x==n+1){
		if(k && T.Query(1,1,m,1,m)<=k/2) ans+=t;
		if(ans>=mod) ans%=mod;
		return;
	}
	dfs(x+1,k,t);
	for(int j=1;j<=m;j++)
	if(a[x][j]){
		now=t*a[x][j];
		if(now>=mod) now%=mod;
		T.Update(1,1,m,j,1);
		dfs(x+1,k+1,now);
		T.Update(1,1,m,j,-1);
	}
}
int main()
{
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);
	T.init();
	scanf("%d%d",&n,&m);
	for(int i=1;i<=n;i++)
	 for(int j=1;j<=m;j++) a[i][j]=read();
	 dfs(1,0,1);
	 cout<<ans;
	 return 0;
}
