#include <bits/stdc++.h>
using namespace std;
template <typename T> inline void read(T &x) {
	x = 0;
	char ch = getchar();
	T fh = 1;
	for (; !isdigit(ch); ch = getchar()) if (ch == '-') fh = -1;
	for (; isdigit(ch); ch = getchar()) x = (x << 1) + (x << 3) + (ch ^ 48);
	x *= fh;
}
const int MAXN = 3e5;
int n;
struct info{
	int to, nex;
}l[MAXN << 1];
int fro[MAXN], siz[MAXN], f[MAXN], rd[MAXN], r;
long long ans;
bool us[MAXN << 1], abi[MAXN];
inline void build(int p, int fa) {
	f[p] = fa;
	siz[p] = 1;
	for (int e = fro[p]; e; e = l[e].nex) {
		if (!us[e] && l[e].to != fa) {
			build(l[e].to, p);
			siz[p] += siz[l[e].to];
		}
	}
}
inline void dfs(int p) {
	for (int e = fro[p]; e; e = l[e].nex) {
		if (us[e] || l[e].to == f[p]) continue;
		int u = l[e].to;
		dfs(u);
		if (siz[u] > (siz[r] >> 1)) abi[p] = true;
	}
	if (siz[r] - siz[p] > (siz[r] >> 1)) abi[p] = true;
}
int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	memset(us, false, sizeof(us));
	int T;
	read(T);
	while(T --) {
		ans = 0;
		memset(rd, 0, sizeof(rd));
		memset(fro, 0, sizeof(fro));
		read(n);
		int u, v;
		for (int i = 1; i < n; i ++) {
			read(u); read(v);
			rd[u] ++; rd[v] ++;
			l[i] = (info) {v, fro[u]};
			fro[u] = i;
			l[i + n - 1] = (info) {u, fro[v]};
			fro[v] = i + n - 1;
		}
		if (n >= 49991) {
			for (int i = 1; i <= n; i ++) {
				if (rd[i] == 1) ans += i * 2;
				else ans += i * 3;
			}
			printf("%lld\n", ans);
			continue;
		}
		for (int i = 1; i < n; i ++) {
			memset(abi, false, sizeof(abi));
			us[i] = us[i + n - 1] = true;
			build(l[i].to, 0); build(l[i + n - 1].to, 0);
			r = l[i].to; dfs(l[i].to);
			r = l[i + n - 1].to; dfs(l[i + n - 1].to);
			for (int j = 1; j <= n; j ++) {
				if (!abi[j]) ans += j;
			}
			us[i] = us[i + n - 1] = false;
		}
		printf("%lld\n", ans);
	}
	return 0;
}

