#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cmath>
#include<string>
#include<vector>
using namespace std;

const int Maxm = 5*1e5 + 5;
int cnt = 0, ans = 0, num[Maxm], n, d[Maxm], ds[Maxm], T;
vector<int> v[Maxm];
bool vis[Maxm];
void dfs1(int root){
	for(int i = 0; i < v[root].size(); ++i){
		int x = v[root][i];
		if(!vis[x]){
			num[x] = cnt++;
			d[cnt] = x;
			vis[x] = true;
			dfs1(x);
		}
	}
}

bool checkl(){
	int s1 = 0, s2 = 0;
	for(int i = 1; i <= n; ++i){
		if(ds[i] == 1) s1++;
		if(ds[i] == 2) s2++;
	}
	return (s1 == 2 && s2 == n - 2);
}
bool check(){
	int s2 = 0, s3 = 0, s4 = 0;
	for(int i = 1; i <= n; ++i){
		if(ds[i] == 2) s2++;
		if(ds[i] == 3) s3++;
		if(ds[i] == 1) s4++;
	}
	return (s2 == 1 && s4 == s2 + s3 + 1);
}
int main(){
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	cin >> T;
	while(T--){
		cin >> n;
		ans = 0;
		for(int i = 1;i <= n; ++i){
			ds[i] = 0;
			vis[i] = false;
		}
		for(int i = 1; i < n; ++i){
			int x, y;
			cin >> x >> y;
			v[x].push_back(y);
			v[y].push_back(x);
			ds[x]++;
			ds[y]++;
	 	}
		if(checkl()){
			int root;
			for(int i = 1; i <= n; ++i){
				if(ds[i] == 1){
					root = i;
					break;
				}
			}
			
			vis[root] = true;
			d[1] = root;
			cnt = 1;
			dfs1(root);
			for(int i = 1; i < n; ++i){
				int k = n + i + 1;
				if(i % 2 == 0) ans += d[i/2] + d[i/2 + 1];
				if(i % 2 == 1) ans += d[i/2 + 1];
				if(k % 2 == 0) ans += d[k/2];
				if(k % 2 == 1) ans += d[k/2 + 1] + d[k/2];
			} 
		}
		else if(check()){
			int root;
			for(int i = 1; i <= n; ++i){
				if(ds[i] == 2){
					root = i;
					break;
				}
			}
			
			vis[root] = true;
			d[1] = root;
			cnt = 1;
			dfs1(root);
			ans = ((d[2]+d[3]) * ((n - 1)/2) + (n + 1) * n / 2 - d[2] - d[3]) * 2;
		}
		cout << ans << endl;
	}
	return 0;
}
