#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cmath>
#include<string>
using namespace std;

const int Mod = 998244353, Maxn = 105, Maxm = 2005;
int n, m, a[Maxn][Maxm], ans = 0, d[Maxm];
void dfs(int ff, int cs, int fa){
	if(ff > n){
		for(int i = 1; i <= m; ++i){
			if(d[i] > (cs/2)) return;
		}
		ans = (ans + fa) % Mod;
		return;
	}
	for(int i = 1; i <= m; ++i){
		if(!a[ff][i]) continue;
		d[i] ++;
		dfs(ff + 1, cs + 1, (fa * a[ff][i]) % Mod);
		d[i]--;
	}
	dfs(ff + 1, cs, fa);
	return;
}
int main(){
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	cin >> n >> m;
	for(int i = 1; i <= n; ++i){
		for(int j = 1; j <= m; ++j){
			cin >> a[i][j];
		}
	}
	
	dfs(1, 0, 1);
	cout << ans - 1;
	return 0;
}
