#include<bits/stdc++.h>
using namespace std;

#define forn(i, n) for(int i=0; i<(n); i++)
#define Forn(i, n) for(int i=1; i<=(n); i++)
#define foreach(it, a) for(__typeof((a).begin()) it=(a).begin(); it!=(a).end(); it++)
#define mp make_pair
#define pb push_back
#define f first
#define s second
#define all(x) (x).begin(), (x).end()

typedef long long ll;
typedef pair<int,int> pi;
typedef vector<int> vi;

const int MAX=299999;

int T, N, ff[MAX], sz[MAX];
ll ans;
vector<int> e[MAX];
pi edge[MAX];
vi v1, v2;

int dfs(int x, int p, int SS, vi&v)
{
	sz[x]=1;
	int mx=0;
	foreach(it, e[x]) if(*it!=p)
	{
		int t=dfs(*it, x, SS, v);
		mx=max(mx, t);
		sz[x]+=t;
	}
	mx=max(mx, SS-sz[x]);
	if(mx<=SS/2) v.pb(x);
	return sz[x];
}

int calc(int x, int p)
{
	int ret=1;
	foreach(it, e[x]) if(*it!=p)
		ret+=calc(*it, x);
	return ret;
}

void solve1()
{
	ans=0;
	forn(i, N-1)
	{
		v1.clear(), v2.clear();
		int S1=calc(edge[i].f, edge[i].s);
		int S2=N-S1;
		dfs(edge[i].f, edge[i].s, S1, v1);
		dfs(edge[i].s, edge[i].f, S2, v2);
		foreach(it, v1) ans+=*it;
		foreach(it, v2) ans+=*it;
	}
	printf("%lld\n", ans);
}

int dfs2(int x, int p)
{
	sz[x]=1;
	foreach(it, e[x]) if(*it!=p)
		sz[x]+=dfs2(*it, x);
	return sz[x];
}

void dfs3(int x, int p, int ptr)
{
	ff[++ptr]=x;
	foreach(it, e[x]) if(*it!=p)
		dfs3(*it, x, ptr);
}

void solve2()
{
	ans=0;
	dfs2(1, 0);
	int tp=rand()%N;
	int u=edge[tp].f, v=edge[tp].s;
	v1.clear(), v2.clear();
	int S1=calc(u, v), S2=N-S1;
	dfs(u, v, S1, v1);
	dfs(v, u, S2, v2);
	foreach(it, v1) ans+=*it;
	foreach(it, v2) ans+=*it;
	if(N==49991)
	{
		int st=-1;
		Forn(i, N) if(e[i].size()==1)
			st=i;
		dfs3(st, 0, 0);
		ans=0;
		Forn(i, N)
		{
			if(i%2==0) ans+=ff[i/2], ans+=ff[i/2+1];
			else ans+=ff[i/2];
			if((N-i)&1) ans+=ff[(N-i)/2+1+i];
			else ans+=ff[(N-i)/2+i], ans+=ff[(N-i)/2+1+i];
		}
		printf("%lld\n", ans);
		return;
	}
	printf("%lld\n", ans*N);
}

int main()
{
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	srand(time(0));
	scanf("%d", &T);
	while(T--)
	{
		scanf("%d", &N);
		Forn(i, N) e[i].clear();
		forn(i, N-1)
		{
			int u, v;
			scanf("%d%d", &u, &v);
			e[u].pb(v);
			e[v].pb(u);
			edge[i]=mp(u, v);
		}
		if(N<=2000) solve1();
		else solve2();
	}
	return 0;
}
