#include <bits/stdc++.h>
using namespace std;
#define rep(i, a, b) for (int i = a; i <= b; ++i)

const int N = 5007;

int T, n, siz[N], deg[N], fa[N];
bool f[N];
long long res, ans;

struct edge{
	int u, v;
}e[N];

vector <pair<int,int> > g[N];

void dfs(int u, int anc){
	siz[u] = 1;
	for (int i = 0; i < (int)g[u].size(); ++i){
		int v = g[u][i].first;
		if (v == anc) continue;
		fa[v] = u;
		dfs(v, u);
		siz[u] += siz[v];
	}
}

void clr(){
	rep(i, 1, n) g[i].clear();
	memset(siz, 0, sizeof(siz));
	memset(fa, 0, sizeof(fa));
}

bool vis[N];
void dfs2(int u, int anc, int si){
	f[u] = 1;
	vis[u] = vis[anc] = 1; bool flag = 1;
	for (int i = 0; i < (int)g[u].size(); ++i){
		int v = g[u][i].first, w = g[u][i].second;
		if (v == anc && vis[v]) continue;
		flag = 0;
		if (w == 1 && siz[v] > si / 2) f[u] = 0;
		else if (w == 2 && n + 1 - siz[v] > si / 2) f[u] = 0; 
		dfs2(v, u, si);
//		printf("@%d %d\n", v, u);
	}
	if (flag) f[u] = 0;
	if (flag && deg[u] == deg[anc]) f[u] = 1;
}

int main(){
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	
	scanf("%d", &T);
	while (T--){
		scanf("%d", &n);
		rep(i, 1, n - 1){
			scanf("%d%d", &e[i].u, &e[i].v);
			int x = e[i].u, y = e[i].v;
			g[x].push_back(make_pair(y, 1)); g[y].push_back(make_pair(x, 2));
			deg[x]++, deg[y]++;
		}
		
		dfs(1, 0);
		
		res = 0, ans = 0;
		rep(i, 1, n - 1){
			int x = e[i].u, y = e[i].v;
			if (fa[x] == y) swap(x, y);
//			printf("!%d %d %d\n", i, x, y);
			deg[x]--;deg[y]--;
			
			ans = 0;
			memset(vis, 0, sizeof(vis));
			memset(f, 0, sizeof(f));
			dfs2(y, x, siz[y]);
			rep(j, 1, n) if (f[j]) ans += j;
//			printf("@ %lld\n", ans);
			
			memset(vis, 0, sizeof(vis));
			memset(f, 0, sizeof(f));
			dfs2(x, y, n - siz[y]);
			rep(j, 1, n) if (f[j]) ans += j;
//			printf("# %lld\n", ans);
			
			res += ans;
			deg[x]++,deg[y]++;
		}
		
		printf("%lld\n", res);
		
		clr();
	}
	return 0;
}
