#include <bits/stdc++.h>
#define fox(i,a,b) for(int i=a;i<=b;++i)
#define LL long long
#define U unsigned
#define Set(a,b) memset(a, b, sizeof a)
#define Cpy(a,b) memcpy(a, b, sizeof a)
#define Debug(x) cout << "-------------- " << x << " ---------------" << endl
using namespace std;

template <typename T> inline void chkmin(T&x, T y) {x < y ? 0 : x = y;}
template <typename T> inline void chkmax(T&x, T y) {x > y ? 0 : x = y;}
int _x; bool _f; char _c;
inline int rd() {
	_x = 0, _f = 1, _c = getchar();
	for (; !isdigit(_c); _c = getchar()) if (_c == '-') _f = 0;
	for (; isdigit(_c); _c = getchar()) _x = _x * 10 + _c - '0';
	return _f ? _x : -_x;
}

const int N = 3e5 + 10;
int n, Maxdeg, deg[N], h[N], tot;
struct edge{int nxt, v;} e[N << 1];
struct Edge{int x, y;} E[N];

inline void add(int x, int y) {e[++tot] = (edge) {h[x], y}, h[x] = tot;}

namespace bl {
	LL ans;
	int siz[N], s[N], ms, fa[N];
	void dfs(int x) {
		siz[x] = 1;
		for (int i = h[x], v; i; i = e[i].nxt) {
			if ((v = e[i].v) == fa[x]) continue;
			fa[v] = x, dfs(v);
			siz[x] += siz[v];
		}
	}
	
	void query(int x, int pre) {
		int mx = 0, i, v;
		s[x] = 1;
		for (int i = h[x], v; i; i = e[i].nxt) {
			if ((v = e[i].v) == pre) continue;
			query(v, x);
			s[x] += s[v], chkmax(mx, s[v]);
		}
		chkmax(mx, ms - s[x]);
		if (mx <= ms / 2) ans += x;
	}
	
	void solve() {
		Set(fa, 0);
		dfs(1), ans = 0;
		fox (i, 1, n - 1) {
			if (fa[E[i].y] == E[i].x) swap(E[i].x, E[i].y);
			ms = siz[E[i].x];
			query(E[i].x, E[i].y);
			ms = n - ms;
			query(E[i].y, E[i].x);
		}
		
		cout << ans << endl;
	}
}

namespace chain{
	int p[N];
	LL ans;
	void dfs(int x, int y) {
		for (int i = h[x], v; i; i = e[i].nxt) {
			if ((v = e[i].v) == y) continue;
			dfs(v, x);
			p[x] = p[v] + 1;
		}
	}
	
	void solve() {
		ans = 0;
		fox (i, 1, n) if (deg[i] == 1) {
			dfs(i, 0);
			break;
		}
		int ll, rr;
		fox (i, 1, n) {
			ll = p[i], rr = n - 1 - p[i];
			if (ll > rr) swap(rr, ll);
			ans += i;
			if (rr - ll - 1 >= 0) ans += i;
			if (ll) ans += i;
		}
		
		cout << ans << endl;
	}
}

namespace xx {
	int rt, siz[N], fa[N], Maxdep;
	LL p[N], ans;
	void dfs(int x) {
		siz[x] = 1;
		for (int i = h[x], v; i; i = e[i].nxt) {
			if ((v = e[i].v) == fa[x]) continue;
			fa[v] = x, dfs(v);
			siz[x] += siz[v];
			if (siz[v] == n / 2) rt = x;
		}
	}
	
	void Dfs(int x, int pre, int dep) {
		int i, v; p[dep] += x;
		for (int i = h[x], v; i; i = e[i].nxt) {
			if ((v = e[i].v) == pre) continue;
			Dfs(v, x, dep + 1);
		}
		chkmax(Maxdep, dep);
	}
	
	void solve() {
		Set(p, 0), Maxdep = 0, rt = 0;
		Set(fa, 0);
		dfs(1);
		ans = 0;
		Dfs(rt, 0, 1);
		fox (i, 3, Maxdep) ans += p[i];
		ans += 1LL * ((n >> 1) + 1) * p[2];
		ans += 1LL * ((n >> 1) + 1) * p[1];
		cout << ans << endl;
	}
}


int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int u, v;
	for (int t = rd(); t--; ) {
		n = rd();
		Maxdeg = tot = 0, Set(h, 0), Set(deg, 0);
		fox (i, 2, n) {
			u = rd(), v = rd();
			add(u, v), add(v, u);
			++deg[u], ++deg[v];
			E[i-1] = (Edge) {u, v};
			chkmax(Maxdeg, deg[u]);
			chkmax(Maxdeg, deg[v]);
		}
		
		if (n <= 2000) {
			bl::solve();
		}else if (Maxdeg == 2) {
			chain::solve();
		} else {
			xx::solve();
		}
	}
	return 0;
}

