#include <bits/stdc++.h>
#define rep(i, a, b) for(int i(a), i##_END(b); i <= i##_END; i++)
#define drep(i, a, b) for(int i(a), i##_END(b); i >= i##_END; i--)
using namespace std;

template<typename T> T chkmin(T &a, T b) { return a = (a < b ? a : b); }
template<typename T> T chkmax(T &a, T b) { return a = (a > b ? a : b); }
int read() {
	int res = 0, f = 1; char c = getchar();
	while(c != '-' && (c < '0' || c > '9')) c = getchar(); if(c == '-') f = -1, c = getchar();
	while(c >= '0' && c <= '9') res = (res << 3) + (res << 1) + c - '0', c = getchar(); return res * f;
}
const int maxn = 300010, inf = 0x3f3f3f3f;
int n, head[maxn], ver[maxn * 2], Next[maxn * 2], tot, sz[maxn], mn, rt, c[maxn][2], fa[maxn];
int u[maxn][2];
long long ans;
void add(int x, int y) { ver[++tot] = y, Next[tot] = head[x], head[x] = tot; }
void getroot(int x, int pa) {
	sz[x] = 1; int tmp = 0;
	for(int i = head[x]; i; i = Next[i]) if(ver[i] != pa) 
		getroot(ver[i], x), sz[x] += sz[ver[i]], tmp = max(tmp, sz[ver[i]]);
	tmp = max(tmp, n - sz[x]);
	if(tmp < mn) mn = tmp, rt = x;
}
void dfs1(int x, int pa) {
	sz[x] = 1; fa[x] = pa; c[x][0] = c[x][1] = x;
	for(int i = head[x]; i; i = Next[i]) if(ver[i] != pa) {
		int y = ver[i];
		dfs1(ver[i], x);
		sz[x] += sz[ver[i]];
		if(sz[x] - sz[y] == sz[y]) c[x][0] = x, c[x][1] = y;
		else {
			if(sz[x] - sz[y] < sz[y]) c[x][0] = c[x][1] = c[y][0];
			while(c[x][0] != x && sz[x] - sz[c[x][0]] > sz[c[x][0]]) c[x][0] = fa[c[x][0]]; 
			while(c[x][1] != x && sz[x] - sz[c[x][1]] >= sz[c[x][1]]) c[x][1] = fa[c[x][1]]; 
		}
	}
}
void dfs2(int x, int pa) {
	int cnt = n - sz[x];
	u[x][0] = u[x][1] = u[pa][0];
	while(u[x][0] != rt && cnt - sz[u[x][0]] > sz[u[x][0]]) u[x][0] = fa[u[x][0]];
	while(u[x][1] != rt && cnt - sz[u[x][1]] >= sz[u[x][1]]) u[x][1] = fa[u[x][1]];
	if(u[x][0] == u[x][1]) ans += u[x][0];
	else ans += u[x][0] + u[x][1];
	for(int i = head[x]; i; i = Next[i]) if(ver[i] != pa) dfs2(ver[i], x);
}
int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T = read();
	while(T--) {
		ans = 0; tot = 0;
		memset(head, 0, sizeof(head));
		memset(c, 0, sizeof(c));
		n = read();
		int x, y;
		rep(i, 2, n) x = read(), y = read(), add(x, y), add(y, x);
		mn = inf;
		getroot(1, 0);
		dfs1(rt, 0);
		rep(i, 1, n) if(i != rt) {
			ans += c[i][0];
			if(c[i][1] && c[i][1] != c[i][0]) ans += c[i][1];
		}
//		rep(i, 1, n) cout << c[i][0] << ' ' << c[i][1] << endl;
		int fir = 0, sec = 0, w1 = rt, w2 = rt;
		for(int i = head[rt]; i; i = Next[i]) {
			if(sz[ver[i]] > fir) sec = fir, w2 = w1, fir = sz[ver[i]], w1 = ver[i];
			else if(sz[ver[i]] > sec) sec = sz[ver[i]], w2 = ver[i];
		}
		for(int i = head[rt]; i; i = Next[i]) {
			if(ver[i] == w1) u[rt][0] = u[rt][1] = c[w2][1], dfs2(ver[i], rt);
			else u[rt][0] = u[rt][1] = c[w1][1], dfs2(ver[i], rt);
		}
		printf("%lld\n", ans);
	}
	return 0;
}
