#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <utility>
#include <queue>
#define maxn 105
#define maxm 2005

using namespace std;
typedef long long ll;
const int LEN = 100000;
const int mod = 998244353;

struct fastio{
  char s[LEN + 5];
  int it,len;
  fastio(){
    it = len = 0;
  }
  char get(){
    if(it < len) return s[it++];
    len = fread(s,1,LEN,stdin), it = 0;
    return len ? s[it++] : EOF;
  }
  bool notend(){
    char c;
    for(c = get();c == ' ' || c == '\n';c = get());
    if(it == 0) return false;
    it--;
    return true;
  }
}buff;
inline int getint(){
  int res = 0, sig = 1;
  char c;
  for(c = buff.get();c < '0' || c > '9';c = buff.get()) if(c == '-') sig = -1;
  for(;c >= '0' && c <= '9';c = buff.get()) res = res * 10 + (c - '0');
  return sig * res;
}

int n,m,a[maxn][maxm];
// a[i][0] = a[i][1] + a[i][2] + ... + a[i][m].
int f[maxn][maxn];
int main(){
  freopen("meal.in","r",stdin);
  freopen("meal.out","w",stdout);
  n = getint(), m = getint();
  for(int i = 1;i <= n;i++){
    for(int j = 1;j <= m;j++){
      a[i][j] = getint();
      a[i][0] = (a[i][0] + a[i][j]) % mod;
    }
  }
  int tot = 1;
  for(int i = 1;i <= n;i++) tot = (ll)tot * (a[i][0] + 1) % mod;
  tot = (tot + mod - 1) % mod;
  for(int i = 1;i <= m;i++){
    memset(f,0,sizeof(f));
    f[0][0] = 1;
    for(int l = 1;l <= n;l++){
      for(int j = l;j >= 0;j--){
        for(int k = j;k >= 0;k--){
          if(j >= 1 && k >= 1) f[j][k] = ((ll)f[j][k] + (ll)a[l][i] * f[j - 1][k - 1]) % mod;
          if(j >= 1) f[j][k] = ((ll)f[j][k] + ll(a[l][0] - a[l][i]) * f[j - 1][k]) % mod;
        }
      }
    }
    for(int j = 1;j <= n;j++){
      for(int k = j / 2 + 1;k <= j;k++){
        (tot -= f[j][k]) %= mod;
      }
    }
  }
  printf("%d\n",(tot % mod + mod) % mod);
  return 0;
}

