#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <utility>
#include <queue>
#define maxn 5005

using namespace std;
typedef long long ll;
const ll infll = 0x3f3f3f3f3f3f3f3fll;
const int LEN = 100000;

struct fastio{
  char s[LEN + 5];
  int it,len;
  fastio(){
    it = len = 0;
  }
  char get(){
    if(it < len) return s[it++];
    len = fread(s,1,LEN,stdin), it = 0;
    return len ? s[it++] : EOF;
  }
  bool notend(){
    char c;
    for(c = get();c == ' ' || c == '\n';c = get());
    if(it == 0) return false;
    it--;
    return true;
  }
}buff;
inline int getint(){
  int res = 0, sig = 1;
  char c;
  for(c = buff.get();c < '0' || c > '9';c = buff.get()) if(c == '-') sig = -1;
  for(;c >= '0' && c <= '9';c = buff.get()) res = res * 10 + (c - '0');
  return sig * res;
}

int n,type,a[maxn],sum[maxn],bound[maxn][maxn];
ll f[maxn][maxn],mini[maxn][maxn];
int main(){
  freopen("partition.in","r",stdin);
  freopen("partition.out","w",stdout);
  n = getint(), type = getint();
  if(type == 1) return 0;
  for(int i = 1;i <= n;i++){
    a[i] = getint();
    sum[i] = sum[i - 1] + a[i];
  }
  for(int l = 2;l <= n;l++){
    int i = l - 1;
    for(int r = l;r <= n;r++){
      while(i >= 1 && sum[l - 1] - sum[i - 1] <= sum[r] - sum[l - 1]) i--;
      bound[l][r] = i;
    }
  }
  for(int i = 1;i <= n;i++){
    f[i][i] = (ll)sum[i] * sum[i];
    for(int j = 1;j < i;j++){
      int l = i - j + 1;
      f[i][j] = mini[i - j][i - j - bound[l][i]];
      f[i][j] += ll(sum[i] - sum[i - j]) * (sum[i] - sum[i - j]);
    }
    mini[i][0] = infll;
    for(int j = 1;j <= i;j++) mini[i][j] = min(mini[i][j - 1],f[i][j]);
  }
  ll ans = infll;
  for(int j = 1;j <= n;j++) ans = min(ans,f[n][j]);
  printf("%lld\n",ans);
  return 0;
}

