#include<bits/stdc++.h>
using namespace std;
template <typename T> inline T read(T &x){
	x = 0;
	int minus = 0;
	char ch = getchar();
	while(ch != '-' && !isdigit(ch)) ch = getchar();
	if(ch == '-') minus = 1, ch = getchar();
	while(isdigit(ch)){
		x = x * 10 + ch - '0';
		ch = getchar();
	}
	if(minus) x = -x;
	return x;
}

const int P = 998244353; 
const int maxn = 100;
const int maxm = 2000;
int a[maxn + 5][maxm + 5];
int v[maxn + 5];
int n, m;
long long ans = 0;

void dfs(int pos, int k, long long cnt, int ek){
	
	if(ek > n) return;
	if(pos == n && k == 0) return;
	if((ek - k) > (n - pos + 1)) return;
	
	if(pos > n){
		if(k < 2) return;
		if(ek > k) return;
		ans = (ans + cnt) % P;
		return;
	}
	
	for(int i = 1; i <= m; i++){
		if((v[i] * 2) > n) return; 
		if(a[pos][i] > 0){
			v[i]++;
			dfs(pos + 1, k + 1, cnt * a[pos][i] % P, max(ek, v[i] * 2));
			v[i]--;
		}
	}
	
	dfs(pos + 1, k, cnt, ek);

}

int main(){
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	
	read(n);
	read(m);
	for(int i = 1; i <= n; i++)
		for(int j = 1; j <= m; j++)
			read(a[i][j]);
	
	dfs(1, 0, 1, 0);
	
	cout << ans << endl;
	
	return 0;
}


