#include <cstdio>
#include <cstring>
#include <fstream>
#include <iostream>
#include <algorithm>
#define fi(i,l,r) for(int i=l;i<=r;i++)
#define fd(i,r,l) for(int i=r;i>=l;i--)

using namespace std;
const int maxn=105;
const int maxm=2005;
const int INF=0x3f3f3f3f;

int n,m,ans;
int a[maxn][maxm];
int hang[maxn],lie[maxm];

template<typename T>void Read(T &x)
{
	x=0;char c=getchar();
	while(c<'0'||c>'9') c=getchar();
	while(c>='0'&&c<='9') x=(x<<3)+(x<<1)+(c^48),c=getchar();
}

template<typename T>void Print(T x)
{
	if(x<0) {putchar('-');Print(-x);return;} if(x>9) Print(x/10);putchar((x%10)^48);
}

void Dfs(int step,int goal,int now,int last_hang)
{
	if(step==goal+1) {ans+=now;return;}
	for(int i=last_hang+1;i<=n;i++)
	{
		if(hang[i]==0)
		{
			hang[i]=1;
			for(int j=1;j<=m;j++)
			{
				if(lie[j]+1<=(goal>>1)&&a[i][j]!=0)
				{
					lie[j]++;
					Dfs(step+1,goal,now*a[i][j],i);
					lie[j]--;
				}
			}
			hang[i]=0;
		}
	}
}

int main ()
{
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);
	Read(n);Read(m);
	fi(i,1,n)
	{
		fi(j,1,m)
		  Read(a[i][j]);
	}
	fi(k,2,n)
	{
		memset(hang,0,sizeof(hang));
		memset(lie,0,sizeof(lie));
		Dfs(1,k,1,0);
	}
	Print(ans);putchar(10);
	return 0;
}
