#include <bits/stdc++.h>
using namespace std;
typedef long long lint;
typedef unsigned int uint;
typedef unsigned long long ulint;
typedef pair<int, int> pii;
typedef pair<lint, lint> pll;
#define endl '\n'
#define fst first
#define sed second
#define pb push_back
#define mp make_pair
#define SZ(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rep(it, ff, ee) for (int it = (ff); it <= (ee); ++it)
#define per(it, ff, ee) for (int it = (ff); it >= (ee); --it)
const int MAXN = 3e5 + 10;
vector<int> edge[MAXN];
int n;
namespace BF {
	int sz[2020], wei;
	pii e[2020];
	ulint ans;
	inline void dfs1(int u, int p) {
		sz[u] = 1;
		rep (i, 0, SZ(edge[u]) - 1) {
			if (edge[u][i] != p) {
				dfs1(edge[u][i], u);
				sz[u] += sz[edge[u][i]];
			}
		}
	}
	inline void dfs2(int u, int p) {
		bool flag = true;
		if (wei - sz[u] > wei / 2) {
			flag = false;
		}
		rep (i, 0, SZ(edge[u]) - 1) {
			if (edge[u][i] != p) {
				dfs2(edge[u][i], u);
				if (sz[edge[u][i]] > wei / 2) {
					flag = false;
				}
			}
		}
		if (flag) ans += u;
	}
	inline void work(int u, int p) {
		dfs1(u, p);
		wei = sz[u];
		dfs2(u, p);
	}
	inline void solve() {
		ans = 0;
		rep (i, 1, n - 1) {
			int u, v;
			u = e[i].fst;
			v = e[i].sed;
			work(u, v);
			work(v, u);
		}
		cout << ans << endl;
	}
}
namespace LK {
	int id[MAXN];
	inline bool isLink() {
		rep (i, 1, n) {
			if (SZ(edge[i]) > 2) return false;
		}
		return true;
	}
	inline int findStart() {
		rep (i, 1, n) {
			if (SZ(edge[i]) == 1) {
				return i;
			}
		}
		return 23333;
	}
	inline void dfs(int u) {
		id[1] = u;
		rep (i, 1, n - 1) {
			rep (j, 0, SZ(edge[id[i]]) - 1) {
				if (edge[id[i]][j] != id[i - 1]) {
					id[i + 1] = edge[id[i]][j];
				}
			}
		}
	}
	inline int getMid(int l, int r) {
		if ((r - l) & 1) { // two mids
			return id[(l + r) >> 1] + id[(l + r + 1) >> 1];
		} else {
			return id[(l + r) >> 1];
		}
	}
	inline void solve() {
		dfs(findStart());
		ulint ans = 0;
		rep (i, 1, n - 1) {
			ans += getMid(1, i);
			ans += getMid(i + 1, n);
		}
		cout << ans << endl;
	}
}
namespace PF {
	inline int findRoot() {
		rep (i, 1, n) {
			if (SZ(edge[i]) == 2) {
				return i;
			}
		}
		return 23333;
	}
	inline void solve() {
		ulint res = 0;
		int rt = findRoot();
		ulint mul = ((n + 1) >> 1) - 1;
		res = rt * mul;
		res += edge[rt][0] * mul;
		res += edge[rt][1] * mul;
		rep (i, 1, n) res += i;
		cout << res << endl;
	}
}
inline void solve() {
	scanf("%d", &n);
	rep (i, 1, n) {
		edge[i].clear();
	}
	rep (i, 2, n) {
		int u, v;
		scanf("%d%d", &u, &v);
		edge[u].push_back(v);
		edge[v].push_back(u);
		if (n <= 2019) {
			BF::e[i - 1].fst = u;
			BF::e[i - 1].sed = v;
		}
	}
	if (n <= 2019) {
		BF :: solve();
		return;
	}
	if (LK :: isLink()) {
		LK :: solve();
		return;
	}
	PF :: solve();
}
int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T;
	scanf("%d", &T);
	while (T--) solve();
	return 0;
}
