#include <bits/stdc++.h>
using namespace std;
typedef long long lint;
typedef unsigned int uint;
typedef unsigned long long ulint;
typedef pair<int, int> pii;
typedef pair<lint, lint> pll;
#define endl '\n'
#define fst first
#define sed second
#define pb push_back
#define mp make_pair
#define SZ(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rep(it, ff, ee) for (int it = (ff); it <= (ee); ++it)
const int MAXN = 121;
const int MAXM = 2020;
const int MOD = 998244353;
inline void check(int & x) {
	if (x >= MOD) x -= MOD;
	else if (x < 0) x += MOD;
}
int a[MAXN][MAXM], cnt[MAXN], n, m;
/*
int dp[MAXN][MAXN][MAXN]; // this is a O(n^3 * m) solution
inline int getDP(int ID) {
	memset(dp, 0, sizeof(dp));
	dp[0][0][0] = 1;
	rep (i, 0, n - 1) rep (j, 0, i) {
		rep (k, 0, i) if (dp[i][j][k]) {
			check(dp[i + 1][j][k] += dp[i][j][k]);
			check(dp[i + 1][j + 1][k + 1] += dp[i][j][k] * 1ll * a[i + 1][ID] % MOD);
			check(dp[i + 1][j][k + 1] += dp[i][j][k] * 1ll * (cnt[i + 1] - a[i + 1][ID] - 1 + MOD) % MOD);
		}
	}
	int res = 0;
	rep (j, 1, n) {
		rep (k, 1, n) {
			if (j > k / 2) {
				check(res += dp[n][j][k]);
			}
		}
	}
	return res;
}
*/
int dp[MAXN][MAXN * 2];
inline int getDP(int ID) { // this is a O(n^2 * m) solution
	memset(dp, 0, sizeof(dp));
	dp[0][110] = 1;
	rep (i, 0, n - 1) rep (j, 110 - i, 110 + i) {
		if (dp[i][j] == 0) continue;
		check(dp[i + 1][j] += dp[i][j]); // don't use the mothed
		check(dp[i + 1][j + 1] += dp[i][j] * 1ll * a[i + 1][ID] % MOD);
		check(dp[i + 1][j - 1] += dp[i][j] * (cnt[i + 1] - a[i + 1][ID] - 1ll + MOD) % MOD);
	}
	int res = 0;
	rep (i, 110 + 1, 110 + n) {
		check(res += dp[n][i]);
	}
	return res;
}
int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	scanf("%d%d", &n, &m);
	rep (i, 1, n) {
		cnt[i] = 1; // don't use this mothod
		rep (j, 1, m) {
			cin >> a[i][j];
			check(cnt[i] += a[i][j]);
		}
	}
	int all = 1;
	rep (i, 1, n) {
		all = all * 1ll * cnt[i] % MOD;
	}
	check(all -= 1); // k >= 1
	rep (i, 1, m) {
		check(all -= getDP(i));
	}
	cout << all << endl;
	return 0;
}
