#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cstdlib>
#include<cstring>
#include<string>
#include<cmath>
#include<vector>
#include<set>
#include<queue>
#include<stack>
#include<map>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef double dbl;
typedef pair<int,int> pii;
const int MAXN = 1e5 + 11;
const int INF = 0x3f3f3f3f;
const int MOD = 998244353;
#define For(a,b,c)	for (int (a) = (b);(a) < (c);(a)++)
#define fi first
#define se second
#define mp make_pair
#define pb push_back
int T,N,S;
struct edge{
	int x,y,nxt,bj;
	edge(){}
	edge(int nx,int ny,int nnxt){
		x = nx;y = ny;nxt = nnxt;bj = 0;
	}
}E[MAXN << 1];
int head[MAXN],cnt;
inline void link(int x,int y){
	E[++cnt] = edge(x,y,head[x]);
	head[x] = cnt;
	E[++cnt] = edge(y,x,head[y]);
	head[y] = cnt;
}
ll ans;
int siz[MAXN],totsiz;
void dfs(int u,int fa){
	siz[u] = 1;
	for (int i = head[u];i;i = E[i].nxt)	if (!E[i].bj && E[i].y != fa){
		dfs(E[i].y,u);
		siz[u] += siz[E[i].y];
	}
}
void dfs1(int u,int fa){
	int mx = 0;
	for (int i = head[u];i;i = E[i].nxt)	if (!E[i].bj && E[i].y != fa)	mx = max(mx,siz[E[i].y]);
	mx = max(mx,totsiz - siz[u]);
	if (mx <= totsiz / 2)	ans += (ll)u;
	for (int i = head[u];i;i = E[i].nxt)	if (!E[i].bj && E[i].y != fa)	dfs1(E[i].y,u);
}
void solve(int o){
	memset(siz,0,sizeof(siz));
	totsiz = 0;
	dfs(o,0);totsiz = siz[o];
	dfs1(o,0);
}
int A[MAXN],p,tp[MAXN];
void dfs0(int u,int fa){
	A[++p] = u;
	for (int i = head[u];i;i = E[i].nxt)	if (E[i].y != fa)	dfs0(E[i].y,u);
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	while(T--){
		memset(head,0,sizeof(head));cnt = 1;
		scanf("%d",&N);
		For(i,1,N){
			int a,b;scanf("%d%d",&a,&b);
			link(a,b);
		}
		ans = 0;
		if (N <= 2000){
			for (int i = 2;i <= cnt;i += 2){
				E[i].bj = 1;E[i ^ 1].bj = 1;
				solve(E[i].x);solve(E[i].y);
				E[i].bj = 0;E[i ^ 1].bj = 0;
			}
		}else{
			int st = 0;
			For(i,1,N + 1)	if (!E[head[i]].nxt){
				st = i;break;
			}	
			p = 0;dfs0(st,0);
			For(i,1,N + 1)	{
				if (2 * (i - 1) + 1 < N)	ans += (ll)A[i];
				if (2 * (i - 1) + 2 < N)	ans += (ll)A[i];
				if (i > 1 && 2 * (i - 2) + 2 < N)	ans += (ll)A[i];
			}
			For(i,1,N + 1)	tp[i] = A[i];
			For(i,1,N + 1)	A[i] = tp[N - i + 1];
			For(i,1,N + 1)	{
				if (2 * (i - 1) + 1 < N)	ans += (ll)A[i];
				if (2 * (i - 1) + 2 < N)	ans += (ll)A[i];
				if (i > 1 && 2 * (i - 2) + 2 < N)	ans += (ll)A[i];
			}
		}
		printf("%lld\n",ans);
	}
	return 0;
}
