#include<bits/stdc++.h>

using namespace std;

#define FOR(i, x, y) for(int i = (x); i < (y); ++i)
#define REP(i, x, y) for(int i = (x); i <= (y); ++i)
#define PB push_back
#define MP make_pair
#define PH push
#define fst first
#define snd second
typedef long long ll;
typedef unsigned long long ull;
typedef double db;
typedef long double ldb;
typedef pair<int, int> pii;

int n;

namespace Solve1{
	const int myMaxn = 2005;
	int ans;
	int sz[myMaxn], cen[myMaxn];
	int ed[myMaxn][2];
	vector<int> g[myMaxn];
	inline void dfs2(int u, int p, int siz){
		cen[u] = 1;
		FOR(i, 0, (int)g[u].size()){
			int v = g[u][i];
			if(v == p) continue;
			dfs2(v, u, siz);
			cen[u] &= (sz[v] <= siz / 2);
		}
		cen[u] &= ((siz - sz[u]) <= siz / 2);
		ans += cen[u] * (u + 1); 
		return;
	}
	inline void dfs(int u, int p){
		sz[u] = 1;
		FOR(i, 0, (int)g[u].size()){
			int v = g[u][i];
			if(v == p) continue;
			dfs(v, u);
			sz[u] += sz[v];
		}
		return;
	}
	inline void work(){
		ans = 0;
		FOR(u, 0, n) g[u].clear();
		memset(cen, 0, sizeof(cen));
		FOR(i, 1, n){
			int u, v; scanf("%d%d", &u, &v); --u; --v;
			g[u].PB(v);
			g[v].PB(u);
			ed[i][0] = u, ed[i][1] = v;
		}
		FOR(i, 1, n){
			dfs(ed[i][0], ed[i][1]);
			dfs(ed[i][1], ed[i][0]);
			dfs2(ed[i][0], ed[i][1], sz[ed[i][0]]);
			dfs2(ed[i][1], ed[i][0], sz[ed[i][1]]);
			//printf("curans = %d\n", ans);
		}
		printf("%d\n", ans);
		return;
	}
}

namespace Solve2{
	ll ans; 
	const int myMaxn = 262150;
	int q[myMaxn], hd = 0, tl = 0;
	int vis[myMaxn];
	vector<int> g[myMaxn];
	inline void work(){
		ans = 0;
		//printf("n = %d\n", n);
		FOR(i, 0, n) g[i].clear();
		FOR(i, 1, n){
			int x, y; scanf("%d%d", &x, &y);
			--x; --y;
			g[x].PB(y);
			g[y].PB(x);
		}
		hd = tl = 0;
		memset(vis, 0, sizeof(vis));
		FOR(i, 0, n) if((int)g[i].size() == 1){
			q[tl++] = i;
			vis[i] = 1;
			break;
		}
		while(hd < tl){
			int u = q[hd++];
			//printf("u = %d\n", u);
			FOR(i, 0, (int)g[u].size()){
				int v = g[u][i];
				if(!vis[v]){
					vis[v] = 1;
					q[tl++] = v;
				}
			}
		}
		FOR(i, 0, n - 1){
			int lsiz = i + 1;
			int rsiz = n - i - 1;
			if(lsiz & 1) ans += q[lsiz >> 1] + 1;
			else ans += q[lsiz >> 1] + 1 + q[(lsiz >> 1) - 1] + 1;
			if(rsiz & 1) ans += q[i + 1 + (rsiz >> 1)] + 1;
			else ans += q[i + 1 + (rsiz >> 1) - 1] + 1 + q[i + 1 + (rsiz >> 1)] + 1;
		}
		printf("%lld\n", ans);
		return;
	}
}

inline void solve(){
	scanf("%d", &n);
	if(n <= 1999)
		Solve1::work();
	else if(n == 49991)
		Solve2::work();
	else{}
}

int main(){
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T;
	for(scanf("%d", &T); T--; solve()); 
	return 0;
}

/*
2
5
1 2
2 3
2 4
3 5
7
1 2
1 3
1 4
3 5
3 6
6 7
*/
