#include<bits/stdc++.h>

using namespace std;

#define FOR(i, x, y) for(int i = (x); i < (y); ++i)
#define REP(i, x, y) for(int i = (x); i <= (y); ++i)
#define PB push_back
#define MP make_pair
#define PH push
#define fst first
#define snd second
typedef long long ll;
typedef unsigned long long ull;
typedef double db;
typedef long double ldb;
typedef pair<int, int> pii;

const int maxn = 105;
const int maxm = 2005;
const int INF = 998244353;

int n, m, ans;
int a[maxn][maxm], sum[maxn];
int dp[maxn][maxn], f[maxn][maxn << 1];

inline void uadd(int &x, int y){
	x += y;
	x -= ((x >= INF) ? INF : 0);
}

inline int mul(int x, int y){
	return (1ll * x * y % INF);
}

inline void usub(int &x, int y){
	(x -= y) += INF;
	x -= ((x >= INF) ? INF : 0);
}

inline int sub(int x, int y){
	return (x - y + INF) % INF; 
}

int main(){
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	scanf("%d%d", &n, &m);
	FOR(i, 0, n) FOR(j, 0, m){
		scanf("%d", &a[i][j]);
		(sum[i] += a[i][j]) %= INF;
	}
	dp[0][0] = 1;
	FOR(i, 0, n) REP(j, 0, i) if(dp[i][j]){
		uadd(dp[i + 1][j + 1], mul(dp[i][j], sum[i]));
		uadd(dp[i + 1][j], dp[i][j]);
	}
	REP(j, 1, n) uadd(ans, dp[n][j]);
	//printf("ans = %d\n", ans);
	FOR(spe, 0, m){
		memset(f, 0, sizeof(f));
		f[0][maxn] = 1;
		FOR(i, 0, n) FOR(j, -maxn, maxn) if(f[i][j + maxn]){
			//printf("i = %d j = %d %d\n", i, j, f[i][j + maxn]);
			if(j + 1 + maxn < maxn * 2)
				uadd(f[i + 1][j + 1 + maxn], mul(f[i][j + maxn], a[i][spe]));
			if(j - 1 + maxn >= 0)
				uadd(f[i + 1][j - 1 + maxn], mul(f[i][j + maxn], sub(sum[i], a[i][spe])));
			uadd(f[i + 1][j + maxn], f[i][j + maxn]);
		}
		REP(j, 1, n){
			//printf("spe = %d j = %d %d\n", spe, j, f[n][j + maxn]);
			usub(ans, f[n][j + maxn]);
		}
	}
	printf("%d\n", ans);
	return 0;
}

/*
5 5
1 0 0 1 1
0 1 0 1 0
1 1 1 1 0
1 0 1 0 1
0 1 1 0 1
*/
