#include<cstdio>
#include<iostream>
#include<string>
#include<cstring>
#include<cstdlib>
#include<queue>
#include<set>
#include<map>
#include<algorithm>
#include<cmath>
//#include<ctime>
using namespace std;

typedef long long ll;

const int INF=0x3f3f3f3f;
const int MAXINT=2147483647;
const ll INFLL=0x3f3f3f3f3f3f3f3fll;
const double EPS=1e-6;
const ll MOD=998244353;

int read(){
	int s=0,f=1;
	char c=getchar();
	while (c<'0' || c>'9'){if (c=='-') f=-1;c=getchar();}
	while (c>='0' && c<='9'){s=s*10+c-'0';c=getchar();}
	s=s*f;
	return s;
}

int readu(){
	int s=0;
	char c=getchar();
	while (c<'0' || c>'9') c=getchar();
	while (c>='0' && c<='9'){s=s*10+c-'0';c=getchar();}
	return s;
}

ll readll(){
	ll s=0,f=1;
	char c=getchar();
	while (c<'0' || c>'9'){if (c=='-') f=-1;c=getchar();}
	while (c>='0' && c<='9'){s=s*10+c-'0';c=getchar();}
	s=s*f;
	return s;
}

ll readull(){
	ll s=0;
	char c=getchar();
	while (c<'0' || c>'9') c=getchar();
	while (c>='0' && c<='9'){s=s*10+c-'0';c=getchar();}
	return s;
}

int n,m;
ll a[45][5],dp[45][5][45][45],sum[45];
ll dp1[2][505][45][45];

void solve1(){
	for (register int i=1;i<=n;++i){
		sum[i]=0;
		for (register int j=1;j<=m;++j){
			a[i][j]=readull();
			sum[i]=(sum[i]+a[i][j])%MOD;
		}
	}
	for (register int j=1;j<=m;++j){
		dp[0][j][0][0]=1;
	}
	for (register int i=1;i<=n;++i){
		for (register int j=1;j<=m;++j){
			for (register int k=0;k<=i;++k){
				for (register int l=0;l<=k;++l){
					dp[i][j][k][l]=(dp[i-1][j][k][l]+dp[i-1][j][k-1][l-1]*a[i][j]%MOD+dp[i-1][j][k-1][l]*(((sum[i]-a[i][j])%MOD+MOD)%MOD)%MOD)%MOD;
//					printf("(%d,%d,%d,%d)%lld\n",i,j,k,l,dp[i][j][k][l]);
				}
			}
		}
	}
	ll ans=1;
	for (register int i=1;i<=n;++i){
		ans=(ans*(sum[i]+1))%MOD;
	}
//	printf("%lld\n",ans);
	for (register int j=1;j<=m;++j){
		for (register int k=1;k<=n;++k){
			for (register int l=k/2+1;l<=k;++l){
				ans=((ans-dp[n][j][k][l])%MOD+MOD)%MOD;
			}
		}
	}
	ans=((ans-1)%MOD+MOD)%MOD;
	printf("%lld\n",ans);
}

void solve2(){
	for (register int i=1;i<=n;++i){
		sum[i]=0;
		for (register int j=1;j<=m;++j){
			a[i][j]=readull();
			sum[i]=(sum[i]+a[i][j])%MOD;
		}
	}
	for (register int j=1;j<=m;++j){
		dp1[0][j][0][0]=1;
	}
	for (register int i=1;i<=n;++i){
		for (register int j=1;j<=m;++j){
			for (register int k=0;k<=i;++k){
				for (register int l=0;l<=k;++l){
					dp1[i%2][j][k][l]=(dp1[(i-1)%2][j][k][l]+dp1[(i-1)%2][j][k-1][l-1]*a[i][j]%MOD+dp1[(i-1)%2][j][k-1][l]*(((sum[i]-a[i][j])%MOD+MOD)%MOD)%MOD)%MOD;
//					printf("(%d,%d,%d,%d)%lld\n",i,j,k,l,dp[i][j][k][l]);
				}
			}
		}
	}
	ll ans=1;
	for (register int i=1;i<=n;++i){
		ans=(ans*(sum[i]+1))%MOD;
	}
//	printf("%lld\n",ans);
	for (register int j=1;j<=m;++j){
		for (register int k=1;k<=n;++k){
			for (register int l=k/2+1;l<=k;++l){
				ans=((ans-dp1[n%2][j][k][l])%MOD+MOD)%MOD;
			}
		}
	}
	ans=((ans-1)%MOD+MOD)%MOD;
	printf("%lld\n",ans);
}

int main(){
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);
	n=readu();m=readu();
	if (n<=40 && m<=3){
		solve1();
	} 
	else if (n<=40 && m<=2000){
		solve2();
	}
	return 0;
}

