#include<bits/stdc++.h>
#define ll long long
#define MAXN 45

using namespace std;

const ll pmod = 998244353;
ll f[MAXN][MAXN][MAXN][MAXN];
int n , m;
int a[MAXN][MAXN];
ll ans;

template <typename T> inline void read(T &x) {
	x = 0; T f = 1; char c = getchar();
	for (; !isdigit(c); c = getchar()) if (c == '-') f = -1;
	for (; isdigit(c); c = getchar()) x = (x << 3) + (x << 1) + (c ^ 48);
	x *= f;
}

template <typename T> inline void chkmax(T &x , T y) {x = x > y ? x : y; }
template <typename T> inline void chkmin(T &x , T y) {x = x < y ? x : y; }

template <typename T> inline void print(T x) {
	if (x > 9) print(x / 10);
	putchar(x % 10 + '0');
}
template <typename T> inline void write(T x) {
	if (x < 0) {x = -x; putchar('-'); }
	print(x);
	putchar('\n');
}

int main() {

	freopen("meal.in" , "r" , stdin);
	freopen("meal.out" , "w" , stdout);

	read(n); read(m);
	
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			read(a[i][j]);
		}
	}
	
	if (m == 3) {
		f[1][0][0][0] = 1;
		f[1][1][0][0] = a[1][1];
		f[1][0][1][0] = a[1][2];
		f[1][0][0][1] = a[1][3];
		for (int i = 2; i <= n; i++) {
			f[i][0][0][0] = 1;
			for (int j = 0; j <= i; j++) {
				for (int k = 0; k <= i; k++) {
					for (int l = 0; l <= i; l++) {
						if (j + k + l > i) continue;
						if (!j && !k && !l) continue;
						if (a[i][1] && j) f[i][j][k][l] = (f[i][j][k][l] + f[i - 1][j - 1][k][l] * a[i][1]) % pmod;
						if (a[i][2] && k) f[i][j][k][l] = (f[i][j][k][l] + f[i - 1][j][k - 1][l] * a[i][2]) % pmod;
						if (a[i][3] && l) f[i][j][k][l] = (f[i][j][k][l] + f[i - 1][j][k][l - 1] * a[i][3]) % pmod;
						f[i][j][k][l] = (f[i][j][k][l] + f[i - 1][j][k][l]) % pmod;
					}
				}
			}
		}
		for (int i = 0; i <= n; i++) {
			for (int j = 0; j <= n; j++) {
				for (int k = 0; k <= n; k++) {
					int s = i + j + k;
					if (s < 2) continue;
					s /= 2;
					if (i <= s && j <= s && k <= s) {
						ans = (ans + f[n][i][j][k]) % pmod;
					}
				}
			}
		}
		write(ans);
	}
	else {
		f[1][0][0][0] = 1;
		f[1][1][0][0] = a[1][1];
		f[1][0][1][0] = a[1][2];
		for (int i = 2; i <= n; i++) {
			f[i][0][0][0] = 1;
			for (int j = 0; j <= i; j++) {
				for (int k = 0; k <= i; k++) {
					if (j + k > i) continue;
					if (!j && !k) continue;
					if (a[i][1] && j) f[i][j][k][0] = (f[i][j][k][0] + f[i - 1][j - 1][k][0] * a[i][1]) % pmod;
					if (a[i][2] && k) f[i][j][k][0] = (f[i][j][k][0] + f[i - 1][j][k - 1][0] * a[i][2]) % pmod;
					f[i][j][k][0] = (f[i][j][k][0] + f[i - 1][j][k][0]) % pmod;
				}
			}
		}
		for (int i = 0; i <= n; i++) {
			for (int j = 0; j <= n; j++) {
				int s = i + j;
				if (s < 2) continue;
				s /= 2;
				if (i <= s && j <= s) {
					ans = (ans + f[n][i][j][0]) % pmod;
				}
			}
		}
		write(ans);
	}
	

	return 0;

}

