#include<bits/stdc++.h>
#define MAXN 440
#define ll long long

using namespace std;

int n , T;
ll a[MAXN];
ll dp[MAXN][MAXN];
ll sum[MAXN];

template <typename T> inline void read(T &x) {
	x = 0; T f = 1; char c = getchar();
	for (; !isdigit(c); c = getchar()) if (c == '-') f = -1;
	for (; isdigit(c); c = getchar()) x = (x << 3) + (x << 1) + (c ^ 48);
	x *= f;
}

template <typename T> inline void chkmax(T &x , T y) {x = x > y ? x : y; }
template <typename T> inline void chkmin(T &x , T y) {x = x < y ? x : y; }

template <typename T> inline void print(T x) {
	if (x > 9) print(x / 10);
	putchar(x % 10 + '0');
}
template <typename T> inline void write(T x) {
	if (x < 0) {x = -x; putchar('-'); }
	print(x);
	putchar('\n');
}

int main() {

	freopen("partition.in" , "r" , stdin);
	freopen("partition.out" , "w" , stdout);

	read(n); read(T);
	
	for (int i = 1; i <= n; i++) {
		read(a[i]);
		sum[i] = sum[i - 1] + a[i];
	}
	
	
	dp[1][1] = a[1] * a[1];
	
	for (int i = 2; i <= n; i++) {
		dp[i][i] = sum[i] * sum[i];
		for (int j = 1; j < i; j++) {
			for (int k = 1; k + j <= i; k++) {
				if (sum[i - j] - sum[i - j - k] > sum[i] - sum[i - j]) break;
				if (!dp[i - j][k]) continue;
				if (!dp[i][j]) dp[i][j] = dp[i - j][k] + (sum[i] - sum[i - j]) * (sum[i] - sum[i - j]);
				else chkmin(dp[i][j] , dp[i - j][k] + (sum[i] - sum[i - j]) * (sum[i] - sum[i - j]));
			}
		}
	}
	
	ll ans = LONG_LONG_MAX;
	for (int i = 1; i <= n; i++) {
		if (!dp[n][i]) continue;
		chkmin(ans , dp[n][i]);
	}
	write(ans);

	return 0;

}

