#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <vector>
#include <queue>
#include <map>
#include <cctype>
using namespace std;

typedef long long ll;
const int maxn = 117;
const int maxm = 2017;
const int N = 47;
const int mo = 998244353;
int n, m, a[maxn][maxm];
int ans, g[N][N][N], f[N][N][N][N];

void fileio() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
}

inline int add(int x, int y) {
	return (x + y) % mo;
}

inline int mul(int x, int y) {
	return 1ll * x * y % mo;
}

void tsk1() {
	g[0][0][0] = 1;
	for(int i = 1; i <= n; i++) {
		for(int j = 0; j <= i; j++) {
			for(int k = 0; k <= j; k++) {
				if(a[i][1] && j && k) g[i][j][k] = add(g[i][j][k], mul(g[i - 1][j - 1][k - 1], a[i][1]));
				if(a[i][2] && j) g[i][j][k] = add(g[i][j][k], mul(g[i - 1][j - 1][k], a[i][2]));
				g[i][j][k] = add(g[i][j][k], g[i - 1][j][k]);
			}
		}
	}
	for(int j = 2; j <= n; j++) {
		for(int k = 0; k <= j; k++) {
			if(k <= j / 2 && j - k <= j / 2) ans = add(ans, g[n][j][k]);
		}
	}
}

void tsk2() {
	f[0][0][0][0] = 1;
	for(int i = 1; i <= n; i++) {
		for(int j = 0; j <= i; j++) {
			for(int k = 0; k <= j; k++) {
				for(int h = 0; h + k <= j; h++) {
					if(a[i][1] && j && k) f[i][j][k][h] = add(f[i][j][k][h], mul(f[i - 1][j - 1][k - 1][h], a[i][1]));
					if(a[i][2] && j && h) f[i][j][k][h] = add(f[i][j][k][h], mul(f[i - 1][j - 1][k][h - 1], a[i][2]));
					if(a[i][3] && j) f[i][j][k][h] = add(f[i][j][k][h], mul(f[i - 1][j - 1][k][h], a[i][3]));
					f[i][j][k][h] = add(f[i][j][k][h], f[i - 1][j][k][h]);
				}
			}
		}
	}
	for(int j = 2; j <= n; j++) {
		for(int k = 0; k <= j; k++) {
			for(int h = 0; h + k <= j; h++) {
				if(k <= j / 2 && h <= j / 2 && j - k - h <= j / 2) ans = add(ans, f[n][j][k][h]);
			}
		}
	}
}

int main() {
	fileio();
	scanf("%d%d", &n, &m);
	for(int i = 1; i <= n; i++) {
		for(int j = 1; j <= m; j++) {
			scanf("%d", &a[i][j]);
		}
	}
	if(m == 2) tsk1();
	else if(m == 3) tsk2();
	printf("%d\n", ans);
	return 0;
}
/*
if(a[i][1]) f[i][j][k][h] += f[i - 1][j - 1][k - 1][h] * a[i][1];
if(a[i][2]) f[i][j][k][h] += f[i - 1][j - 1][k][h - 1] * a[i][2];
if(a[i][3]) f[i][j][k][h] += f[i - 1][j - 1][k][h] * a[i][3];
f[i][j][k][h] += f[i - 1][j][k][h];
*/
/*
*/
