#include<bits/stdc++.h>
#define LL long long

using namespace std;

struct Edge {
	int v, next;
} edge[600010];

int T, n, ans, tot = 1, head[300010], siz[300010], sz[300010], dep[300010];

inline int read() {
	char c = getchar(); int ret = 0, sig = 1;
	while (c < '0' || c > '9') { if (c == '-') sig = -1; c = getchar(); }
	while (c >= '0' && c <= '9') { ret = ret * 10 + c - '0'; c = getchar(); }
	return ret * sig;
}

inline void add(int x, int y) {
	edge[++tot].v = y;
	edge[tot].next = head[x]; head[x] = tot;
}

inline void dfs1(int x, int depth, int in_edge) {
	siz[x] = 1; dep[x] = depth;
	for (int i = head[x]; i; i = edge[i].next) {
		if (i == (in_edge ^ 1)) continue;
		int y = edge[i].v;
		dfs1(y, depth + 1, i);
		siz[x] += siz[y];
	}
}

inline void dfs(int x, int in_edge, int cu, int totsz) {
	int mmax = 0; sz[x] = 1;
	for (int i = head[x]; i; i = edge[i].next) {
		if (i == (in_edge ^ 1)) continue;
		if (i == cu || i == (cu ^ 1)) continue;
		int y = edge[i].v;
		dfs(y, i, cu, totsz);
		mmax = max(mmax, sz[y]);
		sz[x] += sz[y];
	}
	mmax = max(mmax, totsz - sz[x]);
//	cout << "x : " << x << "  " << mmax << endl;
	if (mmax <= totsz / 2) {
//		cout << "add:" << x << endl;
		ans += x;
	}
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	T = read();
	while (T--) {
		n = read();
		tot = 1, ans = 0;
		memset(head, 0, sizeof(head));
		memset(siz, 0, sizeof(siz));
		for (int i = 1; i < n; i++) {
			int x = read(), y = read();
			add(x, y), add(y, x);
		}
		dfs1(1, 1, -1);
		for (int i = 2; i <= tot; i += 2) {
			int v1 = edge[i].v, v2 = edge[i ^ 1].v;
//			cout << v1 << "  " << v2 << endl;
			memset(sz, 0, sizeof(sz));
			if (dep[v1] < dep[v2]) {
//				cout << n - siz[v2] + 1 << "  " << siz[v2] << endl;
				dfs(v1, -1, i, n - siz[v2]);
				dfs(v2, -1, i, siz[v2]);
			} else {
//				cout << siz[v1] << "  " << n - siz[v1] << endl;
				dfs(v1, -1, i, siz[v1]);
				dfs(v2, -1, i, n - siz[v1]);
			}
		}
		printf("%d\n", ans);
	}
	return 0;
}

