#include <bits/stdc++.h>
using namespace std;

#define INF 0x3F3F3F3F

struct sides
{
	int to, nxt, val;
}e[200010];
int n, x, y, res1, res2, tot, ans, deln;
int cases;
int head[200010], siz[200010], rt[200010], tsiz[200010];

void add_edge(int x, int y)
{
	e[++tot].to = y; e[tot].nxt = head[x]; e[tot].val = true; head[x] = tot;
}

void dfs(int now, int fa, int troot)
{
	siz[now] = 1;
	rt[now] = troot;
	for (int i = head[now]; i + 1; i = e[i].nxt)
	{
		int nxt = e[i].to;
		if (!e[i].val || nxt == deln) continue;
		if (nxt != fa)
		{
			dfs(nxt, now, troot);
			siz[now] += siz[nxt];
		}
	}
}

int main()
{
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	ios::sync_with_stdio(false);
	
	cin >> cases;
	for (int times = 1; times <= cases; times++)
	{
		// clear
		memset(head, -1, sizeof(head));
		tot = -1;
		res1 = res2 = ans = 0;
		cin >> n;
		for (int i = 1; i <= n - 1; i++)
		{
			cin >> x >> y;
			add_edge(x, y);
			add_edge(y, x);
		}
		if (n <= 2000)
		{
			for (int i = 1; i <= tot; i += 2)
			{
				e[i].val = false;
				e[i - 1].val = false;
				memset(rt, 0, sizeof(rt));
				memset(siz, 0, sizeof(siz));
				memset(tsiz, 0, sizeof(tsiz));
				deln = 0;
				dfs(e[i].to, 0, e[i].to);
				dfs(e[i - 1].to, 0, e[i - 1].to);
				tsiz[e[i].to] = siz[e[i].to]; tsiz[e[i - 1].to] = siz[e[i - 1].to];
				for (int j = 1; j <= n; j++)
				{
					deln = j;
					bool flag = true;
					for (int k = 1; k <= n; k++)
					{
						if (k != j && rt[k] == rt[j])
						{
							dfs(k, 0, rt[k]);
							if (siz[k] > tsiz[rt[j]] / 2)
							{
								flag = false;
								break;
							}
						}
					}
					if (flag) ans += j;
				}
				e[i].val = true;
				e[i - 1].val = true;
				//cout << ans << endl;
			}
			cout << ans << endl;
			continue;
		}
	}

	return 0;
}

