#include<iostream>
#include<cstdio>
#include<algorithm>
#include<vector>
#include<cstring>
using namespace std;

int f[300015],fc[300015];
int n,tot,ans;
bool b[300015];

struct Edge{
	int v1,v2;
	Edge(){}
	Edge(int a1,int a2){
		v1=a1,v2=a2;
	}
}e[300015]; 

vector<int>G[300015];

void dfs(int v,int fbd)
{
	int pd=1;
	b[v]=1;
	for(int i=0;i<G[v].size();++i)
	{
		int tv=G[v][i];
		if(!b[tv]&&tv!=fbd)
		{
			dfs(tv,fbd);
			f[v]+=f[tv];
			if(f[tv]>tot/2)pd=0;		
		}
	}
	f[v]+=1;
	if(pd&&tot-f[v]<=tot/2)ans+=v;
	b[v]=0;
}

int main() 
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	scanf("%d",&T);
	while(T--)
	{
		//cout<<"sd"<<T<<endl;
		//memset(b,0,sizeof(b));
		memset(f,0,sizeof(f));
		scanf("%d",&n);
		for(int i=1;i<=n;++i)G[i].clear();
		for(int i=1;i<n;++i)	
		{
			int v1,v2;
			scanf("%d%d",&v1,&v2);
			e[i]=Edge(v1,v2);
			G[v1].push_back(v2);
			G[v2].push_back(v1);
		}
		tot=n;
		dfs(1,0);
		for(int i=1;i<=n;++i)fc[i]=f[i];
		//cout<<endl<<ans<<"Ad"<<endl;
		ans=0;
		//memset(b,0,sizeof(b));
		//memset(f,0,sizeof(f));
		for(int i=1;i<n;++i)
		{//cout<<ans<<endl;
			int v1=e[i].v1,v2=e[i].v2;
			//cout<<endl<<"ad"<<v1<<" "<<v2<<" "<<ans<<endl;
			if(fc[v1]>fc[v2])
			{
				tot=n-fc[v2];
				memset(f,0,sizeof(f));
				dfs(v1,v2);
				
				//memset(b,0,sizeof(b));
				memset(f,0,sizeof(f));
				tot=n-tot;
				dfs(v2,v1);
			}
			else
			{
				tot=n-fc[v1];
				//cout<<endl<<"ad"<<v1<<" "<<v2<<" "<<fc[v1]<<endl;
				memset(f,0,sizeof(f));
				dfs(v2,v1);
				//memset(b,0,sizeof(b));
				memset(f,0,sizeof(f));
				tot=n-tot;
				dfs(v1,v2);
			}
		}
		cout<<ans<<endl;
		
	}
	


	
	return 0;

}
/*
2
5
1 2
2 3
2 4
3 5
7
1 2
1 3
1 4
3 5
3 6
6 7
*/
