#include <iostream>
#include <cstdio>
#include <algorithm>
using namespace std;

int n;
int a[50];

long long mn = 4000000000000000000ll;

void solve(int l, long long res, long long mx){
	if(l == n){
		mn = min(mn, res);
		return ;
	}
	
	long long p = 0;
	for(int i=l; i<n; i++){
		p += a[i];
		if(p < mx)
			continue;
		
		solve(i+1, res+p*p, max(mx, p));
	}
}

int main(){
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	
	int type;
	scanf("%d%d", &n, &type);
	if(type == 1)
		return 0;
	
	for(int i=0; i<n; i++){
		scanf("%d", a+i);
	}
	solve(0, 0, 0);
	
	printf("%lld", mn);
	
	return 0;
}
