#include <iostream>
#include <cstdio>

using namespace std;

inline void solve() {
	
	int n; cin >> n;
	int borders[50001] = {0};
	int cnt[50001] = {0};
	
	for (int i = 1; i < n; ++ i) {
		int u, v;
		cin >> u >> v;
		borders[u] = v;
		cnt[u] ++;
		cnt[v] ++;
	}
	
	int start = 0;
	
	for (int i = 1; i <= n; ++ i) {
		if (cnt[i] == 1 && borders[i]) {
			start = i;
			break;
		}
	}
	
	int curr = start, assoc[50001] = {0};
	long long rslt = 0;
	
	for (int i = 1; i <= n; ++ i) {
		assoc[i] = curr;
		curr = borders[curr];
	}
	
	for (int i = 1; i < n; ++ i) {
		if (i % 2 == 0) {
			rslt += assoc[i / 2] + assoc[i / 2 + 1];
		} else {
			rslt += assoc[i / 2 + 1];
		}
		int another = n - i;
		if (another % 2 == 0) {
			rslt += assoc[n - another / 2] + assoc[n - another / 2 + 1];
		} else {
			rslt += assoc[n - another / 2];
		}
	}
	
	cout << rslt << endl;
	
}

int main() {
	
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	
	int T; cin >> T;
	
	while (T --) {
		solve();
	}
	
	return 0;
	
}
