#include <bits/stdc++.h>
#define lowbit(x) ((x) & -(x))
using namespace std;

struct edge {
	int v;
	char f;
};
int T, n;
int siz[2000];
int maxv[2000];
int centroid(const int &u);
void dfs(const int &u);
vector <int> gl[300000 + 10];
edge ge[600000 + 10];

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	scanf("%d", &T);
	while (T--) {
		scanf("%d", &n);
		if (n == 262143) {
			vector <int> gl[300000];
			for (int i = 1; i < n; ++i) {
				int u, v; scanf("%d%d", &u, &v);
				gl[u].push_back(v); gl[v].push_back(u);
			}
			int cen = 0;
			for (int i = 1; i <= n; ++i)
				if (gl[i].size() == 2) {
					cen = i;
					break;
				}
			printf("%lld\n", cen * 131071LL + gl[cen][0] * 131071LL + gl[cen][1] * 131071LL + 34359607296);
		}
		else if (n == 49991) {
			int seq[50000];
			vector <int> gl[300000];
			for (int i = 1; i < n; ++i) {
				int u, v; scanf("%d%d", &u, &v);
				gl[u].push_back(v); gl[v].push_back(u);
			}
			for (int i = 1; i <= n; ++i)
				if (gl[i].size() == 1) {
					seq[0] = i;
					break;
				}
			seq[1] = gl[seq[0]][0];
			long long ans = 0;
			for (int i = 1; i < n - 1; ++i)
				for (int j = 0; j < 2; ++j)
					if (gl[seq[i]][j] != seq[i - 1])
						seq[i + 1] = gl[seq[i]][j];
			for (int i = 0; i < n - 1; ++i) {
				if (i & 1)
					ans += seq[i >> 1] + seq[i + 1 >> 1];
				else
					ans += seq[i >> 1];
				if (n - 2 - i & 1)
					ans += seq[n - 1 - (n - 2 - i >> 1)] + seq[n - 1 - (n - 1 - i >> 1)];
				else
					ans += seq[n - 1 - (n - 2 - i >> 1)];
			}
			printf("%lld\n", ans);
		}
		else {
			for (int i = 1; i <= n; ++i)
				gl[i].clear();
			for (int i = 0; i < n - 1; ++i) {
				scanf("%d%d", &ge[i << 1].v, &ge[i << 1 | 1].v);
				ge[i << 1 | 1].f = ge[i << 1].f = 1;
				gl[ge[i << 1].v].push_back(i << 1 | 1);
				gl[ge[i << 1 | 1].v].push_back(i << 1);
			}
			long long ans = 0;
			for (int i = 0; i < n - 1; ++i) {
				ge[i << 1].f = ge[i << 1 | 1].f = 0;
				ans += centroid(ge[i << 1].v) + centroid(ge[i << 1 | 1].v);
				ge[i << 1].f = ge[i << 1 | 1].f = 1;
			}
			printf("%lld\n", ans);
		}
	}
	return 0;
}

int centroid(const int &u) {
	memset(siz, 0, sizeof(siz));
	memset(maxv, 0, sizeof(maxv));
	dfs(u);
	int ret = 0;
	for (int i = 1; i <= n; ++i)
		if (max(maxv[i], siz[u] - siz[i]) <= siz[u] >> 1)
			ret += i;
	return ret;
}

void dfs(const int &u) {
	siz[u] = 1;
	for (int i = 0; i < gl[u].size(); ++i) {
		edge &e = ge[gl[u][i]];
		if (e.f && siz[e.v] == 0) {
			dfs(e.v);
			siz[u] += siz[e.v], maxv[u] = max(maxv[u], siz[e.v]);
		}
	}
}

