#include<bits/stdc++.h>
using namespace std;
#define dbg(x) cout << #x << " : " << x << endl
typedef long long LL;
const int N = 2000 + 10, M = 4000 + 10;
const int INF = 0x3f3f3f3f;

int T, n;
struct Edge { int u, v; } e[N];
int head[N], nxt[M], to[M], tot;
bool vis[M];

void add(int x, int y){
	to[++ tot] = y; nxt[tot] = head[x];
	head[x] = tot;
}
void Clear(){
	memset(head, 0, sizeof(head)); memset(nxt, 0, sizeof(nxt)); tot = 0;
}

LL siz[N], maxs[N], Maxs, sum, ans;
void dfs_siz(int x, int fa){
	siz[x] = 1; maxs[x] = 0;
	for(int i = head[x]; i; i = nxt[i]){
		int y = to[i];
		if(y == fa || vis[i]) continue;
		dfs_siz(y, x);
		siz[x] += siz[y];
		maxs[x] = max(maxs[x], siz[y]);
	}
}
void find(int x, int fa, int final){
	if(siz[final] - siz[x] > maxs[x])
		maxs[x] = siz[final] - siz[x];
	if(Maxs > maxs[x])
		Maxs = maxs[x];
	for(int i = head[x]; i; i = nxt[i]){
		int y = to[i];
		if(y == fa || vis[i]) continue;
		find(y, x, final);
	}
}
void query(int x, int fa){
	if(Maxs == maxs[x]) sum += x;
	for(int i = head[x]; i; i = nxt[i]){
		int y = to[i];
		if(y == fa || vis[i]) continue;
		query(y, x);
	}
}
void solve1(){
	Clear();
	for(int i = 1; i < n; ++ i){
		scanf("%d%d", &e[i].u, &e[i].v);
		add(e[i].u, e[i].v); add(e[i].v, e[i].u);
	}
	ans = 0;
	for(int i = 1; i < n; ++ i){
		vis[i * 2] = vis[i * 2 - 1] = true;
		sum = 0;
		Maxs = INF; dfs_siz(e[i].u, 0); find(e[i].u, 0, e[i].u); query(e[i].u, 0);
		Maxs = INF; dfs_siz(e[i].v, 0); find(e[i].v, 0, e[i].v); query(e[i].v, 0);
		ans += sum;
		vis[i * 2] = vis[i * 2 - 1] = false;
	}
	printf("%lld\n", ans);
}

int p[50010];
void solve2(){
	ans = 0;
	for(int i = 1; i < n; ++ i) scanf("%d%d", &p[i], &p[i + 1]);
	for(int i = 1; i < n; ++ i){
		int p1 = i, p2 = i + 1;
		int x, y;
		if(p1 % 2 == 1) x = p[(p1 + 1) / 2];
		else x = p[(p1 + 1) / 2] + p[(p1 + 1) / 2 + 1];
		if((n - p1) % 2 == 1) y = p[(p2 + n) / 2];
		else y = p[(p2 + n) / 2] + p[(p2 + n) / 2 + 1];
		ans += x + y;
	}
	printf("%lld\n", ans);
}


void solve3(){
	LL root, s1, s2;
	scanf("%lld%lld", &root, &s1); scanf("%lld%lld", &root, &s2);
	ans += root * (LL)(n + 1) / 2 + (s1 + s2) * (LL)(n - 1) / 2 + s1 + s2;
	for(int i = 1; i < n - 2; ++ i){
		scanf("%lld%lld", &s1, &s2);
		ans += s2;
	}
	printf("%lld\n", ans);
}

int main()
{
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	scanf("%d", &T);
	while(T --){
		scanf("%d", &n);
		if(n <= 2000) solve1();
		else if(n == 49991) solve2();
		else solve3();
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}
