#include<bits/stdc++.h>
using namespace std;
#define dbg(x) cout << #x << " : " << x << endl
typedef long long LL;
const int N = 40 + 5;
const int MOD = 998244353;

int n, m;
LL a[N][10], f[N][N][N][N], g[N][N][N], ans;

void solve1(){
	f[0][0][0][0] = 1;
	for(int i = 1; i <= n; ++ i){
		for(int j = 0; j <= n; ++ j){
			for(int k = 0; k <= n; ++ k){
				for(int p = 0; p <= n; ++ p){
					if(j - 1 >= 0) f[i][j][k][p] += (f[i - 1][j - 1][k][p] * a[i][1]) % MOD, f[i][j][k][p] %= MOD;
					if(k - 1 >= 0) f[i][j][k][p] += (f[i - 1][j][k - 1][p] * a[i][2]) % MOD, f[i][j][k][p] %= MOD;
					if(p - 1 >= 0) f[i][j][k][p] += (f[i - 1][j][k][p - 1] * a[i][3]) % MOD, f[i][j][k][p] %= MOD;
					f[i][j][k][p] += f[i - 1][j][k][p], f[i][j][k][p] %= MOD;
				}
			}
		}
	}
	for(int i = 0; i <= n; ++ i){
		for(int j = 0; j <= n; ++ j){
			for(int k = 0; k <= n; ++ k){
				int tot = i + j + k;
				if(tot < 1) continue;
				if(i > tot / 2 || j > tot / 2 || k > tot / 2) continue;
				ans += f[n][i][j][k]; ans %= MOD;
			}
		}
	}
	printf("%lld", ans);
}
void solve2(){
	g[0][0][0] = 1;
	for(int i = 1; i <= n; ++ i){
		for(int j = 0; j <= n; ++ j){
			for(int k = 0; k <= n; ++ k){
				if(j - 1 >= 0) g[i][j][k] += (g[i - 1][j - 1][k] * a[i][1]) % MOD, g[i][j][k] %= MOD;
				if(k - 1 >= 0) g[i][j][k] += (g[i - 1][j][k - 1] * a[i][2]) % MOD, g[i][j][k] %= MOD;
				g[i][j][k] += g[i - 1][j][k], g[i][j][k] %= MOD;
			}
		}
	}
	for(int i = 0; i <= n; ++ i){
		for(int j = 0; j <= n; ++ j){
			int tot = i + j;
			if(tot < 1) continue;
			if(i > tot / 2 || j > tot / 2) continue;
			ans += g[n][i][j]; ans %= MOD;
		}
	}
	printf("%lld", ans);
}

int main()
{
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	scanf("%d%d", &n, &m);
	for(int i = 1; i <= n; ++ i){
		for(int j = 1; j <= m; ++ j){
			scanf("%lld", &a[i][j]);
		}
	}
	if(m == 3) solve1();
	else if(m == 2) solve2();
	else printf("0");
	fclose(stdin);
	fclose(stdout);
	return 0;
}
