#include <bits/stdc++.h>
using namespace std;

typedef pair<int,int> pii;
typedef long long ll;

const ll mod=998244353;
const int maxn=100005;

template<class T>ostream& operator<<(ostream& out,vector<T> _v){for(int i=0;i<_v.size();++i)out<<_v[i]<<' ';return out;}
template<class T1,class T2>ostream& operator<<(ostream& out,pair<T1,T2> _p){out<<_p.first<<' '<<_p.second;return out;}
ll fastp(ll b,int x){if(x==0)return 1ll;ll tmp=fastp(b,x>>1);if(x&1)return tmp*tmp%mod*b%mod;return tmp*tmp%mod;}

int n,m;
ll a[105][2005];
int cnt[2005];
ll sum[105];
ll dp[40][40][40];
ll dp2[40][40][40][40];
ll dp3[2][2005][105];
ll dp4[105][105];
ll dp5[2][2005][105];

ll dfs(int x,int k){
	if(x==n){
		if(k==0)return 0ll;
		for(int i=0;i<m;++i)if(cnt[i]>k/2)return 0ll;
		return 1ll;
	}
	ll ans=0ll;
	ans+=dfs(x+1,k);
	ans%=mod;
	for(int i=0;i<m;++i){
		if(a[x][i]==0)continue;
		cnt[i]++;
		ans+=dfs(x+1,k+1)*a[x][i];
		ans%=mod;
		cnt[i]--;
	}
	return ans;
}

void add(ll& a,ll b){
	if(b<0)b+=mod;
	a+=b;
	a%=mod;
}

void task60_1(){
	dp[0][0][0]=1ll;
	dp[0][1][0]=a[0][1];
	dp[0][1][1]=a[0][0];
	for(int i=0;i<n-1;++i){
		for(int j=0;j<=i+1;++j){
			for(int cnt1=0;cnt1<=j;++cnt1){
				if(dp[i][j][cnt1]==0)continue;
				int cnt2=j-cnt1;
				add(dp[i+1][j][cnt1],dp[i][j][cnt1]);
				add(dp[i+1][j+1][cnt1+1],dp[i][j][cnt1]*a[i+1][0]);
				add(dp[i+1][j+1][cnt1],dp[i][j][cnt1]*a[i+1][1]);
			}
		}
	}
//	for(int i=0;i<n;++i){
//		for(int j=0;j<=i+1;++j){
//			for(int k=0;k<=j;++k){
//				if(dp[i][j][k]==-1)continue;
//				printf("dp[%d][%d][%d]=%lld\n",i,j,k,dp[i][j][k]);
//			}
//		}
//	}
	ll ans=0;
	for(int i=2;i<=n;++i){
		for(int cnt1=0;cnt1<=i;++cnt1){
			int cnt2=i-cnt1;
			if(cnt1<=i/2&&cnt2<=i/2)add(ans,dp[n-1][i][cnt1]);
		}
	}
	printf("%lld\n",ans);
}

void task60_2(){
	dp2[0][0][0][0]=1ll;
	dp2[0][1][0][0]=a[0][2];
	dp2[0][1][0][1]=a[0][1];
	dp2[0][1][1][0]=a[0][0];
	for(int i=0;i<n-1;++i){
		for(int j=0;j<=i+1;++j){
			for(int cnt1=0;cnt1<=j;++cnt1){
				for(int cnt2=0;cnt2+cnt1<=j;++cnt2){
					int cnt3=j-cnt2-cnt1;
					if(!dp2[i][j][cnt1][cnt2])continue;
					add(dp2[i+1][j][cnt1][cnt2],dp2[i][j][cnt1][cnt2]);
					add(dp2[i+1][j+1][cnt1+1][cnt2],dp2[i][j][cnt1][cnt2]*a[i+1][0]);
					add(dp2[i+1][j+1][cnt1][cnt2+1],dp2[i][j][cnt1][cnt2]*a[i+1][1]);
					add(dp2[i+1][j+1][cnt1][cnt2],dp2[i][j][cnt1][cnt2]*a[i+1][2]);
				}
			}
		}
	}
	ll ans=0;
	for(int i=2;i<=n;++i){
		for(int cnt1=0;cnt1<=i;++cnt1){
			for(int cnt2=0;cnt2+cnt1<=i;++cnt2){
				int cnt3=i-cnt1-cnt2;
				if(cnt1<=i/2&&cnt2<=i/2&&cnt3<=i/2)add(ans,dp2[n-1][i][cnt1][cnt2]);
			}
		}
	}
	printf("%lld\n",ans);
}

void task60(){
	if(m==2)task60_1();
	else task60_2();
}

void task100(){
	int now=0,nxt=1;
	for(int i=0;i<m;++i){
		dp3[now][i][1]=a[0][i];
		dp3[now][i][0]=1ll;
	}
	for(int i=0;i<n-1;++i){
		for(int j=0;j<m;++j)for(int k=0;k<=n;++k)dp3[nxt][j][k]=0ll;
		for(int j=0;j<m;++j){
			for(int k=0;k<=i+1;++k){
				add(dp3[nxt][j][k+1],dp3[now][j][k]*a[i+1][j]);
				add(dp3[nxt][j][k],dp3[now][j][k]);
			}
		}
		swap(now,nxt);
//		for(int j=0;j<m;++j){
//		for(int k=0;k<=n;++k){
//			if(dp3[now][j][k])printf("dp[%d][%d][%d]=%lld\n",i+1,j,k,dp3[now][j][k]);
//		}
//	}
	}
//	for(int j=0;j<m;++j){
//		for(int k=0;k<=n;++k){
//			if(dp3[now][j][k])printf("dp[%d][%d][%d]=%lld\n",n-1,j,k,dp3[now][j][k]);
//		}
//	}
	dp4[0][0]=1ll;
	for(int i=0;i<m;++i){
		add(dp4[0][1],a[0][i]);
	}
	for(int i=0;i<n-1;++i){
		for(int k=0;k<=i+1;++k){
			if(dp4[i][k]==0)continue;
			for(int j=0;j<m;++j){
				add(dp4[i+1][k+1],dp4[i][k]*a[i+1][j]);
			}
			add(dp4[i+1][k],dp4[i][k]);
		}
	}
	int now2=0,nxt2=1;
	for(int i=0;i<m;++i){
		add(dp5[0][i][0],1ll);
		add(dp5[0][i][1],sum[0]-a[0][i]);
	}
	for(int i=0;i<n-1;++i){
		for(int k=0;k<=i+1;++k){
			for(int j=0;j<m;++j)dp5[nxt2][j][k]=0ll;
			for(int j=0;j<m;++j){
				if(dp5[now2][j][k]==0)continue;
				add(dp5[nxt2][j][k+1],dp5[now2][j][k]*(sum[i+1]-a[i+1][j]));
				add(dp5[nxt2][j][k],dp5[now2][j][k]);
			}
		}
		swap(now2,nxt2);
	}
//	for(int i=0;i<=n;++i){
//		for(int j=0;j<m;++j){
//			printf("dp[%d][%d][%d]=%d\n",n-1,j,i,dp[now2][j][i]);
//		}
//	}
	ll ans=0;
	for(int i=2;i<=n;++i){
		add(ans,dp4[n-1][i]);
		for(int j=i/2+1;j<=i;++j){
			for(int k=0;k<m;++k){
				add(ans,-dp3[now][k][j]*dp5[now2][k][i-j]);
			}
		}
//		cerr<<ans<<endl;
	}
//	cerr<<"HERE";
	printf("%lld\n",ans);
}


int main(){
	freopen("meal.in","r",stdin);
	freopen("meal.out","w",stdout);
	scanf("%d%d",&n,&m);
	for(int i=0;i<n;++i){
		for(int j=0;j<m;++j){
			int x;
			scanf("%d",&x);
			a[i][j]=x;
			sum[i]+=a[i][j];
		}
	}
	if(m<=3)task60();
	task100();
	return 0;
}

