#include<bits/stdc++.h>
using namespace std;
const int MAXN = 3e5 + 5;
template <typename T> void read(T &x) {
	x = 0; int f = 1;
	char ch = getchar();
	for (; !isdigit(ch); ch = getchar()) if (ch == '-') f = -f;
	for (; isdigit(ch); ch = getchar()) x = x * 10 + ch - '0';
	x *= f;
}
struct edge {
	int dest;
	int nxt;
} a[MAXN * 2];
void chkmax(int &x, int y) {if (y > x) x = y; }
int n, tot, h[MAXN], subt[MAXN], inc[MAXN]; long long ans;
int root, son[MAXN], size[MAXN], weight[MAXN], father[MAXN];
void toson(int pos, int fa, int l) {
	int r = n;
	if (son[pos]) {
		r = n - 2 * size[son[pos]];
		toson(son[pos], pos, r);
	}
	assert(l <= r);
	for (int i = l; i <= r; i++)
		inc[i] += pos;
}
void getans(int pos, int fa) {
	ans += inc[size[pos]];
	for (int i = h[pos]; i != 0; i = a[i].nxt)
		if (a[i].dest != fa) getans(a[i].dest, pos);
}
void work(int pos, int fa) {
	father[pos] = fa;
	son[pos] = weight[pos] = 0, size[pos] = 1;
	for (int i = h[pos]; i != 0; i = a[i].nxt)
		if (a[i].dest != fa) {
			work(a[i].dest, pos);
			size[pos] += size[a[i].dest];
			chkmax(weight[pos], size[a[i].dest]);
			if (size[a[i].dest] > size[son[pos]]) son[pos] = a[i].dest;
		}
	if (son[pos]) subt[pos] = subt[son[pos]];
	else subt[pos] = pos;
	while (subt[pos] != pos && 2 * size[subt[pos]] < size[pos])
		subt[pos] = father[subt[pos]];
	if (fa != 0) {
		ans += subt[pos];
		if (2 * size[subt[pos]] == size[pos]) ans += father[subt[pos]];
	}
}
void dfs(int pos, int fa) {
	size[pos] = 1, weight[pos] = 0;
	for (int i = h[pos]; i != 0; i = a[i].nxt)
		if (a[i].dest != fa) {
			dfs(a[i].dest, pos);
			size[pos] += size[a[i].dest];
			chkmax(weight[pos], size[a[i].dest]);
		}
	chkmax(weight[pos], n - size[pos]);
	if (weight[pos] < weight[root]) root = pos;
}
int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T; read(T);
	while (T--) {
		ans = tot = 0, memset(h, 0, sizeof(h));
		read(n), assert(n >= 3);
		for (int i = 1; i <= n - 1; i++) {
			int x, y; read(x), read(y);
			a[++tot] = (edge) {y, h[x]}, h[x] = tot;
			a[++tot] = (edge) {x, h[y]}, h[y] = tot;
		}
		weight[root = 0] = n + 1;
		dfs(1, 0), work(root, 0);
		memset(inc, 0, sizeof(inc));
		toson(root, 0, 0);
		for (int i = h[root]; i != 0; i = a[i].nxt)
			if (a[i].dest != son[root]) getans(a[i].dest, root);
		memset(inc, 0, sizeof(inc));
		int Nax = 0;
		for (int i = h[root]; i != 0; i = a[i].nxt)
			if (a[i].dest != son[root] && size[a[i].dest] > size[Nax]) Nax = a[i].dest;
		int r = n - 2 * size[Nax];
		for (int i = 0; i <= r; i++)
			inc[i] += root;
		toson(Nax, root, r);
		getans(son[root], root); 
		cout << ans << endl;
	}
	return 0;
}
