#include<bits/stdc++.h>
using namespace std;
const int MAXN = 205;
const int MAXM = 2005;
const int P = 998244353; 
template <typename T> void read(T &x) {
	x = 0; int f = 1;
	char ch = getchar();
	for (; !isdigit(ch); ch = getchar()) if (ch == '-') f = -f;
	for (; isdigit(ch); ch = getchar()) x = x * 10 + ch - '0';
	x *= f;
}
int power(int x, int y) {
	if (y == 0) return 1;
	int tmp = power(x, y / 2);
	if (y % 2 == 0) return 1ll * tmp * tmp % P;
	else return 1ll * tmp * tmp % P * x % P;
}
void update(int &x, int y) {
	x += y;
	if (x >= P) x -= P;
}
int n, m, ans, s[MAXN], a[MAXN][MAXM];
int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	read(n), read(m);
	int ans = 1;
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			read(a[i][j]);
			update(s[i], a[i][j]);
		}
		ans = 1ll * ans * (s[i] + 1) % P;
	}
	update(ans, P - 1);
	for (int i = 1; i <= m; i++) {
		static int dp[MAXN][MAXN];
		memset(dp, 0, sizeof(dp)), dp[0][n] = 1;
		for (int j = 0; j <= n - 1; j++) {
			int x = a[j + 1][i], y = (s[j + 1] - x + P) % P;
			for (int k = n - j; k <= n + j; k++) {
				update(dp[j + 1][k], dp[j][k]);
				update(dp[j + 1][k + 1], 1ll * x * dp[j][k] % P);
				update(dp[j + 1][k - 1], 1ll * y * dp[j][k] % P);
			}
		}
		for (int j = n + 1; j <= 2 * n; j++)
			update(ans, P - dp[n][j]);
	}
	cout << ans << endl;
	return 0;
}
