#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
template <typename T> inline void read(T &x)
{
	int f = 1; x = 0; char c = getchar();
	for (; !isdigit(c); c = getchar()) if (c == '-') f = -1;
	for (; isdigit(c); c = getchar()) x = (x << 3) + (x << 1) + (c ^ 48);
	x *= f;
}
template <typename T> inline void chkmax(T &x, T y) { x = x > y ? x : y; }
template <typename T> inline void chkmin(T &x, T y) { x = x < y ? x : y; }
int n, t;
namespace solver1
{
	const int N = 15;
	const int INF = 1e9;
	int ans, a[N], s[N];
	vector <int> vec;
	inline int check()
	{
		vec.push_back(n);
		int ret = 0;
		int las = -1;
		for (int i = 1; i < vec.size(); i++)
		{
			int now = s[vec[i]] - s[vec[i - 1]];
			if (now < las) return INF;
			
			las = now;
			ret += now * now;
		}
		return ret;
	}
	inline void dfs(int dep)
	{
		if (dep > n)
		{
			chkmin(ans, check());
			vec.pop_back();
			return;
		}
		dfs(dep + 1);
		vec.push_back(dep);
		dfs(dep + 1);
		vec.pop_back();
	}
	inline void solve()
	{
		for (int i = 1; i <= n; i++) read(a[i]), s[i] = s[i - 1] + a[i];
		ans = INF;
		vec.push_back(0);
		dfs(1);
		printf("%d\n", ans);
	}
}
namespace solver2
{
	const int N = 4e2 + 5;
	const ll INF = 1e18;
	ll a[N], s[N];
	bool p[N];
	ll ans;
	inline ll check()
	{
		vector <int> vec;
		vec.push_back(0);
		for (int i = 1; i <= n; i++) if (p[i]) vec.push_back(i);
		vec.push_back(n);
		ll ret = 0;
		ll las = -1;
		for (int i = 1; i < vec.size(); i++)
		{
			ll now = s[vec[i]] - s[vec[i - 1]];
			if (now < las) return INF;
			
			las = now;
			ret += now * now;
		}
		return ret;
	}
	inline void BackFire()
	{
		double T = 2000;
		
		while (T > 1e-14)
		{
			int x = rand() % n + 1;
			p[x] ^= 1;
			
			ll now = check(), delta = now - ans;
			
			if (delta < 0) ans = now;
			else if (exp(-delta * 1.0 / T) * RAND_MAX < rand()) p[x] ^= 1;
			
			T *= 0.98;
		}
	}
	inline void solve()
	{
		for (int i = 1; i <= n; i++) read(a[i]), s[i] = s[i - 1] + a[i];
		
		for (int i = 1; i <= n; i++) p[i] = 0;
		double t = clock();
		ans = LONG_LONG_MAX / 2;
		while (clock() - t <= 1.3 * CLOCKS_PER_SEC) BackFire();
		printf("%lld\n", ans);
	}
}
int main(){
	freopen ("partition.in", "r", stdin);
	freopen ("partition.out", "w", stdout);
	srand(time(0));
	read(n); read(t);
	if (t == 0)
	{
		if (n <= 10) solver1::solve();
		else solver2::solve(); 
	}
  return 0;
}
