#include <bits/stdc++.h>
#define write(x) printf("%d\n", x)
#define DEBUG
using namespace std;
typedef long long ll;
template <typename T>
void read(T &x) //unsigned
{
	x = 0;
	char c;
	while (!isdigit(c = getchar()));
	do
	{
		x = (x << 1) + (x << 3) + (c ^ 48);
	}while (isdigit(c = getchar()));
}
int T;
int n;
vector<int> edge[500000];
int a[500000];
int cut(int i)
{
	int res;
	if (n & 1)
	{
		if (i & 1) res = a[i >> 1] + a[(n + i) >> 1] + a[((n + i) >> 1) - 1];
		else res = a[i >> 1] + a[(i >> 1) - 1] + a[(n + i) >> 1];
	}
	else
	{
		if (i & 1) res = a[i >> 1] + a[(n + i) >> 1];
		else res = a[i >> 1] + a[(i >> 1) - 1] + a[(n + i) >> 1] + a[((n + i) >> 1) - 1];
	}
	return res;
}
ll getsum()
{
	ll sum = 0;
	for (int i = 1;i < n;++i)
	{
		sum += cut(i);
	}
	return sum;
}
int fa[500000];
void dfs(int x)
{
	for (int i = 0;i < edge[x].size();++i)
	{
		if (edge[x][i] != fa[x])
		{
			fa[edge[x][i]] = x;
			dfs(edge[x][i]);
		} 
	}
}
int main()
{
#ifdef DEBUG
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
#endif
	//ios::sync_with_stdio(0);
	read(T);
	while (T--)
	{
		read(n);
		for (int i = 1;i <= n;++i)
		{
			edge[i].clear();
		}
		for (int i = 1;i < n;++i)
		{
			int x, y;
			read(x);read(y);
			edge[x].push_back(y);
			edge[y].push_back(x);
		}
		int maxedge = 1;
		int leaf1 = 0, leaf2 = 0;
		for (int i = 1;i <= n;++i)
		{
			if (edge[i].size() == 1)
			{
				if (leaf1) leaf2 = i;
				else leaf1 = i;
			}
			else maxedge = max(maxedge, (int)edge[i].size());
		}
		if (maxedge != 2) 
		{
			cerr << "RP++" << endl;
			exit(0);
		}
		fa[leaf1] = 0;
		dfs(leaf1);
		a[0] = leaf2;
		int cur = leaf2;
		for (int i = 1;i < n;++i)
		{
			a[i] = (cur = fa[cur]);
		}
		cout << getsum() << endl;
	}
	return 0;
}

