#include<bits/stdc++.h>
using namespace std;
#define MAXN 50000+5
#define PB push_back
int T,n,f[MAXN],ans,fr[MAXN],nt[MAXN],sz[MAXN],pat[MAXN],lnk[MAXN],top;
vector <int> edge[MAXN];
void dfs(int x,int fa)
{
	f[x]=0,sz[x]=1; int ne=edge[x].size(),son=0;
	for(int i=0;i<ne;i++)
	{
		int y=edge[x][i];
		if(y==fa) continue;
		dfs(y,x);
		son+=sz[y],f[x]=max(f[x],sz[y]);
	}
	pat[x]=son,sz[x]+=son;
}
void dfs_calc(int x,int fa,int bl_sz)
{
	int mx_sz=max(f[x],bl_sz-pat[x]-1);
	if(mx_sz<=bl_sz/2) ans+=x;
	int ne=edge[x].size();
	for(int i=0;i<ne;i++)
	{
		int y=edge[x][i];
		if(y==fa) continue;
		dfs_calc(y,x,bl_sz);
	}
}
void brute_force()
{
	for(int i=1;i<n;i++)
	{
		int u,v; cin>>u>>v;
		fr[i]=u,nt[i]=v;
		edge[u].PB(v);
		edge[v].PB(u);
	}
	for(int i=1;i<n;i++)
	{
		dfs(fr[i],nt[i]);
		dfs_calc(fr[i],nt[i],sz[fr[i]]);
		dfs(nt[i],fr[i]);
		dfs_calc(nt[i],fr[i],sz[nt[i]]);
	}
	cout<<ans<<endl; ans=0;
	for(int i=1;i<=n;i++) edge[i].clear();
}
void get_link(int x,int fa)
{
	lnk[++top]=x; int ne=edge[x].size();
	for(int i=0;i<ne;i++)
	{
		int y=edge[x][i];
		if(y==fa) continue;
		get_link(y,x);
	}
}
void solve_link()
{
	long long res=0;
	for(int i=1;i<n;i++)
	{
		int u,v; cin>>u>>v;
		fr[i]=u,nt[i]=v;
		edge[u].PB(v);
		edge[v].PB(u);
	}
	for(int i=1;i<=n;i++)
		if(edge[i].size()==1)
		{
			get_link(i,0);
			break;
		}
	for(int i=2;i<=n;i++)
	{
		if((i-1)%2==1) res+=1LL*lnk[i/2];
		else res+=1LL*lnk[(i-1)/2],res+=1LL*lnk[(i+1)/2];
		if((n-i)%2==0) res+=1LL*lnk[(n+i)/2];
		else res+=1LL*lnk[(n+i)/2],res+=1LL*lnk[(n+i+1)/2];
	}
	cout<<res<<endl; top=0;
	for(int i=1;i<=n;i++) edge[i].clear();
}
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	cin>>T;
	while(T--)
	{
		cin>>n;
		if(n%10==1) solve_link();
		else brute_force();
	}
	return 0;
}
