#include <bits/stdc++.h>
using namespace std;

typedef long long LL;
const int N = 300010;
int T, n, Minsz, ret, Time;
struct e {
	int v, p;
};
int dfn[N], id[N];
int X[N], Y[N], Max[N], S[N], d[N], sz[N], DU[N];
vector<e> E[N];

template <typename T> void read(T &a) {
	a = 0; char c = getchar(); int f = 1;
	while (!isdigit(c)) { if (c == '-') f = -1; c = getchar(); }
	while (isdigit(c)) { a = a * 10 + c - '0'; c = getchar(); }
	a *= f;
}

void dfs_Init(int u, int fa) {
	S[u] = 1;
	for (int i=0;i<E[u].size();++i) {
		int v = E[u][i].v;
		if (v == fa) continue;
		d[v] = d[u] + 1;
		dfs_Init(v, u);
		S[u] += S[v];
	}
}

void dfs(int u, int fa, int ban, int tot) {
	sz[u] = 1; Max[u] = 0;
	for (int i=0;i<E[u].size();++i) {
		int v = E[u][i].v;
		if (v == fa || E[u][i].p == ban) continue;
		dfs(v, u, ban, tot);
		sz[u] += sz[v];
		Max[u] = max(Max[u], sz[v]);
	}
	int Maxsz = max(Max[u], tot - sz[u]);
	if (Maxsz < Minsz) Minsz = Maxsz, ret = u;
	else if (Maxsz == Minsz) ret += u;
}

int WALK(int u, int ban, int tot) {
	Minsz = tot; ret = 0;
	dfs(u, 0, ban, tot);
	return ret;
}

void solve_bf() {
	dfs_Init(1, 0);
	int ans = 0;
	for (int i=1;i<n;++i) {
		int x = X[i], y = Y[i];
		int tmpx, tmpy;
		if (d[x] < d[y]) tmpy = S[y], tmpx = n - S[y];
		else tmpx = S[x], tmpy = n - S[x];
		ans += WALK(x, i, tmpx) + WALK(y, i, tmpy);
	}
	cout << ans << '\n';
}

void dfs_chain(int u, int fa) {
	dfn[u] = ++Time; id[Time] = u;
	for (int i=0;i<E[u].size();++i) {
		int v = E[u][i].v;
		if (v == fa) continue;
		dfs_chain(v, u);
	}
}

void solve_chain() {
	int rt = 1;
	for (int i=1;i<=n;++i)
		if (DU[i] == 1) { rt = i; break; }
	Time = 0;
	dfs_chain(rt, 0);
	LL ans = 0;
	for (int i=1;i<n;++i) {
		int len = n - i;
		if (i % 2) {
			ans += (LL)id[dfn[i / 2 + 1]];
		}
		else ans += (LL)id[dfn[i / 2]] + (LL)id[dfn[i / 2 + 1]];
		if (len % 2) {
			ans += (LL)id[dfn[(n + i + 1) / 2]];
		}
		else ans += (LL)id[dfn[(n + i + 1) / 2]] + (LL)id[dfn[(n + i + 2) / 2]];
	}
	cout << ans << '\n';
}

int main() {
	freopen("centroid.in", "r", stdin); freopen("centroid.out", "w", stdout);
	read(T);
	while (T--) {
		read(n);
		for (int i=1;i<=n;++i) E[i].clear();
		for (int i=1;i<=n;++i) DU[i] = 0;
		for (int i=1;i<n;++i) {
			int x, y; read(x); read(y);
			E[x].push_back((e){y, i});
			E[y].push_back((e){x, i});
			X[i] = x, Y[i] = y;
			++DU[x], ++DU[y];
		}
		if (n <= 2000) { solve_bf(); continue; }
		if (n == 49991) {
			solve_chain();
			continue;
		}
	}
	return 0;
}

