#include <bits/stdc++.h>
#define foreach(a, b) for (__typeof(a.begin()) b = a.begin(); b != a.end(); b++)

using namespace std;

void fileio() {
    freopen("partition.in", "r", stdin);
    freopen("partition.out", "w", stdout);
}

typedef long long ll;
typedef unsigned long long ull;

const int MAX_N = 4e7 + 10;
const ull K = 100000000;

int N, Type, trans[MAX_N];
ll sumA[MAX_N];

struct Info {
    ll req;
    int id;
    Info() {}
    Info(ll req, int id) : req(req), id(id) {}
};

Info que[MAX_N];
int qfi, qla;

int main() {
    fileio();
    scanf("%d%d", &N, &Type);
    if (Type == 0) {
        for (int i = 1; i <= N; i++) scanf("%lld", &sumA[i]);
    } else {
        ll x, y, z; scanf("%lld%lld%lld", &x, &y, &z);
        scanf("%lld%lld", &sumA[1], &sumA[2]);
        for (int i = 3; i <= N; i++) sumA[i] = (sumA[i - 1] * x + sumA[i - 2] * y + z) & ((1 << 30) - 1);
        int M; scanf("%d", &M);
        int last = 1;
        for (int i = 1; i <= M; i++) {
            ll l, r; int p; scanf("%d%lld%lld", &p, &l, &r);
            for (int a = last; a <= p; a++) {
                sumA[a] = sumA[a] % (r - l + 1) + l;
            }
            last = p + 1;
        }
    }
    for (int i = 1; i <= N; i++) sumA[i] += sumA[i - 1];
    int opt = 0;
    qla = -1;
    for (int i = 1; i <= N; i++) {
        while (qfi <= qla && sumA[i] >= que[qfi].req) {
            opt = que[qfi++].id;
        }

        ll G = sumA[i] - sumA[opt];
        trans[i] = opt;

        while (qla >= qfi && que[qla].req >= sumA[i] + G)
            qla--;
        que[++qla] = Info(sumA[i] + G, i);
    }

    static ull ans[5], tmp1[5], tmp2[5];

    for (int i = N; i; i = trans[i]) {
        ll v = sumA[i] - sumA[trans[i]];
        memset(tmp1, 0, sizeof(tmp1));
        memset(tmp2, 0, sizeof(tmp2));
        tmp1[0] = v % K;
        tmp1[1] = v / K % K;
        tmp1[2] = v / (K * K) % K;
        for (int a = 0; a <= 2; a++) {
            for (int b = 0; b <= 2; b++) {
                tmp2[a + b] += tmp1[a] * tmp1[b];
            }
        }
        for (int a = 0; a < 4; a++) {
            tmp2[a + 1] += tmp2[a] / K;
            tmp2[a] %= K;
        }
        for (int a = 0; a < 4; a++)
            ans[a] += tmp2[a];
    }
    for (int a = 0; a < 4; a++) {
        ans[a + 1] += ans[a] / K;
        ans[a] %= K;
    }
    bool any = false;
    for (int a = 4; a >= 0; a--) {
        ull t = K / 10, v = ans[a];
        for (int b = 7; b >= 0; b--) {
            int curr = v / t % 10;
            if (curr) any = true;
            if (any) printf("%d", curr);
            t /= 10;
        }
    }
    if (!any) printf("0");
    printf("\n");
}
