#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef vector<int> lnum;
const int base = 1000;
const int maxn = 5e5 + 5;
ll a[maxn];
ll cnt[maxn],ma[maxn];
lnum operator *(const lnum &a,const lnum &b)
{
	lnum ret;
	ret.assign(a.size() + b.size() + 1,0);
	for(int i = 0;i < a.size(); ++i)
	{
		int carry = 0;
		for(int j = 0;j < b.size() || carry; ++j)
		{
			int bj = j < b.size() ? b[j] : 0;
			ret[i + j] += a[i] * b[j] + carry;
			carry = ret[i + j] / base;
			ret[i + j] %= base;
		}
	}
	while(ret.back() == 0 && ret.size() > 1)
	{
		ret.pop_back();
	}
	return ret;
}
int Max(int a,int b)
{
	return a > b ? a : b;
}
lnum operator +(const lnum &a,const lnum &b)
{
	lnum ret;
	int maxsize = max((int)a.size(),(int)b.size());
	ret.assign(maxsize + 1,0);
	int carry = 0;
	for(int i = 0;i < maxsize; ++i)
	{
		int ai = i < a.size() ? a[i] : 0;
		int bi = i < b.size() ? b[i] : 0;
		ret[i] += ai + bi + carry;
		carry = ret[i] / base;
		ret[i] %= base;
	}
	while(ret.back() == 0 && ret.size() > 1)
	{
		ret.pop_back();
	}
	return ret;
}
bool operator <(const lnum &a,const lnum &b)
{
	if(a.size() != b.size())
	{
		return a.size() < b.size();
	}
	for(int i = 0;i < a.size(); ++i)
	{
		if(a[i] != b[i])
		{
			return a[i] < b[i];
		}
	}
	return 0;
}
bool operator ==(const lnum &a,const lnum &b)
{
	return a == b;
}
bool operator <=(const lnum &a,const lnum &b)
{
	return a == b || a < b;
}
lnum tolnum(ll p)
{
	lnum ret;
	if(p == 0)
	{
		ret.push_back(0);
		return ret;
	}
	while(p)
	{
		ret.push_back(p % base);
		p /= base;
	}
	reverse(ret.begin(),ret.end());
	return ret;
}
ll ans,n;
void dfs(ll pos,ll ret,ll p,ll last)
{
	if(ret + p * p >= ans)
	{
		return;
	}
	if(pos == n)
	{
		ans = ret + p * p;
		return;
	}
	pos++;
	//1
	if(last <= p + a[pos])
	{
		dfs(pos,ret + (p + a[pos]) * (p + a[pos]),0,p + a[pos]);
	}
	//2
	dfs(pos,ret,p + a[pos],last);
}
int main()
{
	freopen("partition.in","r",stdin);
	freopen("partition.out","w",stdout);
	int type;
	cin>>n>>type;
	if(type == 0)
	{
		for(int i = 1;i <= n; ++i)
		{
			scanf("%lld",&a[i]);
		}
		if(n >= 30)
		{
			a[n + 1] = 1e18;
			ans = 0;
			ll last = a[1];
			ll cnta = 1;
			cnt[1] = 1;
			for(int i = 2;i <= n; ++i)
			{
				if(a[i] >= last)
				{
					cnt[i] = cnt[i - 1] + 1;
					last = a[i];
				}
				else
				{
					if((a[i - 1] > a[i + 1] 
						&& a[i - 1] <= a[i] + a[i + 1]))
					{
						cnt[i] = cnt[i + 1] = cnt[i - 1] + 1;
						last = a[i] + a[i + 1];
						i++;
					}
					else
					{
						cnt[i] = cnt[i - 1];
						last += a[i];
					}
				}
			}
			ll now = 0;
			for(int i = 1;i <= n; ++i)
			{
				if(cnt[i] != cnt[i - 1])
				{
					ans += now * now;
					now = 0;
				}
				now += a[i];
			}
			ans += now * now;
			cout<<ans<<endl;
		}
//		else if(n <= 10)
//		{
//			ans = 4e18;
//			for(int i = 0;i < (1 << (n - 1)); ++i)
//			{
//				ll now = 0;
//				ll ret = 0;
//				int last = 0;
//				for(int j = 0;j < n - 1; ++j)
//				{
//					now += a[j];
//					if(i & (1 << j))
//					{
//						if(last > now)
//						{
//							ret = 1e18;
//							break;
//						}
//						ret += now * now;
//						last = now;
//						now = 0;
//					}
//				}
//				now += a[n - 1];
//				if(now < last)
//				{
//					ret = 1e18;
//				}
//				ret += now * now;
//				ans = min(ans,ret);
//			}
//			cout<<ans<<endl;
//		}
		else
		{
			for(int i=1;i<=n;++i)
			{
				a[i-1] = a[i];
			}
			ans = 4e18;
		for(int i = 0;i < (1 << (n - 1)); ++i)
		{
			ll now = 0;
			ll ret = 0;
			int last = 0;
			for(int j = 0;j < n - 1; ++j)
			{
				now += a[j];
				if(i & (1 << j))
				{
					if(last > now)
					{
						ret = 1e18;
						break;
					}
					ret += now * now;
					last = now;
					now = 0;
				}
			}
			now += a[n - 1];
			if(now < last)
			{
				ret = 1e18;
			}
			if(ret == 1e18)
			{
				continue;
			}
			ret += now * now;
			ans = min(ans,ret);
		}
		cout<<ans<<endl;
		}
	}
	return 0;
}
