#include <cstdio>
typedef long long int64;
const int NSZ = 107;
const int MSZ = 2007;
const int64 MOD = 998244353;

int64 n, m, a[NSZ][MSZ];
int64 use[MSZ];
int64 cnt;

inline bool check(int64 x, int64 k) {
	if (k == 0)
		return false;
	register int64 limit = k / 2;
	for (register int64 i = 1; i <= m; i++)
		if (use[i] > limit)
			return false;
	return true;
}

void dfs(int64 x, int64 k, int64 s) { // xҪλ 
	if (x > n)
		return;
	// ѡ 
//	if (check(x, k))
//		cnt = (cnt + s) % MOD;
	dfs(x + 1, k, s);
	// ѡĲ 
	for (int i = 1; i <= m; i++) {
		if (a[x][i]) {
			use[i]++, k++;
			if (check(x, k))
				cnt = (cnt + s*a[x][i]) % MOD;
			dfs(x + 1, k, s*a[x][i] % MOD);
			use[i]--, k--;
		}
	}
}

int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	scanf("%lld%lld", &n, &m);
	for (register int64 i = 1; i <= n; i++)
		for (register int64 j = 1; j <= m; j++)
			scanf("%lld", &a[i][j]);
	dfs(1, 0, 1);
	printf("%lld", cnt);
	return 0;
}
