#include<cstdio>
#include<cctype>
#include<cstring>
#include<vector>
template<typename tn> void fead(tn &n) {
	tn i = 1, f = 1, k = 0; char ch = getchar();
	while (!isdigit(ch)) {if (ch == '-') f = -1; ch = getchar();}
	while (isdigit(ch)) k = k * 10 + ch - '0', ch = getchar();
	if (ch == '.') {ch = getchar(); while (isdigit(ch)) i /= 10, k += i * (ch - '0'), ch = getchar();}
	n = k * f;
}
int T, n, x, y, dfn[300010], sz[300010], e[300010][2], maxsz[300010];
long long ans = 0;
std::vector<int> edges[300010];
void init(int u, int fa) {
	sz[u] = 1; maxsz[u] = 0;
	for (int i = 0; i < edges[u].size(); i++)
		if (edges[u][i] != fa) {
			init(edges[u][i], u);
			sz[u] += sz[edges[u][i]];
			if (sz[edges[u][i]] > maxsz[u])
				maxsz[u] = sz[edges[u][i]];
		}
}
int work(int rt, int fa) {
	init(rt, fa);
	for (int i = 1; i <= n; i++)
		if (sz[i] && maxsz[i] < sz[rt] - sz[i])
			maxsz[i] = sz[rt] - sz[i];
	int pos = rt, minsz = maxsz[rt];
	for (int i = 1; i <= n; i++)
		if (sz[i] && i != rt) {
			if (minsz == maxsz[i])
				pos += i;
			if (minsz > maxsz[i]) {
				pos = i;
				minsz = maxsz[i];
			}
		}
	return pos;
}
int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	fead(T);
	while (T--) {
		fead(n);
		for (int i = 1; i <= n; i++) edges[i].clear();
		for (int i = 1; i < n; i++) {
			fead(e[i][0]); fead(e[i][1]);
			edges[e[i][0]].push_back(e[i][1]);
			edges[e[i][1]].push_back(e[i][0]);
		}
		ans = 0;
		for (int i = 1; i < n; i++) {
			x = e[i][0], y = e[i][1];
			memset(sz, 0, sizeof sz);
			ans += work(x, y);
			memset(sz, 0, sizeof sz);
			ans += work(y, x);
		}
		printf("%lld\n", ans);
	}
	return 0;
}
