#include<cstdio>
#include<cctype>
#include<algorithm>
template<typename tn> void fead(tn &n) {
	tn i = 1, f = 1, k = 0; char ch = getchar();
	while (!isdigit(ch)) {if (ch == '-') f = -1; ch = getchar();}
	while (isdigit(ch)) k = k * 10 + ch - '0', ch = getchar();
	if (ch == '.') {ch = getchar(); while (isdigit(ch)) i /= 10, k += i * (ch - '0'), ch = getchar();}
	n = k * f;
}
const long long key = 998244353LL;
int n, m;
long long a[110][2010], b[110][2010], c[2010][110], f[110][110][110], ans = 1LL;
int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	fead(n); fead(m);
	for (int i = 1; i <= n; i++) {
		long long tmp = 0;
		for (int j = 1; j <= m; j++) {
			fead(a[i][j]); tmp = tmp + a[i][j];
		}
		for (int j = 1; j <= m; j++)
			b[i][j] = tmp - a[i][j];
		ans = (ans * (tmp + 1LL)) % key;
	}
	ans--;
	for (int t = 1; t <= m; t++) {
		for (int i = 0; i <= n; i++)
			f[i][0][0] = 1LL, f[i][1][0] = (f[i - 1][1][0] + a[i][t]) % key, f[i][0][1] = (f[i - 1][0][1] + b[i][t]) % key;
		for (int i = 1; i <= n; i++)
			for (int j = 0; j <= n; j++)
				for (int k = 0; k <= n; k++) {
					f[i][j][k] = f[i - 1][j][k];
					if (j > 0) f[i][j][k] = (f[i][j][k] + f[i - 1][j - 1][k] * a[i][t] % key) % key;
					if (k > 0) f[i][j][k] = (f[i][j][k] + f[i - 1][j][k - 1] * b[i][t] % key) % key;
				}
		for (int j = 1; j <= n; j++)
			for (int k = 0; k < j; k++)
				ans = (ans - f[n][j][k] + key) % key;
	}
	printf("%lld\n", ans);
	return 0;
}
