#include<cstdio>
#include<cctype>
#include<queue>
#include<vector>
template<typename tn> void fead(tn &n) {
	tn i = 1, f = 1, k = 0; char ch = getchar();
	while (!isdigit(ch)) {if (ch == '-') f = -1; ch = getchar();}
	while (isdigit(ch)) k = k * 10 + ch - '0', ch = getchar();
	if (ch == '.') {ch = getchar(); while (isdigit(ch)) i /= 10, k += i * (ch - '0'), ch = getchar();}
	n = k * f;
}
int n, type;
long long a[40000010], s[40000010], ans = 0, last = 0;
struct range{
	int l, r, sp;
	long long val;
}tmp;
bool operator< (range aa, range bb) {
	return aa.l > bb.l;
}
std::priority_queue<range> H;
std::vector<int> v;
long long get_sum(int l, int r) {return s[r] - s[l - 1];}
void get_val(range &x) {
	int l = x.l, r = x.r, ans;
	while (l <= r) {
		int mid = (l + r) >> 1;
		if (get_sum(x.l, mid) <= get_sum(mid + 1, x.r)) l = mid + 1, ans = mid;
		else r = mid - 1;
	}
	if (x.l == x.r || r < x.l || get_sum(x.l,  ans) > get_sum(ans + 1, x.r)) {
		x.val = -1LL; x.sp = x.l;
	}
	else {
		x.val = 2LL * get_sum(x.l, ans) * get_sum(ans + 1, x.r);
		x.sp = ans;
	}
}
void work(int dep, long long sum) {
	if (dep > n) {
		if (v.size() && sum * sum >= v[v.size() - 1]) {
			v.push_back(sum * sum);
			long long res = 0;
			for (int i = 0; i < v.size(); i++)
				res += v[i];
			if (res < ans) ans = res;
			v.pop_back();
		}
		return ;
	}
	work(dep + 1, sum + a[dep]);
	if (!v.size() || sum * sum >= v[v.size() - 1]) {
		v.push_back(sum * sum);
		work(dep + 1, a[dep]);
		v.pop_back();
	}
}
int main() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	fead(n); fead(type);
	if (!type)
		for (int i = 1; i <= n; i++)
			fead(a[i]);
	for (int i = 1; i <= n; i++)
		s[i] = s[i - 1] + a[i];
	if (n <= 10) {
		ans = 1e16;
		v.clear();
		work(2, a[1]);
	}
	else {
		tmp.l = 1; tmp.r = n; get_val(tmp); H.push(tmp);
		while (!H.empty()) {
			range u = H.top(); H.pop();
			if (u.val >= 0 && (get_sum(u.l, u.sp) >= last)) {
				tmp.l = u.l; tmp.r = u.sp; get_val(tmp); H.push(tmp);
				tmp.l = u.sp + 1; tmp.r = u.r; get_val(tmp); H.push(tmp);
			}
			else {
				last = get_sum(u.l, u.r);
				ans += last * last;
			}
		}
	}
	printf("%lld\n", ans);
	return 0;
}
