#include <bits/stdc++.h>
using namespace std;

#define ll long long
const int MAX_N = 2000 + 10, MOD = 998244353;
int vis[MAX_N], used[MAX_N], n, m;
ll A[MAX_N][MAX_N], ans;

void dfs(int cur, int dep, int last, ll ret) {
	if (cur == dep + 1) {
		ans = (ans + ret) % MOD;
		return;
	}
	for (int i = last; i <= n; ++i) {
		if (vis[i]) continue;
		vis[i] = 1;
		for (int j = 1; j <= m; ++j) {
			if (A[i][j] == 0) continue;
			++used[j];
			if (used[j] > dep / 2) {
				--used[j];
				continue;
			}
			dfs(cur + 1, dep, i, ret * A[i][j] % MOD);
			--used[j];
		}
		vis[i] = 0;
	}
}

int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	scanf("%d%d", &n, &m);
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j)
			scanf("%lld", &A[i][j]);
	for (int i = 2; i <= n; ++i) {
		memset(vis, 0, sizeof vis);
		memset(used, 0, sizeof used);
		dfs(1, i, 1, 1);
	}
	printf("%lld\n", ans);
	return 0;
}
