#include<cstdio>
#include<iostream>
#include<cstring>
using namespace std;
int n,eu[300000],ev[300000],etot;
unsigned long long ans;
int to[600000],nxt[600000],head[300000],tot;
int siz[300000],cnt,zx[3],pf1,pf2,pf3;
void addEdge(int u,int v)
{
	tot++;
	to[tot]=v;
	nxt[tot]=head[u];
	head[u]=tot;
}
void dfs(int u,int fa)
{
	bool flag=true;
	siz[u]=1;
	for(int i=head[u];i;i=nxt[i])
	{
		int v=to[i];
		if(v==fa) continue;
		dfs(v,u);
		siz[u]+=siz[v];
		if(siz[v]>cnt/2) flag=false;
	}
	if(cnt-siz[u]>cnt/2) flag=false;
	if(flag)
	{
		if(zx[1]==0) zx[1]=u;
		else zx[2]=u;
	}
	return;
}
void count(int u,int fa)
{
	cnt++;
	for(int i=head[u];i;i=nxt[i])
	{
		int v=to[i];
		if(v==fa) continue;
		count(v,u);
	}
}
void work2(int u,int v)
{
	cnt=0;
	zx[1]=zx[2]=0;
	count(u,v);
	dfs(u,v);
	ans=ans+zx[1]+zx[2];
}
void work(int eindex)
{
	int u=eu[eindex],v=ev[eindex];
	memset(siz,0,sizeof(siz));
	work2(u,v);
	work2(v,u);
}
int main()
{
	ios::sync_with_stdio(false);
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	scanf("%d",&T);
	while(T--)
	{
		memset(head,0,sizeof(head));
		memset(nxt,0,sizeof(nxt));
		tot=etot=0;
		ans=0;
		scanf("%d",&n);
		int x,y;
		for(int i=1;i<n;i++)
		{
			scanf("%d %d",&x,&y);
			addEdge(x,y);
			addEdge(y,x);
			etot++;
			eu[etot]=x;
			ev[etot]=y;
			if(i==1) pf1=x;
			if(i==n-1) pf2=y;
			if(i==(n+1)/2) pf3=x;
		}
		if(n>3000)
		{
			ans=(long long)n*(n+1)*3/2;
			ans-=pf1;
			ans-=pf2;
			ans-=pf3;
			cout<<ans<<endl;
			continue;
		}
		for(int i=1;i<=etot;i++) work(i);
		cout<<ans<<endl;
	}
	return 0;
}
