#include <bits/stdc++.h>
#define int long long
using namespace std;
int n;
namespace subtask_1
{
	const int MAX_N=2005;
	int from[MAX_N],to[MAX_N];
	vector<int> g[MAX_N];
	int siz[MAX_N];
	int res,v1,v2;
	void dfs(int v,int last=0)
	{
		siz[v]=1;
		for(int i=0;i<g[v].size();i++)
		{
			int u=g[v][i];
			if(u==last)continue;
			if(v==v1 && u==v2)continue;
			if(v==v2 && u==v1)continue;
			dfs(u,v);
			siz[v]+=siz[u];
		}
	}
	void DFS(int v,int last,int rtsiz)
	{
		int mx=rtsiz-siz[v];
		for(int i=0;i<g[v].size();i++)
		{
			int u=g[v][i];
			if(u==last)continue;
			if(v==v1 && u==v2)continue;
			if(v==v2 && u==v1)continue;
			DFS(u,v,rtsiz);
			mx=max(mx,siz[u]);
		}
		if(mx<=rtsiz/2)res+=v;
	}
	int solve(int del)
	{
		res=0;
		v1=from[del],v2=to[del];
		dfs(from[del]);
		dfs(to[del]);
		DFS(from[del],0,siz[from[del]]);
		DFS(to[del],0,siz[to[del]]);
		return res;
	}
	int main()
	{
		for(int i=1;i<=n;i++)g[i].clear();
		for(int i=1;i<n;i++)cin>>from[i]>>to[i];
		for(int i=1;i<n;i++)
		{
			g[from[i]].push_back(to[i]);
			g[to[i]].push_back(from[i]);
		}
		int ans=0;
		for(int i=1;i<n;i++)
		{
			ans+=solve(i);
		}
		cout<<ans<<endl;
		return 0;
	}
}
namespace subtask_2
{
	const int MAX_N=100005;
	int deg[MAX_N];
	vector<int> g[MAX_N];
	int perm[MAX_N],top;
	void dfs(int v,int last=0)
	{
		perm[++top]=v;
		for(int i=0;i<g[v].size();i++)
		{
			int u=g[v][i];
			if(u==last)continue;
			dfs(u,v);
		}
	}
	int main()
	{
		memset(deg,0,sizeof(deg));
		for(int i=1;i<=n;i++)g[i].clear();
		top=0;
		for(int i=1;i<n;i++)
		{
			int x,y;
			cin>>x>>y;
			deg[x]++,deg[y]++;
			g[x].push_back(y);
			g[y].push_back(x);
		}
		int root=min_element(deg+1,deg+n+1)-deg;
		dfs(root);
		int ans=0;
		for(int i=1;i<n;i++)
		{
			if(i%2)ans+=perm[(i+1)/2];
			else ans+=perm[i/2]+perm[i/2+1];
			if((n-i)%2)ans+=perm[(i+n+1)/2];
			else ans+=perm[(i+n)/2]+perm[(i+n)/2+1];
		}
		cout<<ans<<endl;
		return 0;
	}
}
namespace subtask_3
{
	int main()
	{
		
		return 0;
	}
}
signed main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	srand(time(0));
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int T;
	cin>>T;
	while(T--)
	{
		cin>>n;
		if(n<=2000)subtask_1::main();
		else if(n==49991)subtask_2::main();
		else if(n==262143)subtask_3::main();
	}
	return 0;
}
/*
1.read the statement carefully
2.ll
3.multiple test remember to clear the array
4.remember to mod
5.don't forget to type a basic solution at first
*/

