#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

int n, m;
int a[41][501] = {};
const ll MOD = 998244353ll;

namespace bf {

int cnt[11] = {};
ll ans = 0;
ll mul = 1;

void dfs(int x, int X, int c) {
	if (c >= X || x > n) {
		if (c >= X) {
			for (int i=1;i<=n;i++) {
				if (cnt[i] > X/2) {
					return;	
				}
			}
			ans+=mul; ans%=MOD;
		}
		return;
	}
	ll oldmul;
	for (int i=1;i<=m;i++) {
		if (a[x][i]) {
			oldmul = mul;
			mul = (mul * a[x][i]) % MOD;
			cnt[i]++;
			dfs(x+1, X, c+1);
			cnt[i]--;
			mul = oldmul;
		}
	}
	dfs(x+1, X, c);
}

void solve() {
	ll final_ans = 0;
	for (int i=2;i<=n;i++) {
		ans = 0;
		dfs(1, i, 0);
		final_ans += ans; final_ans %= MOD;
	}
	cout << final_ans << endl;
}

}

ll dp[41][41] = {};
ll dp2[501][2][41][41] = {};
ll dp3[501][2][41] = {};
ll dp4[501][41][41] = {};
int cur1[501], nxt1[501];
int cur2[501], nxt2[501];
int cnt[41] = {}; 
int cnt2[41] = {};

ll solve(int x) {
	ll ans = 0;
	int lim;
	for (int i=1;i<=m;i++) {
		if (cnt2[i] > x / 2) {
			// first of all select (x/2+1) from the meals with it
			
			lim = min(x-x/2, cnt2[i] - x/2);
			for (int j=0;j<lim;j++) {
				ans += (dp4[i][x/2+1][x/2+1+j]) * (dp3[i][cur2[i]][x-x/2-1-j]);
				ans %= MOD;
			}
		}
	}
	return ((dp[n][x] - ans) + MOD) % MOD;
}

int main() {
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
	ios::sync_with_stdio(false); cin.tie(NULL);

	cin>>n>>m;
	for (int i=1;i<=n;i++) {
		for (int j=1;j<=m;j++) {
			cin>>a[i][j];
			if (a[i][j]) {
				cnt[i] = (cnt[i] + a[i][j]) % MOD;
				cnt2[j]++;
			}
		}
	}
	
	if (n <= 10) {
		bf::solve();
		return 0;
	}
	
	for (int i=1;i<=m;i++) cur1[i] = cur2[i] = 0, nxt1[i] = nxt2[i] = 1;
	
	// choose j meals from i
	dp[0][0] = 1;
	for (int i=1;i<=n;i++) {
		dp[i][0] = 1;
		for (int j=1;j<=n;j++) {
			dp[i][j] = (1ll * dp[i-1][j] + 1ll * dp[i-1][j-1] * cnt[i])%MOD;
		}
	}
	
	for (int i=1;i<=m;i++) {
		for (int j=1;j<=n;j++) {
			dp2[i][cur1[i]][0][0] = 1;
			for (int k=0;k<=n;k++) {
				for (int l=0;l<=n;l++) {
					dp2[i][nxt1[i]][k][l] = dp2[i][cur1[i]][k][l] + (dp2[i][cur1[i]][k-1][l] * a[j][i])%MOD + (dp2[i][cur1[i]][k][l-1] * (cnt[j] - a[j][i]))%MOD;
					dp2[i][nxt1[i]][k][l] %= MOD;
				}
			}
			swap(cur1[i], nxt1[i]);
		}
	}
	for (int i=1;i<=m;i++) {
		for (int j=1;j<=n;j++) {
			for (int l=0;l<=j;l++)
				for (int k=l;k<=j;k++)
					dp4[i][l][j] += dp2[i][cur1[i]][k][j-k];
		}
	}
	
	for (int i=1;i<=m;i++) {
		dp3[i][cur2[i]][0] = 1;
		for (int j=1;j<=n;j++) {
			dp3[i][cur2[i]][0] = 1;
			for (int k=0;k<=n;k++) {
				if (!a[j][i]) {
					dp3[i][nxt2[i]][k] = 1ll * dp3[i][cur2[i]][k] + 1ll * dp3[i][cur2[i]][k-1] * (cnt[j]);
					dp3[i][nxt2[i]][k] %= MOD;
				} else {
					dp3[i][nxt2[i]][k] = dp3[i][cur2[i]][k];
				}
			}
			swap(cur2[i], nxt2[i]);
		}
	}
	
	ll ans = 0;
	for (int i=2;i<=n;i++) {
		ans += solve(i);
		ans %= MOD;
	}
	cout << ans << endl;

	return 0;
}


