#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
const int maxn=50005;
int T,n,x[maxn],y[maxn];
struct Case1
{
	static const int maxn=2005;
	struct Edge { int v; Edge *nxt; };
	Edge mem[maxn*2],*G[maxn],*ecnt;
	inline void AddEdge(int u,int v) { ecnt->v=v; ecnt->nxt=G[u]; G[u]=ecnt++; }
	int sz[maxn],size,flg[maxn],t;
	void dfs1(int u,int fa)
	{
		sz[u]=1;
		for(Edge *it=G[u];it;it=it->nxt) if(it->v!=fa) { dfs1(it->v,u); sz[u]+=sz[it->v]; }
	}
	void dfs2(int u,int fa)
	{
		flg[u]=1;
		if(sz[u]>size/2) flg[fa]=0;
		for(Edge *it=G[u];it;it=it->nxt) if(it->v!=fa) dfs2(it->v,u);
		if(flg[u]&&size-sz[u]<=size/2) t+=u;
	}
	int ZX(int u,int lim)
	{
		dfs1(u,lim);
		size=sz[u];
		t=0;
		dfs2(u,lim);
		return t;
	}
	void main()
	{
		ecnt=mem;
		memset(G,0,sizeof(G));
		for(int i=1;i<=n-1;i++)
		{
			AddEdge(x[i],y[i]);
			AddEdge(y[i],x[i]);
		}
		int res=0;
		for(int i=1;i<=n-1;i++) res+=ZX(x[i],y[i])+ZX(y[i],x[i]);
		printf("%d\n",res);
	}
}C1;
struct Case2
{
	struct Edge { int v; Edge *nxt; };
	int d[maxn],v[maxn],cnt;
	Edge mem[maxn*2],*G[maxn],*ecnt;
	inline void AddEdge(int u,int v) { ecnt->v=v; ecnt->nxt=G[u]; G[u]=ecnt++; }
	void dfs1(int u,int fa)
	{
		v[++cnt]=u;
		for(Edge *it=G[u];it;it=it->nxt) if(it->v!=fa) dfs1(it->v,u);
	}
	void main()
	{
		ecnt=mem;
		memset(G,0,sizeof(G));
		cnt=0;
		for(int i=1;i<=n-1;i++) { AddEdge(x[i],y[i]); AddEdge(y[i],x[i]); }
		for(int i=1;i<=n-1;i++) { d[x[i]]++; d[y[i]]++; }
		for(int i=1;i<=n;i++) if(d[i]==1)
		{
			dfs1(i,0);
			break;
		}
		long long res=0;
		for(int i=1;i<=n-1;i++)
		{
			if(i&1) res+=v[i/2+1];
			else res+=v[i/2]+v[i/2+1];
			if((n-i)&1) res+=v[n-(n-i)/2];
			else res+=v[n-(n-i)/2]+v[n-(n-i)/2+1];
		}
		printf("%lld\n",res);
	}
}C2;
int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	while(T-->0)
	{
		scanf("%d",&n);
		for(int i=1;i<=n-1;i++) scanf("%d%d",&x[i],&y[i]);
		if(n<=2000) C1.main();
		else if(n==49991||n==4991) C2.main();
	}
	return 0;
}
